--Encapsulate SimpleAudioEngine to AudioEngine,Play music and sound effects. 
M = class("M")
M.__index = M


M.MUSIC_ON = 0
M.MUSIC_OFF = 1
M.musicTag = cc.UserDefault:getInstance():getIntegerForKey("MusicTag")
M.effectTag = cc.UserDefault:getInstance():getIntegerForKey("EffectTag")

M.musicFile = ""
M.musicIsLoop = false

function M.init()
	--[[
	if SDK_PLATFORM == "SDK_TGAME_IOS" or SDK_PLATFORM == "SDK_TGAME_ANDROID" then
		M.musicTag = M.MUSIC_OFF
		M.effectTag = M.MUSIC_OFF
		M.setEffectsVolume(0)
	end
	]]
	if M.effectTag == M.MUSIC_ON then
		--这里是音效从有到无
		M.setEffectsVolume(1)
	elseif M.effectTag == M.MUSIC_OFF then
		--这里是音效从无到有
		M.setEffectsVolume(0)
	end
	
end

function M.setMusicTag(tag)
	local sourceTag = M.musicTag
	M.musicTag = tag
	cc.UserDefault:getInstance():setIntegerForKey("MusicTag", tag)
	if sourceTag == M.MUSIC_ON and M.musicTag == M.MUSIC_OFF then
		M.stopMusic()
	elseif sourceTag == M.MUSIC_OFF and M.musicTag == M.MUSIC_ON then
		M.playMusic()
	end
end

function M.setEffectTag(tag)
	print("M.setEffectTag", tag)
	local sourceTag = M.effectTag
	M.effectTag = tag
	cc.UserDefault:getInstance():setIntegerForKey("EffectTag", tag)
	
	if sourceTag == M.MUSIC_ON and M.effectTag == M.MUSIC_OFF then
		--这里是音效从有到无
		M.setEffectsVolume(0)
	elseif sourceTag == M.MUSIC_OFF and M.effectTag == M.MUSIC_ON then
		--这里是音效从无到有
		M.setEffectsVolume(1)
	end
end

function M.stopAllEffects()
    cc.SimpleAudioEngine:getInstance():stopAllEffects()
end

function M.getMusicVolume()
    return cc.SimpleAudioEngine:getInstance():getMusicVolume()
end

function M.isMusicPlaying()
    return cc.SimpleAudioEngine:getInstance():isMusicPlaying()
end

function M.getEffectsVolume()
    return cc.SimpleAudioEngine:getInstance():getEffectsVolume()
end

function M.setMusicVolume(volume)
    cc.SimpleAudioEngine:getInstance():setMusicVolume(volume)
end

function M.stopEffect(handle)
    cc.SimpleAudioEngine:getInstance():stopEffect(handle)
end

function M.stopMusic(isReleaseData)
    local releaseDataValue = false
    if nil ~= isReleaseData then
        releaseDataValue = isReleaseData
    end
    cc.SimpleAudioEngine:getInstance():stopMusic(releaseDataValue)
end

function M.playMusic(filename, isLoop)
	if nil ~= filename then
		M.musicFile = filename
	end
	
    if nil ~= isLoop then
        M.musicIsLoop = isLoop
    end
	
	if M.musicTag == M.MUSIC_ON then
		cc.SimpleAudioEngine:getInstance():playMusic(M.musicFile, M.musicIsLoop)
	end
end

function M.pauseAllEffects()
    cc.SimpleAudioEngine:getInstance():pauseAllEffects()
end

function M.preloadMusic(filename)
    cc.SimpleAudioEngine:getInstance():preloadMusic(filename)
end

function M.resumeMusic()
    cc.SimpleAudioEngine:getInstance():resumeMusic()
end

function M.playEffect(filename, isLoop)
    local loopValue = false
    if nil ~= isLoop then
        loopValue = isLoop
    end
	
	if M.effectTag == M.MUSIC_ON then
		cc.SimpleAudioEngine:getInstance():playEffect(filename, loopValue)
	end
end

function M.rewindMusic()
    cc.SimpleAudioEngine:getInstance():rewindMusic()
end

function M.willPlayMusic()
    return cc.SimpleAudioEngine:getInstance():willPlayMusic()
end

function M.unloadEffect(filename)
    cc.SimpleAudioEngine:getInstance():unloadEffect(filename)
end

function M.preloadEffect(filename)
    cc.SimpleAudioEngine:getInstance():preloadEffect(filename)
end

function M.setEffectsVolume(volume)
    cc.SimpleAudioEngine:getInstance():setEffectsVolume(volume)
end

function M.pauseEffect(handle)
    cc.SimpleAudioEngine:getInstance():pauseEffect(handle)
end

function M.resumeAllEffects(handle)
    cc.SimpleAudioEngine:getInstance():resumeAllEffects()
end

function M.pauseMusic()
    cc.SimpleAudioEngine:getInstance():pauseMusic()
end

function M.resumeEffect(handle)
    cc.SimpleAudioEngine:getInstance():resumeEffect(handle)
end

function M.getInstance()
    return cc.SimpleAudioEngine:getInstance()
end

function M.destroyInstance()
    return cc.SimpleAudioEngine:destroyInstance()
end

