BagItem = class("BagItem", function() 
	return cc.Layer:create() 
end)
BagItem.__index = BagItem

BagItem.itemBack    = nil	--背景
BagItem.itemSprite  = nil	--图标
BagItem.itemPlace   = nil	--位置
BagItem.itemOutLine = nil	--外框
BagItem.itemLevel   = nil	--等级
BagItem.itemCount   = nil	--数量
BagItem.itemPlusNumber = nil	--强化
BagItem.itemName =  nil	    --名称
BagItem.itemLeft =  nil     --剩余数量
BagItem.slotLayer = nil	    --宝石镶嵌层
BagItem.itemInfoTable = {}

BagItem.noticeNode = nil --特效节点

BagItem.canTouch = true
BagItem.itemType = nil	--0空装备，1装备，2物品
BagItem.extraData = nil

BAG_ITEM_SIZE = 90
BAG_ITEM_SMALL_SLOT_SIZE = 18

--类型
BAG_ITEM_TYPE_EMPTY_EQUIP = 0	     --空的装备选择
BAG_ITEM_TYPE_EQUIP = 1			     --装备
BAG_ITEM_TYPE_THING = 2			     --道具
BAG_ITEM_TYPE_EMPTY_SLOT = 3	     --空白格子
BAG_ITEM_TYPE_EMPTY_MELTEQUIP = 4    --熔炼空装备
BAG_ITEM_TYPE_MELTEQUIP = 5          --熔炼装备
BAG_ITEM_TYPE_STONE = 6			     --镶嵌石头
BAG_ITEM_TYPE_EMPTY_EATEQUIP = 7     --神器空吞噬
BAG_ITEM_TYPE_EATEQUIP = 8           --神器吞噬
BAG_ITEM_TYPE_EMPTY_INHERITEQUIP = 9 --神器空传承
BAG_ITEM_TYPE_INHERITEQUIP = 10      --神器传承
BAG_ITEM_TYPE_EMPTY_HERO_EQUIP = 11  --护法装备空格子
BAG_ITEM_TYPE_HERO_EQUIP       = 12  --护法装备
BAG_ITEM_TYPE_THING_SHOP =     13	 --道具商品
BAG_ITEM_TYPE_PLAYER = 14			 --角色头像，用于查看其他玩家
BAG_ITEM_TYPE_EQUIP_DETAIL = 15      --用于纯显示装备属性 

local TAG_BACK_SPRITE   = 1
local TAG_MIDDLE_SPRITE = 2
local TAG_PLACE_LABEL   = 3
local TAG_FRAME_SPRITE  = 4
local TAG_LEVEL_LABEL   = 5
local TAG_COUNT_LABEL   = 6
local TAG_NAME_LABEL    = 7
local TAG_LEFT_LABEL    = 8
local TAG_PLUS_LABEL    = 9
local TAG_STONE_LAYER   = 10
local TAG_MAX  = 10

function BagItem:ctor()
	self:setContentSize(cc.size(BAG_ITEM_SIZE, BAG_ITEM_SIZE))
	self:setAnchorPoint(0.5, 0.5)
	self:ignoreAnchorPointForPosition(false)
	--[[
	self.itemSprite = cc.Sprite:createWithSpriteFrameName("board_baseboard.png")
	self.itemSprite:setPosition(cc.p(BAG_ITEM_SIZE / 2, BAG_ITEM_SIZE / 2))
	self:addChild(self.itemSprite,-2,0)
	
	self.itemOutLine = cc.Sprite:createWithSpriteFrameName("frame_grey.png")
	self.itemOutLine:setPosition(cc.p(BAG_ITEM_SIZE / 2, BAG_ITEM_SIZE / 2))
	self:addChild(self.itemOutLine)
	
	self.itemLevel = cc.Label:create("", DefaultFontName, FontSize1)
	self.itemLevel:setPosition(cc.p(BAG_ITEM_SIZE / 2, 0))
	self:addChild(self.itemLevel)
	
	self.itemCount = cc.Label:create("", DefaultFontName, FontSize1)
	self.itemCount:setAnchorPoint(cc.p(1,0.5))
	self.itemCount:setPosition(cc.p(78, 19))
	self:addChild(self.itemCount)
	
	self.itemName = cc.Label:create("", DefaultFontName, FontSize1)
	self.itemName:setPosition(cc.p(BAG_ITEM_SIZE / 2, -5))
	self:addChild(self.itemName)
	
	self.itemLeft = cc.Label:create("", DefaultFontName, FontSize1)
	self.itemLeft:setAnchorPoint(cc.p(0.5,0))
	self.itemLeft:setPosition(cc.p(BAG_ITEM_SIZE / 2, 7))
	self:addChild(self.itemLeft)
	
	self.itemPlusNumber = cc.Label:create("", DefaultFontName, FontSize1)
	self.itemPlusNumber:setAnchorPoint(cc.p(1, 0.5))
	self.itemPlusNumber:setPosition(cc.p(78, 70))
	self:addChild(self.itemPlusNumber)
	
	self.slotLayer = cc.Layer:create()
	self.slotLayer:ignoreAnchorPointForPosition(false)
	self.slotLayer:setAnchorPoint(0.5, 0.5)
	self.slotLayer:setPosition(cc.p(BAG_ITEM_SIZE / 2, 10))
	self:addChild(self.slotLayer)
	]]
	local eventDispatcher = self:getEventDispatcher()
	
	local function onTouchBegan(touch, event)
		if self.canTouch == false then
			return false
		end
		return getIsTouchInLayer(self, touch) 
	end
	
	local function onTouchEnded(touch, event)
		print("onTouchEnded", self.itemType, BAG_ITEM_TYPE_EMPTY_EQUIP)
		if self.itemType == BAG_ITEM_TYPE_EQUIP then
			ItemDetail:ItemDetailEnter(self.itemInfoTable)
			self:setItemNoteEffect(false)
			EquipLayer:deleteNotePlace(GameData:getPropDataTable(self.itemInfoTable.prop_id).place)
		elseif self.itemType == BAG_ITEM_TYPE_EQUIP_DETAIL then
			ItemDetail:ItemDetailEnter(self.itemInfoTable, true, true)
		elseif  self.itemType == BAG_ITEM_TYPE_HERO_EQUIP then
			ItemDetail:ItemDetailEnter(self.itemInfoTable)
		elseif self.itemType == BAG_ITEM_TYPE_EMPTY_EQUIP then
		
			cclog("item empty click %d", self.itemInfoTable.place)
			GameGuide:handStepClick(12, self)
			EquipFilterLayer:EquipFilterLayerEnter(1, self.itemInfoTable.place, UserInfo:getUserInfo().data.info.role)
			self:setItemNoteEffect(false)
			EquipLayer:deleteNotePlace(self.itemInfoTable.place)
		elseif self.itemType == BAG_ITEM_TYPE_EMPTY_HERO_EQUIP then
			cclog("item empty click %d", self.itemInfoTable.place)
			EquipFilterLayer:EquipFilterLayerEnter(self.extraData.id, self.itemInfoTable.place, self.extraData.role)
		elseif self.itemType == BAG_ITEM_TYPE_THING then
			cclog("item thing click")
			PropDetail:PropDetailEnter(self.itemInfoTable)
		elseif self.itemType == BAG_ITEM_TYPE_THING_SHOP then
			cclog("item thing click")
			PropDetail:PropDetailEnter(self.itemInfoTable, true)
		elseif self.itemType == BAG_ITEM_TYPE_EMPTY_SLOT then
			EquipStoneSet:EquipOpenStoneClick(self:getTag())
		elseif self.itemType == BAG_ITEM_TYPE_EMPTY_MELTEQUIP then
			EquipMeltFilterLayer:EquipMeltFilterLayerEnter()
		elseif self.itemType == BAG_ITEM_TYPE_MELTEQUIP then
			print("BAG_ITEM_TYPE_MELTEQUIP")
			EquipMeltLayer:EquipMeltLayerRemoveItem(self.itemInfoTable)
		elseif self.itemType == BAG_ITEM_TYPE_EMPTY_EATEQUIP then
            MasterEquipFilterChange:MasterEquipFilterChangeEnter(MasterEquipEatLayer.selectEquipMaster,1)
		elseif self.itemType == BAG_ITEM_TYPE_EATEQUIP then
			MasterEquipEatLayer:MasterEquipEatLayerRemoveItem(self.itemInfoTable)
        elseif self.itemType == BAG_ITEM_TYPE_EMPTY_INHERITEQUIP or self.itemType == BAG_ITEM_TYPE_INHERITEQUIP  then
            MasterEquipFilterChange:MasterEquipFilterChangeEnter(MasterEquipInheritLayer.selectMasterEquipData,2)
		elseif self.itemType == BAG_ITEM_TYPE_STONE then
			cclog("item stone click")
			EquipStoneSet:EquipStoneClick(self.itemInfoTable)
		elseif self.itemType == BAG_ITEM_TYPE_PLAYER then
			cclog("item recent actor click")
		end
	end
	
	local listener = cc.EventListenerTouchOneByOne:create()    
	listener:setSwallowTouches(false)
	listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN )
	listener:registerScriptHandler(onTouchEnded,cc.Handler.EVENT_TOUCH_ENDED )
	eventDispatcher:addEventListenerWithSceneGraphPriority(listener, self)
end

function BagItem:setCanTouch(enabled)
	self.canTouch = enabled
end

function BagItem:setItemType(pType)
	self.itemType = pType
end

--设置背景
function BagItem:setItemBack(backSpriteName)
	if backSpriteName ~= nil then
		if self.itemBack == nil then
			self.itemBack = cc.Sprite:createWithSpriteFrameName(backSpriteName)
			self.itemBack:setPosition(cc.p(BAG_ITEM_SIZE / 2, BAG_ITEM_SIZE / 2))
			self:addChild(self.itemBack, TAG_BACK_SPRITE - TAG_MAX, TAG_BACK_SPRITE)
		else
			self.itemBack:setSpriteFrame(backSpriteName)
			self.itemBack:setVisible(true)
		end
	elseif self.itemBack ~= nil then
		self.itemBack:setVisible(false)
	end
end

--设置主图
function BagItem:setItemSprite(spriteName)
	if spriteName ~= nil then
		if self.itemSprite == nil then
			self.itemSprite = cc.Sprite:createWithSpriteFrameName(spriteName)
			self.itemSprite:setPosition(cc.p(BAG_ITEM_SIZE / 2, BAG_ITEM_SIZE / 2))
			self:addChild(self.itemSprite, TAG_MIDDLE_SPRITE - TAG_MAX, TAG_MIDDLE_SPRITE)
		else
			self.itemSprite:setSpriteFrame(spriteName)
			self.itemSprite:setVisible(true)
		end
	elseif self.itemSprite ~= nil then
		self.itemSprite:setVisible(false)
	end
	
	self:setEmptyBgByPlace(nil)
end

--装备部位
function BagItem:setEmptyBgByPlace(place)
	if place ~= nil then
		if self.itemPlace == nil then
			self.itemPlace = CreateCommonLabel(MultiLan("equip_place_"..place),Pos(self:getContentSize()),FontSize2)
			self:addChild(self.itemPlace, TAG_PLACE_LABEL - TAG_MAX, TAG_PLACE_LABEL)
		else
			self.itemPlace:setString(MultiLan("equip_place_"..place))
		end
	elseif self.itemPlace ~= nil then
		self.itemPlace:setString("")
	end
end

--设置外框
function BagItem:setItemOutLine(outLineName)
	if outLineName ~= nil then
		if self.itemOutLine == nil then
			self.itemOutLine = cc.Sprite:createWithSpriteFrameName(outLineName)
			self.itemOutLine:setPosition(cc.p(BAG_ITEM_SIZE / 2, BAG_ITEM_SIZE / 2))
			self:addChild(self.itemOutLine, TAG_FRAME_SPRITE - TAG_MAX, TAG_FRAME_SPRITE)
		else
			self.itemOutLine:setSpriteFrame(outLineName)
			self.itemOutLine:setVisible(true)
		end
	elseif self.itemOutLine ~= nil then
		self.itemOutLine:setVisible(false)
	end
end

function BagItem:setEquipOutLine(itemGrade)
	if itemGrade > 0 and itemGrade <= table.maxn(FRAME_ICON_ARR) then
		self:setItemOutLine(FRAME_ICON_ARR[itemGrade])
	end
end

--设置等级
function BagItem:setItemLevel(levelNum)
	if levelNum ~= 0 and levelNum ~= nil then
		if self.itemLevel == nil then
			self.itemLevel = CreateCommonLabel("Lv" .. levelNum, cc.p(BAG_ITEM_SIZE / 2, 0), FontSize1)
			self:addChild(self.itemLevel, TAG_LEVEL_LABEL - TAG_MAX, TAG_LEVEL_LABEL)
		else
			self.itemLevel:setString("Lv" .. levelNum)
		end
	elseif self.itemLevel ~= nil then
		self.itemLevel:setString("")
	end
end

--设置数量
function BagItem:setItemCount(countNum)
	local str = ""
	if countNum ~= 0 and countNum ~= nil then
		if countNum ~= 1 or (self.itemInfoTable.attr == nil or self.itemInfoTable.attr == CJSON_NULL) then
			str = "x"..countNum
		end
		if self.itemCount == nil then
			self.itemCount = cc.Label:create(str, DefaultFontName, FontSize1)
			self.itemCount:setAnchorPoint(cc.p(1,0.5))
			self.itemCount:setPosition(cc.p(78, 19))
			self:addChild(self.itemCount, TAG_COUNT_LABEL - TAG_MAX, TAG_COUNT_LABEL)
		else
			self.itemCount:setString(str)
		end
	elseif self.itemCount ~= nil then
		self.itemCount:setString("")
	end
end
--设置名字
function BagItem:setItemName(nameStr)
	if nameStr ~= nil then
		if self.itemName == nil then
			self.itemName = cc.Label:create(nameStr, DefaultFontName, 16)
			self.itemName:setDimensions(115, 40)
			self.itemName:setPosition(cc.p(BAG_ITEM_SIZE / 2, -20))	
			self:addChild(self.itemName, TAG_NAME_LABEL - TAG_MAX, TAG_NAME_LABEL)
		else
			self.itemName:setString(nameStr)
		end
	elseif self.itemName ~= nil then
		self.itemName:setString("")
	end
end

--设置剩余数量
function BagItem:setItemLeft(str)
	if str ~= nil then
		if self.itemLeft == nil then
			self.itemLeft = cc.Label:create(str, DefaultFontName, FontSize1)
			self.itemLeft:setAnchorPoint(cc.p(0.5,0))
			self.itemLeft:setPosition(cc.p(BAG_ITEM_SIZE / 2, 7))
			self:addChild(self.itemLeft, TAG_LEFT_LABEL - TAG_MAX, TAG_LEFT_LABEL)
		else
			self.itemLeft:setString(str)
		end
	elseif self.itemLeft ~= nil then
		self.itemLeft:setString("")
	end
end

--设置强化数量
function BagItem:setItemPlusNumber(plusNum)
	if plusNum ~= 0 and plusNum ~= nil then
		if self.itemPlusNumber == nil then
			self.itemPlusNumber = cc.Label:create("+" .. plusNum, DefaultFontName, FontSize1)
			self.itemPlusNumber:setAnchorPoint(cc.p(1, 0.5))
			self.itemPlusNumber:setPosition(cc.p(78, 70))
			self:addChild(self.itemPlusNumber, TAG_PLUS_LABEL - TAG_MAX, TAG_PLUS_LABEL)
		else
			self.itemPlusNumber:setString("+" .. plusNum)
		end
	elseif self.itemPlusNumber ~= nil then
		self.itemPlusNumber:setString("")
	end
end

function SetEquipStone(stonelayer, slotNum, stoneTable)
    if slotNum ~= nil and slotNum ~= CJSON_NULL then
	    stonelayer:setContentSize(cc.size(BAG_ITEM_SMALL_SLOT_SIZE * slotNum, BAG_ITEM_SMALL_SLOT_SIZE))
	    for i = 1, slotNum do
		    local sprite = cc.Sprite:createWithSpriteFrameName("equipgem_05.png")
		    sprite:setTag(i)
		    sprite:setScale(0.75)
		    sprite:setAnchorPoint(cc.p(0, 0))
		    sprite:setPosition(cc.p((i-1)*BAG_ITEM_SMALL_SLOT_SIZE, BAG_ITEM_SMALL_SLOT_SIZE * 0.5))
		    stonelayer:addChild(sprite)
	    end
    end
	if stoneTable ~= nil and stoneTable ~= CJSON_NULL then
		for i = 1, table.maxn(stoneTable) do
			local stoneInfoTable = GameData:getPropDataTable(stoneTable[i]) 
			tolua.cast(stonelayer:getChildByTag(i), "cc.Sprite"):setSpriteFrame("equipgem_0" .. stoneInfoTable.place .. ".png")
		end
	end
end

--设置宝石层
function BagItem:setItemStone(slotNum, stoneTable)
	if slotNum == nil and stoneTable == nil then
		if self.slotLayer ~= nil then
			self.slotLayer:removeAllChildren(true)
		end
		return
	else
		if self.slotLayer == nil then
			self.slotLayer = cc.Layer:create()
			self.slotLayer:ignoreAnchorPointForPosition(false)
			self.slotLayer:setAnchorPoint(0.5, 0.5)
			self.slotLayer:setPosition(cc.p(BAG_ITEM_SIZE / 2, 10))
			self:addChild(self.slotLayer, TAG_STONE_LAYER - TAG_MAX, TAG_STONE_LAYER)
		else
			self.slotLayer:removeAllChildren(true)
		end
	end

	SetEquipStone(self.slotLayer, slotNum, stoneTable)
end

function BagItem:setItemInfoTable(infoTable, extraData)	--在调用这个函数之前一定要调用setItemType
	self.itemInfoTable = infoTable
	self.extraData = extraData
	if self.itemType == BAG_ITEM_TYPE_EMPTY_EQUIP then
		self:setItemSprite("board_baseboard.png")
		self:setItemOutLine("frame_grey.png")
		self:setItemLevel(0)
		self:setItemPlusNumber(0)
		self:setItemStone(0, nil)
		self:setMasterEffect(false)
	elseif self.itemType == BAG_ITEM_TYPE_EMPTY_HERO_EQUIP then
		self:setItemSprite("board_baseboard.png")
		self:setItemOutLine("frame_grey.png")
		self:setItemLevel(0)
		self:setItemPlusNumber(0)
		self:setItemStone(0, nil)
		self:setMasterEffect(false)
	elseif self.itemType == BAG_ITEM_TYPE_EMPTY_SLOT then
		self.setItemBack("board_drilling.png")
	elseif self.itemType == BAG_ITEM_TYPE_STONE then
		self:setItemOutLine("frame_grey.png")
		self:setItemCount(infoTable.amount)
		self:setItemName(MultiLan(EquipHelper:getStaticData(infoTable).name))
		self:setItemSprite("prop_"..EquipHelper:getStaticData(infoTable).id..".png")
		self:setItemBack("board_baseboard.png")
	elseif   self.itemType == BAG_ITEM_TYPE_EMPTY_MELTEQUIP  then
		self:setItemSprite("board_empty.png")
		self:setItemOutLine("frame_grey.png")
		self:setItemLevel(0)
		self:setItemStone(0, nil)
		self:setItemPlusNumber(0)
		self:setMasterEffect(false)
    elseif   self.itemType == BAG_ITEM_TYPE_EMPTY_EATEQUIP  then
		self:setItemSprite("board_empty.png")
		self:setItemOutLine("frame_grey.png")
		self:setItemLevel(0)
		self:setItemStone(0, nil)
		self:setItemPlusNumber(0)
		self:setMasterEffect(false)
    elseif   self.itemType == BAG_ITEM_TYPE_EMPTY_INHERITEQUIP  then
		self:setItemSprite("board_empty.png")
		self:setItemOutLine("frame_grey.png")
		self:setItemLevel(0)
		self:setItemPlusNumber(0)
		self:setMasterEffect(false)
	elseif 	self.itemType == BAG_ITEM_TYPE_PLAYER then
		self:setItemSprite("actor_icon_" .. infoTable.role .. ".png")
		self.itemLevel:setString(infoTable.name)
		self.itemPlusNumber:setString("Lv" .. infoTable.level)
	else
		self:setItemSprite("prop_" .. infoTable.prop_id .. ".png")
		local propInfo = EquipHelper:getStaticData(infoTable)
		if self.itemType == BAG_ITEM_TYPE_EQUIP  
			or  self.itemType == BAG_ITEM_TYPE_HERO_EQUIP 
			or  self.itemType == BAG_ITEM_TYPE_EQUIP_DETAIL
            or  self.itemType == BAG_ITEM_TYPE_MELTEQUIP 
            or  self.itemType == BAG_ITEM_TYPE_EATEQUIP
            or  self.itemType == BAG_ITEM_TYPE_INHERITEQUIP   then -- 
			local itemGrade = self:getItemGrade()
			if itemGrade == 0 or itemGrade == CJSON_NULL then
				self:setItemOutLine("frame_grey.png")
			elseif itemGrade == 1 then
				self:setItemOutLine("frame_green.png")
			elseif itemGrade == 2 then
				self:setItemOutLine("frame_blue.png")
			elseif itemGrade == 3 then
				self:setItemOutLine("frame_violet.png")
			elseif itemGrade == 4 then
				self:setItemOutLine("frame_yellow.png")
			end
			self:setItemPlusNumber(infoTable.strengthen)
			self:setItemLevel(propInfo.level)
			self:setItemStone(infoTable.slots, infoTable.stone)
			self:setMasterEffect()
		elseif self.itemType == BAG_ITEM_TYPE_THING or self.itemType == BAG_ITEM_TYPE_THING_SHOP then
			self:setItemOutLine("frame_grey.png")
			self:setItemCount(infoTable.amount)
			self:setItemName(MultiLan(propInfo.name))

			if propInfo.ptype == PROP_TYPE_GEM then
				self:setItemBack("board_baseboard.png")
			else
				self:setItemBack(nil)
			end
		end
	end
end

function BagItem:getItemGrade()
	print(self.itemInfoTable.prop_id,self.itemInfoTable.extra,self.itemInfoTable.id)
	local grade = 0
	if self.itemInfoTable.extra == nil or self.itemInfoTable.extra == CJSON_NULL then
		return CJSON_NULL
	end
	table.foreach(self.itemInfoTable.extra,function(i, v) grade = grade+1 end)
	return grade
end

--提醒特效
function BagItem:setItemNoteEffect(bNeedNote)
	if bNeedNote and self.noticeNode == nil then
		self.noticeNode = AddNewNoteEffect(self,Pos(self:getContentSize()))
	elseif bNeedNote == false and self.noticeNode ~= nil then
		self:removeChildByTag(GUIDE_EFFECT_TAG)
		self.noticeNode = nil
	end
end

function SetEquipMasterEffect(equip, equipinfo, reset)
	local masterAttrCount = 0
	if EquipHelper:isMaster(equipinfo) then
		masterAttrCount = GetTableMenberCount(equipinfo.master)
		if masterAttrCount >= 1 then
			AddMasterEffect(equip, Pos(equip:getContentSize()))
		end
	end
	
	if EquipHelper:isGlyph(equipinfo) then
		masterAttrCount = GetTableMenberCount(equipinfo.glyph)
		AddGlyphMasterEffect(equip,Pos(equip:getContentSize()))
	end
	
	if reset == false or masterAttrCount == 0 then
		if equip:getChildByTag(MASTER_EFFECT_TAG) ~= nil then
			removeSelf(equip:getChildByTag(MASTER_EFFECT_TAG))
		end
		
		if equip:getChildByTag(D_MASTER_EFFECT_TAG) ~= nil then
			equip:removeChildByTag(D_MASTER_EFFECT_TAG)
		end
	end
end

--设置神器特效
function BagItem:setMasterEffect(reset)
	--print("setMasterEffect",reset)
	SetEquipMasterEffect(self, self.itemInfoTable, reset)
end

return BagItem