EquipFilterLayer = class("EquipFilterLayer")
EquipFilterLayer.__index = EquipFilterLayer

EquipFilterLayer.isCreated = false
EquipFilterLayer.topNode = nil

EquipFilterLayer.actorType = 0	--1是主角，2,3,4是佣兵
EquipFilterLayer.equipType = 0
EquipFilterLayer.roleType = 0
EquipFilterLayer.filterScroll = nil

ccb["EquipFilterLayer"] = EquipFilterLayer
EquipFilterLayerOwner = EquipFilterLayerOwner or {}
ccb["EquipFilterLayerOwner"] = EquipFilterLayerOwner

function EquipFilterLayer:EquipFilterLayerEnter(aType, eType, role)
	if self.isCreated then
		self.topNode:setVisible(true)
	else
		self.isCreated = true
		local proxy = cc.CCBProxy:create()
		self.topNode = CommonCreatePopup(CCBReaderLoad("ccb/EquipFilterLayer.ccbi",proxy,EquipFilterLayerOwner))
		
		EquipFilterLayerOwner["mButtonClose"]:setTitleForState(MultiLan("button_close"), 1)
	end

	EquipFilterLayerOwner["mTitleFilterLabel"]:setString(ZGMultiLan("equip_title_autoSell"))

	self.actorType = aType
	self.equipType = eType
	self.roleType = role
	cclog("equip filter %d %d %d", aType, eType, role)
	self:EquipFilterLayerCreate()
	self:EquipFilterLayerRefresh()
end

function EquipFilterLayer:EquipFilterLayerExit()
	self.topNode:setVisible(false)
	EquipFilterLayerOwner["mEquipFilterChoose"]:removeAllChildren(true)
end

function EquipFilterLayer:EquipFilterLayerCreate()
	local filterLayer = EquipFilterLayerOwner["mEquipFilterChoose"]
	self.filterScroll = cc.ScrollView:create()
	filterLayer:addChild(self.filterScroll)
	self.filterScroll:setViewSize(cc.size(filterLayer:getContentSize().width, filterLayer:getContentSize().height))
	self.filterScroll:setPosition(cc.p(0,0))
	self.filterScroll:ignoreAnchorPointForPosition(true)
	self.filterScroll:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
	self.filterScroll:setClippingToBounds(true)
	self.filterScroll:setBounceable(true)
	self.filterScroll:setDelegate()
	self.filterScroll:setVisible(true)
end

function EquipFilterLayer:EquipFilterLayerRefresh()
	local scrollLayer = cc.Layer:create()
	scrollLayer:ignoreAnchorPointForPosition(true)
	self.filterScroll:setContainer(scrollLayer)
	local scrollWorldPos = self.filterScroll:getParent():convertToWorldSpace(cc.p(self.filterScroll:getPosition()))
	local scrollViewSize = self.filterScroll:getViewSize()
	local curPosY = 0
	local bagEquipList = UserInfo:sortBagEquipByScore(self.equipType, self.roleType) 
	local i = table.maxn(bagEquipList)
	local tmpFlag = false
	while i >= 1 do
		cclog("equip type %d", self.equipType)
		tmpFlag = true
		local itemLayer = cc.Layer:create()
		itemLayer:ignoreAnchorPointForPosition(true)
		
		local itemBgSprite = cc.Sprite:createWithSpriteFrameName("board_equipchoose.png")
		itemBgSprite:setAnchorPoint(cc.p(0, 0))
		itemLayer:addChild(itemBgSprite)
		
		local itemRichInfo = EquipHelper:createItemInfoRichtext(bagEquipList[i])
		itemRichInfo:setContentSize(cc.size(270, 500))
		itemRichInfo:formatText()
		itemRichInfo:ignoreAnchorPointForPosition(true)
		itemRichInfo:setPosition(cc.p(115, itemRichInfo:getTextMaxHeight()-500 + 30/2))
		itemLayer:setContentSize(496, itemRichInfo:getTextMaxHeight() + 30)
		itemLayer:addChild(itemRichInfo)
		itemLayer:setPosition(cc.p(0, curPosY))
		curPosY = curPosY + itemLayer:getContentSize().height
		
		EquipHelper:setEquipPlaceNameLabel(itemLayer, bagEquipList[i])
		cclog("rich text height %.2f", itemRichInfo:getTextMaxHeight())
		
		itemBgSprite:setScaleY(itemLayer:getContentSize().height / itemBgSprite:getSpriteFrame():getRect().height)
		
		local bagItem = CreateBagItem()
		bagItem:setCanTouch(false)
		bagItem:setItemType(BAG_ITEM_TYPE_EQUIP)
		bagItem:setItemInfoTable(bagEquipList[i])
		bagItem:setPosition(cc.p(50, itemLayer:getContentSize().height - 60))
		itemLayer:addChild(bagItem)
		
		local function takeonEquipmentCallback(jsonDataTable)
			if jsonDataTable.ret ~= 0 then
				cclog("take on equip failed %d", jsonDataTable.ret)
				return 
			end
			local takeonId = jsonDataTable.data.id
			cclog("takeon id is %d", takeonId)
			local takeonEquipTable = UserInfo:removeEquipByIdAndObj(takeonId, 0)
			if takeonEquipTable ~= nil then
				print("takeon equip id",takeonEquipTable.id )
				UserInfo:addEquipByObj(takeonEquipTable, jsonDataTable.data.obj)
			end
			UserAttr:equipAttrChange(jsonDataTable.data.obj, true)
			
			if jsonDataTable.data.obj == 1 then
				GameGuide:handStepClick(13)
			end
		end
		
		local function takeonEquipment(node)
			print("node tag is %d", node:getTag(), EquipHelper:getStaticData(FindFirstByKey(UserInfo:getUserInfo().data.bag_equip,"id", node:getTag())).level)
			if EquipHelper:getStaticData(FindFirstByKey(UserInfo:getUserInfo().data.bag_equip,"id", node:getTag())).level - UserSelfInfo.level > 10 then
				CommonNote(MultiLan("EFC_note1"))
				return
			end
			
			HttpSend("equip/load", {"id=" .. node:getTag(), "obj="..self.actorType}, takeonEquipmentCallback)
			EquipFilterLayer:EquipFilterLayerExit()
		end
		local pBackgroundButton = cc.Scale9Sprite:createWithSpriteFrameName("button_blue.png")
		local pTitle = cc.Label:create(MultiLan("lan_equip"), DefaultFontName, FontSize3)
		local takeonButton = cc.ControlButton:create(pTitle, pBackgroundButton)
		takeonButton:setTag(bagEquipList[i].id)
		takeonButton:registerControlEventHandler(takeonEquipment,cc.CONTROL_EVENTTYPE_TOUCH_UP_INSIDE)
		takeonButton:setPosition(cc.p(420, itemLayer:getContentSize().height * 0.4))
		takeonButton:setPreferredSize(cc.size(158, 67))
		takeonButton:setScale(0.8)
		takeonButton:setScrollViewRect(cc.rect(scrollWorldPos.x, scrollWorldPos.y, scrollViewSize.width, scrollViewSize.height))
		itemLayer:addChild(takeonButton)
		print("i", i)
		if i== table.maxn(bagEquipList) then
			GameGuide:setHandGuide(13, takeonButton)
		end
		
		scrollLayer:addChild(itemLayer)

		i = i-1
	end
	if tmpFlag then
		EquipFilterLayerOwner["mEquipFilterNoEquip"]:setVisible(false)
	else
		EquipFilterLayerOwner["mEquipFilterNoEquip"]:setVisible(true)
		tolua.cast(EquipFilterLayerOwner["mEquipFilterNoEquip"], "cc.Label"):setString(MultiLan("EFC_noFitEquip"))
	end
	local filterLayer = EquipFilterLayerOwner["mEquipFilterChoose"]
	if scrollLayer:getContentSize().height <= filterLayer:getContentSize().height then
		scrollLayer:setContentSize(cc.size(filterLayer:getContentSize().width, filterLayer:getContentSize().height))
		self.filterScroll:setContentOffset(cc.p(0, 0), false)
	else
		scrollLayer:setContentSize(cc.size(filterLayer:getContentSize().width, curPosY))
		self.filterScroll:setContentOffset(cc.p(0, -scrollLayer:getContentSize().height + filterLayer:getContentSize().height), false)
	end
	self.filterScroll:updateInset()
end

function onEquipFilterLayerClose()
	EquipFilterLayer:EquipFilterLayerExit()
	if HandGuideStep == 13 then
		HandGuideStep = 12 
		GameGuide:setHandGuide(12, EquipLayer.itemTable[1])
	end
end

EquipFilterLayer["onEquipFilterLayerClose"] = onEquipFilterLayerClose