EquipLayer = class("EquipLayer")
EquipLayer.__index = EquipLayer

EquipLayer.isCreated = false
EquipLayer.topNode = nil
EquipLayer.itemTable = {}
EquipLayer.notePlaceTable = {}

ccb["EquipLayer"] = EquipLayer
EquipLayerOwner = EquipLayerOwner or {}
ccb["EquipLayerOwner"] = EquipLayerOwner

EQUIP_MAX = 10

function EquipLayer:EquipLayerCreateItem()
	for i = 1, EQUIP_MAX do
		self.itemTable[i] = CreateBagItem()
		self.itemTable[i]:setPosition(cc.p(BAG_ITEM_SIZE / 2, BAG_ITEM_SIZE / 2))
		self.itemTable[i]:setTag(i)
		tolua.cast(EquipLayerOwner["mEquipItemLayer" .. i], "cc.Node"):addChild(self.itemTable[i])
	end
	
	--初始化
	--local attrTable = {"力量：","敏捷：","智力：","耐力：","伤害：","护甲：","魔抗：","命中：","暴击：","闪避：","韧性："}
    local attrTable = {"str","int","agi","sta","damage","armor","mr","hit","crit","dodge","tough"}

	for i=1, 11 do
		tolua.cast(EquipLayerOwner["mEquipProperty"..i], "cc.Label"):setString(MultiLan( "attr_role_"..attrTable[i])..":")
		tolua.cast(EquipLayerOwner["mEquipProperty"..i], "cc.Label"):setColor(COLOR_ORANGE)
	end
	EquipLayerOwner["mEquipValue5"]:setColor(COLOR_GREEN)
	tolua.cast(EquipLayerOwner["mEquipBattleValue"], "cc.Label"):setColor(COLOR_ORANGE)
end

function EquipLayer:EquipLayerRefreshItem()
	print("EquipLayerRefreshItem")
    if self.isCreated == false and CommonEquipLayer:isVisible() == false then
       return
    end
    --self.notePlaceTable = {}
    for i = 1, EQUIP_MAX do
		self.itemTable[i]:setItemType(BAG_ITEM_TYPE_EMPTY_EQUIP)
		self.itemTable[i]:setItemInfoTable({place=i})
		if findValueFromTable(self.notePlaceTable, i) then
			self.itemTable[i]:setItemNoteEffect(true)
		else
			self.itemTable[i]:setItemNoteEffect(false)
		end
        self.itemTable[i]:setEmptyBgByPlace(i)
	end
	if UserInfo:getUserInfo().data.equip.hero_1 ~= nil and UserInfo:getUserInfo().data.equip.hero_1 ~= CJSON_NULL then
		for i = 1, table.maxn(UserInfo:getUserInfo().data.equip.hero_1) do
			local propId = UserInfo:getUserInfo().data.equip.hero_1[i].prop_id
			local propInfoTable = GameData:getPropDataTable(propId)
			cclog("place is %d", propInfoTable.place)
			self.itemTable[propInfoTable.place]:setItemType(BAG_ITEM_TYPE_EQUIP)
			self.itemTable[propInfoTable.place]:setItemInfoTable(UserInfo:getUserInfo().data.equip.hero_1[i])
		end
	end
	self:PropertyLabelRefresh()
	--小手引导
	GameGuide:setHandGuide(12, self.itemTable[1])
end

function EquipLayer:PropertyLabelRefresh()
	tolua.cast(EquipLayerOwner["mEquipActorName"], "cc.Label"):setString("Lv." .. UserInfo:getUserInfo().data.info.level .. " " .. UserInfo:getUserInfo().data.info.name)
	tolua.cast(EquipLayerOwner["mEquipBattleValue"], "cc.Label"):setString(UserAttr:getFightNum())
	tolua.cast(EquipLayerOwner["mEquipBattleValue"], "cc.Label"):setColor(COLOR_WHITE)
	--UserSelfInfo.title = 100+ (math.random(os.clock()*10^6)%9 + 1)
	if UserSelfInfo.title == 0 then
		-- EquipLayerOwner["mEquipUserTitle"]:setVisible(false)
		EquipLayerOwner["mEquipHonor"]:setVisible(false)
	else
		-- EquipLayerOwner["mEquipUserTitle"]:setVisible(true)
		-- tolua.cast(EquipLayerOwner["mEquipUserTitle"], "cc.Sprite"):setSpriteFrame("honor_"..UserSelfInfo.title..".png")
		EquipLayerOwner["mEquipHonor"]:setString(ZGMultiLan("honor_" .. UserSelfInfo.title))
	end
	
	local userAttr = UserAttr:getAttrTable()
	tolua.cast(EquipLayerOwner["mEquipValue1"], "cc.Label"):setString(userAttr.str)
	tolua.cast(EquipLayerOwner["mEquipValue2"], "cc.Label"):setString(userAttr.int)
	tolua.cast(EquipLayerOwner["mEquipValue3"], "cc.Label"):setString(userAttr.agi)
	tolua.cast(EquipLayerOwner["mEquipValue4"], "cc.Label"):setString(userAttr.sta)
	tolua.cast(EquipLayerOwner["mEquipValue5"], "cc.Label"):setString(math.ceil(userAttr.damage/2).." - "..userAttr.damage)
	tolua.cast(EquipLayerOwner["mEquipValue6"], "cc.Label"):setString(userAttr.armor)
	tolua.cast(EquipLayerOwner["mEquipValue7"], "cc.Label"):setString(userAttr.mr)
	tolua.cast(EquipLayerOwner["mEquipValue8"], "cc.Label"):setString(userAttr.hit)
	tolua.cast(EquipLayerOwner["mEquipValue9"], "cc.Label"):setString(userAttr.crit)
	tolua.cast(EquipLayerOwner["mEquipValue10"], "cc.Label"):setString(userAttr.dodge)
	tolua.cast(EquipLayerOwner["mEquipValue11"], "cc.Label"):setString(userAttr.tough)
	
	EquipLayerOwner["mEquipLayerHp"]:setString(userAttr.hp)
	EquipLayerOwner["mEquipLayerMp"]:setString(userAttr.mp)
	EquipLayerOwner["mEquipLayerBody"]:setSpriteFrame("body_icon_"..UserSelfInfo.role..".png")
end

function EquipLayer:EquipLayerEnter()
	print("EquipLayer:EquipLayerEnter")
	GameGuide:resetHandGuide()
	GameGuide:handStepClick(11, XiaLayerOwner["mMainButton3"])
	if self.isCreated then
		print("isCreated")
		self:EquipLayerRefreshItem()
		self.topNode:setVisible(true)
	else
		self.isCreated = true
		
		local proxy = cc.CCBProxy:create()
		self.topNode = CCBReaderLoad("ccb/EquipLayer.ccbi", proxy, EquipLayerOwner)
		CommonEquipLayer:addChild(self.topNode)
		
		self:EquipLayerCreateItem()
		self:EquipLayerRefreshItem()
		CommonMoveLabelUnderBtn(EquipLayerOwner["mEquipMoreProperty"], EquipLayerOwner["lbEquipMoreProperty"])

		EquipLayerOwner["mEquipBattleValueTitle"]:setString(ZGMultiLan("equip_battle_value_title"))
		-- EquipLayerOwner["mEquipMoreProperty"]:setTitleForState(ZGMultiLan("btn_equip_more_proporties"), 1)
		EquipLayerOwner["lbBasePropertiesTitle"]:setString(ZGMultiLan("lbBasePropertiesTitle"))
	end

end

function EquipLayer:addNotePlace(place)
	print("EquipLayer:addNotePlace",place)
	if false == findValueFromTable(self.notePlaceTable,place) then
		table.insert(self.notePlaceTable, place)
		GameGuide:newEquipGuide(self.notePlaceTable)
		if CommonEquipLayer:isVisible() then
			self:EquipLayerRefreshItem()
		end
	end
end

function EquipLayer:deleteNotePlace(place)
	print("EquipLayer:deleteNotePlace",place)
	if findValueFromTable(self.notePlaceTable,place) then
		removeFromTable(self.notePlaceTable, place)
		GameGuide:newEquipGuide(self.notePlaceTable)
		print(CommonEquipLayer:isVisible())
		if CommonEquipLayer:isVisible() then
			self:EquipLayerRefreshItem()
		end
	end
end

function EquipLayer:EquipLayerExit()
	self.topNode:setVisible(false)
end

local function onEquipButtonMore()
	print("Equip  我我我我万千瓦为去去ore property click")
	MorepertyPopup(UserAttr:getAttrTable(),UserAttr:getFightNum(),UserSelfInfo.name,UserSelfInfo.level,UserSelfInfo.role)
end

EquipLayer["onEquipButtonMore"] = onEquipButtonMore