EquipMeltFilterLayer = class("EquipMeltFilterLayer")
EquipMeltFilterLayer.__index = EquipMeltFilterLayer

EquipMeltFilterLayer.topNode = nil
EquipMeltFilterLayer.filterScroll = nil

ccb["EquipMeltFilterLayer"] = EquipMeltFilterLayer
EquipMeltFilterLayerOwner = EquipMeltFilterLayerOwner or {}
ccb["EquipMeltFilterLayerOwner"] = EquipMeltFilterLayerOwner

EquipMeltFilterLayer.meltEquipFilterDataTable = {}
EquipMeltFilterLayer.bagEquipList = {} 
EquipMeltFilterLayer.MeltEquipFilterCount = 0
local CanMeltFilter = false

--////////////////////////////////////////////////////
function EquipMeltFilterLayer:EquipMeltFilterLayerEnter()
    
    if self.topNode ~= nil then
        return
    end

	local proxy = cc.CCBProxy:create()
	self.topNode = CCBReaderLoad("ccb/EquipMeltFilterLayer.ccbi",proxy,EquipMeltFilterLayerOwner)
	POPUP_LAYER:addChild(self.topNode)
	EquipMeltFilterLayerOwner["mButtonOk"]:setTitleForState(MultiLan("button_ok"), 1)
	EquipMeltFilterLayerOwner["mTitleFilterLabel"]:setString(ZGMultiLan("equip_title_filter"))
	self:EquipMeltFilterLayerCreate()
	self:EquipMeltFilterLayerRefresh()
end

function EquipMeltFilterLayer:EquipMeltFilterLayerExit()
 
    if CanMeltFilter == true then
		EquipMeltLayer.meltEquipDataTable = {}
        for i=1,table.maxn(self.meltEquipFilterDataTable) do
		    table.insert(EquipMeltLayer.meltEquipDataTable, self.meltEquipFilterDataTable[i])
	    end
        EquipMeltLayer:EquipMeltLayerRefreshItem()
    else
       EquipMeltLayer:EquipMeltLayerExit()
    end
    
    self.topNode:removeFromParent()
	self.topNode = nil
end

function EquipMeltFilterLayer:EquipMeltFilterLayerCreate()
	local filterLayer = EquipMeltFilterLayerOwner["mEquipMeltFilterChoose"]
	self.filterScroll = cc.ScrollView:create()
	filterLayer:addChild(self.filterScroll)
	self.filterScroll:setViewSize(cc.size(filterLayer:getContentSize().width, filterLayer:getContentSize().height))
	self.filterScroll:setPosition(cc.p(0,0))
	self.filterScroll:ignoreAnchorPointForPosition(true)
	self.filterScroll:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
	self.filterScroll:setClippingToBounds(true)
	self.filterScroll:setBounceable(true)
	self.filterScroll:setDelegate()
	self.filterScroll:setVisible(true)
	
		--swallowLaer
	local function onEquipMeltFilterSwallowTouch(touch, event)
		--print("onPlayerInfoSwallowTouch")
        if CanMeltFilter == false then 
			EquipMeltFilterLayer:EquipMeltFilterLayerExit()
        end
		return true
	end
	SetTouchEventForLayer(EquipMeltFilterLayerOwner["mEquipMeltFilterSwallowLayer"], onEquipMeltFilterSwallowTouch)
end

function EquipMeltFilterLayer:checkHasSelect(nodeIndex)
    for index = 1 , EquipMeltFilterLayer.MeltEquipFilterCount do
        if  EquipMeltFilterLayer.meltEquipFilterDataTable[index].id == EquipMeltFilterLayer.bagEquipList[nodeIndex].id  then
            return index
        end
    end 
    return 0
end

function EquipMeltFilterLayer:MeltItemExternFun(node)
   if node == nil then
      node = self
    end

   local nodeBagPos = node:getTag()
   local hasSelectPos = EquipMeltFilterLayer:checkHasSelect(nodeBagPos)
   local pSelectFlag = tolua.cast(node, "cc.Layer"):getChildByTag(101)
   if hasSelectPos > 0 then
      EquipMeltFilterLayer.MeltEquipFilterCount = EquipMeltFilterLayer.MeltEquipFilterCount - 1
      table.remove(EquipMeltFilterLayer.meltEquipFilterDataTable, hasSelectPos)
      pSelectFlag:setVisible(false)
   elseif hasSelectPos < 1  and EquipMeltFilterLayer.MeltEquipFilterCount < 6 then
      EquipMeltFilterLayer.MeltEquipFilterCount = EquipMeltFilterLayer.MeltEquipFilterCount + 1
      table.insert(EquipMeltFilterLayer.meltEquipFilterDataTable, EquipMeltFilterLayer.bagEquipList[nodeBagPos])
      pSelectFlag:setVisible(true)
   end
end

function EquipMeltFilterLayer:EquipMeltFilterLayerRefresh()
	local scrollLayer = cc.Layer:create()
	scrollLayer:ignoreAnchorPointForPosition(true)
	self.filterScroll:setContainer(scrollLayer)
	local scrollWorldPos = self.filterScroll:getParent():convertToWorldSpace(cc.p(self.filterScroll:getPosition()))
	local scrollViewSize = self.filterScroll:getViewSize()
	local curPosY = 0
	
    self.bagEquipList = {}
	local bagEquipListOrign = UserInfo:getBagEquip()
    for k=1,table.maxn(bagEquipListOrign) do
        local equipDataInfo = bagEquipListOrign[k]
        if not EquipHelper:isRedEquip(equipDataInfo) and (equipDataInfo.stone == CJSON_NULL or table.maxn(equipDataInfo.stone) == 0) then
            table.insert(self.bagEquipList,equipDataInfo)
        end
    end
	table.sort(self.bagEquipList, sortByGradeAndScore)

    EquipMeltFilterLayer.MeltEquipFilterCount = 0 --table.maxn(EquipMeltLayer.meltEquipDataTable)

	EquipMeltFilterLayer.meltEquipFilterDataTable = {}
    for i=1,MELTEQUIP_MAX do
		if EquipMeltLayer.meltEquipDataTable[i] ~= nil then
			table.insert(EquipMeltFilterLayer.meltEquipFilterDataTable, EquipMeltLayer.meltEquipDataTable[i])
			EquipMeltFilterLayer.MeltEquipFilterCount = EquipMeltFilterLayer.MeltEquipFilterCount + 1
		end
	end
    EquipMeltLayer:EquipMeltLayerClearItem()

	local equipCount = table.maxn(EquipMeltFilterLayer.bagEquipList)
    if equipCount < 1 then
        CanMeltFilter = false
        return
    end 
    CanMeltFilter = true
	local i = 1
	while i <= equipCount do

		local itemLayer = CreateMasterFilterItem()
		itemLayer:ignoreAnchorPointForPosition(true)
		itemLayer:setTag(i)
		itemLayer:setScrollViewRect(cc.rect(scrollWorldPos.x, scrollWorldPos.y, scrollViewSize.width, scrollViewSize.height))
        itemLayer:setExternFun(self.MeltItemExternFun)
        	
		local itemBgSprite = cc.Sprite:createWithSpriteFrameName("board_equipchoose.png")
		itemBgSprite:setAnchorPoint(cc.p(0, 0))
		itemLayer:addChild(itemBgSprite)

		local itemRichInfo,realHeight = EquipHelper:CreateEquipDesc(EquipMeltFilterLayer.bagEquipList[i])
		itemRichInfo:ignoreAnchorPointForPosition(true)
		itemRichInfo:setPosition(cc.p(115, realHeight-500 + 30/2))
		itemLayer:setContentSize(496, realHeight + 30)
		itemLayer:addChild(itemRichInfo)
		itemLayer:setPosition(cc.p(0, curPosY))
		curPosY = curPosY + itemLayer:getContentSize().height
		
		EquipHelper:setEquipPlaceNameLabel(itemLayer, EquipMeltFilterLayer.bagEquipList[i])
			
		itemBgSprite:setScaleY(itemLayer:getContentSize().height / itemBgSprite:getSpriteFrame():getRect().height)
		itemLayer:addChild(CreateEquipByInfo(EquipMeltFilterLayer.bagEquipList[i], cc.p(50, itemLayer:getContentSize().height - 60)))

        local pSelectFlag = nil	


		local function takeonMeltEquipment(node)
            EquipMeltFilterLayer:MeltItemExternFun(node:getParent())  
		end
			
        local pSelectFlag = cc.Scale9Sprite:createWithSpriteFrameName("pic_hook.png")
        if  EquipMeltFilterLayer:checkHasSelect(i) > 0 then
            pSelectFlag:setVisible(true)
         else
            pSelectFlag:setVisible(false)
        end
        pSelectFlag:setPosition(cc.p(430, itemLayer:getContentSize().height * 0.4))
		pSelectFlag:setPreferredSize(cc.size(50, 50))
        itemLayer:addChild(pSelectFlag,101,101)

		local pBackgroundButton = cc.Scale9Sprite:createWithSpriteFrameName("board_skill03.png")
		local pTitle = cc.Label:create("", DefaultFontName, FontSize1)
		local takeonButton = cc.ControlButton:create(pTitle, pBackgroundButton)
		takeonButton:setTag(i)
		takeonButton:registerControlEventHandler(takeonMeltEquipment,cc.CONTROL_EVENTTYPE_TOUCH_UP_INSIDE)
		takeonButton:setPosition(pSelectFlag:getPosition())
		takeonButton:setPreferredSize(cc.size(45, 45))
		takeonButton:setScrollViewRect(cc.rect(scrollWorldPos.x, scrollWorldPos.y, scrollViewSize.width, scrollViewSize.height))
		itemLayer:addChild(takeonButton)
			
		scrollLayer:addChild(itemLayer)	
	    --///////////////////////
		i = i+1
	end
	local filterLayer = EquipMeltFilterLayerOwner["mEquipMeltFilterChoose"]
	if scrollLayer:getContentSize().height <= filterLayer:getContentSize().height then
		scrollLayer:setContentSize(cc.size(filterLayer:getContentSize().width, filterLayer:getContentSize().height))
		self.filterScroll:setContentOffset(cc.p(0, 0), false)
	else
		scrollLayer:setContentSize(cc.size(filterLayer:getContentSize().width, curPosY))
		self.filterScroll:setContentOffset(cc.p(0, -scrollLayer:getContentSize().height + filterLayer:getContentSize().height), false)
	end
	self.filterScroll:updateInset()
end

function onEquipMeltFilterLayerClose()
	EquipMeltFilterLayer:EquipMeltFilterLayerExit()
end

EquipMeltFilterLayer["onEquipMeltFilterLayerClose"] = onEquipMeltFilterLayerClose