EquipStoneSet = class("EquipStoneSet")
EquipStoneSet.__index = EquipStoneSet

EquipStoneSet.isCreated = false
EquipStoneSet.topNode = nil
EquipStoneSet.icon = nil
EquipStoneSet.stoneSlot = {}
EquipStoneSet.itemInfo = nil
EquipStoneSet.stoneFilterLayer = nil
EquipStoneSet.stoneFilterScroll = nil

EQUIP_STONE_MAX = 4

ccb["EquipStoneSet"] = EquipStoneSet
EquipStoneSetOwner = EquipStoneSetOwner or {}
ccb["EquipStoneSetOwner"] = EquipStoneSetOwner

function EquipStoneSet:InitAllSlots()
	local equipBgLayer = EquipStoneSetOwner["mEquipStoneBg"]
	self.icon = CreateBagItem()
    self.icon:setItemType(BAG_ITEM_TYPE_EQUIP)
	self.icon:setItemInfoTable(self.itemInfo)
	self.icon:setCanTouch(false)
	self.icon:setPosition(cc.p(285, 390))
	equipBgLayer:addChild(self.icon)
	
	for i = 1, EQUIP_STONE_MAX do
		EquipStoneSet.stoneSlot[i] = CreateBagItem()
		EquipStoneSet.stoneSlot[i]:setPosition(cc.p(55, 170))
		EquipStoneSet.stoneSlot[i]:setItemSprite("board_drilling.png")
		EquipStoneSet.stoneSlot[i]:setItemType(BAG_ITEM_TYPE_EMPTY_SLOT)
		EquipStoneSet.stoneSlot[i]:setItemInfoTable()
		EquipStoneSet.stoneSlot[i]:setTag(i)
		EquipStoneSetOwner["mEquipStone" .. i]:addChild(EquipStoneSet.stoneSlot[i])
	end
end

function EquipStoneSet:RefreshAllSlots()

    local propdetail = GameData:getPropDataTable(self.itemInfo.prop_id)
    local nameStr = "Lv"..propdetail.level.."  "..MultiLan(propdetail.name)
    if self.itemInfo.strengthen > 0 then
       nameStr = nameStr.."  +"..self.itemInfo.strengthen
    end
    tolua.cast(EquipStoneSetOwner["mEquipStoneName"], "cc.Label"):setString(nameStr)

	self.icon:setItemInfoTable(self.itemInfo)
	--EquipStoneSetOwner["mEquipStoneTakeoffAll"]:setEnabled(false)
	for i = 1, EQUIP_STONE_MAX do
		if i <= self.itemInfo.slots then
			if self.itemInfo.stone ~= nil and self.itemInfo.stone ~= CJSON_NULL and i <= table.maxn(self.itemInfo.stone) then
				EquipStoneSet.stoneSlot[i]:setItemSprite("prop_" .. self.itemInfo.stone[i] .. ".png")
				EquipStoneSet.stoneSlot[i]:setCanTouch(false)
				EquipStoneSet.stoneSlot[i]:setItemBack("board_baseboard.png")
				EquipStoneSet.stoneSlot[i]:setItemOutLine("frame_grey.png")
				--EquipStoneSetOwner["mEquipStoneTakeoffAll"]:setEnabled(true)
				local attrTable = {"agi","str","int","sta"}
				local stoneInfo = GameData:getPropDataTable(self.itemInfo.stone[i])
				tolua.cast(EquipStoneSetOwner["mEquipStone" .. i]:getChildByTag(1), "cc.Label"):setString(MultiLan(stoneInfo.name))
				tolua.cast(EquipStoneSetOwner["mEquipStone" .. i]:getChildByTag(2), "cc.Label"):setString(ATTR_DESC[attrTable[stoneInfo.place]] .. " +" .. stoneInfo.attr_value)
			else
				EquipStoneSet.stoneSlot[i]:setItemSprite("board_chooseprop.png")
				EquipStoneSet.stoneSlot[i]:setCanTouch(true)
				tolua.cast(EquipStoneSetOwner["mEquipStone" .. i]:getChildByTag(1), "cc.Label"):setString("")
				tolua.cast(EquipStoneSetOwner["mEquipStone" .. i]:getChildByTag(2), "cc.Label"):setString("")
			end
		else
			EquipStoneSet.stoneSlot[i]:setItemSprite("board_drilling.png")
			EquipStoneSet.stoneSlot[i]:setCanTouch(true)
			tolua.cast(EquipStoneSetOwner["mEquipStone" .. i]:getChildByTag(1), "cc.Label"):setString(MultiLan("ESS_desc_1"))
			tolua.cast(EquipStoneSetOwner["mEquipStone" .. i]:getChildByTag(2), "cc.Label"):setString("")
		end
	end
end

function EquipStoneSet:EquipOpenStoneClick(tagNum)
	if tagNum <= self.itemInfo.slots then
		cclog("stone choose item %d %d", tagNum, self.itemInfo.slots)
		equipStoneFilterOpen()
	else
        if UserInfo:getUserInfo().data.info.level < 20 then
           CommonNote(MultiLan("ESS_poreLvl"))
           return
        end
        
        if tagNum > self.itemInfo.slots + 1 then
           CommonNote(string.format(MultiLan("ESS_noPoreNeeded"),tostring(self.itemInfo.slots + 1)))
           return
        end

		local function equipOpenStoneCallback(jsonDataTable)
			if jsonDataTable.ret ~= 0 then
				cclog("open stone failed %d", jsonDataTable.ret)
				return 
			end

            if self.itemInfo.slots == 0 then
                local slotCost = 1500*GameData:getPropDataTable(self.itemInfo.prop_id).level
                UserInfo:setGold(UserInfo:getGold() - slotCost)
            else
                tumbId = self.itemInfo.slots + 100005
                UserInfo:removepropByPropId(tumbId,1)
            end

			self.itemInfo.slots = self.itemInfo.slots+1
			BagLayer:UpdateItem(self.itemInfo)

			self:RefreshAllSlots()
			
			if self.itemInfo.obj == 0 then
			
			elseif self.itemInfo.obj == 1 and CommonEquipLayer:isVisible() then
				EquipLayer:EquipLayerRefreshItem()
			elseif CommonHeroLayer:isVisible() then
				UpdateHeroInfo()
			end
			CommonNote(MultiLan("ESS_poreSucceed"))
		end
		cclog("open stone %d", tagNum)
        local function sendEquipSlot()

            if self.itemInfo.slots == 0 then
                local slotCost = 1500*GameData:getPropDataTable(self.itemInfo.prop_id).level
                if UserInfo:getUserInfo().data.info.gold < 1500*GameData:getPropDataTable(self.itemInfo.prop_id).level then
                   CommonNote(MultiLan("lan_silverNotEnough"))
                   return
                end
            elseif self.itemInfo.slots == 1 then
                    local haveStrengJin = 0
                    local bagProp = UserInfo:getUserInfo().data.bag_prop
                    for i = 1,table.maxn(bagProp) do
                        if bagProp[i].prop_id == 100006 then
                           haveStrengJin = haveStrengJin + bagProp[i].amount
                        end
                    end

                    if haveStrengJin < 1 then
                        CommonNote(MultiLan("ESS_copperHammerNotEnough"))
                        return
                    end
            elseif self.itemInfo.slots == 2 then
                    local haveStrengJin = 0
                    local bagProp = UserInfo:getUserInfo().data.bag_prop
                    for i = 1,table.maxn(bagProp) do
                        if bagProp[i].prop_id == 100007 then
                           haveStrengJin = haveStrengJin + bagProp[i].amount
                        end
                    end

                    if haveStrengJin < 1 then
                        CommonNote(MultiLan("ESS_silverHammerNotEnough"))
                        return
                    end
            elseif self.itemInfo.slots == 3 then
                    local haveStrengJin = 0
                    local bagProp = UserInfo:getUserInfo().data.bag_prop
                    for i = 1,table.maxn(bagProp) do
                        if bagProp[i].prop_id == 100008 then
                           haveStrengJin = haveStrengJin + bagProp[i].amount
                        end
                    end

                    if haveStrengJin < 1 then
                        CommonNote(MultiLan("ESS_goldHammerNotEnough"))
                        return
                    end
            else
                cclog("open stone")
                return
             end

            HttpSend("equip/slot", {"id=" .. self.itemInfo.id}, equipOpenStoneCallback)
        end

		local equipSlotNeedStr = nil
        if self.itemInfo.slots == 0 then
            local slotCost = 1500*GameData:getPropDataTable(self.itemInfo.prop_id).level
            equipSlotNeedStr = string.format(MultiLan("ESS_poreNeeded_1"),tostring(slotCost))
        elseif self.itemInfo.slots == 1 then
            equipSlotNeedStr = MultiLan("ESS_poreNeeded_2")
        elseif self.itemInfo.slots == 2 then
            equipSlotNeedStr = MultiLan("ESS_poreNeeded_3")
        elseif self.itemInfo.slots == 3 then
            equipSlotNeedStr = MultiLan("ESS_poreNeeded_4")
        else
           cclog("open stone %d", tagNum)
           return
        end
        local content = cc.Label:create(equipSlotNeedStr, DefaultFontName, FontSize3,cc.size(460,160),0,1)
        CreateSmallPopupWithCancel("dighole",content, sendEquipSlot)
	end
end

function EquipStoneSet:EquipStoneSetEnter(infoTable)
	if self.isCreated then
		cclog("equip stone set enter")
		self.topNode:setVisible(true)
		self.itemInfo = infoTable
	else
		self.isCreated = true
		
		local proxy = cc.CCBProxy:create()
		self.topNode = CommonCreatePopup(CCBReaderLoad("ccb/EquipStoneSet.ccbi", proxy, EquipStoneSetOwner))
		--ccb多语言
		EquipStoneSetOwner["mDesc"]:setString(MultiLan("stoneset_desc1"))
		EquipStoneSetOwner["mButtonUnload"]:setTitleForState(MultiLan("stoneset_unload"), 1)
		EquipStoneSetOwner["mTitleEquipStone"]:setString(ZGMultiLan("equip_stone_title"))
		
		self.itemInfo = infoTable
		self:InitAllSlots()
		
		self.stoneFilterLayer = createMiddleEquipPopupBoard("title_gemchoose.png")
		self.stoneFilterLayer:setVisible(false)
		POPUP_LAYER:addChild(self.stoneFilterLayer)
		
		local closeButton = tolua.cast(self.stoneFilterLayer:getChildByTag(1):getChildByTag(3), "cc.ControlButton")
		closeButton:registerControlEventHandler(equipStoneFilterClose,cc.CONTROL_EVENTTYPE_TOUCH_UP_INSIDE)
		local chacha = tolua.cast(self.stoneFilterLayer:getChildByTag(1):getChildByTag(4), "cc.ControlButton")
		chacha:registerControlEventHandler(equipStoneFilterClose,cc.CONTROL_EVENTTYPE_TOUCH_UP_INSIDE)
		
		self:EquipStoneFilterScrollCreate()
	end
	self:RefreshAllSlots()
end

function EquipStoneSet:EquipStoneSetExit()
	self.topNode:setVisible(false)
end

function EquipStoneSet:EquipStoneFilterScrollCreate()
	local filterLayer = self.stoneFilterLayer:getChildByTag(1):getChildByTag(2)
	self.stoneFilterScroll = cc.ScrollView:create()
	filterLayer:addChild(self.stoneFilterScroll)
	self.stoneFilterScroll:setViewSize(cc.size(filterLayer:getContentSize().width, filterLayer:getContentSize().height))
	self.stoneFilterScroll:setPosition(cc.p(0,0))
	self.stoneFilterScroll:ignoreAnchorPointForPosition(true)
	self.stoneFilterScroll:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL )
	self.stoneFilterScroll:setClippingToBounds(true)
	self.stoneFilterScroll:setBounceable(true)
	self.stoneFilterScroll:setDelegate()
	self.stoneFilterScroll:setVisible(true)
end

function EquipStoneSet:EquipStoneFilterScrollRefresh()
	local LINE_MAX = 5	--一行几个格子
	local GRID_WIDTH = 100	--每个格子大小
	
	local filterLayer = self.stoneFilterLayer:getChildByTag(1):getChildByTag(2)
	local stoneInsideLayer = cc.Layer:create()
	stoneInsideLayer:ignoreAnchorPointForPosition(true)
	self.stoneFilterScroll:setContainer(stoneInsideLayer)
	
	local lineCount = math.ceil(table.maxn(UserInfo:getUserInfo().data.bag_prop) / LINE_MAX)	--一共几行
	if lineCount <= 5 then
		stoneInsideLayer:setContentSize(filterLayer:getContentSize().width, filterLayer:getContentSize().height)
		self.stoneFilterScroll:setContentOffset(cc.p(0, 0), false)
	else
		stoneInsideLayer:setContentSize(filterLayer:getContentSize().width, lineCount * GRID_WIDTH)
		self.stoneFilterScroll:setContentOffset(cc.p(0, -stoneInsideLayer:getContentSize().height + filterLayer:getContentSize().height), false)
	end
	local equipScrollWorldPos = self.stoneFilterScroll:getParent():convertToWorldSpace(cc.p(self.stoneFilterScroll:getPosition()))
	local equipScrollViewSize = self.stoneFilterScroll:getViewSize()
	local index = 1
	for i = 1, table.maxn(UserInfo:getUserInfo().data.bag_prop) do
		local propId = UserInfo:getUserInfo().data.bag_prop[i].prop_id
		local propInfoTable = GameData:getPropDataTable(propId)
		if propInfoTable.ptype == PROP_TYPE_GEM then		--6是宝石
			local bagItem = CreateBagItem()
			bagItem:setItemType(BAG_ITEM_TYPE_STONE)
			bagItem:setItemInfoTable(UserInfo:getUserInfo().data.bag_prop[i])
			bagItem:setScrollViewRect(cc.rect(equipScrollWorldPos.x, equipScrollWorldPos.y, equipScrollViewSize.width, equipScrollViewSize.height))
			local tmp = math.mod((index-1), LINE_MAX)
			local tmp2 = math.floor((index-1) / LINE_MAX) + 1
			--cclog("%d tmp is %d, tmp2 %d", i, tmp, tmp2)
			bagItem:setPosition(cc.p(filterLayer:getContentSize().width * (0.1 + 0.2 * tmp), stoneInsideLayer:getContentSize().height - tmp2 * GRID_WIDTH + GRID_WIDTH * 0.5))
			stoneInsideLayer:addChild(bagItem)
			index = index + 1
		end
	end
	self.stoneFilterScroll:updateInset()
end

function EquipStoneSet:EquipStoneClick(stoneInfo)
    local Id = stoneInfo.id
	local function equipStoneClickCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			cclog("equip stone set failed %d", jsonDataTable.ret)
			return 
		end
		
		if self.itemInfo.stone == nil or self.itemInfo.stone == CJSON_NULL then
			self.itemInfo.stone = {}
		end
		local removePropInfo = BagLayer:removePropFromBag(Id, 1)
		if removePropInfo ~= nil then
			table.insert(self.itemInfo.stone, removePropInfo.prop_id)
			BagLayer:UpdateItem(self.itemInfo)
		end
		self:RefreshAllSlots()
		equipStoneFilterClose()
		
		UserAttr:equipAttrChange(self.itemInfo.obj, true)
	end
    if self.itemInfo.stone ~= nil and self.itemInfo.stone ~= CJSON_NULL then
        local selectStonePlace = GameData:getPropDataTable(stoneInfo.prop_id).place
        for i=1,table.maxn(self.itemInfo.stone) do
            if GameData:getPropDataTable(self.itemInfo.stone[i]).place == selectStonePlace then
                CommonNote(MultiLan("ESS_jewelSame"))
                return
            end
        end
    end

	cclog("equip stone click %d", Id)
	HttpSend("equip/stone", {"id=" .. self.itemInfo.id, "stone=" .. Id}, equipStoneClickCallback)
end

function equipStoneFilterClose()
	EquipStoneSet.stoneFilterLayer:setVisible(false)
end

function equipStoneFilterOpen()
	EquipStoneSet.stoneFilterLayer:setVisible(true)
	EquipStoneSet:EquipStoneFilterScrollRefresh()
end

local function onEquipStoneClose()
	EquipStoneSet:EquipStoneSetExit()
end

local function onEquipStoneTakeoffAll()
	local function equipStoneTakeoffAllCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			cclog("equip stone takeoff failed %d", jsonDataTable.ret)
			return 
		end

		EquipStoneSet.itemInfo = UserInfo:setEquipByIdAndObj(jsonDataTable.data.equip)
		UserInfo:addProp(jsonDataTable.data.stone)
		EquipStoneSet:RefreshAllSlots()
		UserAttr:equipAttrChange(jsonDataTable.data.equip.obj, true)
		BagLayer:setDirty(true)
	end
    if EquipStoneSet.itemInfo.stone == nil or EquipStoneSet.itemInfo.stone == CJSON_NULL  or table.maxn(EquipStoneSet.itemInfo.stone) < 1 then
       CommonNote(MultiLan("ESS_noJewel"))
    else
       HttpSend("equip/unloadstone", {"id=" .. EquipStoneSet.itemInfo.id, "stone=" .. 0}, equipStoneTakeoffAllCallback)
    end
	
end

local function onEquipStoneSetHelp()
	HelpPopup("stoneload")
end

EquipStoneSet["onEquipStoneClose"] = onEquipStoneClose
EquipStoneSet["onEquipStoneTakeoffAll"] = onEquipStoneTakeoffAll
EquipStoneSet["onEquipStoneSetHelp"] = onEquipStoneSetHelp