
local bActInited = false
local ACT_MAIN_COUNT = 4  --活动主界面显示的活动数量
Activity_ActArr = {}

UserActiveInfo = nil --活动总入口

local VicActShowTag = 0
local bForeignVersion = false

NEW_PAY_DAYS = 10 --新手累计充值时间
REWARD_LEVEL = 10 --领取额外经验需要与世界等级相差的等级
ACT_LEVEL_COST1 = 20000
ACT_LEVEL_COST2 = 15

--活动类型
ACT_TYPE_CONPAY      = 0 --连续充值  
ACT_TYPE_CONPAY_TEMP = 0 --临时连续充值        
ACT_TYPE_NEW         = 0 --新手
ACT_TYPE_VIP_FREE    = 0 --VIP福利
ACT_TYPE_PAY         = 0 --新手累计充值
ACT_TYPE_PAY_TEMP    = 0 --临时累计充值
ACT_TYPE_FREE        = 0 --免费年卡
ACT_TYPE_VIP_GIFT    = 0 --临时累计充值
ACT_TYPE_EXC         = 0 --收集换大礼
ACT_TYPE_FIRST       = 0 --首冲奖励说明
ACT_TYPE_LIST        = 0 --冲榜奖励说明
ACT_TYPE_LEVEL       = 0 --世界等级
ACT_TYPE_DAILY       = 0 --每日消费
ACT_TYPE_ZHUAN       = 0 --转盘
ACT_TYPE_SHOP        = 0 --云游商人

GameActShowTag = 0

local bActExcInit = false
local actExcChooseTag = nil
local ActWorldLevel = 0
local ActLevelRewardHour = 0

--根据剩余时间返回描述字符串 type1为XX天XX小时XX分钟(向下取整) type2为XX小时(向上取整) 
function TurnSecendsToDay(t, tType)
	local day = math.floor(t/24/3600)
	local hour = math.floor((t - 24*3600*day)/3600)
	local minute = math.floor((t - 24*3600*day - 3600*hour)/60)
	local str = ""
	
	if tType == nil or tType == 1 then
		if day ~= 0 then
			str = str..day.." "..MultiLan("lan_day").." "
		end
		if hour ~= 0 then
			str = str..hour.." "..MultiLan("lan_hour").." "
		end
		if minute >= 0 then
			if day == 0 and hour == 0 and minute == 0 then
				minute = 1
			end
			str = str..minute.." "..MultiLan("lan_minute")
		end

		if t <= 0 then
			str = MultiLan("GAL_actStateFinish")
		end
	elseif tType == 2 then
		hour = math.ceil(t/3600)
		if hour ~= 0 then
			str = str..hour..MultiLan("lan_hour")
		end
	end	
	
	return str
end

--根据服务器的数据创建奖励显示
function createRewardLayer(itemTable)
	local width = 90+20
	local count = table.maxn(itemTable)
	local layer = CreateLayer(cc.size(width*count,90), 1)
	local x,y = width/2,45
	
	local colorDesc = {MultiLan("lan_white"), MultiLan("lan_green"),MultiLan("lan_blue"), MultiLan("lan_purple"), MultiLan("lan_orange"),MultiLan("lan_artifact")}
	for i=1, count do
		
		local staticData = GameData:getPropDataTable(itemTable[i].prop_id)
		--print(i,itemTable[i].prop_id,staticData.ptype)
		local quality = 1
		if staticData.ptype == 7 then
			quality = itemTable[i].num + 1
		else
		    quality = staticData.color
		end
		layer:addChild(CreateCommonSprite("prop_"..itemTable[i].prop_id..".png", cc.p(x,45)))
		local frameSprite = CreateCommonSprite(FRAME_ICON_ARR[quality], cc.p(x,45))
		layer:addChild(frameSprite)
		if staticData.ptype == 7 then
			layer:addChild(CreateCommonLabel(string.format(MultiLan("GAL_equipExplain"),MultiLan("equip_place_" .. staticData.place),staticData.level), cc.p(x,-15), FontSize1))
			if quality == 6 then
				AddMasterEffect(frameSprite, Pos(frameSprite:getContentSize()))
			end
		else
			layer:addChild(CreateCommonLabel(MultiLan(staticData.name), cc.p(x,-5), FontSize1))
			layer:addChild(CreateCommonLabel("x"..itemTable[i].num, cc.p(x,-25), FontSize1))
		end
	
		x = x + width
	end

	return layer
end

--根据服务器的数据创建道具收集显示
function createCollectLayer(itemTable)
	local width = 90+20
	local count = table.maxn(itemTable)
	local layer = CreateLayer(cc.size(width*count,90), 1)
	local x,y = width/2,45
	
	for i=1, count do
		local dynamicData = UserInfo:getPropByPropid(itemTable[i].prop_id)
		local staticData = GameData:getPropDataTable(itemTable[i].prop_id)

		local totleNeed = itemTable[i].num
		local haveCount = 0
		if dynamicData ~= nil then
			haveCount = dynamicData.amount
		end

		layer:addChild(CreateCommonSprite("prop_"..itemTable[i].prop_id..".png", cc.p(x,45)))
		local frameSprite = CreateCommonSprite(FRAME_ICON_ARR[staticData.color], cc.p(x,45))
		layer:addChild(frameSprite)
		local countLabel = CreateCommonLabel(haveCount.."/"..totleNeed, cc.p(x,-15), FontSize1)
		layer:addChild(countLabel)

		if haveCount < totleNeed then
			countLabel:setColor(COLOR_RED)
		end
	
		x = x + width
	end

	return layer
end

--从其他界面跳转到活动界面的公共处理
function JumpToActInit()
	if not CommonActLayer:isVisible() then
		ActLayerInit()
		ActSetMain()
		CommonActLayer:setVisible(true)
		CommonHomeLayer:setVisible(false)
		resetActLayer()
		XiaLayerOwner["mActMain"]:setVisible(false)
	end
end

--刷新连续充值
local function refreshConScroll(actConInfo)
    --奖励
	local height = 170
	local count = table.maxn(actConInfo.reward)
	local fatherHeight = XiaLayerOwner["mActConScroll"]:getContentSize().height
	local y = math.max(fatherHeight-0.5*height, (count - 0.5)*height)
	local layer = cc.Layer:create()
	
	local function SendConReward(node)
		local function conpayRewardCallback(jsonDataTable)
			if jsonDataTable.ret == 0 then
				--添加道具
				UserInfo:addProp(jsonDataTable.data.items)
				UserInfo:addPropNote(jsonDataTable.data.items)
				
				--修改数据
				if ACT_TYPE_CONPAY == GameActShowTag then
					UserSelfInfo.conpay_reward = UserSelfInfo.conpay_reward + math.pow(2, jsonDataTable.data.days-1)
				elseif ACT_TYPE_CONPAY_TEMP == GameActShowTag then
					UserSelfInfo.actconpay_reward = UserSelfInfo.actconpay_reward + math.pow(2, jsonDataTable.data.days-1)
				end
				
				
				--刷新界面
				node:setVisible(false)
				
				if ACT_TYPE_CONPAY == GameActShowTag then
					Activity_ActArr[ACT_TYPE_CONPAY].canReward = IsConpayCanReward(Activity_ActArr[ACT_TYPE_CONPAY].info)
					if Activity_ActArr[ACT_TYPE_CONPAY].canReward == false and Activity_ActArr[ACT_TYPE_CONPAY].noteNode ~= nil then
						removeSelf(Activity_ActArr[ACT_TYPE_CONPAY].noteNode)
					end
				elseif ACT_TYPE_CONPAY_TEMP == GameActShowTag then
					Activity_ActArr[ACT_TYPE_CONPAY_TEMP].canReward = IsTempConpayCanReward(Activity_ActArr[ACT_TYPE_CONPAY_TEMP].info)
					if Activity_ActArr[ACT_TYPE_CONPAY_TEMP].canReward == false and Activity_ActArr[ACT_TYPE_CONPAY_TEMP].noteNode ~= nil then
						removeSelf(Activity_ActArr[ACT_TYPE_CONPAY_TEMP].noteNode)
					end
				end
			end
		end
		--CommonNote("假数据")
		print(node:getTag())
		
		if ACT_TYPE_CONPAY == GameActShowTag then
			HttpSend("activity/conpayaward", {"days="..node:getTag()}, conpayRewardCallback)
		elseif ACT_TYPE_CONPAY_TEMP == GameActShowTag then
			HttpSend("activity/actconpayaward", {"days="..node:getTag()}, conpayRewardCallback)
		end
	end

	local curConDay = UserSelfInfo.conpay_days
	local rewardTag = UserSelfInfo.conpay_reward
	if ACT_TYPE_CONPAY_TEMP == GameActShowTag then
		curConDay = UserSelfInfo.actconpay_days
		rewardTag = UserSelfInfo.actconpay_reward
	end
	for i=1,count do
		local back = CreateCommonSprite("board_moneyagae.png", cc.p(320,y))
		back:setScale(0.96)
		layer:addChild(back)
		back:addChild(CreateCommonSprite("board_moneyagag.png", Pos(back:getContentSize(),0.29,0.87)))
		back:addChild(CreateCommonLabel(string.format(MultiLan("GAL_continueCharge"), i), Pos(back:getContentSize(),0.03,0.87), FontSize4, COLOR_YELLOW,cc.p(0,0.5)))
		local getButton = CreateCommonButton("button_green.png", Pos(back:getContentSize(),0.83,0.5), cc.size(158,67), SendConReward,{str=MultiLan("button_collect"),size = FontSize3})
		getButton:setSwallowTouch(false)
		back:addChild(getButton,0,i)
		
		local itemLayer = createRewardLayer(actConInfo.reward[i])
		itemLayer:setAnchorPoint(cc.p(0,0.5))
		itemLayer:setPosition(Pos(back:getContentSize(),0.01,0.49))
		back:addChild(itemLayer)
		print("rewardTag")
		local bit = rewardTag%2
		print(i, bit)
		rewardTag = math.floor(rewardTag/2)
		if i > curConDay or bit == 1  then --已领取
			getButton:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_gray.png"), cc.CONTROL_STATE_NORMAL)
			getButton:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_gray.png"), cc.CONTROL_STATE_HIGH_LIGHTED)
			getButton:setEnabled(false)
			if bit == 1 then
				getButton:setTitleForState(MultiLan("GAL_collected"), cc.CONTROL_STATE_DISABLED)
				--getButton:setVisible(false)
			end
		end
		y = y - height
	end

	layer:setContentSize(cc.size(640, math.max(fatherHeight, count*height)))
	local scrolView = CreateScrollViewByFather(XiaLayerOwner["mActConScroll"], layer, cc.p(0, math.min(0,fatherHeight-count*height)), kScrollViewDirectionVertical)
end

--刷新累计充值说明
local function refreshPayScroll(t)
	debug.traceback("1","1")
	print("refreshPayScroll", t)
	if t == nil or t == CJSON_NULL then
		CreateRichtextByFather(XiaLayerOwner["mActPayScroll"], nil, true)
		return
	end
	
	local color = {COLOR_GREEN, COLOR_RED, COLOR_WHITE, COLOR_WHITE, COLOR_GREEN, COLOR_PURPLE}
	local size  = {FontSize2,FontSize2,FontSize2,FontSize2,FontSize2}
	local textArr = {}
	local bFirst = true
	for i=1,table.maxn(t) do
		if t[i].t == 4 then
			table.insert(textArr, {size=nil})
		else
			table.insert(textArr, {size=size[t[i].t], color=color[t[i].t],str=MultiLan(t[i].d)})
		end
	end
	
	CreateRichtextByFather(XiaLayerOwner["mActPayScroll"], textArr, true, true)
end
---服务端数据奖励刷新
local function refreshPayScrollWithServerData(t)
	print("refreshPayScrollWithServerData", t)
	if t == nil or t == CJSON_NULL then
		CreateRichtextByFather(XiaLayerOwner["mActPayScroll"], nil, true)
		return
	end
	local colorDesc = {MultiLan("lan_white"), MultiLan("lan_green"),MultiLan("lan_blue"), MultiLan("lan_purple"), MultiLan("lan_orange"),MultiLan("lan_artifact")}
	local color = {COLOR_GREEN, COLOR_RED, COLOR_WHITE, COLOR_WHITE, COLOR_GREEN, COLOR_PURPLE}
	local size  = {FontSize2,FontSize2,FontSize2,FontSize2,FontSize2}
	local textArr = {}
	local bFirst = true
	-- for i=1,table.maxn(t) do
	-- 	if t[i].t == 4 then
	-- 		table.insert(textArr, {size=nil})
	-- 	else
	-- 		table.insert(textArr, {size=size[t[i].t], color=color[t[i].t],str=MultiLan(t[i].d)})
	-- 	end
	-- end
	print("-----------------------------"..table.maxn(t))
	for i =1 ,table.maxn(t) do
		table.insert(textArr, {size=FontSize2, color=color[3],str=MultiLan("CL_vipPrivilege_2")})
		table.insert(textArr, {size=FontSize2, color=color[1],str=t[i].price..MultiLan("prop_name_100001")})
		table.insert(textArr, {size=FontSize2, color=color[3],str=MultiLan("help_endlessCharge_frsh1_3")})
		local items = t[i].items
		local mark = 0
		for k,v in pairs(items) do
			if mark ~= 0 then
				table.insert(textArr, {size=FontSize2, color=color[1],str=","})
			end
			local item = GameData:getPropDataTable(v.id)
			for m, t in pairs(item) do
				print(m.."------------------------"..t)
			end
			if item.ptype == 7 then
				table.insert(textArr, {size=FontSize2, color=color[1],str=MultiLan(item.name)..colorDesc[item.color]})
			else
				table.insert(textArr, {size=FontSize2, color=color[1],str=MultiLan(item.name).."*"..v.num})
			end
			mark = mark +1
		end
		table.insert(textArr, {size=nil})
	end
	table.insert(textArr, {size=FontSize2, color=color[3],str=MultiLan("help_endlessCharge_frsh5_31")})
	CreateRichtextByFather(XiaLayerOwner["mActPayScroll"], textArr, true, true)
end
--设置连续充值活动
function setConAct(node)
	local actInfo = Activity_ActArr[ACT_TYPE_CONPAY]
	if actInfo == nil then
		print("setConAct wrong tag %s", ACT_TYPE_CONPAY)
		return
	end
	-- XiaLayerOwner["mActConTitle"]:setSpriteFrame("pic_xinshoulxchz.png")
	XiaLayerOwner["lbActConTitle"]:setString(ZGMultiLan("lbActConTitleConPayNew"))
	XiaLayerOwner["mActConBack"]:setSpriteFrame(actInfo.back)
	actInfo.layer:setVisible(true)
	CreateRichtextByFather(XiaLayerOwner["mActConDesc"], 
							{{str=MultiLan("GAL_remindTime"), size=FontSize4},
							 {str=TurnSecendsToDay(TimeDown:getTimeById(actInfo.timerId)), size=FontSize3, color=COLOR_GREEN},
							 {size = nil},
							 {str=MultiLan("GAL_Chargeday_1"), size=FontSize4},
							 {str=UserSelfInfo.conpay_days..MultiLan("GAL_Chargeday_2"), size=FontSize3, color=COLOR_YELLOW}
							 }, true)
							 
	refreshConScroll(Activity_ActArr[ACT_TYPE_CONPAY].info)
end

--设置临时连续充值活动
function setTempConAct(node) 
	local actInfo = Activity_ActArr[ACT_TYPE_CONPAY_TEMP]
	if actInfo == nil then
		print("setConAct wrong tag %s", ACT_TYPE_CONPAY_TEMP)
		return
	end
	-- XiaLayerOwner["mActConTitle"]:setSpriteFrame("title_moneyag.png")
	XiaLayerOwner["lbActConTitle"]:setString(ZGMultiLan("lbActConTitleConPay"))
	XiaLayerOwner["mActConBack"]:setSpriteFrame(actInfo.back)
	actInfo.layer:setVisible(true)
	CreateRichtextByFather(XiaLayerOwner["mActConDesc"], 
							{{str=MultiLan("GAL_remindTime"), size=FontSize4},
							 {str=TurnSecendsToDay(TimeDown:getTimeById(actInfo.timerId)), size=FontSize4, color=COLOR_GREEN},
							 {size = nil},
							 {str=MultiLan("GAL_Chargeday_1"), size=FontSize4},
							 {str=UserSelfInfo.actconpay_days..MultiLan("GAL_Chargeday_2"), size=FontSize4, color=COLOR_YELLOW}
							 }, true)
							 
	refreshConScroll(Activity_ActArr[ACT_TYPE_CONPAY_TEMP].info)
end

--刷新连续充值
local function refreshDailyScroll(actDailyInfo)
    --奖励
	local height = 170
	local count = table.maxn(actDailyInfo.reward)
	local fatherHeight = XiaLayerOwner["mActConScroll"]:getContentSize().height
	local y = math.max(fatherHeight-0.5*height, (count - 0.5)*height)
	local layer = cc.Layer:create()
	
	local function SendDailyReward(node)
		local function conpayRewardCallback(jsonDataTable)
			if jsonDataTable.ret == 0 then
				--添加道具
				UserInfo:addProp(jsonDataTable.data.items)
				UserInfo:addPropNote(jsonDataTable.data.items)
				
				--修改数据
				Activity_ActArr[ACT_TYPE_DAILY].info.accpay_reward = Activity_ActArr[ACT_TYPE_DAILY].info.accpay_reward + math.pow(2, jsonDataTable.data.idx -1)

				--刷新界面
				node:setVisible(false)
				
				Activity_ActArr[ACT_TYPE_DAILY].canReward = IsDailyCanReward(Activity_ActArr[ACT_TYPE_DAILY].info)
				if Activity_ActArr[ACT_TYPE_DAILY].canReward == false and Activity_ActArr[ACT_TYPE_DAILY].noteNode ~= nil then
					removeSelf(Activity_ActArr[ACT_TYPE_DAILY].noteNode)
				end
			end
		end

		HttpSend("activity/dailypayaward", {"id="..node:getTag()}, conpayRewardCallback)
	end

	local curCost = actDailyInfo.accpay
	local rewardTag = actDailyInfo.accpay_reward
	for i=1,count do
		local back = CreateCommonSprite("board_moneyagae.png", cc.p(320,y))
		back:setScale(0.96)
		layer:addChild(back)
		back:addChild(CreateCommonSprite("board_moneyagag.png", Pos(back:getContentSize(),0.29,0.87)))
		back:addChild(CreateCommonLabel(string.format(MultiLan("GAL_daily_desc_2"), actDailyInfo.reward[i].price), Pos(back:getContentSize(),0.03,0.87), FontSize4, COLOR_YELLOW,cc.p(0,0.5)))
		local getButton = CreateCommonButton("button_green.png", Pos(back:getContentSize(),0.83,0.5), cc.size(158,67), SendDailyReward,{str=MultiLan("button_collect"),size = FontSize3})
		getButton:setScale(0.9)
		getButton:setSwallowTouch(false)
		back:addChild(getButton,0,i)
		print("itemLayer", i, table.maxn(actDailyInfo.reward[i].items))
		local itemLayer = createRewardLayer(actDailyInfo.reward[i].items)
		itemLayer:setAnchorPoint(cc.p(0,0.5))
		itemLayer:setPosition(Pos(back:getContentSize(),0.01,0.49))
		itemLayer:setScale(0.8)
		back:addChild(itemLayer)
		print("rewardTag")
		local bit = rewardTag%2
		print(i, bit)
		rewardTag = math.floor(rewardTag/2)
		if actDailyInfo.reward[i].price > curCost or bit == 1  then --已领取
			getButton:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_gray.png"), cc.CONTROL_STATE_NORMAL)
			getButton:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_gray.png"), cc.CONTROL_STATE_HIGH_LIGHTED)
			getButton:setEnabled(false)
			if bit == 1 then
				getButton:setTitleForState(MultiLan("GAL_collected"), cc.CONTROL_STATE_DISABLED)
				--getButton:setVisible(false)
			end
		end
		y = y - height
	end

	layer:setContentSize(cc.size(640, math.max(fatherHeight, count*height)))
	local scrolView = CreateScrollViewByFather(XiaLayerOwner["mActConScroll"], layer, cc.p(0, math.min(0,fatherHeight-count*height)), kScrollViewDirectionVertical)
end

--设置消耗返奖
function setDailyAct(node)
	local actInfo = Activity_ActArr[ACT_TYPE_DAILY]
	if actInfo == nil then
		print("setConAct wrong tag %s", ACT_TYPE_DAILY)
		return
	end
	-- XiaLayerOwner["mActConTitle"]:setSpriteFrame("title_nxiaof.png")
	XiaLayerOwner["lbActConTitle"]:setString(ZGMultiLan("lbActConTitleNxf"))
	XiaLayerOwner["mActConBack"]:setSpriteFrame(actInfo.back)
	actInfo.layer:setVisible(true)
	local function refreshDailyCostAct()
		print("refreshDailyCostAct", actInfo.info.accpay)
		CreateRichtextByFather(XiaLayerOwner["mActConDesc"], 
								{{str=MultiLan("GAL_remindTime"), size=FontSize4},
								 {str=TurnSecendsToDay(TimeDown:getTimeById(actInfo.timerId)), size=FontSize4, color=COLOR_GREEN},
								 {size = nil},
								 {str=MultiLan("GAL_daily_desc_1"), size=FontSize4},
								 {str=actInfo.info.accpay, size=FontSize4, color=COLOR_YELLOW}
								 }, true)
								 
		refreshDailyScroll(Activity_ActArr[ACT_TYPE_DAILY].info)
	end
	refreshDailyCostAct()
	
	local function conpayRewardCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			local oldCount = actInfo.info.accpay
			actInfo.info.accpay = jsonDataTable.data.accpay

			if oldCount ~= jsonDataTable.data.accpay then
				refreshDailyCostAct()
			end
		end
	end

	HttpSend("activity/dailypayinfo", {}, conpayRewardCallback)
end

--设置新手活动
function setNewAct(node)
	local actInfo =  Activity_ActArr[ACT_TYPE_NEW]
	if actInfo == nil then
		return
	end

	actInfo.layer:setVisible(true)

	local descTable = {MultiLan("GAL_freshmanAct_1"),
						MultiLan("GAL_freshmanAct_2"),
						MultiLan("GAL_freshmanAct_3"),
						MultiLan("GAL_freshmanAct_4"),
						MultiLan("GAL_freshmanAct_5"),
						MultiLan("GAL_freshmanAct_6"),
						MultiLan("GAL_freshmanAct_7"),
						MultiLan("GAL_freshmanAct_8")}
	
	local richtextArr = {}	
	for i=1,8 do
		if UserSelfInfo.regdays == i then
			table.insert(richtextArr,{size=FontSize3, str=descTable[i],color=COLOR_ORANGE})
		else
			table.insert(richtextArr,{size=FontSize3, str=descTable[i],color=COLOR_GREEN})
		end
		table.insert(richtextArr,{size=nil})
	end
	CreateRichtextByFather(XiaLayerOwner["mActNewDesc2"], richtextArr)
	
	XiaLayerOwner["mActNewCurrent"]:setString(string.format(MultiLan("GAL_freshmanActCur"),tostring(UserSelfInfo.regdays)))
	XiaLayerOwner["mActNewCurrent"]:setColor(COLOR_ORANGE)
end

--设置Vip奖励
local function refreshVipScroll()
    --奖励
	local vipRewardData = GameData:getGameDataTable().vip_benefit
	local height = 141
	local count = table.maxn(vipRewardData)
	local fatherHeight = XiaLayerOwner["mActVipScroll"]:getContentSize().height
	local y = math.max(fatherHeight-0.5*height, (count - 0.5)*height)
	local layer = cc.Layer:create()
	local offsetPos = count
	for i=1,count do
		local back = CreateCommonSprite("board_vipfl.png", cc.p(320,y))
		--back:setScale(0.96)
		layer:addChild(back)
		
		local itemLayer = createRewardLayer(vipRewardData[i])
		itemLayer:setAnchorPoint(cc.p(0,0.5))
		itemLayer:setPosition(Pos(back:getContentSize(),0.01,0.59))
		back:addChild(itemLayer)
		print("rewardTag")
		
		local vipSprite = CreateCommonSprite("vip.png", Pos(back:getContentSize(),0.8,0.5), 1.5)
		back:addChild(vipSprite)
		
		local label = cc.LabelBMFont:create(i, "ccb/ccbResources/bmfont_vip.fnt")
		label:setScale(1.5)
		label:setAnchorPoint(cc.p(0,0.55))
		label:setPosition(cc.p(vipSprite:getPositionX()+vipSprite:getContentSize().width*1.5/2+5, vipSprite:getPositionY()))
		back:addChild(label)
		
		--back:addChild(CreateCommonLabel("VIP"..i, Pos(back:getContentSize(),0.7,0.5), FontSize3))
		if UserSelfInfo.vip == i then
			VicActShowTag = i
			back:addChild(CreateCommonSprite("pic_yourvip.png", Pos(back:getContentSize())))
			if i > 1 then
				offsetPos = count - (i-1)
			end
		end
		
		y = y - height
	end

	layer:setContentSize(cc.size(640, math.max(fatherHeight, count*height)))
	local scrolView = CreateScrollViewByFather(XiaLayerOwner["mActVipScroll"], layer, cc.p(0, math.min(0,fatherHeight-offsetPos*height)), kScrollViewDirectionVertical)
end

local function SendVipGiftReward(node)
	local tag = node:getTag()
	local vipRewardData = GameData:getGameDataTable().vipgift
	if FindValue(UserSelfInfo.vip_gift, tag) then
		return
	end
	
	if UserSelfInfo.vip + 1 < tag then
		CommonNote(string.format(MultiLan("GAL_vip_desc3"), tostring(tag-1)))
		return
	end
	
	local function sendVipGiftBuy()
		if UserSelfInfo.cash < vipRewardData[tag].cash then
			CommonCashNeed()
			return 
		end
	
		local function vipGiftCallback(jsonDataTable)
			if jsonDataTable.ret == 0 then
				--添加道具
				UserInfo:addProp(jsonDataTable.data.items)
				UserInfo:addPropNote(jsonDataTable.data.items)
				
				--修改数据
				table.insert(UserSelfInfo.vip_gift, jsonDataTable.data.id)
				UserSelfInfo.cash = UserSelfInfo.cash - jsonDataTable.data.cash
				UseCash(jsonDataTable.data.cash)

				local getButton = tolua.cast(node, "cc.ControlButton")
				getButton:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_gray.png"), cc.CONTROL_STATE_NORMAL)
				getButton:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_gray.png"), cc.CONTROL_STATE_HIGH_LIGHTED)
				getButton:setTitleForState(MultiLan("button_buyyet"),  cc.CONTROL_STATE_NORMAL)
				getButton:setTitleForState(MultiLan("button_buyyet"),  cc.CONTROL_STATE_HIGH_LIGHTED)
				getButton:setEnabled(false)
			end
		end
		
		HttpSend("shop/buyvipgift", {"id="..tag}, vipGiftCallback)
	end

	CreateSmallPopupWithCancel("prompt",CreateCommonLabel(string.format(MultiLan("GAL_vip_desc4"), vipRewardData[tag].cash, tostring(tag-1)),nil,FontSize3,nil,nil,cc.size(455, 80)), sendVipGiftBuy)
end

--设置Vip礼包奖励
function refreshVipGiftScroll()
    --奖励
	local vipRewardData = GameData:getGameDataTable().vipgift
	local height = 173
	local count = table.maxn(vipRewardData)
	local fatherHeight = XiaLayerOwner["mActVipScroll"]:getContentSize().height
	local y = math.max(fatherHeight-0.5*height, (count - 0.5)*height)
	local layer = cc.Layer:create()
	local offsetPos = count
	local showTag = 0
	for i=1,count do
		local back = CreateCommonSprite("board_viplibaolist.png", cc.p(320,y))
		--back:setScale(0.96)
		layer:addChild(back)
		
		local itemLayer = createRewardLayer(vipRewardData[i].items)
		itemLayer:setAnchorPoint(cc.p(0,0.5))
		itemLayer:setScale(0.8)
		itemLayer:setPosition(Pos(back:getContentSize(),0,0.44))
		back:addChild(itemLayer)
		
		local vipLabel = CreateCommonLabel(string.format(MultiLan("GAL_vip_desc1"),""..(i-1)), Pos(back:getContentSize(),0.03,0.86), FontSize4, COLOR_YELLOW, cc.p(0,0.5))
		back:addChild(vipLabel)

		back:addChild(CreateCommonSprite("icon_gold.png", Pos(back:getContentSize(),0.8,0.75)))
		back:addChild(CreateCommonLabel(vipRewardData[i].cash, Pos(back:getContentSize(),0.86,0.75), FontSize4, COLOR_YELLOW, cc.p(0,0.5)))
		
		local rewardButton = CreateCommonButton("button_green.png", Pos(back:getContentSize(),0.87,0.4), cc.size(158,67), SendVipGiftReward,{str=MultiLan("button_buy"),size = FontSize3})
		rewardButton:setScale(0.85)
		back:addChild(rewardButton, 0, i)
		if FindValue(UserSelfInfo.vip_gift, i) then
			rewardButton:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_gray.png"), cc.CONTROL_STATE_NORMAL)
			rewardButton:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_gray.png"), cc.CONTROL_STATE_HIGH_LIGHTED)
			rewardButton:setTitleForState(MultiLan("button_buyyet"),  cc.CONTROL_STATE_NORMAL)
			rewardButton:setTitleForState(MultiLan("button_buyyet"),  cc.CONTROL_STATE_HIGH_LIGHTED)
			rewardButton:setEnabled(false)
		end
		
		if showTag == 0 and not FindValue(UserSelfInfo.vip_gift, i) then
			showTag = i
			offsetPos = count - (i-1)
		end
		
		y = y - height
	end
	
	

	layer:setContentSize(cc.size(640, math.max(fatherHeight, count*height)))
	local scrolView = CreateScrollViewByFather(XiaLayerOwner["mActVipScroll"], layer, cc.p(0, math.min(0,fatherHeight-offsetPos*height)), kScrollViewDirectionVertical)
end

local function setActVipRewardButton()
	if UserSelfInfo.vip_benefit == 0 and UserSelfInfo.vip > 0 then
		XiaLayerOwner["mActVipReward"]:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_green.png"), cc.CONTROL_STATE_NORMAL)
		XiaLayerOwner["mActVipReward"]:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_green.png"), cc.CONTROL_STATE_HIGH_LIGHTED)
	else
		XiaLayerOwner["mActVipReward"]:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_gray.png"), cc.CONTROL_STATE_NORMAL)
		XiaLayerOwner["mActVipReward"]:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_gray.png"), cc.CONTROL_STATE_HIGH_LIGHTED)
	end
end

--设置vip活动
function setVipAct(node)
	print("setVipAct", VicActShowTag)
	Activity_ActArr[ACT_TYPE_VIP_FREE].layer:setVisible(true)
				
	-- XiaLayerOwner["mActVipTitle"]:setSpriteFrame("title_vipfl.png")
	XiaLayerOwner["lbActVipTitle"]:setString(ZGMultiLan("lbActVipTitleFuli"))
	XiaLayerOwner["mActVipReward"]:setVisible(true)
	XiaLayerOwner["mActVipPay"]:setPosition(Pos(XiaLayerOwner["mActVip"]:getContentSize(), 0.3, 0.17))
	XiaLayerOwner["mActVipReward"]:setPosition(Pos(XiaLayerOwner["mActVip"]:getContentSize(), 0.7, 0.17))
	--vip
	CreateRichtextByFather(XiaLayerOwner["mActVipDesc"], 
										{{str=MultiLan("GAL_actDescDetail_4"), size=FontSize4},
										 {size=nil},
										{str=MultiLan("GAL_actDescDetail_5"), size=FontSize4}}, true)
						
	--if VicActShowTag == 0 or VicActShowTag > 0 and VicActShowTag ~= UserSelfInfo.vip then
	    refreshVipScroll()
	--end
	
	setActVipRewardButton()
end

--设置vip礼包活动
function setVipGiftAct(node)
	Activity_ActArr[ACT_TYPE_VIP_GIFT].layer:setVisible(true)
	
	-- XiaLayerOwner["mActVipTitle"]:setSpriteFrame("title_viplibao.png")
	XiaLayerOwner["lbActVipTitle"]:setString(ZGMultiLan("lbActVipTitleLibao"))
	XiaLayerOwner["mActVipReward"]:setVisible(false)
	XiaLayerOwner["mActVipPay"]:setPosition(Pos(XiaLayerOwner["mActVip"]:getContentSize(), 0.5, 0.17))
	--vip
	CreateRichtextByFather(XiaLayerOwner["mActVipDesc"], 
										{{str=MultiLan("GAL_vip_desc2"), size=FontSize4}}, true)

	refreshVipGiftScroll()
end

--设置累计充值活动
function setPayAct()
	print("setPayAct")
	Activity_ActArr[ACT_TYPE_PAY].layer:setVisible(true)
	-- XiaLayerOwner["mActPayTitle"]:setSpriteFrame("title_nebigljcz.png")
	XiaLayerOwner["lbActPayTitle"]:setString(ZGMultiLan("title_nebigljcz"))
	XiaLayerOwner["mTotSprite"]:setSpriteFrame(Activity_ActArr[ACT_TYPE_PAY].back)
	-- XiaLayerOwner["mTopDescSprite"]:setSpriteFrame("pic_ljdaoju.png")
	XiaLayerOwner["lbActPayDesc"]:setString(ZGMultiLan("act_desc_ljdaoju"))
	XiaLayerOwner["mActPayPay"]:setVisible(true)
	XiaLayerOwner["mActPayBlack"]:setVisible(true)
	XiaLayerOwner["mActPayScroll"]:removeAllChildren(true)
	local actInfo = Activity_ActArr[ACT_TYPE_PAY].info
	print(actInfo.countdown, TimeDown:getTimeById(actInfo.timerId))
	CreateRichtextByFather(XiaLayerOwner["mActPayDesc"], 
							{{str=MultiLan("GAL_remindTime"), size=FontSize4},
							 {str=TurnSecendsToDay(TimeDown:getTimeById(Activity_ActArr[ACT_TYPE_PAY].timerId)), size=FontSize4, color=COLOR_GREEN},
							 {size = nil},
							 {str=MultiLan("GAL_Chargeday_3"), size=FontSize4},
							 {str=" "..actInfo.count, size=FontSize4, color=COLOR_YELLOW}
							 }, true)
	refreshPayScroll(GameData:getGameDataTable().help["endlessCharge_fresh"..actInfo.id])				
	--refreshPayScrollWithServerData(actInfo.info.award)
	
	
	--活动到期请求新活动信息
	local endRound = 5
	if bForeignVersion then
		endRound = 2
	end
	if Activity_ActArr[ACT_TYPE_PAY].info.id < 5 and TimeDown:getTimeById(Activity_ActArr[ACT_TYPE_PAY].timerId) <= 0 then
		local function payActTimeUpcallback(jsonDataTable)
			if jsonDataTable.ret == 0 then
				Activity_ActArr[ACT_TYPE_PAY].info = jsonDataTable.data
				TimeDown:setTimeInfo(Activity_ActArr[ACT_TYPE_PAY].timerId, Activity_ActArr[ACT_TYPE_PAY].info.countdown)
				if CommonActLayer:isVisible() and false == XiaLayerOwner["mActMain"]:isVisible() then
					setPayAct()
				end
			end
		end
		
		HttpSend("activity/naccpay", {},payActTimeUpcallback)
	end
end

--设置临时累计充值活动
function setPayTempAct()
	local actInfo = Activity_ActArr[ACT_TYPE_PAY_TEMP]
	if actInfo == nil then
		return
	end

	Activity_ActArr[ACT_TYPE_PAY_TEMP].layer:setVisible(true)
	-- XiaLayerOwner["mActPayTitle"]:setSpriteFrame("title_bigljcz.png")
	XiaLayerOwner["lbActPayTitle"]:setString(ZGMultiLan("title_bigljcz"))
	XiaLayerOwner["mTotSprite"]:setSpriteFrame(Activity_ActArr[ACT_TYPE_PAY_TEMP].back)
	-- XiaLayerOwner["mTopDescSprite"]:setSpriteFrame("pic_ljdaoju.png")
	XiaLayerOwner["lbActPayDesc"]:setString(ZGMultiLan("act_desc_ljdaoju"))
	XiaLayerOwner["mActPayPay"]:setVisible(true)
	XiaLayerOwner["mActPayScroll"]:removeAllChildren(true)
	XiaLayerOwner["mActPayBlack"]:setVisible(true)
						
	CreateRichtextByFather(XiaLayerOwner["mActPayDesc"], 
							{{str=MultiLan("GAL_remindTime"), size=FontSize4},
							 {str=TurnSecendsToDay(TimeDown:getTimeById(actInfo.timerId)), size=FontSize4, color=COLOR_GREEN},
							 {size = nil},
							 {str=MultiLan("GAL_Chargeday_3"), size=FontSize4},
							 {str=" "..actInfo.info.accpay, size=FontSize4, color=COLOR_YELLOW}
							 }, true)
	-- for k,v in pairs(actInfo.info) do
	-- 	print(k.."-----------"..v)
	-- end
	refreshPayScrollWithServerData(actInfo.info.award)				
	--refreshPayScroll(GameData:getGameDataTable().help.endlessCharge_festival)
end

--设置免费年卡活动
function setFreeAct()
	print("setFreeAct 1")
	Activity_ActArr[ACT_TYPE_FREE].layer:setVisible(true)
	-- XiaLayerOwner["mActPayTitle"]:setSpriteFrame("title_freefuli.png")
	XiaLayerOwner["lbActPayTitle"]:setString(ZGMultiLan("title_freefuli"))
	XiaLayerOwner["mTotSprite"]:setSpriteFrame(Activity_ActArr[ACT_TYPE_FREE].back)
	-- XiaLayerOwner["mTopDescSprite"]:setSpriteFrame("pic_freefulia.png")
	XiaLayerOwner["lbActPayDesc"]:setString(ZGMultiLan("act_desc_freefulia"))
	XiaLayerOwner["mActPayPay"]:setVisible(false)
	XiaLayerOwner["mActPayBlack"]:setVisible(false)
						
	CreateRichtextByFather(XiaLayerOwner["mActPayDesc"], {{str=MultiLan("GAL_free_nitice"), size=FontSize2}}, true)
	print("------------------------------------------")	
	local function SendFreeReward(node)
		print("SendFreeReward："..node:getTag()..":"..tostring(UserSelfInfo.level))
		if node:getTag() == 3 and UserSelfInfo.vip < 4 then
			CommonNote(MultiLan("GAL_free_needvip"))
			return
		elseif node:getTag() == 2 and UserSelfInfo.level < 15 then
			CommonNote(MultiLan("yearcard_need_lv_15"))
			return
		end	
		local function freeCardRewardCallback(jsonDataTable)
			if jsonDataTable.ret == 0 then
				--添加道具
				UserInfo:addProp(jsonDataTable.data.items)
				UserInfo:addPropNote(jsonDataTable.data.items)
				
				--修改数据
				if UserSelfInfo.free_card == CJSON_NULL then
					UserSelfInfo.free_card = {}
				end
				table.insert(UserSelfInfo.free_card, jsonDataTable.data.id)
				
				--刷新界面
				node:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_gray.png"), cc.CONTROL_STATE_NORMAL)
				node:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_gray.png"), cc.CONTROL_STATE_HIGH_LIGHTED)
				node:setTitleForState(MultiLan("GAL_collected"),  cc.CONTROL_STATE_NORMAL)
				node:setTitleForState(MultiLan("GAL_collected"),  cc.CONTROL_STATE_HIGH_LIGHTED)
				node:setEnabled(false)
				
				Activity_ActArr[ACT_TYPE_FREE].canReward = IsActFreeCanReward()
				if Activity_ActArr[ACT_TYPE_FREE].canReward == false and Activity_ActArr[ACT_TYPE_FREE].noteNode ~= nil then
					removeSelf(Activity_ActArr[ACT_TYPE_FREE].noteNode)
				end
			end
		end

		HttpSend("activity/freecard", {"id="..node:getTag()}, freeCardRewardCallback)
	end
						
	XiaLayerOwner["mActPayScroll"]:removeAllChildren(true)
	local size = XiaLayerOwner["mActPayScroll"]:getContentSize()
	local height = 140
	local y = size.height - 0.5*height
	for i=1, 3 do
		local back = CreateCommonSprite("board_fulilist.png", cc.p(size.width/2, y))
		XiaLayerOwner["mActPayScroll"]:addChild(back)
		
		if i== 1 then
			back:addChild(CreateCommonSprite("pic_fuliyb.png", Pos(back:getContentSize(),0.11,0.5)))
		elseif i==2 then
			back:addChild(CreateCommonSprite("pic_fuliyuanb.png", Pos(back:getContentSize(),0.11,0.5)))
		elseif i==3 then
			back:addChild(CreateCommonSprite("prop_"..PROP_ID_PRESTIGE..".png", Pos(back:getContentSize(),0.11,0.5)))
			back:addChild(CreateCommonSprite("frame_yellow.png", Pos(back:getContentSize(),0.11,0.5)))
		end
		
		back:addChild(CreateCommonLabel(MultiLan("GAL_free_title"..i), Pos(back:getContentSize(), 0.22,0.8),FontSize2, nil, cc.p(0,0.5)))
		back:addChild(CreateCommonLabel(MultiLan("GAL_free_desc"..i), Pos(back:getContentSize(), 0.22,0.45),FontSize1, nil, cc.p(0,0.5)))
		
		local button = CreateCommonButton("button_green.png", Pos(back:getContentSize(),0.86,0.5), cc.size(158,67), SendFreeReward,{str=MultiLan("button_collect"),size = FontSize3})
		button:setScale(0.8)
		back:addChild(button,0,i)
		
		if FindFirstByValue(UserSelfInfo.free_card, i) ~= nil then
			button:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_gray.png"), cc.CONTROL_STATE_NORMAL)
			button:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_gray.png"), cc.CONTROL_STATE_HIGH_LIGHTED)
			button:setTitleForState(MultiLan("GAL_collected"),  cc.CONTROL_STATE_NORMAL)
			button:setTitleForState(MultiLan("GAL_collected"),  cc.CONTROL_STATE_HIGH_LIGHTED)
			button:setEnabled(false)
		end

		y = y - height
	end
end

--设置首充活动
function setFirstAct()
	Activity_ActArr[ACT_TYPE_FIRST].layer:setVisible(true)
	-- XiaLayerOwner["mActPayTitle"]:setSpriteFrame("title_dalaisc.png")
	XiaLayerOwner["lbActPayTitle"]:setString(ZGMultiLan("title_dalaisc"))
	XiaLayerOwner["mTotSprite"]:setSpriteFrame(Activity_ActArr[ACT_TYPE_FIRST].back)
	-- XiaLayerOwner["mTopDescSprite"]:setSpriteFrame("pic_scbuzhi.png")
	XiaLayerOwner["lbActPayDesc"]:setString(ZGMultiLan("act_desc_scbuzhi"))
	XiaLayerOwner["mActPayPay"]:setVisible(true)
	XiaLayerOwner["mActPayBlack"]:setVisible(true)
	XiaLayerOwner["mActPayScroll"]:removeAllChildren(true)
	
	XiaLayerOwner["mActPayDesc"]:removeAllChildren(true)
	XiaLayerOwner["mActPayDesc"]:addChild(CreateCommonLabel(MultiLan("GAL_firstpay"), Pos(XiaLayerOwner["mActPayDesc"]:getContentSize(),0.03,0.5),FontSize3, COLOR_ORANGE,cc.p(0,0.5)))

	refreshPayScroll(GameData:getGameDataTable().help["endlessCharge_firstpay"])
end

--冲榜活动
function setListAct()
	print("setListAct", Activity_ActArr[ACT_TYPE_LIST].info.list, Activity_ActArr[ACT_TYPE_LIST].info.status)
	Activity_ActArr[ACT_TYPE_LIST].layer:setVisible(true)
	-- XiaLayerOwner["mActPayTitle"]:setSpriteFrame("title_xinfcb.png")
	XiaLayerOwner["lbActPayTitle"]:setString(ZGMultiLan("title_xinfcb"))
	XiaLayerOwner["mTotSprite"]:setSpriteFrame(Activity_ActArr[ACT_TYPE_LIST].back)
	-- XiaLayerOwner["mTopDescSprite"]:setSpriteFrame("pic_xinfcbdal.png")
	XiaLayerOwner["lbActPayDesc"]:setString(ZGMultiLan("act_desc_xinfcbdal"))
	XiaLayerOwner["mActPayPay"]:setVisible(true)
	XiaLayerOwner["mActPayBlack"]:setVisible(true)
	XiaLayerOwner["mActPayScroll"]:removeAllChildren(true)
	local actInfo = Activity_ActArr[ACT_TYPE_LIST]
	CreateRichtextByFather(XiaLayerOwner["mActPayDesc"], 
							{{str=MultiLan("GAL_list_desc1"), size=FontSize4},
							 {str=TurnSecendsToDay(TimeDown:getTimeById(actInfo.timerId)), size=FontSize4, color=COLOR_GREEN},
							 {size = nil},
							 {str=MultiLan("GAL_list_desc2"), size=FontSize2}
							 }, true)

	if actInfo.info.status == 0 then
		refreshPayScroll(GameData:getGameDataTable().help["endlessCharge_list"])
	elseif actInfo.info.list ~= nil then
		local nameTable = actInfo.info.list
		local strTable = {}
		for i=1, 4 do
			local t = {1,1,2,10,11,20}
			local middleTable = {}
			for j=1, 3 do
				local str = ""
				for k=1, table.maxn(nameTable[i]) do
					local count = 0
					print("k", t[2*j-1], t[2*j], nameTable[i][k])
					if k >= t[2*j-1] and k <= t[2*j] and nameTable[i][k]~=nil then
						print("add ".. nameTable[i][k])
						str = str .. nameTable[i][k]
						if k~= t[2*j] then
							str = str .. ", "
						end
					end
				end
				table.insert(middleTable, str)
			end
			table.insert(strTable, middleTable)
		end
		
		--榜单
		local showTable = {{str=MultiLan("GAL_list_desc3"), size=FontSize4, color = COLOR_GREEN},{size = nil},
							 
							{str="   ",size=FontSize4},{size = nil},
							  {str=MultiLan("GAL_list_desc5"), size=FontSize4},{size = nil},
							 {str=MultiLan("GAL_list_desc8"), size=FontSize4},
							 {str=strTable[1][1], size=FontSize4, color = EQUIP_COLOR_ARR[5]},{size = nil},
							 {str=MultiLan("GAL_list_desc9"), size=FontSize4},
							 {str=strTable[1][2], size=FontSize4, color = EQUIP_COLOR_ARR[4]},{size = nil},
							 {str=MultiLan("GAL_list_desc10"), size=FontSize4},
							 {str=strTable[1][3], size=FontSize4, color = EQUIP_COLOR_ARR[3]},{size = nil},
							 
							{str="   ",size=FontSize4},{size = nil},
							  {str=MultiLan("GAL_list_desc6"), size=FontSize4},{size = nil},
							 {str=MultiLan("GAL_list_desc8"), size=FontSize4},
							 {str=strTable[2][1], size=FontSize4, color = EQUIP_COLOR_ARR[5]},{size = nil},
							 {str=MultiLan("GAL_list_desc9"), size=FontSize4},
							 {str=strTable[2][2], size=FontSize4, color = EQUIP_COLOR_ARR[4]},{size = nil},
							 {str=MultiLan("GAL_list_desc10"), size=FontSize4},
							 {str=strTable[2][3], size=FontSize4, color = EQUIP_COLOR_ARR[3]},{size = nil},
							 
							{str="   ",size=FontSize4},{size = nil},
							  {str=MultiLan("GAL_list_desc7"), size=FontSize4},{size = nil},
							 {str=MultiLan("GAL_list_desc8"), size=FontSize4},
							 {str=strTable[3][1], size=FontSize4, color = EQUIP_COLOR_ARR[5]},{size = nil},
							 {str=MultiLan("GAL_list_desc9"), size=FontSize4},
							 {str=strTable[3][2], size=FontSize4, color = EQUIP_COLOR_ARR[4]},{size = nil},
							 {str=MultiLan("GAL_list_desc10"), size=FontSize4},
							 {str=strTable[3][3], size=FontSize4, color = EQUIP_COLOR_ARR[3]},{size = nil},
							 
							{str=" ",size=FontSize4},{size = nil},
							{str=MultiLan("GAL_list_desc4"), size=FontSize4},{size = nil},
							 {str=MultiLan("GAL_list_desc8"), size=FontSize4},
							 {str=strTable[4][1], size=FontSize4, color = COLOR_RED},{size = nil},
							 {str=MultiLan("GAL_list_desc9"), size=FontSize4},
							 {str=strTable[4][2], size=FontSize4, color = EQUIP_COLOR_ARR[5]},{size = nil},
							 {str=MultiLan("GAL_list_desc10"), size=FontSize4},
							 {str=strTable[4][3], size=FontSize4, color = EQUIP_COLOR_ARR[4]},{size = nil},
							 }
		CreateRichtextByFather(XiaLayerOwner["mActPayScroll"], showTable, true, true)
	end
	
	
	if actInfo.info.list == nil and (actInfo.info.status == 1 or (actInfo.info.status == 0 and TimeDown:getTimeById(actInfo.timerId)<=0)) then
		local function actRankInfoCallback(jsonDataTable)
			print("actRankInfoCallback", jsonDataTable.ret)
			if jsonDataTable.ret == 0 then
				Activity_ActArr[ACT_TYPE_LIST].info.list = jsonDataTable.data.list
				Activity_ActArr[ACT_TYPE_LIST].info.status = 1
				print(CommonActLayer:isVisible(), XiaLayerOwner["mActMain"]:isVisible())
				if CommonActLayer:isVisible() and false == XiaLayerOwner["mActMain"]:isVisible() then
					setListAct()
				end
			end
		end
		HttpSend("activity/rank", {}, actRankInfoCallback)
	end
end

--世界等级
function setPayLevel(bOnlyRefresh)
	Activity_ActArr[ACT_TYPE_LEVEL].layer:setVisible(true)
	local actInfo = Activity_ActArr[ACT_TYPE_LEVEL]
	local worldLevel = 0
	local countDown = 0
	local addValue = 0
	local rewardHour = 0
	
	local function refreshLevelInfo()
		if ExpPerHour == nil then
			ExpPerHour = 0
		end
		if worldLevel - UserSelfInfo.level > REWARD_LEVEL then
			addValue = math.ceil(math.pow(worldLevel - UserSelfInfo.level - REWARD_LEVEL, 2)/6)
		end
		print("refreshLevelInfo", countDown, TimeDown.serverTime)
		if TimeDown.serverTime -  countDown > 3600 then
			if worldLevel - UserSelfInfo.level > REWARD_LEVEL then
				XiaLayerOwner["mActLevelDesc5"]:setVisible(true) 
				rewardHour = math.min(math.floor((TimeDown.serverTime - countDown)/3600), 24)
				ActLevelRewardHour = rewardHour
			else
				XiaLayerOwner["mActLevelDesc5"]:setVisible(false)
			end

			XiaLayerOwner["mActLevelDesc5"]:setString(MultiLan("GAL_level_desc11"))
			XiaLayerOwner["mActLevelDesc5"]:setAnchorPoint(cc.p(0.5, 0.5))
			XiaLayerOwner["mActLevelTime"]:setString("")

		else
			XiaLayerOwner["mActLevelDesc5"]:setVisible(true)
			XiaLayerOwner["mActLevelDesc5"]:setString(MultiLan("GAL_level_desc6"))
			XiaLayerOwner["mActLevelDesc5"]:setAnchorPoint(cc.p(1, 0.5))
			local function levelTimeUp()
				if XiaLayerOwner["mActLevel"]:isVisible() then
					setPayLevel(true)
				end
			end
			

			TimeDown:setTimeInfo(actInfo.timerId, 3600 - TimeDown.serverTime + countDown, XiaLayerOwner["mActLevelTime"], levelTimeUp)
		end

		XiaLayerOwner["mActLevelDesc1"]:setString(MultiLan("GAL_level_desc10")..worldLevel)
		
		XiaLayerOwner["mActLevelExp"]:setString(GameData:getGameDataTable()["exp"][UserSelfInfo.level].exp - UserSelfInfo.exp)
		XiaLayerOwner["mActLevelHour"]:setString(string.format(MultiLan("GBLa_fastBttl_7"), ExpPerHour))
		XiaLayerOwner["mActLevelAdd"]:setString(addValue.."%")

		XiaLayerOwner["mActLevelCost1"]:setString(ACT_LEVEL_COST1*rewardHour)
		XiaLayerOwner["mActLevelCost2"]:setString(ACT_LEVEL_COST2*rewardHour)
		
		XiaLayerOwner["mActLevelBack"]:removeAllChildren(true)
		local layer = CreateMultiTextLine({CreateCommonLabel(MultiLan("GAL_level_mylevel1"), nil, FontSize2),
											CreateCommonLabel(UserSelfInfo.level, nil, FontSize2, COLOR_GREEN),
											CreateCommonLabel(MultiLan("GAL_level_mylevel2"), nil, FontSize2),
											CreateCommonLabel(math.abs(worldLevel - UserSelfInfo.level), nil, FontSize2, COLOR_GREEN),
											CreateCommonLabel(MultiLan("GAL_level_mylevel3"), nil, FontSize2)
										})
		layer:setPosition(Pos(XiaLayerOwner["mActLevelBack"]:getContentSize(), 0.5, 0.74))
		layer:setScale(1.1)
		XiaLayerOwner["mActLevelBack"]:addChild(layer)
		
		layer = CreateMultiTextLine({CreateCommonLabel(MultiLan("GAL_level_reward1"), nil, FontSize2, COLOR_ORANGE),
											CreateCommonLabel(string.format(MultiLan("GAL_level_reward2"), ActLevelRewardHour), nil, FontSize2, COLOR_GREEN),
											CreateCommonLabel(MultiLan("GAL_level_reward3"), nil, FontSize2, COLOR_ORANGE),
											CreateCommonLabel(math.floor(ExpPerHour*addValue/100)*ActLevelRewardHour, nil, FontSize2, COLOR_ORANGE)
										})
		layer:setPosition(Pos(XiaLayerOwner["mActLevelBack"]:getContentSize(), 0.5, 0.26))
		layer:setScale(1.1)
		XiaLayerOwner["mActLevelBack"]:addChild(layer)
	end
	
	
	local function actLevelInfoCallback(jsonDataTable)
		print("actLevelInfoCallback", jsonDataTable.ret, jsonDataTable.data.get_time, TimeDown.serverTime)
		if jsonDataTable.ret == 0 then
			--jsonDataTable.data = {world_level = 60, get_time=0}
			worldLevel = jsonDataTable.data.world_level
			ActWorldLevel = worldLevel
			countDown = jsonDataTable.data.get_time
			addValue = 0
			rewardHour = 0
			ActLevelRewardHour = 0
			refreshLevelInfo()
		end
	end
	
	if bOnlyRefresh then
		refreshLevelInfo()
	else
		HttpSend("activity/exp", {}, actLevelInfoCallback)
	end
end

function onWorleLevelReward(node)
	local tag = node:getTag()
	print("onWorleLevelReward", tag, ActLevelRewardHour, ActWorldLevel)
	local rewardType = {1,2,5}
	if rewardType[tag] == nil then
		return 
	end
	
	if ExpPerHour == nil or ExpPerHour == 0 or ActLevelRewardHour == 0 or ActWorldLevel - UserSelfInfo.level <= REWARD_LEVEL or
	ACT_TYPE_LEVEL == 0 or TimeDown:getTimeById(Activity_ActArr[ACT_TYPE_LEVEL].timerId) > 0 then
		CommonNote(MultiLan("GAL_level_desc9"))
		return
	end
	
	--发送请求
	local function sendRewardRequest()
		local function actExpRewardCallback(jsonDataTable)
			print("actExpRewardCallback", jsonDataTable.ret)
			if jsonDataTable.ret == 0 then
				--jsonDataTable.data = {world_level = 60, get_time=0}
				--升级
				UserAttr:SetUserLevelInfo(jsonDataTable.data.expinfo)
				--消耗
				UserSelfInfo[jsonDataTable.data.use_type] = UserSelfInfo[jsonDataTable.data.use_type] - jsonDataTable.data.use_num
				if jsonDataTable.data.use_type == "cash" then
					UseCash(jsonDataTable.data.use_num)
				end
				
				setPayLevel()
				
				CommonNote(MultiLan("lan_exp").."+"..jsonDataTable.data.exp)
			end
		end
		
		if  ExpPerHour == nil or ExpPerHour == 0 or ActLevelRewardHour == 0 or ActWorldLevel - UserSelfInfo.level <= REWARD_LEVEL or
		ACT_TYPE_LEVEL == 0 or TimeDown:getTimeById(Activity_ActArr[ACT_TYPE_LEVEL].timerId) > 0 then
			CommonNote(MultiLan("GAL_level_desc9"))
			return
		end
		
		if tag == 2 and UserSelfInfo.gold < ACT_LEVEL_COST1*ActLevelRewardHour then
			CommonGoldNeed()
		elseif tag == 3 and UserSelfInfo.cash < ACT_LEVEL_COST2*ActLevelRewardHour then 
			CommonCashNeed()
		else
			HttpSend("activity/getexp", {"etype="..tostring(tag)}, actExpRewardCallback)
		end
	end
	
	if tag == 1 then
		sendRewardRequest()
	elseif tag == 2 then
		CreateSmallPopupWithCancel("prompt",CreateCommonLabel(string.format(MultiLan("GAL_level_sure_gold"), ACT_LEVEL_COST1*ActLevelRewardHour),nil,FontSize3,nil,nil,cc.size(455, 80)), sendRewardRequest)
	elseif tag == 3 then
		CreateSmallPopupWithCancel("prompt",CreateCommonLabel(string.format(MultiLan("GAL_level_sure_cash"), ACT_LEVEL_COST2*ActLevelRewardHour),nil,FontSize3,nil,nil,cc.size(455, 80)), sendRewardRequest) 
	end
	

end

--设置收集活动
local EXC_BUTTON_TITLE = {MultiLan("GAL_exc_button1"),MultiLan("GAL_exc_button2"),MultiLan("GAL_exc_button3"),MultiLan("GAL_exc_button4")}
function setExcAct()
	print("setExcAct", XiaLayerOwner["mActExcTitle"]:isVisible())
	XiaLayerOwner["mActExcTitle"]:setSpriteFrame("title_sjhuandali.png")
	local buttonChooseArr = {"button_sjzhongji01.png", "button_sjjingzhi01.png","button_sjyouzhi01.png", "button_sjshouji01.png"}
	local buttonArr =       {"button_sjzhongji02.png", "button_sjjingzhi02.png","button_sjyouzhi02.png", "button_sjshouji02.png"}  

	local actInfo = Activity_ActArr[ACT_TYPE_EXC]
	actInfo.layer:setVisible(true)
	
	if actExcChooseTag == nil then
		actExcChooseTag = 1
	end

	CreateRichtextByFather(XiaLayerOwner["mActExcDesc"], {{str=MultiLan("GAL_remindTime"), size=FontSize4}, {str=TurnSecendsToDay(TimeDown:getTimeById(actInfo.timerId)), size=FontSize4, color=COLOR_GREEN}}, true)
	XiaLayerOwner["mActExcBtnLayer"]:removeAllChildren(true)
	local function changeExcType(node)
		actExcChooseTag = node:getTag()
		setExcAct()
	end
	
	local count = table.maxn(actInfo.info.info)
	local totleWidth = 580
	for i=1, count do
		local button = CreateCommonButton(buttonArr[i], cc.p(300+(i-count/2-0.5)*130, 0), cc.size(116, 53), changeExcType,{str=EXC_BUTTON_TITLE[i],size=FontSize2})
		button:setAnchorPoint(cc.p(0.5,0))
		button:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName(buttonChooseArr[i]), cc.CONTROL_STATE_DISABLED)
		if IsExchangeCanReward(UserActiveInfo.exchange, i) then
			GameGuide:setButtonNote(button, true, Pos(button:getContentSize(),0.9,0.85), 0.8)
		end
		XiaLayerOwner["mActExcBtnLayer"]:addChild(button,0,i) 
		if i == actExcChooseTag then
			button:setEnabled(false)
		end
	end

	--道具数量
	XiaLayerOwner["mActExcCollectLayer"]:removeAllChildren(true)
	local collectLayer = createCollectLayer(actInfo.info.info[actExcChooseTag].prop)
	collectLayer:setPosition(Pos(XiaLayerOwner["mActExcCollectLayer"]:getContentSize(), 0.5,0.5))
	XiaLayerOwner["mActExcCollectLayer"]:addChild(collectLayer)
	
	--奖励
	XiaLayerOwner["mActExcRewardLayer"]:removeAllChildren(true)
	local rewardLayer = createRewardLayer(actInfo.info.info[actExcChooseTag].award)
	rewardLayer:setPosition(Pos(XiaLayerOwner["mActExcRewardLayer"]:getContentSize(), 0.5,0.6))
	XiaLayerOwner["mActExcRewardLayer"]:addChild(rewardLayer)
end

--设置转盘活动
local isZhuanInited = false
function setZhuanAct()
	Activity_ActArr[ACT_TYPE_ZHUAN].layer:setVisible(true)
	local actInfo = Activity_ActArr[ACT_TYPE_ZHUAN]

	CreateRichtextByFather(XiaLayerOwner["mActZhuanDesc"], 
							{{str=MultiLan("GAL_remindTime"), size=FontSize4},
							 {str=TurnSecendsToDay(TimeDown:getTimeById(actInfo.timerId)), size=FontSize4, color=COLOR_GREEN},
							 {size = nil},
							 {str=MultiLan("GAL_zhuan_desc1"), size=FontSize4},
							 {str=" "..actInfo.info.count, size=FontSize4, color=COLOR_GREEN}
							 }, true)
	XiaLayerOwner["mActZhuanDesc1"]:setString(MultiLan("GAL_zhuan_desc2"))
	XiaLayerOwner["mActZhuanDesc2"]:setString(MultiLan("GAL_zhuan_desc3"))
	XiaLayerOwner["mActZhuanDesc3"]:setString(MultiLan("GAL_zhuan_desc4").." "..actInfo.info.left)
	if not isZhuanInited then
		for i=1, 8 do
			local itemLayer = CreateBagItem()
			itemLayer:setItemBack("board_baseboard.png")
			itemLayer:setItemSprite("prop_"..actInfo.info.award[i].prop_id..".png")
			itemLayer:setItemOutLine(FRAME_ICON_ARR[GameData:getPropDataTable(actInfo.info.award[i].prop_id).color])
			itemLayer:setItemCount(actInfo.info.award[i].num)
			itemLayer:setPosition(Pos(XiaLayerOwner["mActZhuanItem"..i]:getContentSize()))
			XiaLayerOwner["mActZhuanItem"..i]:addChild(itemLayer)
		end
		isZhuanInited = true
	end
end

function setShopAct()
	Activity_ActArr[ACT_TYPE_SHOP].layer:setVisible(true)
	local shopListInfo = {}
	local shopScrollLayer = nil
	local shopScrollView = nil
	
	--购买回掉
	local function shopBuyCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			cclog("shopBuyCallback failed %d", jsonDataTable.ret)
			return 
		end
		print("shopBuyCallback",table.maxn(jsonDataTable.data.item))
		--增加
		UserInfo:addProp(jsonDataTable.data.item)
		
		local num = 0
		
		local line = math.ceil(table.maxn(shopListInfo.info.list)/3)
		LuckShopLock = true
		local function deleteItem()
			print("deleteItem",num,table.maxn(jsonDataTable.data.buy))
			num = num + 1
			M.playEffect("sound/buy_succeed.mp3")
			for i=1,table.maxn(shopListInfo.info.list) do
				if shopListInfo.info.list[i].id == jsonDataTable.data.buy[num] and shopListInfo.info.list[i].button ~= nil then
					removeSelf(shopListInfo.info.list[i].layer)
					table.remove(shopListInfo.info.list, i)
					print("remove", i, table.maxn(shopListInfo.info.list))
					--重排位置
					local count = table.maxn(shopListInfo.info.list)
					print("count", count, line)
					local tempLine = math.ceil(table.maxn(shopListInfo.info.list)/3)
					shopScrollLayer:setContentSize(cc.size(600, math.max(535, 250*tempLine-20)))
					shopScrollView:setContentOffset(cc.p(0, 535-(250*tempLine-20)))
					if 250  * tempLine - 20 < 535 then
						shopScrollView:setTouchEnabled(false)
					end
					
					for j=1,tempLine do
						for k=1,3 do
							local p = (j-1)*3 + k
							if shopListInfo.info.list[p] ~= nil and shopListInfo.info.list[p].button ~= nil then
								shopListInfo.info.list[p].layer:setPosition(cc.p(200*k-100, 250 * (tempLine-j+1) - 140))
								shopListInfo.info.list[p].button:setTag(p)
							end
						end
					end
					

					
					if jsonDataTable.data.newinfo ~= nil and num == table.maxn(jsonDataTable.data.buy) then
						shopListInfo.info.list = jsonDataTable.data.newinfo.list
						table.sort(shopListInfo.info.list,SortTableById)
						ShopUpdateList()
					end
					if num == table.maxn(jsonDataTable.data.buy) then
						LuckShopLock = false
					end
					
					break
				end
			end
		end
		
		--飘字
		local noteArr = {}
		for i=1, table.maxn(jsonDataTable.data.buy) do
			for j=1,table.maxn(shopListInfo.info.list) do
				if shopListInfo.info.list[j].id == jsonDataTable.data.buy[i] then
					table.insert(noteArr, string.format(MultiLan("shop_desc1"), MultiLan(GameData:getPropDataTable(shopListInfo.info.list[j].prop_id).name)))
					break
				end
			end
		end
		
		--for i=1, table.maxn(jsonDataTable.data.item) do
		--	table.insert(noteArr, "购买 ".. (jsonDataTable.data.item[i].prop_id).name.." 成功")
		--end
		if table.maxn(noteArr) == 1 then
			CommonNote(noteArr,nil,deleteItem)
		else
			CommonNote(noteArr,nil,deleteItem,0.2)
		end
		
		--消耗
		for i=1,table.maxn(jsonDataTable.data.use) do
			UserSelfInfo[jsonDataTable.data.use[i].use_type] = UserSelfInfo[jsonDataTable.data.use[i].use_type] - jsonDataTable.data.use[i].use_num
			if jsonDataTable.data.use[i].use_type == "cash" then
				UseCash(jsonDataTable.data.use[i].use_num)
			end
		end
		SetCommonMoneyLayer()
	end

	
	local function onActShopItemClicked(node)
		if LuckShopLock then
			return
		end

		local tag = tolua.cast(node,"cc.Node"):getTag()
		print("onItemClicked",tag,table.maxn(shopListInfo.info.list))
		if UserSelfInfo.vip == 0 and shopListInfo.info.list[tag].id == 1 then
			CommonNote(MultiLan("shop_desc2"))
			return
		end
		
		if shopListInfo.info.list[tag].type == 1 and UserSelfInfo.gold < shopListInfo.info.list[tag].cost then
			CommonGoldNeed()
			return
		elseif shopListInfo.info.list[tag].type == 2 and UserSelfInfo.cash < shopListInfo.info.list[tag].cost then
			CommonCashNeed()
			return
		elseif shopListInfo.info.list[tag].type == 6 and UserSelfInfo.coupon < shopListInfo.info.list[tag].cost then
			CommonCouponNeed()
			return
		end
		HttpSend("shop/buy", {"id=5", "itemid="..shopListInfo.info.list[tag].id}, shopBuyCallback)
	end	
	
	local function showActShop()
		local layer = cc.Layer:create()
		local scrolView = CreateScrollViewByFather(XiaLayerOwner["mActShopScrollLayer"], layer, cc.p(0,0), kScrollViewDirectionVertical)
		local line = math.ceil(table.maxn(shopListInfo.info.list)/3)
		local scrollWorldPos = XiaLayerOwner["mActShopScrollLayer"]:convertToWorldSpace(cc.p(scrolView:getPosition()))
		local scrollViewSize = scrolView:getViewSize()
		local y = 250 * line - 140
		for i=1, line do
			for j=1,3 do
				local x = 200*j-100
				local itemInfo = shopListInfo.info.list[(i-1)*3+j]
				if itemInfo ~= nil then
					local back = CreateLayer(cc.size(200,250),1,cc.p(x, y))
					itemInfo.layer = back
					layer:addChild(back)
				
					back:addChild(CreateCommonSprite("board_pvpgoods.png", cc.p(100, 125+30)))
					local buyButton = CreateCommonButton("MainButton12.png", cc.p(100, 125-85), cc.size(137, 53), onActShopItemClicked, {str = MultiLan("button_buy"),size=FontSize3})
					buyButton:setScrollViewRect(cc.rect(scrollWorldPos.x, scrollWorldPos.y, scrollViewSize.width, scrollViewSize.height))
					buyButton:setSwallowTouch(false)
					itemInfo.button = buyButton
					back:addChild(buyButton,0, (i-1)*3+j)
					
					local propInfo = GameData:getPropDataTable(itemInfo.prop_id)
					local itemObj = CreateBagItem()
					if itemInfo.attr ~= nil and itemInfo.attr ~= CJSON_NULL then
						itemObj:setItemType(BAG_ITEM_TYPE_HERO_EQUIP)
						itemObj:setItemInfoTable(itemInfo)
						itemObj:setCanTouch(false)
					else
						itemObj:setItemType(BAG_ITEM_TYPE_THING_SHOP)
						itemObj:setItemInfoTable(itemInfo)
						itemObj:setItemName("")
					end
					itemObj:setPosition(cc.p(100,125+58))
					back:addChild(itemObj)
					
					back:addChild(CreateCommonLabel(MultiLan(propInfo.name), cc.p(100, 125-8), FontSize2, cc.c3b(210, 0, 255)))
					if itemInfo.type == 1 then
						back:addChild(CreateCommonSprite("icon_silver.png", cc.p(100-38, 125-38),0.85))
					elseif itemInfo.type == 2 then
						back:addChild(CreateCommonSprite("icon_gold.png", cc.p(100-38, 125-38),0.85))
					elseif itemInfo.type == 6 then
						back:addChild(CreateCommonSprite("icon_drafts.png", cc.p(100-38, 125-38),0.85))
					end
					back:addChild(CreateCommonLabel(itemInfo.cost, cc.p(100+24, 125-37), FontSize2))
				end
			end
		
			y = y- 250
		end

		layer:setContentSize(cc.size(600, math.max(535, 250*line-20)))
		shopScrollLayer = layer
		scrolView:setContentOffset(cc.p(0, 535-(250*line-20)))
		shopScrollView = scrolView
		if 250  * line - 20 < 535 then
			scrolView:setTouchEnabled(false)
		end
	end
	
	local function actShopCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			shopListInfo = jsonDataTable.data
			if shopListInfo ~= nil and shopListInfo ~= CJSON_NULL then
				showActShop()
			end
			
		end
	end

	HttpSend("shop/info", {"id=5"}, actShopCallback)
end

--刷新主界面
function ActSetMain()
	local height = 170
	local count = math.max(4,table.maxn(Activity_ActArr)+1)
	local fatherHeight = XiaLayerOwner["mActMainScroll"]:getContentSize().height
	local y = math.max(fatherHeight-0.5*height, (count - 0.5)*height)
	local layer = cc.Layer:create()
	
	print("ActSetMain",table.maxn(Activity_ActArr))
	local function ShowWait()
		CommonNote(MultiLan("GAL_pleaseWait"), COLOR_WHITE)
	end

	local function actClick(node)
		local tag = node:getTag()
		if Activity_ActArr[tag] ~= nil and Activity_ActArr[tag].callback ~= nil then
			resetActLayer()
			GameActShowTag = tag
			XiaLayerOwner["mActMain"]:setVisible(false)
			Activity_ActArr[tag].callback()
			if GameActShowTag == ACT_TYPE_SHOP then
				XiaLayerOwner["mCommonMoneyLayer"]:setVisible(true)
				SetCommonMoneyLayer()
			else
				XiaLayerOwner["mCommonMoneyLayer"]:setVisible(false)
			end
		end
	end
	
	local actCount = 0
	for i=1,count do
		if Activity_ActArr[i] ~= nil then
			actCount = actCount + 1
			print(Activity_ActArr[i].back)
			local button = CreateCommonButton(Activity_ActArr[i].back, cc.p(320,y), cc.size(568,168), actClick)
			
			button:setSwallowTouch(false)
			layer:addChild(button, 0,i)
			button:addChild(CreateCommonSprite("board_actpic.png", cc.p(284,84+20)))
			-- button:addChild(CreateCommonSprite(Activity_ActArr[i].title, cc.p(284,84+20)))
			button:addChild(CreateCommonFntLabel(ZGMultiLan("act_title_" .. Activity_ActArr[i].title), FntTypeUserTitle, cc.p(284,84+20)))
			button:addChild(CreateCommonLabel(Activity_ActArr[i].desc, cc.p(284,84-25),FontSize3))
			if Activity_ActArr[i].canReward then
				Activity_ActArr[i].noteNode = GameGuide:setButtonNote(button, true, cc.p(540,135), 1.5)
			else
				Activity_ActArr[i].noteNode = nil
			end
			--layer:addChild(CreateCommonSprite(backArr[i].title, cc.p(320,y+40)))
			--Activity_ActArr[i].noteNode = nil
			y = y - height
		end
	end
	
	for i=1, count - actCount do
		local button = CreateCommonButton("board_closedact.png", cc.p(320,y), cc.size(568,168), ShowWait)
		button:setSwallowTouch(false)
		layer:addChild(button)
		button:addChild(CreateCommonSprite("board_actpic.png", cc.p(284,84)))
		-- button:addChild(CreateCommonSprite("pic_waitww.png", cc.p(284,84)))
		button:addChild(CreateCommonFntLabel(ZGMultiLan("game_info_teambattle_waiting"), FntTypeCommonDisableGray, cc.p(284,84)))
		y = y - height
	end

	layer:setContentSize(cc.size(640, math.max(fatherHeight, count*height)))
	local scrolView = CreateScrollViewByFather(XiaLayerOwner["mActMainScroll"], layer, cc.p(0, math.min(0,fatherHeight-count*height)), kScrollViewDirectionVertical)
end

--初始化活动列表
function InitActArr()
	Activity_ActArr = {}
	if SDK_PLATFORM == "SDK_TGAME_IOS" or SDK_PLATFORM == "SDK_TGAME_ANDROID" or
	 SDK_PLATFORM == "SDK_TGAME_VN_IOS" or SDK_PLATFORM == "SDK_TGAME_VN_ANDROID" or
	  SDK_PLATFORM == "SDK_TGAME_TH_IOS" or SDK_PLATFORM == "SDK_TGAME_TH_ANDROID" or
	  SDK_PLATFORM == "SDK_TGAME_XMT_IOS" or SDK_PLATFORM == "SDK_TGAME_XMT_ANDROID" or 
	  SDK_PLATFORM == "SDK_JAGUAR_ANDROID" or SDK_PLATFORM == "SDK_JAGUAR_THIRD" then
		bForeignVersion = true
	end
	
	--首充活动
	if bForeignVersion == false then
		local totleCount = UserInfo:getUserInfo().data.pay_extra
		local sanbeiTag = UserSelfInfo.firstpay
		sanbeiTag = 5
		totleCount = 3
		if sanbeiTag < math.pow(2, totleCount)-1 then
			local payActData = {back="board_dxlaisc.png", 
							   title = "daxlaisc", 
							   desc=MultiLan("GAL_actDesc_8"), 
							   callback=setFirstAct,
							   layer= XiaLayerOwner["mActPay"]}
			table.insert(Activity_ActArr, payActData)
			ACT_TYPE_FIRST = table.maxn(Activity_ActArr)
		end
	end
	
	--冲榜
	if UserActiveInfo ~= nil and UserActiveInfo.rank ~= nil then
		local listTimerId = TimeDown:register()
		TimeDown:setTimeInfo(listTimerId, UserActiveInfo.rank.countdown)

		local payActData = {back="board_xinfcb.png", 
						   title = "xinfcb", 
						   desc=MultiLan("GAL_actDesc_9"), 
						   timerId = listTimerId,
						   callback=setListAct,
						   layer= XiaLayerOwner["mActPay"],
						   info = UserActiveInfo.rank}
		table.insert(Activity_ActArr, payActData)
		ACT_TYPE_LIST = table.maxn(Activity_ActArr)
	end

	--新手前8天
	if UserSelfInfo.regdays <= 8 then
		
		table.insert(Activity_ActArr, {back="board_youngact.png", 
									   title = "youngact", 
									   desc=MultiLan("GAL_actDesc_2"), 
									   callback=setNewAct,
									   layer= XiaLayerOwner["mActNew"]})
		ACT_TYPE_NEW = table.maxn(Activity_ActArr)
	end
	
	--云游商人
	if UserSelfInfo.level >= 25 then
		local shopActData = {back="board_yunyousr.png", 
						   title = "yunyousr", 
						   desc=MultiLan("GAL_actDesc_13"), 
						   timerId = zhuanTimerId,
						   callback= setShopAct,
						   layer= XiaLayerOwner["mActShop"]}
		table.insert(Activity_ActArr, shopActData)
		ACT_TYPE_SHOP = table.maxn(Activity_ActArr)
	end

	--消费返礼
	--UserActiveInfo.daily_pay = {mtime=1000,reward={{{prop_id=100001,num=100}},{{prop_id=201011,num=3}}}}
	if UserActiveInfo ~= nil and UserActiveInfo.daily_pay ~= nil and UserActiveInfo.daily_pay ~= CJSON_NULL then
		local conpayTimerId = TimeDown:register()
		TimeDown:setTimeInfo(conpayTimerId, UserActiveInfo.daily_pay.countdown)
		local conpayData = {back="board_nixiaofei.png", 
						   title = "nixiaofeiw", 
						   desc=MultiLan("GAL_actDesc_11"), 
						   callback=setDailyAct,
						   layer= XiaLayerOwner["mActCon"],
						   timerId=conpayTimerId,
						   canReward = false,
						   info = UserActiveInfo.daily_pay}
		table.insert(Activity_ActArr, conpayData)
		ACT_TYPE_DAILY = table.maxn(Activity_ActArr)
		--是否可以领奖
		conpayData.canReward = IsDailyCanReward(Activity_ActArr[ACT_TYPE_DAILY].info)
	end

	--UserActiveInfo.conpay = {mtime=1000,reward={{{prop_id=100001,num=100}},{{prop_id=201011,num=3}}}}
	--新手连续充值
	--连续
	if UserActiveInfo ~= nil and UserActiveInfo.conpay ~= nil and UserActiveInfo.conpay ~= CJSON_NULL then
		local conpayTimerId = TimeDown:register()
		TimeDown:setTimeInfo(conpayTimerId, UserActiveInfo.conpay.mtime)
		local conpayData = {back="board_moneyag.png", 
						   title = "xinshoulxchz", 
						   desc=MultiLan("GAL_actDesc_1"), 
						   callback=setConAct,
						   layer= XiaLayerOwner["mActCon"],
						   timerId=conpayTimerId,
						   canReward = false,
						   info = UserActiveInfo.conpay}
		table.insert(Activity_ActArr, conpayData)
		ACT_TYPE_CONPAY = table.maxn(Activity_ActArr)
		--是否可以领奖
		conpayData.canReward = IsConpayCanReward(Activity_ActArr[ACT_TYPE_CONPAY].info)
	end
		--老服连续充值
	if UserActiveInfo ~= nil and UserActiveInfo.actconpay ~= nil and UserActiveInfo.actconpay ~= CJSON_NULL then
		local conpayTimerId = TimeDown:register()
		TimeDown:setTimeInfo(conpayTimerId, UserActiveInfo.actconpay.mtime)
		local conpayData = {back="board_moneyag.png", 
						   title = "moneyag", 
						   desc=MultiLan("GAL_actDesc_1"), 
						   callback=setTempConAct,
						   layer= XiaLayerOwner["mActCon"],
						   timerId=conpayTimerId,
						   canReward = false,
						   info = UserActiveInfo.actconpay}
		table.insert(Activity_ActArr, conpayData)
		ACT_TYPE_CONPAY_TEMP = table.maxn(Activity_ActArr)
		--是否可以领奖
		conpayData.canReward = IsTempConpayCanReward(Activity_ActArr[ACT_TYPE_CONPAY_TEMP].info)
	end

	--老服累计充值
	if UserActiveInfo ~= nil and UserActiveInfo.accpay ~= nil then
		--UserActiveInfo.accpay.countdown = math.max(0, UserActiveInfo.accpay.end_time - UserActiveInfo.accpay.now_time)
		local temppayTimerId = TimeDown:register()
		TimeDown:setTimeInfo(temppayTimerId, UserActiveInfo.accpay.countdown)
		local payActData = {back="board_ljchongzhi.png", 
						   title = "ljchongzhi", 
						   desc=MultiLan("GAL_actDesc_4"), 
						   timerId = temppayTimerId,
						   callback=setPayTempAct,
						   info= UserActiveInfo.accpay,
						   layer= XiaLayerOwner["mActPay"]}
		table.insert(Activity_ActArr, payActData)
		ACT_TYPE_PAY_TEMP = table.maxn(Activity_ActArr)
	end

	--转盘
	if UserActiveInfo ~= nil and UserActiveInfo.daily_lottery ~= nil then
		local zhuanTimerId = TimeDown:register()
		TimeDown:setTimeInfo(zhuanTimerId, UserActiveInfo.daily_lottery.countdown)
		local zhuanActData = {back="board_fkzzz.png", 
						   title = "fkzzz", 
						   desc=MultiLan("GAL_actDesc_12"), 
						   timerId = zhuanTimerId,
						   callback= setZhuanAct,
						   info = UserActiveInfo.daily_lottery,
						   canReward = IsZhuanCanReward(UserActiveInfo.daily_lottery),
						   layer= XiaLayerOwner["mActZhuan"]}
		table.insert(Activity_ActArr, zhuanActData)
		ACT_TYPE_ZHUAN = table.maxn(Activity_ActArr)
	end 

	--VIP礼包
	local vipGiftActData = {back="board_viplibaoi.png", 
						   title = "viplibao", 
						   desc=MultiLan("GAL_actDesc_5"), 
						   callback=setVipGiftAct,
						   layer= XiaLayerOwner["mActVip"]}
	table.insert(Activity_ActArr, vipGiftActData)
	ACT_TYPE_VIP_GIFT = table.maxn(Activity_ActArr)
	
	--免费年卡
	local freeActData = {back="board_freefuli.png", 
					   title = "freefuli", 
					   desc=MultiLan("GAL_actDesc_7"), 
					   callback=setFreeAct,
					   layer= XiaLayerOwner["mActPay"],
					   canReward = IsActFreeCanReward()}
	table.insert(Activity_ActArr, freeActData)
	ACT_TYPE_FREE = table.maxn(Activity_ActArr)
	

	--新服累计充值
	if UserActiveInfo ~= nil and UserActiveInfo.newserver_pay ~= nil then
		local payTimerId = TimeDown:register()
		TimeDown:setTimeInfo(payTimerId, UserActiveInfo.newserver_pay.countdown)
		print("newserver_pay", UserActiveInfo.newserver_pay.countdown, payTimerId)
		local payActData = {back="board_ljchongzhi.png", 
						   title = "neljchongzhi", 
						   desc=MultiLan("GAL_actDesc_4"), 
						   timerId = payTimerId,
						   callback=setPayAct,
						   layer= XiaLayerOwner["mActPay"],
						   info = UserActiveInfo.newserver_pay}
		table.insert(Activity_ActArr, payActData)
		ACT_TYPE_PAY = table.maxn(Activity_ActArr)
	end

		--收集换大礼
	if UserActiveInfo ~= nil and UserActiveInfo.exchange ~= nil and UserActiveInfo.exchange ~= CJSON_NULL then
		local excTimerId = TimeDown:register()
		TimeDown:setTimeInfo(excTimerId, UserActiveInfo.exchange.mtime)
		local exchangeData = {back="board_sjhuandali.png", 
						   title = "sjhuandali", 
						   desc=MultiLan("GAL_actDesc_6"), 
						   callback=setExcAct,
						   layer= XiaLayerOwner["mActExc"],
						   timerId= excTimerId,
						   canReward = IsExchangeCanReward(UserActiveInfo.exchange),
						   info = UserActiveInfo.exchange}
		table.insert(Activity_ActArr, exchangeData)
		ACT_TYPE_EXC = table.maxn(Activity_ActArr)
	end
	--VIP每天领奖
	local vipActData = {back="board_thingsvip.png", 
					   title = "vipfuli", 
					   desc=MultiLan("GAL_actDesc_3"), 
					   callback=setVipAct,
					   layer= XiaLayerOwner["mActVip"],
					   canReward = IsActVipCanReward()}
	table.insert(Activity_ActArr, vipActData)
	ACT_TYPE_VIP_FREE = table.maxn(Activity_ActArr)
	
	--世界等级
	if UserInfo:getUserInfo().data.open_days > 5 then
		local levelActData = {back="board_worldlv.png", 
						   title = "worldlvft", 
						   desc=MultiLan("GAL_actDesc_10"), 
						   timerId = TimeDown:register(),
						   callback=setPayLevel,
						   layer= XiaLayerOwner["mActLevel"]}
		table.insert(Activity_ActArr, levelActData)
		ACT_TYPE_LEVEL = table.maxn(Activity_ActArr)
		TimeDown:setTimeInfo(Activity_ActArr[ACT_TYPE_LEVEL].timerId, 0)
	end
	

end

--重置界面显示
function resetActLayer()
	for i=1, table.maxn(Activity_ActArr) do
		if Activity_ActArr[i] ~= nil and Activity_ActArr[i].layer ~= nil then
			Activity_ActArr[i].layer:setVisible(false)
		end
	end
	XiaLayerOwner["mActMain"]:setVisible(true)
	XiaLayerOwner["mActNew"]:setVisible(false)
	XiaLayerOwner["mActCon"]:setVisible(false)
	XiaLayerOwner["mActVip"]:setVisible(false)
	XiaLayerOwner["mActPay"]:setVisible(false)
	XiaLayerOwner["mActExc"]:setVisible(false)
	XiaLayerOwner["mActLevel"]:setVisible(false)
	XiaLayerOwner["mActZhuan"]:setVisible(false)
	XiaLayerOwner["mActShop"]:setVisible(false)
	
	XiaLayerOwner["mCommonMoneyLayer"]:setVisible(false)
	GameActShowTag = 0
end

--界面初始化
function ActLayerInit()
	print("ActLayerInit")
	if bActInited then
		return
	end
	bActInited = true

	--新手活动
	CreateRichtextByFather(XiaLayerOwner["mActNewDesc"], 
							{{str=MultiLan("GAL_actDescDetail_1"), size=FontSize4},
							 {str=MultiLan("GAL_actDescDetail_2"), size=FontSize4, color=COLOR_CYAN},
							 })
							 
	XiaLayerOwner["mActLiveBlack"]:setOpacity(190)				 
	-- XiaLayerOwner["mActNewDesc2"]:setPositionY(165)
	--连续充值
	XiaLayerOwner["mActConPay"]:setTitleForState(MultiLan("GAL_actDescDetail_3"), cc.CONTROL_STATE_NORMAL)
	
	XiaLayerOwner["mActVipPay"]:setTitleForState(MultiLan("button_charge"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mActVipReward"]:setTitleForState(MultiLan("button_collect"), cc.CONTROL_STATE_NORMAL)
	
	--累计充值
	XiaLayerOwner["mActPayPay"]:setTitleForState(MultiLan("GAL_actDescDetail_3"), cc.CONTROL_STATE_NORMAL)
	
	--收集活动
	XiaLayerOwner["mActExcDesc1"]:setString(MultiLan("GAL_exc_desc1"))
	XiaLayerOwner["mActExcButton"]:setTitleForState(MultiLan("button_exchange"), cc.CONTROL_STATE_NORMAL)
	--世界等级
	CreateRichtextByFather(XiaLayerOwner["mActLevelDesc"], 
							{{str=MultiLan("GAL_level_desc1"), size=FontSize2},
								{size=nil},
							 {str=MultiLan("GAL_level_desc2"), size=FontSize2},
							 })
							 
	XiaLayerOwner["mActLevelDesc1"]:setString(MultiLan("GAL_level_desc10"))
	XiaLayerOwner["mActLevelDesc1"]:setColor(COLOR_GREEN)
	XiaLayerOwner["mActLevelDesc2"]:setString(MultiLan("GAL_level_desc3"))
	XiaLayerOwner["mActLevelDesc3"]:setString(MultiLan("GAL_level_desc4"))
	XiaLayerOwner["mActLevelDesc4"]:setString(MultiLan("GAL_level_desc5"))
	XiaLayerOwner["mActLevelDesc5"]:setString(MultiLan("GAL_level_desc6"))
	XiaLayerOwner["mActLevelDesc6"]:setString(MultiLan("GAL_level_desc8"))
	
	
	XiaLayerOwner["mActLevelExp"]:setString("")
	XiaLayerOwner["mActLevelExp"]:setColor(COLOR_GREEN)
	XiaLayerOwner["mActLevelHour"]:setString("")
	XiaLayerOwner["mActLevelHour"]:setColor(COLOR_GREEN)
	XiaLayerOwner["mActLevelAdd"]:setString("")
	XiaLayerOwner["mActLevelAdd"]:setColor(COLOR_GREEN)
	XiaLayerOwner["mActLevelTime"]:setString("")
	XiaLayerOwner["mActLevelCost1"]:setString("")
	XiaLayerOwner["mActLevelCost2"]:setString("")
	
	XiaLayerOwner["mActLevelButton1"]:setTitleForState(MultiLan("GAL_level_button1"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mActLevelButton2"]:setTitleForState(MultiLan("GAL_level_button2"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mActLevelButton3"]:setTitleForState(MultiLan("GAL_level_button3"), cc.CONTROL_STATE_NORMAL)
	
	--
	XiaLayerOwner["mActZhuanPay"]:setTitleForState(MultiLan("GAL_actDescDetail_3"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mActZhuanDesc3"]:setColor(COLOR_GREEN)
	
	XiaLayerOwner["mActShopBuyall"]:setVisible(false)
end

function ActEnter(enterType)
	print("ActEnter", enterType)
	--InitActArr()
	if enterType == nil then
		ActLayerInit()
		ActSetMain()
		resetActLayer()
	elseif Activity_ActArr[enterType] ~= nil then 
		Activity_ActArr[enterType].callback()
	end
end

function ActExit()
	XiaLayerOwner["mCommonMoneyLayer"]:setVisible(false)
end

--是否可以领取新手连续充值奖励
function IsConpayCanReward(actConInfo)
	local curConDay = UserSelfInfo.conpay_days
	local rewardTag = UserSelfInfo.conpay_reward
	for i=1,curConDay do
		local bit = rewardTag%2
		rewardTag = math.floor(rewardTag/2)
		if actConInfo.reward[i]~= nil and bit == 0 then
			return true
		end
	end
	
	return false
end

--是否可以领取临时连续充值奖励
function IsTempConpayCanReward(actConInfo)
	local curConDay = UserSelfInfo.actconpay_days
	local rewardTag = UserSelfInfo.actconpay_reward
	for i=1,curConDay do
		local bit = rewardTag%2
		rewardTag = math.floor(rewardTag/2)
		if actConInfo.reward[i]~= nil and bit == 0 then
			return true
		end
	end
	
	return false
end

--是否可以领取每日消费奖励
function IsDailyCanReward(actDailyInfo)
	local curCost = actDailyInfo.accpay
	local rewardTag = actDailyInfo.accpay_reward
	for i=1,table.maxn(actDailyInfo.reward) do
		
		local bit = rewardTag%2
		rewardTag = math.floor(rewardTag/2)
		if actDailyInfo.reward[i]~= nil and actDailyInfo.reward[i].price <= curCost and bit == 0 then
			return true
		end
	end

	return false
end


--是否可以领取收集奖励
function IsExchangeCanReward(actInfo, speTag)
	if actInfo == nil or (speTag ~= nil and actInfo.info[speTag] == nil) then
		return false
	end
	print("IsExchangeCanReward")
	
	local bEngough = false
	for i=1,table.maxn(actInfo.info) do
		
		if speTag == nil or speTag == i then
			local itemTable = actInfo.info[i].prop
			local bSingleEnough = true
			for j=1,table.maxn(itemTable) do
				local dynamicData = UserInfo:getPropByPropid(itemTable[j].prop_id)
				local totleNeed = itemTable[j].num
				local haveCount = 0
				if dynamicData ~= nil then
					haveCount = dynamicData.amount
				end
				if haveCount < totleNeed then
					bSingleEnough = false
					break
				end
			end
			if bSingleEnough then
				bEngough = true
				break
			end
		end
	end
	
	return bEngough 
end

--是否可以领取每日VIP奖励
function IsActVipCanReward()
	if UserSelfInfo.vip_benefit == 0 and UserSelfInfo.vip > 0 then
		return true
	else
		return false
	end
end

--是否可以领取年卡奖励
function IsActFreeCanReward()
	if FindFirstByValue(UserSelfInfo.free_card, 1) == nil or 
	   FindFirstByValue(UserSelfInfo.free_card, 2) == nil or
	   (FindFirstByValue(UserSelfInfo.free_card, 3) == nil and UserSelfInfo.vip >= 4) then
		return true
	else
		return false
	end
end

--是否可以转盘抽奖
function IsZhuanCanReward(actInfo)
	if actInfo.left ~= nil and actInfo.left > 0 then
		return true
	else
		return false
	end
end


local function onActExcReward()
	if IsExchangeCanReward(UserActiveInfo.exchange, actExcChooseTag) then
		local function excRewardCallback(jsonDataTable)
			if jsonDataTable.ret == 0 then
				--添加道具
				UserInfo:addProp(jsonDataTable.data.items)
				UserInfo:addPropNote(jsonDataTable.data.items)
				--删除道具
				for i=1, table.maxn(jsonDataTable.data.use) do
					UserInfo:removepropByPropId(jsonDataTable.data.use[i].prop_id, jsonDataTable.data.use[i].num)
				end
				
				Activity_ActArr[ACT_TYPE_EXC].canReward = IsExchangeCanReward(Activity_ActArr[ACT_TYPE_EXC].info)
				print("onActExcReward", Activity_ActArr[ACT_TYPE_EXC].canReward, Activity_ActArr[ACT_TYPE_EXC].noteNode)
				if Activity_ActArr[ACT_TYPE_EXC].canReward == false and Activity_ActArr[ACT_TYPE_EXC].noteNode ~= nil then
					removeSelf(Activity_ActArr[ACT_TYPE_EXC].noteNode)
				end
				
				--刷新界面
				setExcAct()
			end
		end
		
		HttpSend("activity/exchange", {"id="..UserActiveInfo.exchange.id,"idx="..actExcChooseTag}, excRewardCallback)
	else
		CommonNote(MultiLan("GAL_need_exchange_prop"))
	end
end

local function onActNewBack()
	resetActLayer()
end

local function onActConBack()
	resetActLayer()
end

local function onActPayBack()
	resetActLayer()
end

local function onActVipBack()
	resetActLayer()
end

local function onActExcBack()
	resetActLayer()
end

local function onActLevelBack()
	resetActLayer()
end

local function onActZhuanBack()
	resetActLayer()
end

local function onActHelpClick()
	if XiaLayerOwner["mActCon"]:isVisible() then
		if ACT_TYPE_CONPAY ~= 0 then
			HelpPopup("actilastpay")
		end
	elseif XiaLayerOwner["mActNew"]:isVisible() then
		HelpPopup("actifresh")
	elseif XiaLayerOwner["mActVip"]:isVisible() then
		--HelpPopup("actifresh")
	elseif XiaLayerOwner["mActExc"]:isVisible() then
		HelpPopup("acticollect")
	elseif XiaLayerOwner["mActLevel"]:isVisible() then
		HelpPopup("actilevel")
	elseif XiaLayerOwner["mActShop"]:isVisible() then
		HelpPopup("actishop")
	else
		HelpPopup("actimain")
	end
end

local function onActConPay()
	onMainPay()
end

local function onActPayPay()
	onMainPay()
end

local function onActVipReward()
	local function vipRewardCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			--添加道具
			
			UserInfo:addProp(jsonDataTable.data.items)
			UserInfo:addPropNote(jsonDataTable.data.items)
			
			--修改数据
			UserSelfInfo.vip_benefit = jsonDataTable.data.benefit
			
			--刷新界面
			setActVipRewardButton()
			
			Activity_ActArr[ACT_TYPE_VIP_FREE].canReward = IsActVipCanReward()
			if Activity_ActArr[ACT_TYPE_VIP_FREE].canReward == false and Activity_ActArr[ACT_TYPE_VIP_FREE].noteNode ~= nil then
				removeSelf(Activity_ActArr[ACT_TYPE_VIP_FREE].noteNode)
			end
		end
	end

	if UserSelfInfo.vip <= 0 then
		CommonNote(MultiLan("GAL_vipBenefit_1"))
	elseif UserSelfInfo.vip_benefit == 0 then
		HttpSend("activity/vip", {}, vipRewardCallback)
	else
		CommonNote(MultiLan("GAL_vipBenefit_2"))
	end
end

local function onActVipPay()
	onMainPay()
end

local function onActLevelMore()
	--CommonNote("onActLevelMore")
	local node = cc.Node:create()
	node:setTag(4)
	sendRoleList(node)
end

local function onZhuanpanClick()
	local function ZhuanEffect(stop, rewardItem)
		local sourceRotation = XiaLayerOwner["mActZhuanZhen"]:getRotation()%360
		XiaLayerOwner["mActZhuanZhen"]:setEnabled(false)
		local function resetClick()
			XiaLayerOwner["mActZhuanZhen"]:setEnabled(true)
			UserInfo:addPropNote(rewardItem)
			setZhuanAct()
		end
		local speed = 1200
		local distance = 3600+45*(stop-1)-sourceRotation+180
		XiaLayerOwner["mActZhuanZhen"]:runAction(cc.Sequence:create(cc.RotateBy:create(distance/speed/1.3, distance),
																	cc.RotateBy:create(360/speed*2,360),
																	cc.RotateBy:create(120/speed*4,120),
																	cc.RotateBy:create(60/speed*8,60),
																	cc.CallFunc:create(resetClick)))
	end
	
	
	local function zhuanCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			--添加道具
			UserInfo:addProp(jsonDataTable.data.item)
			
			--修改数据
			Activity_ActArr[ACT_TYPE_ZHUAN].info.countDown = jsonDataTable.data.countDown
			Activity_ActArr[ACT_TYPE_ZHUAN].info.count = jsonDataTable.data.count
			Activity_ActArr[ACT_TYPE_ZHUAN].info.left = jsonDataTable.data.left
			
			Activity_ActArr[ACT_TYPE_ZHUAN].canReward = IsZhuanCanReward(Activity_ActArr[ACT_TYPE_ZHUAN].info)
			if Activity_ActArr[ACT_TYPE_ZHUAN].canReward == false and Activity_ActArr[ACT_TYPE_ZHUAN].noteNode ~= nil then
				removeSelf(Activity_ActArr[ACT_TYPE_ZHUAN].noteNode)
			end
			
			ZhuanEffect(jsonDataTable.data.idx, jsonDataTable.data.item)
		end
	end
	
	if TimeDown:getTimeById(Activity_ActArr[ACT_TYPE_ZHUAN].timerId) > 0 and Activity_ActArr[ACT_TYPE_ZHUAN].info.left > 0 then
		HttpSend("activity/lottery", {}, zhuanCallback)
	end
end

XiaLayer["onActVipBack"]       = onActVipBack
XiaLayer["onActNewBack"]       = onActNewBack
XiaLayer["onActConBack"]       = onActConBack
XiaLayer["onActPayBack"]       = onActPayBack
XiaLayer["onActExcBack"]       = onActExcBack
XiaLayer["onActLevelBack"]     = onActLevelBack
XiaLayer["onActZhuanBack"]     = onActZhuanBack
XiaLayer["onActHelpClick"]     = onActHelpClick

XiaLayer["onActConPay"]      = onActConPay
XiaLayer["onActPayPay"]      = onActPayPay

XiaLayer["onActVipReward"]      = onActVipReward
XiaLayer["onActVipPay"]      = onActVipPay

XiaLayer["onActExcReward"]      = onActExcReward

XiaLayer["onActLevelMore"]      = onActLevelMore
XiaLayer["onWorleLevelReward"]    = onWorleLevelReward

XiaLayer["onZhuanpanClick"]    = onZhuanpanClick