local bArenaInited = false
UserArenaInfo = nil

local rewardTable = {
						{1,1,310,1000,1000},{2,2,290,700,700},{3,3,270,500,500},{4,4,250,400,400},
						{5,5,230,350,350},{6,10,210,300,300},{11,20,190,250,250},{21,30,170,200,200},
						{31,40,150,180,180},{41,50,130,160,160},{51,70,110,150,150},{71,100,100,140,140},
						{101,200,90,130,130},{201,300,80,120,120},{301,400,70,110,110},{401,500,60,100,100},
						{501,700,55,90,90},{701,1000,55,80,80},{1001,2000,50,70,70},{2001,3000,50,60,60},
						{501,700,55,90,90},{701,1000,55,80,80},{1001,2000,50,70,70},{2001,3000,50,60,60},
						{3001,4000,50,50,50},{4001,5000,50,40,40},{5001,7000,45,30,30},{7001,10000,45,20,20},
						{10001,50000,40,10,10}
						}

function setUserHead(node, role)
	--tolua.cast(node, "cc.Sprite"):setSpriteFrame("Lv."..level)
	tolua.cast(node, "cc.Sprite"):setSpriteFrame("actor_icon_"..role..".png")
end

function GetHeadByRole(role,position)
	return CreateCommonSprite("actor_icon_"..role..".png",position)
end

function GetLevelLabel(level, position,size)
	return CreateCommonLabel("Lv"..level, position, size)
end

function GetSchoolIconByRole(role, position)
	return CreateCommonSprite("school_icon_"..role..".png", position)
end

function setUserRoleIcon(node, role)
	tolua.cast(node, "cc.Sprite"):setSpriteFrame("school_icon_"..role..".png")
end

function setLevel(node, level)
	tolua.cast(node, "cc.Node"):setString("Lv."..level)
end

--设置名字和家族
function setNameAndFamily(father, name ,family)
	father:removeAllChildren(true)
	local size = father:getContentSize()
	local nameLabel = CreateCommonLabel(name,cc.p(5,size.height/2),FontSize4,nil,cc.p(0,0.5))
	father:addChild(nameLabel)
	if family ~= nil and family ~= "" then
		father:addChild(CreateCommonLabel("["..family.."]",cc.p(7+nameLabel:getContentSize().width,size.height/2),FontSize4,cc.c3b(210,0 ,255),cc.p(0,0.5)))
	end
end

--设置排名信息  排名 战力 签名
function setListAndMark(father, num , fightNum, desc)
	father:removeAllChildren(true)
	
	local richText = ccui.RichText:create()
	richText:ignoreContentAdaptWithSize(false)
	richText:setContentSize(father:getContentSize())
	richText:setPosition(Pos(father:getContentSize(),0.51,0.5))

	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GALa_rank_1"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(2, COLOR_GREEN, 255 , num,     DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(3, COLOR_WHITE, 255 ,"    "..MultiLan("GALa_rank_2"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(4, COLOR_GREEN, 255 ,fightNum,        DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	richText:pushBackElement(ccui.RichElementText:create(5, cc.c3b(210,0 ,255), 255 , desc, DefaultFontName, FontSize2))
	
	father:addChild(richText)
end

--设置排名信息  排名 积分 帮主
function setListAndMaster(father, num ,score, desc)
	father:removeAllChildren(true)
	
	local richText = ccui.RichText:create()
	richText:ignoreContentAdaptWithSize(false)
	richText:setContentSize(father:getContentSize())
	richText:setPosition(Pos(father:getContentSize(),0.51,0.5))

	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GALa_rank_1"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(2, COLOR_GREEN, 255 , num,     DefaultFontName, FontSize2))
	--richText:pushBackElement(ccui.RichElementText:create(3, COLOR_WHITE, 255 ,"    "..MultiLan("GALa_rank_2"),DefaultFontName, FontSize2))
	--richText:pushBackElement(ccui.RichElementText:create(4, COLOR_GREEN, 255 ,fightNum,        DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(4, COLOR_WHITE, 255 , "    "..MultiLan("union_battle_13"),     DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(4, COLOR_WHITE, 255 , score,     DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("union_battle_12"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(2, cc.c3b(210,0 ,255), 255 , desc, DefaultFontName, FontSize2))
	
	father:addChild(richText)
end

--设置名字和家族
function setFamilyAndScore(father, name ,score)
	father:removeAllChildren(true)
	
	local richText = ccui.RichText:create()
	richText:ignoreContentAdaptWithSize(false)
	richText:setContentSize(father:getContentSize())
	richText:setPosition(Pos(father:getContentSize(),0.51,0.5))

	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,name,DefaultFontName, FontSize2))
	father:addChild(richText)
	--richText:pushBackElement(ccui.RichElementText:create(3, COLOR_WHITE, 255 ,"    "..MultiLan("GALa_rank_2"),DefaultFontName, FontSize2))
	--richText:pushBackElement(ccui.RichElementText:create(4, COLOR_GREEN, 255 ,fightNum,        DefaultFontName, FontSize2))
end
--设置排名信息  排名 战力 排名奖励
local function setListAndReward(father, num ,fightNum)
	father:removeAllChildren(true)
	
	local richText = ccui.RichText:create()
	richText:ignoreContentAdaptWithSize(false)
	richText:setContentSize(father:getContentSize())
	richText:setPosition(Pos(father:getContentSize()))

	richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GALa_rank_1"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(2, COLOR_GREEN, 255 , num,     DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(3, COLOR_WHITE, 255 ,"    "..MultiLan("GALa_rank_2"),DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementText:create(4, COLOR_GREEN, 255 ,fightNum,        DefaultFontName, FontSize2))
	richText:pushBackElement(ccui.RichElementNewLine:create())
	richText:pushBackElement(ccui.RichElementText:create(5, COLOR_WHITE, 255 ,MultiLan("GALa_rank_3"),DefaultFontName, FontSize2))
	local function getRewardByRank(rank)
		for i=1,table.maxn(rewardTable) do
			if rank>= rewardTable[i][1] and rank <= rewardTable[i][2] then
				return rewardTable[i]
			end
		end
		return nil
	end
	local reward = getRewardByRank(num)
	if reward ~= nil then
	richText:pushBackElement(ccui.RichElementText:create(5, COLOR_CYAN, 255 ,MultiLan("GALa_rank_4"),DefaultFontName, FontSize1))
	richText:pushBackElement(ccui.RichElementText:create(5, COLOR_GREEN, 255 ,reward[3],DefaultFontName, FontSize1))
	richText:pushBackElement(ccui.RichElementText:create(5, COLOR_CYAN, 255 ,MultiLan("GALa_rank_5"),DefaultFontName, FontSize1))
	richText:pushBackElement(ccui.RichElementText:create(5, COLOR_GREEN, 255 ,reward[4],DefaultFontName, FontSize1))
	richText:pushBackElement(ccui.RichElementText:create(5, COLOR_CYAN, 255 ,MultiLan("GALa_rank_6"),DefaultFontName, FontSize1))
	richText:pushBackElement(ccui.RichElementText:create(5, COLOR_GREEN, 255 ,reward[5],DefaultFontName, FontSize1))
	end
	
	
	father:addChild(richText)
end

--刷新玩家的信息
local function arenaUpdateSelf()
	setNameAndFamily(XiaLayerOwner["mMyNameLayer"], UserSelfInfo.name, UserArenaInfo.self.union_name)
	setListAndReward(XiaLayerOwner["mMyInfoLayer"], UserArenaInfo.self.idx, UserAttr:getFightNum())
	setUserHead(XiaLayerOwner["mMyHead"], UserSelfInfo.role)
	setUserRoleIcon(XiaLayerOwner["mMyType"], UserSelfInfo.role)
	setLevel(XiaLayerOwner["mMyLevel"], UserSelfInfo.level)
end

--刷新敌人的信息
local function arenaUpdateEnemy()
	for i=1,3 do
		if UserArenaInfo.player[i] ~= nil then
			XiaLayerOwner["mArenaEnemyLayer"..i]:setVisible(true)
			setNameAndFamily(XiaLayerOwner["mEnemyNameLayer"..i], UserArenaInfo.player[i].name, UserArenaInfo.player[i].union_name)
			setListAndReward(XiaLayerOwner["mEnemyInfoLayer"..i],UserArenaInfo.player[i].idx, UserArenaInfo.player[i].power)
			SetCommonButtonSprite(XiaLayerOwner["mArnemyHead"..i], "actor_icon_"..UserArenaInfo.player[i].role..".png")
			setUserRoleIcon(XiaLayerOwner["mArnemyType"..i], UserArenaInfo.player[i].role)
			setLevel(XiaLayerOwner["mEnemyLevel"..i],  UserArenaInfo.player[i].level)
		else
			XiaLayerOwner["mArenaEnemyLayer"..i]:setVisible(false)
		end
	end
end

local function ArenaLayerInit()
	print("ArenaLayerInit")
	arenaUpdateSelf()
	arenaUpdateEnemy()
	XiaLayerOwner["mArenaDesc2"]:setString(UserArenaInfo.num)

	if bArenaInited then
		return
	end
	bArenaInited = true

	--文字
	XiaLayerOwner["mArenaDesc1"]:setString(MultiLan("GALa_enemyInfo_1"))
	XiaLayerOwner["mArenaDesc2"]:setColor(COLOR_GREEN)

	XiaLayerOwner["mArenaButtonList"]:setTitleForState(MultiLan("GALa_enemyInfo_2"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mArenaButtonShop"]:setTitleForState(MultiLan("GALa_enemyInfo_3"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mArenaButtonBuy"]:setTitleForState(MultiLan("GALa_enemyInfo_4"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mArenaButtonChange"]:setTitleForState(MultiLan("GALa_enemyInfo_5"), cc.CONTROL_STATE_NORMAL)
end

function ArenaEnter()
	GameGuide:handStepClick(31, XiaLayerOwner["mArenaButton"])
	ArenaLayerInit()
	GameGuide:setHandGuide(32, XiaLayerOwner["mTiaozhanButton"])
	GameGuide:GuideEnter(GUIDE_TYPE_ARENA)
end

--排行榜
function showArenaList(pvpListInfo)
	cclog("showArenaList")
	local popupContent = CreateLayer(POPUP_SIZE_MAX, 1, Pos(POPUP_SIZE_MAX))
	local scrollLayer  = CreateLayer(cc.size(600,640), 1, Pos(POPUP_SIZE_MAX,0.5,0.505))--nil,nil,cc.c4b(0,255,0,255))
	scrollLayer:setScale(0.98)
	popupContent:addChild(scrollLayer)
	
	--内容
	local layer = cc.Layer:create()
	local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0,0), kScrollViewDirectionVertical)
	local scrollWorldPos = scrolView:getParent():convertToWorldSpace(cc.p(scrolView:getPosition()))
	local scrollViewSize = scrolView:getViewSize()
	local count = table.maxn(pvpListInfo)
	print("count", count)
	local y = count*140-80
	for i=1, count do
		local back = nil
		local speNums = {"pic_pvpfirst.png", "pic_pvpsecond.png", "pic_pvpthird.png"}
		if i<=3 then
			back = CreateCommonSprite("board_challengemap.png", cc.p(300, y))
			back:addChild(CreateCommonSprite(speNums[i], cc.p(522, 72)))
		else
			back = CreateCommonSprite("board_overmap.png", cc.p(300, y))
			back:addChild(CreateCommonSprite("pic_pvpnumber.png", cc.p(522, 64)))
			back:addChild(CreateCommonLabel(i, cc.p(522,64), FontSize3))
		end
		local clickButton = CreateCommonButton("pic_suiyiaaa.png", cc.p(291, 64), cc.size(582,128), onPlayerDetailClick)
		clickButton:setSwallowTouch(false)
		clickButton:setName(pvpListInfo[i].uid)
		--clickButton:setScrollViewRect(cc.rect(scrollWorldPos.x, scrollWorldPos.y, scrollViewSize.width, scrollViewSize.height))
		back:addChild(clickButton, 0, pvpListInfo[i].uid)
		layer:addChild(back)
		
		local nameLayer = CreateCommonSprite("board_skill01.png", cc.p(291, 96))
		back:addChild(nameLayer)
		setNameAndFamily(nameLayer, pvpListInfo[i].name, pvpListInfo[i].union_name)
			
		local listLayer = CreateCommonSprite("board_skill02.png", cc.p(291, 41))
		back:addChild(listLayer)
		setListAndMark(listLayer ,pvpListInfo[i].idx, pvpListInfo[i].power,  pvpListInfo[i].sign)
		--头像
		local head = CreateCommonSprite("board_skill02.png", cc.p(60, 64))
		setUserHead(head, pvpListInfo[i].role)
		back:addChild(head)
		back:addChild(CreateCommonSprite("school_icon_"..pvpListInfo[i].role..".png", cc.p(30, 110)))
		back:addChild(CreateCommonLabel("Lv."..pvpListInfo[i].level, cc.p(70, 18), FontSize2))
		
		y = y - 140
	end


	layer:setContentSize(cc.size(600, math.max(640, 140*count-10)))
	scrolView:setContentOffset(cc.p(0, 640-(140*count-10)))
	if 140*count-10 < 630 then
		scrolView:setTouchEnabled(false)
	end
	
	--说明
	local ruleBack = CreateCommonSprite("board_skill01.png", Pos(POPUP_SIZE_MAX,0.5,0.91))
	ruleBack:setScaleX(1.6)
	popupContent:addChild(ruleBack)
	popupContent:addChild(CreateCommonLabel(MultiLan("GALa_rankDesc"),Pos(POPUP_SIZE_MAX,0.5,0.91), FontSize3))
	
	local popupRoot = CommonCreatePopupMax("pvplist", popupContent)
	--关闭
	local function closeFunc()
		removeSelf(popupRoot)
	end
	popupContent:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_MAX,0.5,0.06), cc.size(158,67), closeFunc, {str = MultiLan("button_close"), size = FontSize3}))
end

function onArenaList()
	local function rankInfoCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			cclog("arenaInfoCallback failed %d", jsonDataTable.ret)
			return 
		end

		showArenaList(jsonDataTable.data)
	end

	HttpSend("arena/rank", {}, rankInfoCallback)
end

--荣誉兑换
local function onArenaShop()
	local function arenaShopCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			cclog("arenaInfoCallback failed %d", jsonDataTable.ret)
			return 
		end
		CommonShopInfo = jsonDataTable.data
		CommonCreateShopPopup(SHOP_TYPE_ARENA)
	end

	HttpSend("shop/info", {"id="..SHOP_TYPE_ARENA}, arenaShopCallback)
end

--购买次数
function onArenaBuy()
	local function arenaBuyCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			cclog("arenaInfoCallback failed %d", jsonDataTable.ret)
			return 
		end
		
		UserArenaInfo.num = jsonDataTable.data.count
		UserSelfInfo.cash = UserSelfInfo.cash - 50
		UseCash(50)
		XiaLayerOwner["mArenaDesc2"]:setString(UserArenaInfo.num)
		CommonNote(MultiLan("GALa_buySucceed"))
	end
	
	local function sendArenaBuy()
		if UserArenaInfo.num >= 5 then
			CommonNote(MultiLan("GALa_challCount_1"))
		else
			HttpSend("arena/buy", {}, arenaBuyCallback)
		end
	end

	if UserSelfInfo.cash < 50 then
		CommonCashNeed()
	else
		CreateSmallPopupWithCancel("buytimes", CreateCommonLabel(MultiLan("GALa_challCount_2"), nil, FontSize3), sendArenaBuy)
	end
end

--换一批
local function onArenaChange()
	local function arenaRefreshCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			cclog("arenaInfoCallback failed %d", jsonDataTable.ret)
			return 
		end
		UserArenaInfo.player = jsonDataTable.data
		arenaUpdateEnemy()
	end

	HttpSend("arena/refresh", {}, arenaRefreshCallback)
end

--挑战
local function onArenaEnemyClicked(node)
	if UserArenaInfo.num <= 0 then
		onArenaBuy()
		return
	end
	
	GameGuide:handStepClick(32, XiaLayerOwner["mTiaozhanButton"])

	local tag = tolua.cast(node, "cc.Node"):getTag()
	ArnerFightId = UserArenaInfo.player[tag].uid
	ArnerFightRank = UserArenaInfo.player[tag].idx
	bFightWithBoss = 0
	NextFightLabel:setString(MultiLan("GALa_challNext").." "..UserArenaInfo.player[tag].name.." ...")
	NextFightLabel:setVisible(true)
	
	local node = cc.Node:create()
	node:setTag(2)
	ShowNew(node)
end

--查看详细信息
local function onArnemyHeadClick(node)
	if UserArenaInfo.player[node:getTag()] ~= nil then
		HttpSend("user/equip", {"fuid="..UserArenaInfo.player[node:getTag()].uid}, userDetailCallback)
	end
end

XiaLayer["onArenaList"]         = onArenaList
XiaLayer["onArenaShop"]         = onArenaShop
XiaLayer["onArenaBuy"]          = onArenaBuy
XiaLayer["onArenaChange"]       = onArenaChange
XiaLayer["onArnemyHeadClick"]   = onArnemyHeadClick
XiaLayer["onArenaEnemyClicked"] = onArenaEnemyClicked