BattleSetting = class("BattleSetting")
BattleSetting.__index = BattleSetting

BattleSetting.isCreated = false
BattleSetting.topNode = nil
BattleSetting.ICON_MAX = 6
BattleSetting.ICON_TABLE = {101, 102, 103, 104, 105, 201}

ccb["BattleSetting"] = BattleSetting
BattleSettingOwner = BattleSettingOwner or {}
ccb["BattleSettingOwner"] = BattleSettingOwner

function BattleSetting:BattleSettingEnter()
	if self.isCreated then
		self.topNode:setVisible(true)
	else
		self.isCreated = true
		local proxy = cc.CCBProxy:create()
		self.topNode = CommonCreatePopup(CCBReaderLoad("ccb/BattleSetting.ccbi",proxy,BattleSettingOwner))
		
		--ccb多语言
		BattleSettingOwner["mDesc"]:setString(MultiLan("set_desc1"))
		BattleSettingOwner["mDesc2"]:setString(MultiLan("set_desc2"))
		BattleSettingOwner["mDesc3"]:setString(MultiLan("set_desc3"))
		BattleSettingOwner["mDesc4"]:setString(MultiLan("set_desc4"))
		BattleSettingOwner["mDesc5"]:setTitleForState(MultiLan("set_desc5"), 1)
		BattleSettingOwner["mDesc6"]:setTitleForState(MultiLan("set_desc6"), 1)

		BattleSettingOwner["mTitleGameSetting"]:setString(ZGMultiLan("game_setting_title"))

		for i=1 , 4 do
			BattleSettingOwner["mColor"..i]:setString(MultiLan("CD_equipColor_"..i))
		end
	end
	for i = 1, self.ICON_MAX do
		BattleSettingOwner["mBattleSettingChoose" .. i]:setVisible(false)
	end
	local settingTable = UserInfo:getUserInfo().data.info.setting
	if settingTable ~= CJSON_NULL and settingTable ~= nil then
		cclog("setting table size %d", table.maxn(settingTable))
		for i = 1, table.maxn(settingTable) do
			for j = 1, self.ICON_MAX do
				if self.ICON_TABLE[j] == settingTable[i] then
					BattleSettingOwner["mBattleSettingChoose" .. j]:setVisible(true)
				end
			end
		end
	end
end

function BattleSetting:BattleSettingExit()
	BattleSetting.topNode:setVisible(false)
end

local function onBattleSettingCancel()
	BattleSetting.topNode:setVisible(false)
end

local function onBattleSettingSave()
	local isFirst = true
	local sendStr = "ids="
	for i = 1, BattleSetting.ICON_MAX do
		if BattleSettingOwner["mBattleSettingChoose" .. i]:isVisible() then
			if isFirst then
				sendStr = sendStr .. BattleSetting.ICON_TABLE[i]
				isFirst = false
			else
				sendStr = sendStr .. "," .. BattleSetting.ICON_TABLE[i]
			end
		end
	end
	cclog("setting str %s", sendStr)
	local function onBattleSettingSaveCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			cclog("onBattleSetting Save Callback failed %d", jsonDataTable.ret)
			return 
		end
		UserInfo:getUserInfo().data.info.setting = jsonDataTable.data.setting
		BattleSetting:BattleSettingExit()
	end
	HttpSend("user/setting", {sendStr}, onBattleSettingSaveCallback)
end

local function mBattleSettingIconClick(Iconbtn)
	local tmpBtn = BattleSettingOwner["mBattleSettingChoose" .. Iconbtn:getTag()]
	tmpBtn:setVisible(not tmpBtn:isVisible())
end

BattleSetting["onBattleSettingCancel"] = onBattleSettingCancel
BattleSetting["onBattleSettingSave"] = onBattleSettingSave
BattleSetting["mBattleSettingIconClick"] = mBattleSettingIconClick