GameConfig = class("GameConfig")
GameConfig.__index = GameConfig

GameConfig.configTable = nil
GameConfig.ChatReginAddress = nil
GameConfig.ChatPort = nil
function GameConfig:LoadConfig()
	self.configTable = {}
	local jsonString = cc.FileUtils:getInstance():getStringFromFile("GameConfig.json")
	self.configTable = (require "cjson").decode(jsonString)
	table.foreach(self.configTable,function(i, v) print (i, v) end)
	
	--print("***" .. GameConfig:GetLoginAddress() .. "***" .. GameConfig:GetAppVersion() .. "***" .. GameConfig:GetAssetUpdateAddress())
end

function GameConfig:GetIsRelease()
	if GameConfig.configTable["ReleaseVersion"] == 0 then
		return false
	else
		return true
	end
end

function GameConfig:GetIsTest()
	if GameConfig.configTable["TestVersion"] == nil then
		return false
	end

	if GameConfig.configTable["TestVersion"] == 0 then
		return false
	else
		return true
	end
end

function GameConfig:GetIsLuaEncry()
	if GameConfig.configTable["LuaEncry"] == 0 then
		return false
	else
		return true
	end
end

function GameConfig:GetLoginAddress()
	return GameConfig.configTable["LoginAddress"]
end

function GameConfig:GetChatAddress()
	return GameConfig.ChatReginAddress
end
function GameConfig:GetChatPort()
	return GameConfig.ChatPort
end

function GameConfig:SetLoginReginAddress( reginAddress)
	GameConfig.configTable["LoginAddress"] = reginAddress
end

function GameConfig:SetChatReginAddress(ChatAddress,port)
	cclog("chat address %s %d", ChatAddress, port)
	GameConfig.ChatReginAddress = ChatAddress
	GameConfig.ChatPort  = port
end

function GameConfig:GetAssetUpdateAddress()
	return GameConfig.configTable["AssetUpdateAddress"]
end

function GameConfig:GetAppVersion()
	return GameConfig.configTable["Version"]
end