GameEnteringLayer = class("GameEnteringLayer")
GameEnteringLayer.__index = GameEnteringLayer

ccb["GameEnteringLayer"] = GameEnteringLayer
GameEnteringLayerOwner = GameEnteringLayerOwner or {}
ccb["GameEnteringLayerOwner"] = GameEnteringLayerOwner

GameEnteringLayer.topNode = nil
GameEnteringLayer.stringLabel = nil
GameEnteringLayer.progressBar = nil
GameEnteringLayer.percent = 0
GameEnteringLayer.scheduleEntry = nil

GameEnteringLayer.REQUEST_USER_INFO = 10
GameEnteringLayer.PREPARE_USER_INFO = 40
GameEnteringLayer.GENERATE_BAG_INFO = 75
GameEnteringLayer.FINISH = 100

function GameEnteringLayerUpdate()
	if GameEnteringLayer.percent == GameEnteringLayer.REQUEST_USER_INFO then
		GameEnteringLayer.stringLabel:setString(MultiLan("GEL_explain_1"))
	elseif GameEnteringLayer.percent == GameEnteringLayer.PREPARE_USER_INFO then
		GameEnteringLayer.stringLabel:setString(MultiLan("GEL_explain_2"))
	elseif GameEnteringLayer.percent == GameEnteringLayer.GENERATE_BAG_INFO then
		GameEnteringLayer.stringLabel:setString(MultiLan("GEL_explain_3"))
	elseif GameEnteringLayer.percent == GameEnteringLayer.FINISH then
		GameEnteringLayer.stringLabel:setString(MultiLan("GEL_explain_4"))
	end
	GameEnteringLayer.progressBar:setPercentage(GameEnteringLayer.percent)
end

function GameEnteringLayer:GameEnteringLayerEnter()	
	local proxy = cc.CCBProxy:create()
	self.topNode = CCBReaderLoad("ccb/gameEnteringLayer.ccbi",proxy,GameEnteringLayerOwner)
	scene:addChild(self.topNode,1)
    
    self.stringLabel = GameEnteringLayerOwner["stringLabel"]
    self.percentLayer = GameEnteringLayerOwner["percentLayer"]

	local x,y = GameEnteringLayerOwner["progresssprite"]:getPosition()	
    GameEnteringLayerOwner["progresssprite"]:removeFromParent(true)

	self.progressBar = cc.ProgressTimer:create(cc.Sprite:createWithSpriteFrameName("pic_enterloading02.png"))
	self.progressBar:setPosition(cc.p(x,y))
	self.progressBar:setType(cc.PROGRESS_TIMER_TYPE_BAR)
	self.progressBar:setMidpoint(cc.p(0, 0))
	self.progressBar:setBarChangeRate(cc.p(1, 0))
	self.percentLayer:addChild(self.progressBar)
	
	self.scheduleEntry = scheduler:scheduleScriptFunc(GameEnteringLayerUpdate, 0, false)
end

function GameEnteringFinish()
	GameEnteringLayer.percent = GameEnteringLayer.FINISH
	
	DelayTimeCallfunc(scene, 0.6, EnteringExit)
end

function EnteringExit()
	GameEnteringLayer:GameEnteringLayerExit()
end

function GameEnteringLayer:GameEnteringLayerExit()
	scheduler:unscheduleScriptEntry(self.scheduleEntry)
	self.topNode:removeFromParent(true)
	LoginLayer.topNode:removeFromParent(true)
	if LoginRegisterLayer.topNode ~= nil then
		LoginRegisterLayer.topNode:removeFromParent(true)
	end
	UI_LAYER:setVisible(true)
end