EquipForgeLayer = class("EquipForgeLayer")
EquipForgeLayer.__index = EquipForgeLayer

EquipForgeLayer.topNode = nil

ccb["EquipForgeLayer"] = EquipForgeLayer
EquipForgeLayerOwner = EquipForgeLayerOwner or {}
ccb["EquipForgeLayerOwner"] = EquipForgeLayerOwner

EquipForgeLayer.forgeEquipDataTable = {}
local RICHINFOTAG = 10
EquipForgeLayer.ForgeRefreshNum = 0
--//////////////////////////////////////////////////////



function RefreshEquipForgeLayer(forgeEquips,Refresh_num)
	if forgeEquips.strengthen == nil then
		forgeEquips.strengthen = 0
	end
	EquipForgeLayer.forgeEquipDataTable =  forgeEquips
	EquipForgeLayer.ForgeRefreshNum =  Refresh_num

    EquipForgeLayer.topNode:removeChildByTag(RICHINFOTAG)
    EquipForgeLayer.topNode:removeChildByTag(RICHINFOTAG + 1)

    UserAttr:setEquipGradeAndScore(EquipForgeLayer.forgeEquipDataTable)

	local itemRichInfo = EquipHelper:createItemInfoRichtext(EquipForgeLayer.forgeEquipDataTable)
    itemRichInfo:setContentSize(cc.size(270, 500))
	itemRichInfo:formatText()
	itemRichInfo:ignoreAnchorPointForPosition(true)
	itemRichInfo:setPosition(cc.p(230, 204))
	EquipForgeLayer.topNode:addChild(itemRichInfo,RICHINFOTAG,RICHINFOTAG)

	local bagItem = CreateBagItem()
	bagItem:setCanTouch(false)
    bagItem:setItemType(BAG_ITEM_TYPE_EQUIP)
	bagItem:setItemInfoTable(EquipForgeLayer.forgeEquipDataTable)
    --local highit =  EquipForgeLayer.topNode:getContentSize().height * 0.68
	bagItem:setPosition(cc.p(150, 960*0.68))
	EquipForgeLayer.topNode:addChild(bagItem,RICHINFOTAG + 1,RICHINFOTAG + 1)
	
	tolua.cast(EquipForgeLayerOwner["mForgeFreeTimes"], "cc.Label"):setString(MultiLan("GEFL_refreshTime")..EquipForgeLayer.ForgeRefreshNum)
	tolua.cast(EquipForgeLayerOwner["mForgeCost"], "cc.Label"):setString(MultiLan("GEFL_makeNeedForge")..
	                EquipForgeLayer.forgeEquipDataTable.cost.."("..MultiLan("GEFL_currentForge")..UserInfo:getUserInfo().data.info.fusion..")")
	if EquipForgeLayer.forgeEquipDataTable.cost >  UserInfo:getUserInfo().data.info.fusion then
	    EquipForgeLayerOwner["mForgeCost"]:setColor(COLOR_RED)
	else
	    EquipForgeLayerOwner["mForgeCost"]:setColor(COLOR_GREEN)
	end

    local propInfoTable = GameData:getPropDataTable(EquipForgeLayer.forgeEquipDataTable.prop_id)
    if propInfoTable.ptype == 7 then
        tolua.cast(EquipForgeLayerOwner["mForgeEquipPlace"], "cc.Label"):setString(MultiLan( "equip_place_"..propInfoTable.place))
    else
        tolua.cast(EquipForgeLayerOwner["mForgeEquipPlace"], "cc.Label"):setString(MultiLan(propInfoTable.name))
    end
end


function InitEquipForgeLayer(forgeEquips)

    RefreshEquipForgeLayer(forgeEquips.info.list[1],forgeEquips.refresh_num)
	--swallowLaer
	local function onEquipForgeSwallowTouch(touch, event)
		return true
	end
	SetTouchEventForLayer(EquipForgeLayerOwner["mEquipForgeSwallowLayer"], onEquipForgeSwallowTouch)
end

function EquipForgeLayer: EquipForgeLayerExit()
    EquipMeltLayer:refreshEquipMeltValue()
	self.topNode:removeFromParent()
	self.topNode = nil
end

function EquipForgeLayer:EquipForgeLayerEnter( forgeEquip)
    if self.topNode ~= nil then
        return
    end

	local proxy = cc.CCBProxy:create()
	self.topNode = CCBReaderLoad("ccb/EquipForgeLayer.ccbi",proxy,EquipForgeLayerOwner)
	
	EquipForgeLayerOwner["mForgeDesc1"]:setString(MultiLan("forge_desc1"))
	EquipForgeLayerOwner["mForgeFreeTimes"]:setString(MultiLan("forge_desc2"))
	EquipForgeLayerOwner["mForgeCost"]:setString(MultiLan("forge_desc3"))
	EquipForgeLayerOwner["mButtonMake"]:setTitleForState(MultiLan("forge_forge"), 1)
	EquipForgeLayerOwner["mButtonRefresh"]:setTitleForState(MultiLan("button_refresh"), 1)
	EquipForgeLayerOwner["mForgeNote"]:setColor(COLOR_GREEN)
	EquipForgeLayerOwner["mForgeNote"]:setString(MultiLan("forge_desc8"))
	EquipForgeLayerOwner["mTitleEquipForge"]:setString(ZGMultiLan("equip_forge_title"))

	if POPUP_LAYER ~= nil then
	    POPUP_LAYER:addChild(self.topNode)
		InitEquipForgeLayer(forgeEquip)
	end
end

function onForgeRefreshBtnClick()
	local function forgeRefreshCallback(jsonDataTable)
        if  jsonDataTable == CJSON_NULL or jsonDataTable.ret ~= 0 then
            return
        end
		
		local shopid = jsonDataTable.data.info.id
        if shopid ~= 1 then
			return
		end

        if jsonDataTable.data.info.list ~= CJSON_NULL then

           if  EquipForgeLayer.ForgeRefreshNum > 0 then
               EquipForgeLayer.ForgeRefreshNum = EquipForgeLayer.ForgeRefreshNum - 1
           else
               UserInfo:setCash(UserInfo:getCash() - 20)
               XiaLayer:SetHomeUserInfo()
           end

		   RefreshEquipForgeLayer(jsonDataTable.data.info.list[1],EquipForgeLayer.ForgeRefreshNum)
        end
	end
 
    local function sendForgeRefresh()
        HttpSend("shop/refresh", {"id=1"}, forgeRefreshCallback)
    end

    if EquipForgeLayer.ForgeRefreshNum > 0  then
	    sendForgeRefresh()
    else
        if UserInfo.UserInfoTable.data.info.cash < 10 then
		    CommonCashNeed()
	    else
        local content = cc.Label:create(MultiLan("GEFL_rfrshNeedGold"), DefaultFontName, FontSize3,cc.size(460,160),0,1)
	    CreateSmallPopupWithCancel("surere",content, sendForgeRefresh)

	    end
    end
end


function onForgeBuyBtnClick()
	cclog("onForgeBuyBtnClick")
	local function forgeBuyCallback(jsonDataTable)
        if  jsonDataTable == CJSON_NULL then
            return
        end
		
		if jsonDataTable.ret ~= 0 then
			cclog("take on equip failed %d", jsonDataTable.ret)
            if jsonDataTable.ret == 1103 then
               CommonNote(MultiLan("GEFL_makeFail_1"))
            elseif jsonDataTable.ret == 1003 then
               CommonNote(MultiLan("GEFL_makeFail_2"))
            end
			return 
		end

        UserInfo:addProp(jsonDataTable.data.item)
        CommonNote(MultiLan("lan_get").. MultiLan(GameData:getPropDataTable(jsonDataTable.data.item[1].prop_id).name))
        UserInfo:getUserInfo().data.info.fusion = UserInfo:getUserInfo().data.info.fusion - EquipForgeLayer.forgeEquipDataTable.cost
        RefreshEquipForgeLayer(jsonDataTable.data.newinfo.list[1],EquipForgeLayer.ForgeRefreshNum)
	end
	if  UserInfo:getUserInfo().data.info.fusion < EquipForgeLayer.forgeEquipDataTable.cost then
        CommonNote(MultiLan("GEFL_makeFail_3"))
    else 
	    HttpSend("shop/buy", {"id=1", "itemid="..EquipForgeLayer.forgeEquipDataTable.id}, forgeBuyCallback)
    end
end

function onEquipForgeHelpBtnClick()
	cclog("onEquipForgeHelpBtnClick")
	HelpPopup("meltnormal")
end

function onCloseEquipForgeBtnClick()
	cclog("onCloseEquipForgeBtnClick")
	EquipForgeLayer:EquipForgeLayerExit()
end

--//////////////////////////////////

EquipForgeLayer["onForgeRefreshBtnClick"] = onForgeRefreshBtnClick
EquipForgeLayer["onForgeBuyBtnClick"] = onForgeBuyBtnClick
EquipForgeLayer["onEquipForgeHelpBtnClick"] = onEquipForgeHelpBtnClick
EquipForgeLayer["onCloseEquipForgeBtnClick"] = onCloseEquipForgeBtnClick