

GameGuide = class("GameGuide")
GameGuide.__index = GameGuide

GameGuide.guideValue = nil    --服务器字段
GameGuide.noteButton = {}

--分布一次性引导
GUIDE_TYPE_BATTLE = 1
GUIDE_TYPE_MAP    = 2
GUIDE_TYPE_FORGE  = 3  
GUIDE_TYPE_SKILL  = 4
GUIDE_TYPE_HERO   = 5
GUIDE_TYPE_ARENA  = 6
GUIDE_TYPE_MARKET = 7
GUIDE_TYPE_SKILLUP = 8
GUIDE_TYPE_SKILLMASTER = 9
GUIDE_TYPE_FASTFIGHT = 10
--连续引导
GUIDE_OFFSET = 20
HandGuideValue = 0
HandGuideStep = 0
IsHandGuideEnd = true

GUIDE_EFFECT_TAG = 1112
MASTER_EFFECT_TAG = 1113
D_MASTER_EFFECT_TAG = 1114
HAND_EFFECT_TAG = 1115

showFailedPopup = false  --控制只有一个战败弹窗

local function checkLevel(level)
	if UserSelfInfo.level < level then
		return false
	else
		return true
	end
end

local function checkFightNum(fight)
	print("checkFightNum", UserAttr:getFightNum(), fight)
	if UserAttr:getFightNum() < fight then
		return false
	else
		return true
	end
end

--检查技能
function CheckSkill()
	print("CheckSkill")
	return checkLevel(5)
end

function SkillNotOpen()
	CommonNote(MultiLan("GG_open_1"))
end

--检查英雄
function CheckHero()
	return checkLevel(15)
end

function HeroNotOpen()
	CommonNote(MultiLan("GG_open_2"))
end

--检查竞技场
function CheckFamily()
	return checkLevel(12)
end

function FamilyNotOpen()
	CommonNote(MultiLan("GG_open_3"))
end

--检查竞技场
function CheckArena()
	return checkFightNum(1000)
end

function ArenaNotOpen()
	CommonNote(MultiLan("GG_open_4"))
end

--检查团战斗
function CheckGroup()
	return checkFightNum(1500)
end

function GroupNotOpen()
	CommonNote(MultiLan("GG_open_5"))
end

--检查护法群战
function CheckTeam()
	return checkLevel(20)
end

--检查技能升级
function CheckSkillLevelup()
	return checkLevel(30)
end

--检查技能专精
function CheckSkillMaster()
	return checkLevel(50)
end

--检查快速战斗
function CheckFastFight()
	return checkLevel(2)
end

function TeamNotOpen()
	CommonNote(MultiLan("GG_open_7"))
end

--检查市集
function CheckMarket()
	if checkLevel(18) or UserSelfInfo.vip > 0 then
		return true
	else
		return false
	end
end

function MarketNotOpen()
	CommonNote(MultiLan("GG_open_8"))
end

function CheckForge()
	if table.maxn(UserInfo:getUserInfo().data.bag_equip) >= UserSelfInfo.bagslots then
		return true
	else
		return false
	end
end

function GameGuide:setButtonNote(button, bNeedNote, pos, scale)
	local node = nil
	if bNeedNote and button:getChildByTag(GUIDE_EFFECT_TAG) == nil then
		if pos == nil then
			node = AddNewNoteEffect(button,Pos(button:getContentSize(),0.8,0.8))
		else
			node = AddNewNoteEffect(button,pos)
		end
		if scale ~= nil then
			node:setScale(scale)
		end
	elseif bNeedNote == false and button:getChildByTag(GUIDE_EFFECT_TAG) ~= nil then
		button:removeChildByTag(GUIDE_EFFECT_TAG)
	end
	return node
end

function GameGuide:checkGuide(guideType)
	print("checkGuide",guideType)
	local value = self.guideValue
	local tag = 0
	for i=1, guideType do
		tag = value%2
		value = math.floor(value/2)
	end
	
	local chekFunc = {nil, nil, CheckForge, CheckSkill , CheckHero, CheckArena, CheckMarket, CheckSkillLevelup, CheckSkillMaster, CheckFastFight}
	print("value", value, tag, chekFunc[guideType])
	if tag == 0 then
		if chekFunc[guideType] == nil or chekFunc[guideType]() then
			return true 
		else
			return false
		end
	else
		return false
	end
end
--初始化引导
function GameGuide:initGuide()
	self.guideValue = UserInfo:getUserInfo().data.info.guide
	print("initGuide", self.guideValue)
	self.noteButton = {XiaLayerOwner["mMainButton2"],XiaLayerOwner["mBattleMapButton"],XiaLayerOwner["mHomeMeltButton"],XiaLayerOwner["mMainButton5"],XiaLayerOwner["mMainButton6"], XiaLayerOwner["mArenaButton"], XiaLayerOwner["mHomeMarketButton"], XiaLayerOwner["mSkillLevelupBtn"], XiaLayerOwner["mSkillMasterBtn"],  XiaLayerOwner["mBattleFastFightButton"]}
	self:refreshGuide()
end

--初始化小手引导
function GameGuide:initHandGuide()
	--连续引导
	HandGuideValue = UserSelfInfo.guide
	for i=1, GUIDE_OFFSET do
		HandGuideValue = math.floor(HandGuideValue/2)
	end
	print("initHandGuide", HandGuideValue)
	if HandGuideValue >= 7 then
		IsHandGuideEnd = true
	else
		IsHandGuideEnd = false
	end
	
	self:resetHandGuide()
end
--重置小手引导
function GameGuide:resetHandGuide()
	print("resetHandGuide",IsHandGuideEnd)
	if IsHandGuideEnd then
		self:setHandEffect(XiaLayerOwner["mMainButton3"], false)
		
		self:setHandEffect(XiaLayerOwner["mMainButton2"], false)
		
		self:setHandEffect(XiaLayerOwner["mBattleMapButton"], false)
		
		self:setHandEffect(XiaLayerOwner["mArenaButton"], false)
		
		return
	end

	if HandGuideValue == 0 then
		HandGuideStep = 11 
		self:setHandEffect(XiaLayerOwner["mMainButton3"], true)
		self:setHandEffect(XiaLayerOwner["mMainButton2"], false)
		self:setHandEffect(XiaLayerOwner["mBattleMapButton"], false)
		self:setHandEffect(XiaLayerOwner["mArenaButton"], false)
	elseif HandGuideValue == 1 then
		HandGuideStep = 21
		self:setHandEffect(XiaLayerOwner["mMainButton3"], false)
		self:setHandEffect(XiaLayerOwner["mMainButton2"], true)
		self:setHandEffect(XiaLayerOwner["mBattleMapButton"], false)
		self:setHandEffect(XiaLayerOwner["mArenaButton"], false)
	elseif HandGuideValue == 3 then
		if CheckArena() then
			HandGuideStep = 31
			self:setHandEffect(XiaLayerOwner["mMainButton3"], false)
			self:setHandEffect(XiaLayerOwner["mMainButton2"], false)
			self:setHandEffect(XiaLayerOwner["mBattleMapButton"], false)
			self:setHandEffect(XiaLayerOwner["mArenaButton"], true)
		else
			HandGuideStep = 0
			self:setHandEffect(XiaLayerOwner["mArenaButton"], false)
		end
	end
	print("resetHandGuide", HandGuideStep)
end

function GameGuide:setHandGuide(step, button)
	if IsHandGuideEnd then
		return
	end
	print("setHandGuide", step)
	if HandGuideStep == step then
		self:setHandEffect(button, true)
	else
		self:setHandEffect(button, false)
	end
end

--点击
function GameGuide:handStepClick(step, button)
	if IsHandGuideEnd then
		return
	end
	print("handStepClick", step, HandGuideStep)
	if HandGuideStep == step then
		self:setHandEffect(button, false)

		if HandGuideStep == 13 then
			GameGuide:GuideEnter(GUIDE_OFFSET + 1)
		elseif HandGuideStep == 23 then
			GameGuide:GuideEnter(GUIDE_OFFSET + 2)
		elseif HandGuideStep == 32 then
			GameGuide:GuideEnter(GUIDE_OFFSET + 3)
		else
			HandGuideStep = HandGuideStep + 1
		end
	end
end

function GameGuide:setHandEffect(button, bHand)
	if IsHandGuideEnd or button == nil then
		return
	end
	
	if bHand and button:getChildByTag(HAND_EFFECT_TAG) == nil then
		local hand = CreateCommonSprite("pic_hand1.png", Pos(button:getContentSize()))
		hand:setAnchorPoint(0.2,0.8)
		hand:setScale(0.8)
		hand:setPosition(cc.p(hand:getPositionX()+20,hand:getPositionY()-20))
		button:addChild(hand, 100 , HAND_EFFECT_TAG)
		
		
		local function changeHand2(node)
			tolua.cast(node, "cc.Sprite"):setSpriteFrame("pic_hand2.png")
		end
		local function changeHand1(node)
			tolua.cast(node, "cc.Sprite"):setSpriteFrame("pic_hand1.png")
		end
		local function resetPosition(node)
			node:setPosition(Pos(button:getContentSize()))
			node:setPosition(cc.p(node:getPositionX()+20,node:getPositionY()-20))
			node:setVisible(false)
			node:setOpacity(255)
		end
		
		hand:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.MoveBy:create(0.8,cc.p(-20,20)), 
											   cc.DelayTime:create(0.1),
											   cc.CallFunc:create(changeHand2),
											   cc.DelayTime:create(0.3),
											   cc.CallFunc:create(changeHand1),
											   cc.DelayTime:create(0.3),
											   cc.FadeOut:create(0.2),
											   cc.CallFunc:create(resetPosition),
											   cc.DelayTime:create(0.2),
											   cc.CallFunc:create(VisivleTrueSelf)
											   )))
	elseif bHand == false and button:getChildByTag(HAND_EFFECT_TAG) ~= nil then
		button:removeChildByTag(HAND_EFFECT_TAG)
	end
end

--刷新引导提示
function GameGuide:refreshGuide(guideType)
	if self.guideValue == nil then
		return
	end
	local position = {Pos(cc.size(102,102),0.8,0.8),Pos(cc.size(144,50),0.9,0.7),Pos(cc.size(196,197),0.85,0.85),Pos(cc.size(102,102),0.8,0.8),Pos(cc.size(102,102),0.8,0.8),Pos(cc.size(196,197),0.85,0.85), Pos(cc.size(196,197),0.85,0.85), Pos(cc.size(158,67),0.95,0.8), Pos(cc.size(158,67),0.95,0.8),Pos(cc.size(144,50),0.9,0.7)}
	
	for i=1,10 do
		print("refreshGuide",i)
		if guideType == nil or guideType == i then
			print(self:checkGuide(i), self.noteButton[i])
			if self:checkGuide(i) and self.noteButton[i] ~= nil then
				print(1)
				if self.noteButton[i]:getChildByTag(GUIDE_EFFECT_TAG) == nil then
					AddNewNoteEffect(self.noteButton[i],position[i])
				end
			else
				print(2)
				if self.noteButton[i] ~= nil and self.noteButton[i]:getChildByTag(GUIDE_EFFECT_TAG) ~= nil then
					self.noteButton[i]:removeChildByTag(GUIDE_EFFECT_TAG)
				end
			end
		end
	end
end

--设置引导内容
function GameGuide:GuideEnter(guideType)
	local function guideCallback(jsonDataTable)
		print("guideCallback")
	end

	if self:checkGuide(guideType) then
		HttpSend("user/guide",{"guide="..math.pow(2, guideType-1)},guideCallback, true)
		self.guideValue = self.guideValue + math.pow(2, guideType-1)
		UserSelfInfo.guide = self.guideValue
		
		if self.noteButton[guideType] ~= nil then
			self.noteButton[guideType]:removeChildByTag(GUIDE_EFFECT_TAG)
		end
		
		if guideType > GUIDE_OFFSET then
			self:initHandGuide()
		else
			self:guidePopup(guideType)
		end
	end
end

--弹窗
function GameGuide:guidePopup(guideType)
	if GUIDE_TYPE_FASTFIGHT == guideType then
		return
	end

	local content = CreateLayer(cc.size(480,180), 1, Pos(POPUP_SIZE_SML))
--popupContet:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_SML, 0.3, 0.18), cc.size(158,67), closeFunc, {str="取消", size = FontSize3}))
	print("guidePopup",guideType)
	local richText = ccui.RichText:create()
	richText:ignoreContentAdaptWithSize(false)
	richText:setAnchorPoint(cc.p(0.5, 0.5))
	richText:setContentSize(cc.size(480,180))
	richText:setPosition(Pos(content:getContentSize()))
	content:addChild(richText)
	if guideType == GUIDE_TYPE_BATTLE then
		print(1)
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_1"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255 ,MultiLan("GG_guide_2"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_3"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255 ,MultiLan("GG_guide_4"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_5"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255 ,MultiLan("GG_guide_6"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_7"),DefaultFontName, FontSize4))
	elseif guideType == GUIDE_TYPE_MAP then
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_8"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255 ,MultiLan("GG_guide_9"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_10"),DefaultFontName, FontSize4))
	elseif guideType == GUIDE_TYPE_FORGE then
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_11"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255 ,MultiLan("GG_guide_12"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_13"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255 ,MultiLan("GG_guide_14"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_15"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255 ,MultiLan("GG_guide_16"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_17"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255 ,MultiLan("GG_guide_18"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_19"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255 ,MultiLan("GG_guide_20"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_21"),DefaultFontName, FontSize4))
	elseif guideType == GUIDE_TYPE_SKILL then
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_8"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255 ,MultiLan("GG_guide_22"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_23"),DefaultFontName, FontSize4))
	elseif guideType == GUIDE_TYPE_HERO then
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_8"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255 ,MultiLan("GG_guide_24"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_25"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255 ,MultiLan("GG_guide_26"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_27"),DefaultFontName, FontSize4))
	elseif guideType == GUIDE_TYPE_ARENA then
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_29"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255 ,MultiLan("GG_guide_30"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_31"),DefaultFontName, FontSize4))
	elseif guideType == GUIDE_TYPE_MARKET then
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_32"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255 ,MultiLan("GG_guide_33"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_34"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255 ,MultiLan("GG_guide_35"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_36"),DefaultFontName, FontSize4))
	elseif guideType == GUIDE_TYPE_SKILLUP then
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_37"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255 ,MultiLan("GG_guide_38"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_39"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255 ,MultiLan("GG_guide_40"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_41"),DefaultFontName, FontSize4))
	elseif guideType == GUIDE_TYPE_SKILLMASTER then
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_42"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255 ,MultiLan("GG_guide_43"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_44"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_RED, 255 ,MultiLan("GG_guide_45"),DefaultFontName, FontSize4))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GG_guide_46"),DefaultFontName, FontSize4))
	end
	richText:pushBackElement(ccui.RichElementNewLine:create())
	richText:setPosition(cc.p(240,90-(180-richText:getTextMaxHeight())/2))

	local titileArr = {"guajiintro", "cmapintro", "smeltintro", "skillintro", "merintro"}
	CreateSmallPopupWithCancel(titileArr[guideType], content) 
end

local function setSmallPopupByMultiLanguage(title, descTable)
	if type(descTable) ~= "table" or table.maxn(descTable) == 0 then
		return
	end
	showFailedPopup = true
	local content = CreateLayer(cc.size(480,180), 1, Pos(POPUP_SIZE_SML))
	local richText = ccui.RichText:create()
	richText:ignoreContentAdaptWithSize(false)
	richText:setAnchorPoint(cc.p(0.5, 0.5))
	richText:setContentSize(cc.size(480,180))
	richText:setPosition(Pos(content:getContentSize()))
	content:addChild(richText)
    
	local typeColor = {COLOR_WHITE, COLOR_RED, COLOR_GREEN}
	for i=1, table.maxn(descTable) do
		richText:pushBackElement(ccui.RichElementText:create(1, typeColor[descTable[i].t], 255 , MultiLan(descTable[i].d),DefaultFontName, FontSize4))
	end
	richText:setPosition(cc.p(240,90-(180-richText:getTextMaxHeight())/2))
	CreateSmallPopupWithCancel(title, content)
end

--战败弹窗
function GameGuide:pveFailedPopup()
	if GameData:getGameDataTable().hint == nil or table.maxn(GameData:getGameDataTable().hint) == 0 or showFailedPopup then
		return
	end
	local noteCount = table.maxn(GameData:getGameDataTable().hint)
	local noteTable = GameData:getGameDataTable().hint[math.random(os.clock()*10^6)%noteCount + 1]
	setSmallPopupByMultiLanguage("bedefeated", noteTable)
end

--可换新装备提示
function GameGuide:newEquipGuide(notePlace)
	print("totle",table.maxn(notePlace),XiaLayerOwner["mMainButton3"]:getChildByTag(GUIDE_EFFECT_TAG))
	if notePlace ~= nil and table.maxn(notePlace) > 0 and XiaLayerOwner["mMainButton3"]:getChildByTag(GUIDE_EFFECT_TAG) == nil then
		AddNewNoteEffect(XiaLayerOwner["mMainButton3"], Pos(cc.size(102,102),0.8,0.8))
	elseif table.maxn(notePlace) == 0 and XiaLayerOwner["mMainButton3"]:getChildByTag(GUIDE_EFFECT_TAG) ~= nil then
		XiaLayerOwner["mMainButton3"]:removeChildByTag(GUIDE_EFFECT_TAG)
	end
end

--护法可换新装备提示
function GameGuide:newEquipHeroGuide(notePlace)
	local bNeedNote = false
	for i=1,table.maxn(notePlace) do
		if notePlace[i] == true then
			bNeedNote = true 
			break
		end
	end
	
	
	GameGuide:setButtonNote(XiaLayerOwner["mMainButton6"], bNeedNote, Pos(cc.size(102,102),0.8,0.8))
	--[[
	print("totle",table.maxn(notePlace),XiaLayerOwner["mMainButton3"]:getChildByTag(GUIDE_EFFECT_TAG))
	if notePlace ~= nil and table.maxn(notePlace) > 0 and XiaLayerOwner["mMainButton3"]:getChildByTag(GUIDE_EFFECT_TAG) == nil then
		AddNewNoteEffect(XiaLayerOwner["mMainButton3"], Pos(cc.size(102,102),0.8,0.8))
	elseif table.maxn(notePlace) == 0 and XiaLayerOwner["mMainButton3"]:getChildByTag(GUIDE_EFFECT_TAG) ~= nil then
		XiaLayerOwner["mMainButton3"]:removeChildByTag(GUIDE_EFFECT_TAG)
	end
	]]
end

--新提示特效
function AddNewNoteEffect(father, position, bFull)
	if father:getChildByTag(GUIDE_EFFECT_TAG) ~= nil then
		return
	end

	local effect = CommonAddEffect("effect_new_", 10, 0.025, GUIDE_EFFECT_TAG)
	if bFull then
		local sp = CreateCommonSprite("pic_bagman.png",Pos(effect:getContentSize()))
		-- sp:setLocalZOrder(3)
		effect:addChild(sp)
	end
	if position ~= nil then
		effect:setPosition(position)
	end
	father:addChild(effect)
	return effect
end

--设置活动消息提示
function GameGuide:setActButtonNote()
	if Activity_ActArr == nil then
		return
	end

	local bNeedNote = FindFirstByKey(Activity_ActArr,"canReward",true)
	print("FindFirstByKey",bNeedNote)
	if bNeedNote == nil then
		bNeedNote = false
	else
		bNeedNote = true
	end
	
	self:setButtonNote(XiaLayerOwner["mHomeActButton"], bNeedNote, Pos(XiaLayerOwner["mHomeActButton"]:getContentSize(),0.85,0.85))
end

function IsNeedGroupNote()
	local bNeedNote = false
	if CheckGroup() then
		if UserGroupInfo == nil then
			if UserSelfInfo.group == 1 then
				bNeedNote = true
			end
		else
			bNeedNote = IsGroupCanBaomin()
		end
	end
	
	return bNeedNote
end

--设置
function GameGuide:setGroupButtonNote()
	local bNeedNote = IsNeedGroupNote()

	self:setButtonNote(XiaLayerOwner["mHomeGroupButton"], bNeedNote, Pos(cc.size(196,197),0.85,0.85))
end

--设置聊天频道按钮的新消息提示
function GameGuide:setTalkButtonNote(button,bNote)
	if bNote and button:getChildByTag(GUIDE_EFFECT_TAG) == nil then
		button:addChild(CreateCommonSprite("effect_new_3.png",Pos(button:getContentSize(),0.9,0.8),1), 0, GUIDE_EFFECT_TAG)
	elseif bNote == false and button:getChildByTag(GUIDE_EFFECT_TAG) ~= nil then
		button:removeChildByTag(GUIDE_EFFECT_TAG)
	end
end

--设置聊天入口的新消息提示
function GameGuide:setTalkNote(bNote)
	print("setTalkNote", XiaLayerOwner["mHomeTalkButton"]:getChildByTag(GUIDE_EFFECT_TAG) )
	if bNote and XiaLayerOwner["mHomeTalkButton"]:getChildByTag(GUIDE_EFFECT_TAG) == nil then
		XiaLayerOwner["mHomeTalkButton"]:addChild(CreateCommonSprite("effect_new_3.png",Pos(XiaLayerOwner["mHomeTalkButton"]:getContentSize(),0.9,0.8), 1.1), 0, GUIDE_EFFECT_TAG)
	elseif bNote == false and XiaLayerOwner["mHomeTalkButton"]:getChildByTag(GUIDE_EFFECT_TAG) ~= nil then
		XiaLayerOwner["mHomeTalkButton"]:removeChildByTag(GUIDE_EFFECT_TAG)
	end
	
	if bNote and BattleTalkButton~= nil and  BattleTalkButton:getChildByTag(GUIDE_EFFECT_TAG) == nil then
		BattleTalkButton:addChild(CreateCommonSprite("effect_new_3.png",cc.p(50,50), 0.85), 0, GUIDE_EFFECT_TAG)
	elseif bNote == false and BattleTalkButton~= nil and  BattleTalkButton:getChildByTag(GUIDE_EFFECT_TAG) ~= nil then
		BattleTalkButton:removeChildByTag(GUIDE_EFFECT_TAG)
	end
end

--设置背包满的提示
function GameGuide:SetBagFullEffect()
	local equipCount = table.maxn(UserInfo:getUserInfo().data.bag_equip)
	if UserSelfInfo.bagslots > equipCount and XiaLayerOwner["mMainButton4"]:getChildByTag(GUIDE_EFFECT_TAG) ~= nil then
		XiaLayerOwner["mMainButton4"]:removeChildByTag(GUIDE_EFFECT_TAG)
	elseif UserSelfInfo.bagslots <= equipCount and  XiaLayerOwner["mMainButton4"]:getChildByTag(GUIDE_EFFECT_TAG) == nil then
		AddNewNoteEffect(XiaLayerOwner["mMainButton4"],Pos(cc.size(102,102),0.8,0.8), true)
	end
end


--神器特效
function AddMasterEffect(father, position)
	if father:getChildByTag(MASTER_EFFECT_TAG) ~= nil then
		return
	end

	local effect = CommonAddEffect("effect_master_", 20, 0.03, MASTER_EFFECT_TAG)
	if position ~= nil then
		effect:setPosition(position)
	end
	father:addChild(effect,4)
	return effect
end

--双属性神器特效
function AddGlyphMasterEffect(father,position)
	if father:getChildByTag(D_MASTER_EFFECT_TAG) ~= nil then
		return
	end

	local effect = CommonAddEffect("effect_master_d_", 20, 0.1, D_MASTER_EFFECT_TAG)
	if position ~= nil then
		effect:setPosition(position)
	end
	father:addChild(effect,5)
	return effect
end


--添加特效  name是前缀字符串 num表总数 t是间隔时间 
function CommonAddEffect(name, num, t,tag, bRepeat)
	print("CommonAddEffect")
	local catch = cc.SpriteFrameCache:getInstance()
	local sprite = CreateCommonSprite(name.."1.png")
	if tag ~= nil then
		sprite:setTag(tag)
	end
	
    local animFrames = {}
	for j = 1, num do
		animFrames[j] = catch:getSpriteFrame(name..j..".png")
	end

    local animation = cc.Animation:createWithSpriteFrames(animFrames, t)
	if bRepeat == false then
		sprite:runAction(cc.Animate:create(animation))
	else
		sprite:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.Animate:create(animation))))
	end

	return sprite
end

function GameGuide:AttentionGuide()
	print("GameGuide:AttentionGuide")
	local popupContent = CreateLayer(POPUP_SIZE_MID, 1, Pos(POPUP_SIZE_MID))
	local descArea = CreateLayer(cc.size(490,510), 1, Pos(POPUP_SIZE_MID,0.5,0.546))--,nil,nil,cc.c4b(255,0,0,255))
	popupContent:addChild(descArea)
	local new = CreateCommonLabel(MultiLan("GG_guide_28"), cc.p(245,490),FontSize3,COLOR_RED)
	new:setScale(1.6)
	descArea:addChild(new)
	
	t = GameData:getGameDataTable().help.attention
	local color = {COLOR_GREEN, COLOR_RED, COLOR_WHITE, COLOR_WHITE, COLOR_GREEN, COLOR_PURPLE}
	local size  = {FontSize3,FontSize3,FontSize3,FontSize3,FontSize3}
	local richText = ccui.RichText:create()
	richText:ignoreContentAdaptWithSize(false)
	richText:setAnchorPoint(cc.p(0.5, 0.5))
	richText:setContentSize(cc.size(470, 460))
	richText:setPosition(cc.p(235,230))

	for i=1,table.maxn(t) do
		if t[i].t == 1 then
			if bFirst == true then
				bFirst = false
			else
				print(i,"here")
				richText:pushBackElement(ccui.RichElementNewLine:create())
				richText:pushBackElement(ccui.RichElementText:create(1,color[t[i].t], 255," ",DefaultFontName,FontSize2))
				richText:pushBackElement(ccui.RichElementNewLine:create())
			end
		end
		
		if t[i].t == 1 then
			richText:pushBackElement(ccui.RichElementText:create(1, color[t[i].t], 255 ,MultiLan(t[i].d),DefaultFontName, size[t[i].t]))
			richText:pushBackElement(ccui.RichElementNewLine:create())
		elseif 	t[i].t == 4 then
			richText:pushBackElement(ccui.RichElementNewLine:create())
		else
			richText:pushBackElement(ccui.RichElementText:create(1,color[t[i].t], 255,MultiLan(t[i].d),DefaultFontName,size[t[i].t]))
		end
	end
	descArea:addChild(richText)
	
	local popupRoot = CommonCreatePopupMid("gamehelp",popupContent)
	local function closeFunc() removeSelf(popupRoot) end
	popupContent:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_MID,0.5,0.08), cc.size(158,67), closeFunc, {str=MultiLan("button_close"), size = FontSize3}))
end
