

local bHeroInited = false
showedHeroTag = 1
HeroInfoTable = nil
local SkillLockedArr = {}
local attrKeyTable = {"str","int","agi","sta","damage","armor","mr","hit","crit","dodge","tough"}
local heroOpenLimit = {15,20,25}
local headChoosedTag = 101
XiaLayer = XiaLayer or {}
ccb["XiaLayer"] = XiaLayer

Hero_ShowStarup = false
Hero_ShowStarupNode = nil

local function UpdateHeroStar()
	local starLayer = XiaLayerOwner["mHeroStarLayer"]
	starLayer:removeAllChildren(true)
	
	local totleStar = HeroInfoTable[showedHeroTag].dynamicData.star_level
	local commonDelay = 0.1
	local totleTime = 0.05 + 0.01*HERO_STAR_MAX/math.max(1,totleStar)
	local function resetScale(node)
		node:setScale(1)
	end
	local function showStar(node)
		local star = CreateCommonSprite("pic_shstar.png")
		star:setScale(1.1)
		star:runAction(cc.Sequence:create(cc.ScaleTo:create(0.05,1.3),cc.DelayTime:create(0.2),cc.ScaleTo:create(0.05,1)))
		star:setPosition(Pos(node:getContentSize()))
		node:addChild(star)
	end
	
	for i=1,HERO_STAR_MAX do
		local starBack = CreateCommonSprite("pic_blstar.png", cc.p(65+54*i, 30))
		starLayer:addChild(starBack)
		if i <= totleStar then
			starBack:runAction(cc.Sequence:create(cc.DelayTime:create(commonDelay + totleTime*i), cc.CallFunc:create(showStar)))
		end
	end
	
	
	for i=1, 5 do
	
	end
end

function UpdateHeroEquip()
	local equipInfo = HeroInfoTable[showedHeroTag].equip
	local equipLayer = XiaLayerOwner["mHeroEquipLayer"]
	equipLayer:removeAllChildren(true)
	local placeArr = {1,2,6,7}

	for i=1,4 do
		local findedEquip = nil
		for j=1, table.maxn(equipInfo) do
			if GameData:getPropDataTable(equipInfo[j].prop_id).place == placeArr[i] then
				findedEquip = equipInfo[j]
			end
		end

		local equip = CreateBagItem()
		if findedEquip ~= nil then
			equip:setItemType(BAG_ITEM_TYPE_HERO_EQUIP)
			equip:setItemInfoTable(findedEquip)
		else
			equip:setItemType(BAG_ITEM_TYPE_EMPTY_HERO_EQUIP)
			equip:setItemInfoTable({place=placeArr[i]}, {id=HeroInfoTable[showedHeroTag].staticData.id,role=HeroInfoTable[showedHeroTag].staticData.role})
		    equip:setEmptyBgByPlace(placeArr[i])
        end
		equip:setPosition(cc.p(100+130*(i-1),55))
		equipLayer:addChild(equip)
	end
end

local function UpdateHeroSkill()
	local skillData = GameData:getGameDataTable().skill
	local skillInfo = HeroInfoTable[showedHeroTag].dynamicData.skill
	local skillLayer = XiaLayerOwner["mHeroSkillLayer"]
	skillLayer:removeAllChildren(true)

	for i=1,4 do
		if skillInfo[i]~= nil then
			skillLayer:addChild(CreateCommonSprite("skill_"..skillInfo[i]..".png", cc.p(100+130*(i-1), 55)))
		else
		
		end
	end
end

local function UpdateHeroState()
	if HeroInfoTable[showedHeroTag].dynamicData.status == 0 then
		XiaLayerOwner["mHeroButtonState"]:setTitleForState(MultiLan("GG_guide_24"), cc.CONTROL_STATE_NORMAL)
		XiaLayerOwner["mHeroButtonState"]:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_red.png"), cc.CONTROL_STATE_NORMAL)
		XiaLayerOwner["mHeroButtonState"]:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_red.png"), cc.CONTROL_STATE_HIGH_LIGHTED)
	else
		XiaLayerOwner["mHeroButtonState"]:setTitleForState(MultiLan("GHL_heroIsFighting"), cc.CONTROL_STATE_NORMAL)
		XiaLayerOwner["mHeroButtonState"]:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_green.png"), cc.CONTROL_STATE_NORMAL)
		XiaLayerOwner["mHeroButtonState"]:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_green.png"), cc.CONTROL_STATE_HIGH_LIGHTED)
	end
end

function UpdateHeroInfo()
	print("UpdateHeroInfo")
	--名字战力 
	XiaLayerOwner["mHeroName"]:setString("Lv."..UserSelfInfo.level.." "..MultiLan(HeroInfoTable[showedHeroTag].staticData.name))
	XiaLayerOwner["mHeroFightNum"]:setString(UserAttr:getHeroFightNum(HeroInfoTable[showedHeroTag].staticData.id))
	
	--血蓝
	local attrTable = UserAttr:getHeroAttrTable(HeroInfoTable[showedHeroTag].staticData.id)
	XiaLayerOwner["mHeroHp"]:setString(attrTable.hp)
	XiaLayerOwner["mHeroMp"]:setString(attrTable.mp)
	print(attrKeyTable[1],attrKeyTable[2],attrKeyTable[3],attrKeyTable[4])
	print(attrTable[attrKeyTable[1]],attrTable[attrKeyTable[2]],attrTable[attrKeyTable[3]],attrTable[attrKeyTable[4]])
	--属性
	for i=1, 11 do
		if i~= 5 then
			XiaLayerOwner["mHeroValue"..i]:setString(attrTable[attrKeyTable[i]])
		else
			XiaLayerOwner["mHeroValue"..i]:setString(math.ceil(attrTable[attrKeyTable[i]]/2).." - "..attrTable[attrKeyTable[i]])
		end
	end
	
	--装备
	UpdateHeroEquip()

	--技能
	UpdateHeroSkill()

	--按钮状态
	UpdateHeroState()
	
	--星级
	UpdateHeroStar()
end

--切换护法
function onHeroChoose(node)
	local tag = tolua.cast(node, "cc.Node"):getTag()
	print("onHeroChoose")
	if tag == showedHeroTag then
		return
	end
	
	if UserSelfInfo.level < heroOpenLimit[tag] then
		return
	end
	
	for i=1,table.maxn(HeroInfoTable) do
		if HeroInfoTable[i].button ~= nil and HeroInfoTable[i].button:getChildByTag(headChoosedTag) ~= nil then
			HeroInfoTable[i].button:getChildByTag(headChoosedTag):removeFromParent(true)
		end
	end
	
	HeroInfoTable[tag].button:addChild(CreateCommonSprite("effect_selected01.png", Pos(HeroInfoTable[tag].button:getContentSize())),0,headChoosedTag)
	showedHeroTag = tag
	UpdateHeroInfo()
end

local function updateHeroHead()
	print("updateHeroHead")
	local layer = cc.Layer:create()
	local count = table.maxn(HeroInfoTable)
	local x = 60
	for i=1, count do
		print(i,HeroInfoTable[i].staticData.role,HeroInfoTable[i].staticData.id)
		HeroInfoTable[i].button = CreateCommonButton("hero_icon_"..HeroInfoTable[i].staticData.role..".png", cc.p(x, 60), cc.size(95,95), onHeroChoose)
		HeroInfoTable[i].button:setSwallowTouch(false)
		layer:addChild(HeroInfoTable[i].button, 0, i)
		if i == showedHeroTag then
			HeroInfoTable[i].button:addChild(CreateCommonSprite("effect_selected01.png", Pos(HeroInfoTable[i].button:getContentSize())),0,headChoosedTag)
		end
		
		if UserSelfInfo.level < heroOpenLimit[i] then
			HeroInfoTable[i].button:addChild(CreateCommonLabel(string.format(MultiLan("GHL_unlockLvl"),tostring(heroOpenLimit[i])), Pos(HeroInfoTable[i].button:getContentSize()), FontSize4, COLOR_GREEN))
			--HeroInfoTable[i].button:setEnabled(false)
		end
		
		x = x + 120
	end

	layer:setContentSize(cc.size(120*count, 120))

	local heroHeadScrollview = CreateScrollViewByFather(XiaLayerOwner["mHeroHeadScrollLayer"], layer, cc.p(0,0), kCCScrollViewDirectionHorizontal)
	if 120*count < XiaLayerOwner["mHeroHeadScrollLayer"]:getContentSize().width then
		heroHeadScrollview:setTouchEnabled(false)
	end
end
	
function HeroLayerInit()
	print("HeroLayerInit")
	if HeroInfoTable == nil or table.maxn(UserSelfInfo.hero_star) == 0 then
		--初始化护法数据
		local StaticData = GameData:getGameDataTable().hero
		HeroInfoTable = {}
		for i=1,table.maxn(StaticData) do
			if StaticData[i].htype == 2 then
				print("insert")
				table.insert(HeroInfoTable,{staticData = StaticData[i], dynamicData=UserInfo:getHero(StaticData[i].id), equip={},bChange=false,button=nil})
				if UserInfo:getUserInfo().data.equip["hero_"..StaticData[i].id] == nil then
					UserInfo:getUserInfo().data.equip["hero_"..StaticData[i].id] = {}
				end
				HeroInfoTable[table.maxn(HeroInfoTable)].equip = UserInfo:getUserInfo().data.equip["hero_"..StaticData[i].id]
				UserAttr:CalHeroFinalAttr(StaticData[i].id)
			end
		end
		
		--护法升星次数初始化
		local heroDynamicData = UserInfo:getUserInfo().data.hero
		for i=1, table.maxn(heroDynamicData) do
			if UserSelfInfo.hero_star["hero_"..heroDynamicData[i].id] == nil then
				UserSelfInfo.hero_star["hero_"..heroDynamicData[i].id] = 0
			end
		end
		
		--默认护法
		showedHeroTag = 1 
		for i=1,table.maxn(HeroInfoTable) do
			if HeroInfoTable[i].dynamicData.status == 1 then
				showedHeroTag = i
			end
		end
	end
	
	--生成头像
	updateHeroHead()

	if bHeroInited then
		return
	end
	bHeroInited = true
	cc.SpriteFrameCache:getInstance():addSpriteFrames("ccb/ccbResources/SkillIcon.plist")
	
	--属性
	--local attrTable = {"力量：","敏捷：","智力：","耐力：","伤害：","护甲：","魔抗：","命中：","暴击：","闪避：","韧性："}
    
	for i=1, 11 do
		XiaLayerOwner["mHeroProperty"..i]:setColor(COLOR_ORANGE)
		XiaLayerOwner["mHeroProperty"..i]:setString(MultiLan( "attr_role_"..attrKeyTable[i])..":")
	end
	XiaLayerOwner["mHeroValue5"]:setColor(COLOR_GREEN)

	--文字
	--XiaLayerOwner["mHeroEquipLabel"]:setString(MultiLan("GHL_heroEquip"))
	--XiaLayerOwner["mHeroSkillLabel"]:setString(MultiLan("GHL_heroSkill"))
	XiaLayerOwner["mHeroStarLabel"]:setString(MultiLan("GHL_heroStar"))
	

	XiaLayerOwner["mHeroButtonTrain"]:setTitleForState(MultiLan("GHL_heroTrain"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mHeroButtonSkill"]:setTitleForState(MultiLan("GHL_heroSkill"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mHeroButtonState"]:setTitleForState(MultiLan("GHL_heroIsFighting"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mHeroButtonStarup"]:setTitleForState(MultiLan("GHL_heroStarUp"), cc.CONTROL_STATE_NORMAL)
end

function HeroEnter()
	HeroLayerInit()
	UpdateHeroInfo()
	GameGuide:GuideEnter(GUIDE_TYPE_HERO)
end

--更多属性
local function onHeroMoreProperty()
	MorepertyPopup(UserAttr:getHeroAttrTable(HeroInfoTable[showedHeroTag].staticData.id),
					UserAttr:getHeroFightNum(HeroInfoTable[showedHeroTag].staticData.id),
					MultiLan(HeroInfoTable[showedHeroTag].staticData.name),
					UserSelfInfo.level,
					HeroInfoTable[showedHeroTag].staticData.role)
end

--培养
local function onHeroTrain()
	cclog("onHeroTrain")
	local attrInfo = HeroInfoTable[showedHeroTag].dynamicData.attr
	local baseAttr = UserAttr:getHeroBaseAttr(HeroInfoTable[showedHeroTag].staticData.id)
	local popupContent = CreateLayer(POPUP_SIZE_MID, 1, Pos(POPUP_SIZE_MID))
	--头像
	popupContent:addChild(CreateCommonSprite("hero_icon_"..HeroInfoTable[showedHeroTag].staticData.role..".png", Pos(POPUP_SIZE_MID,0.2,0.85)))
	--名字
	local name = CreateCommonLabel("Lv."..UserSelfInfo.level.." "..MultiLan(HeroInfoTable[showedHeroTag].staticData.name),Pos(POPUP_SIZE_MID,0.3,0.87), FontSize3,nil, cc.p(0,0))
	popupContent:addChild(name)
	--职业
	name = CreateCommonLabel(MultiLan("lan_career")..":"..MultiLan("role_career_"..HeroInfoTable[showedHeroTag].staticData.role), Pos(POPUP_SIZE_MID,0.3,0.82), FontSize3, COLOR_GREEN, cc.p(0,0))
	popupContent:addChild(name)
	--主属性
	local attrKey = {"str", "int", "agi",  "sta"}
	name = CreateCommonLabel(MultiLan("EH_mainProperty")..":"..MAIN_ATTR_DESC[HeroInfoTable[showedHeroTag].staticData.role],Pos(POPUP_SIZE_MID,0.3,0.77), FontSize3, COLOR_GREEN, cc.p(0,0))
	popupContent:addChild(name)
	
	--培养上限
	local limit_max = {}
	local roleData = HeroInfoTable[showedHeroTag].staticData
	limit_max[1] = roleData.power + UserSelfInfo.level * (roleData.power_incr + 30)
	limit_max[2] = roleData.brain + UserSelfInfo.level * (roleData.brain_incr + 30)
	limit_max[3] = roleData.agile + UserSelfInfo.level * (roleData.agile_incr + 30)
	limit_max[4] = roleData.stamina + UserSelfInfo.level * (roleData.stamina_incr + 30)
	
	local function setMaxLabel(maxLabel, bNeedShow, leftNode)
		if bNeedShow then
			maxLabel:setVisible(true)
			maxLabel:setPositionX(leftNode:getPositionX()+leftNode:getContentSize().width + 3)
		else
			maxLabel:setVisible(false)
		end
	end
	--培养前
	local trainBack = CreateCommonSprite("board_attribute01.png", Pos(POPUP_SIZE_MID,0.29,0.62))
	local backSize = trainBack:getContentSize()
	popupContent:addChild(trainBack)
	trainBack:addChild(CreateCommonLabel(MultiLan("GHL_train_1"),Pos(backSize,0.5,0.88), FontSize3))
	
	local beforTrain = {}
	local beforeAttr = {}
	local maxBeforeLabel = {}
	for i = 1, 4 do
		local attrName = CreateCommonLabel(MAIN_ATTR_DESC[i]..":", Pos(backSize,0.1,0.76-0.17*i), FontSize2, COLOR_ORANGE, cc.p(0, 0))
		trainBack:addChild(attrName)
		beforeAttr[i] = attrInfo[attrKey[i]]+ baseAttr[attrKey[i]]
		local attr1 = CreateCommonLabel(beforeAttr[i], Pos(backSize,0.1,0.76-0.17*i), FontSize2, nil, cc.p(0, 0))
		attr1:setPositionX(attrName:getPositionX()+attrName:getContentSize().width + 5)
		trainBack:addChild(attr1)
		table.insert(beforTrain, attr1)
		local maxLabel = CreateCommonLabel("("..MultiLan("GHL_train_2")..")", Pos(backSize,0.1,0.76-0.17*i), FontSize2, COLOR_YELLOW, cc.p(0, 0))
		trainBack:addChild(maxLabel)
		table.insert(maxBeforeLabel, maxLabel)
		setMaxLabel(maxLabel, beforeAttr[i] >= limit_max[i], attr1)
	end

	
	popupContent:addChild(CreateCommonSprite("icon_arrow02.png", Pos(POPUP_SIZE_MID,0.5,0.62)))
	--培养后
	trainBack = CreateCommonSprite("board_attribute01.png", Pos(POPUP_SIZE_MID,0.71,0.62))
	popupContent:addChild(trainBack)
	trainBack:addChild(CreateCommonLabel(MultiLan("GHL_train_3"),Pos(backSize,0.5,0.88), FontSize3))
	local afterAttrLayer = CreateLayer(backSize, 1,Pos(backSize))
	afterAttrLayer:setVisible(false)
	trainBack:addChild(afterAttrLayer)
	
	local afterTrain = {}
	local afterAttr = {}
	local maxAfterLabel = {}
	for i = 1, 4 do
		local attrName = CreateCommonLabel(MAIN_ATTR_DESC[i]..":", Pos(backSize,0.1,0.76-0.17*i), FontSize2, COLOR_ORANGE, cc.p(0, 0))
		afterAttrLayer:addChild(attrName)
		afterAttr[i] = attrInfo[attrKey[i]] + baseAttr[attrKey[i]]
		local attr1 = CreateCommonLabel(afterAttr[i], Pos(backSize,0.1,0.76-0.17*i), FontSize2, nil, cc.p(0, 0))
		attr1:setPositionX(attrName:getPositionX()+attrName:getContentSize().width + 5)
		afterAttrLayer:addChild(attr1)
		table.insert(afterTrain, attr1)
		local maxLabel = CreateCommonLabel("("..MultiLan("GHL_train_2")..")", Pos(backSize,0.1,0.76-0.17*i), FontSize2, COLOR_YELLOW, cc.p(0, 0))
		maxLabel:setVisible(false)
		afterAttrLayer:addChild(maxLabel)
		table.insert(maxAfterLabel, maxLabel)
	end
	--培养按钮
	local trainButtonArr = {}
	local cancelButton = nil
	local saveButton = nil
	local function trainCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			cclog("trainCallback failed %d", jsonDataTable.ret)
			return 
		end
		
		--扣除货币
		UserSelfInfo[jsonDataTable.data.use_type] = UserSelfInfo[jsonDataTable.data.use_type] - jsonDataTable.data.use_num
		if jsonDataTable.data.use_type == "cash" then
			UseCash(jsonDataTable.data.use_num)
		end

		--更新显示
		afterAttrLayer:setVisible(true)
		for i=1, 4 do
			local changerStr = nil
			local begin = beforeAttr[i]
			local after = baseAttr[attrKey[i]] + jsonDataTable.data.attr[attrKey[i]]
			afterAttr[i] = after
			if after < begin then
				afterTrain[i]:setColor(COLOR_RED)
				changerStr = "-"..(begin - after)
			elseif after > begin then
				afterTrain[i]:setColor(COLOR_GREEN)
				changerStr = "+"..(after - begin)
			else
				afterTrain[i]:setColor(COLOR_WHITE)
			end
			
			if changerStr == nil then
				afterTrain[i]:setString(after)
			else
				afterTrain[i]:setString(after.."("..changerStr..")")
			end
			setMaxLabel(maxAfterLabel[i],afterAttr[i] >= limit_max[i] ,afterTrain[i])
		end
		
		for i=1, table.maxn(trainButtonArr) do trainButtonArr[i]:setVisible(false) end
		cancelButton:setVisible(true)
		saveButton:setVisible(true)
	end
	

	local buttonTitle = {MultiLan("CL_train_1"), MultiLan("CL_train_2"), MultiLan("CL_train_3"), MultiLan("CL_train_4")}
	local buttonPosition = {Pos(popupContent:getContentSize(),0.28,0.4), Pos(popupContent:getContentSize(),0.72,0.4), Pos(popupContent:getContentSize(),0.28,0.25), Pos(popupContent:getContentSize(),0.72,0.25)}
	local costPay = {UserSelfInfo.level*500, 20 , 60, 200}
	--培养消息
	local function trainButtonClick(node)
		local tag = tolua.cast(node, "cc.Node"):getTag()
		
		if limit_max[1] <= beforeAttr[1] and limit_max[2] <= beforeAttr[2] and limit_max[3] <= beforeAttr[3] and limit_max[4] <= beforeAttr[4] then
			CommonNote(MultiLan("GHL_train_4"))
			CommonNote(MultiLan("GHL_train_5"))
			return
		end
		
		print("trainButtonClick",tag, UserSelfInfo.gold,costPay[1])
		if tag == 1 and UserSelfInfo.gold < costPay[1] then
			CommonGoldNeed()
			return
		elseif tag > 1 and  UserSelfInfo.cash < costPay[tag] then
			CommonCashNeed()
			return
		end
		
		HttpSend("hire/ctrain", {"hero=" .. HeroInfoTable[showedHeroTag].staticData.id, "type=" .. tag}, trainCallback)
	end
	
	local function cannotTrainButtonClick(node)
		local tag = tolua.cast(node, "cc.Node"):getTag()
		local vipData = GameData:getGameDataTable().vip
		for i=1,table.maxn(vipData) do
			if vipData[i].hire_train == tag then
				CommonNote(string.format(MultiLan("GHL_train_6"),tostring(vipData[i].level),tostring(buttonTitle[tag])))
				return 
			end
		end
	end
	for i = 1, 4 do
		local button = nil
		if i <= UserVipInfo.hire_train then
			button = CreateCommonButton("board_commongrow.png", buttonPosition[i], cc.size(207, 84), trainButtonClick)
		else
			button = CreateCommonButton("board_seniorgrow.png", buttonPosition[i], cc.size(207, 84), cannotTrainButtonClick)
		end
		button:setTag(i)
		popupContent:addChild(button)
		table.insert(trainButtonArr, button) 
		
		button:addChild(CreateCommonLabel(buttonTitle[i], cc.p(103,22), FontSize2))
		if i == 1 then
			button:addChild(CreateCommonSprite("icon_silver.png", cc.p(40,60)))
		else
			button:addChild(CreateCommonSprite("icon_gold.png", cc.p(40,60)))
		end
		
		button:addChild(CreateCommonLabel(costPay[i], cc.p(120,60), FontSize2))
	end
	local function trainHelp()
		HelpPopup("herotrain")
	end
	local popupRoot = CommonCreatePopupMid("mergrow",popupContent, true, trainHelp)
	--保存取消按钮
	local function cancelFunc() 
		for i=1, table.maxn(trainButtonArr) do trainButtonArr[i]:setVisible(true) end
		cancelButton:setVisible(false)
		saveButton:setVisible(false)
		afterAttrLayer:setVisible(false)
	end
	
	local function tryCancelFunc()
		--四项属性都未下降且至少一条提升
		if beforeAttr[1] <= afterAttr[1] and  beforeAttr[2] <= afterAttr[2] and beforeAttr[3] <= afterAttr[3] and beforeAttr[4] <= afterAttr[4] and
			(beforeAttr[1] < afterAttr[1] or  beforeAttr[2] < afterAttr[2] or beforeAttr[3] < afterAttr[3] or beforeAttr[4] < afterAttr[4]) then
			CreateSmallPopupWithCancel("prompt",CreateCommonLabel(MultiLan("GHL_train_7"),nil,FontSize3,nil,nil,cc.size(455, 80)), cancelFunc)
		else
			cancelFunc()
		end
	end
	
	cancelButton = CreateCommonButton("button_red.png",Pos(POPUP_SIZE_BIG,0.3,0.06), cc.size(158,67), tryCancelFunc, {str=MultiLan("button_cancel"),size=FontSize3})
	popupContent:addChild(cancelButton)
	cancelButton:setVisible(false)
	
	--保存回调
	local function heroAttrSaveCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			cclog("trainCallback failed %d", jsonDataTable.ret)
			return 
		end

		HeroInfoTable[showedHeroTag].dynamicData.attr = jsonDataTable.data.attr
		attrInfo = HeroInfoTable[showedHeroTag].dynamicData.attr
		for i = 1, 4 do
			beforeAttr[i] = attrInfo[attrKey[i]] + baseAttr[attrKey[i]]
			beforTrain[i]:setString(beforeAttr[i])
			setMaxLabel(maxBeforeLabel[i],beforeAttr[i] >= limit_max[i] ,beforTrain[i])
		end
		
		cancelFunc()
		UserAttr:CalHeroFinalAttr(HeroInfoTable[showedHeroTag].staticData.id, true)
		UpdateHeroInfo()
	end
	
	local function sendHeroSave()
		HttpSend("hire/csave", {"hero=" .. HeroInfoTable[showedHeroTag].staticData.id}, heroAttrSaveCallback)
	end
	
	local function saveTrainFunc() 
		--四项属性都未上升且至少一条下降
		if afterAttr[1] <= beforeAttr[1] and  afterAttr[2] <= beforeAttr[2] and afterAttr[3] <= beforeAttr[3] and afterAttr[4] <= beforeAttr[4] and
			(afterAttr[1] < beforeAttr[1] or  afterAttr[2] < beforeAttr[2] or afterAttr[3] < beforeAttr[3] or afterAttr[4] < beforeAttr[4]) then
			CreateSmallPopupWithCancel("prompt",CreateCommonLabel(MultiLan("GHL_train_8"),nil,FontSize3), sendHeroSave)
		else
			sendHeroSave()
		end
	end
	saveButton = CreateCommonButton("button_green.png",Pos(POPUP_SIZE_BIG,0.7,0.06), cc.size(158,67), saveTrainFunc, {str=MultiLan("button_save"),size=FontSize3})
	popupContent:addChild(saveButton)
	saveButton:setVisible(false)
end

--技能
local function onHeroSkill()
	cclog("onHeroSkill")
	local skillInfo = HeroInfoTable[showedHeroTag].dynamicData.skill
	local userLevel = UserSelfInfo.level
	local skillCountLimit = GetSkillCountByLevel(userLevel)
	
	local popupContent = CreateLayer(POPUP_SIZE_MAX, 1, Pos(POPUP_SIZE_MAX))
	--价格
	local ruleBack = CreateCommonSprite("board_skill02.png", Pos(POPUP_SIZE_MAX,0.5,0.17))
	ruleBack:setScaleX(1.6)
	ruleBack:setScaleY(1.5)
	popupContent:addChild(ruleBack)
	local desc1 = CreateCommonLabel("",Pos(POPUP_SIZE_MAX,0.5,0.15), FontSize3)
	desc1:setColor(COLOR_YELLOW)
	popupContent:addChild(desc1)
	local desc2 = CreateCommonLabel("",Pos(POPUP_SIZE_MAX,0.5,0.2), FontSize3)
	popupContent:addChild(desc2)
	local function setRefreshCos()
		if GameData:getGameDataTable().consume[UserSelfInfo.skill_refresh + 1] == nil then
			desc1:setString("")
		else
			desc1:setString(string.format(MultiLan("GHL_heroSkill_1"),tostring(GameData:getGameDataTable().consume[UserSelfInfo.skill_refresh + 1].skill_refresh*(table.maxn(SkillLockedArr)+1)),MultiLan("prop_name_100001")))
		end
		
		desc2:setString(string.format(MultiLan("GHL_heroSkill_2"),tostring(UserSelfInfo.skill_refresh)))
	end
	setRefreshCos()

	popupContent:addChild()
	
	--内容
	local layer = cc.Layer:create()
	local count = 4

	local y = 4 * 140 - 80
	for i=1, count do
		local back = CreateCommonSprite("board_overmap.png", cc.p(300, y-(i-1)*140))
		layer:addChild(back)
	
		if skillInfo[i] ~= nil then
			local skillData = GameData:getSkill(skillInfo[i])
			back:addChild(CreateCommonSprite("skill_"..skillInfo[i]..".png", cc.p(60, 64)))
			back:addChild(CreateCommonSprite("board_skill01.png", cc.p(291, 96)))
			back:addChild(CreateCommonSprite("board_skill02.png", cc.p(291, 41)))

			local name = CreateCommonLabel(MultiLan(skillData.name), cc.p(118, 96), FontSize2)
			name:setAnchorPoint(cc.p(0,0.5))
			back:addChild(name)
			if skillData.level <= userLevel then
				name = CreateCommonLabel(string.format(MultiLan("GHL_heroSkill_3"),tostring(skillData.mp)), cc.p(462, 96), FontSize2, COLOR_CYAN)
			else
				name = CreateCommonLabel(string.format(MultiLan("GHL_heroSkill_4"),""..skillData.level), cc.p(462, 96), FontSize2, COLOR_RED)
			end
			name:setAnchorPoint(cc.p(1,0.5))
			back:addChild(name)
			local desc = CreateCommonLabel(GetSkillDesc(skillData), cc.p(291, 41), 14, COLOR_CYAN, nil, cc.size(340,55))
			back:addChild(desc)
			--按钮
			local function onSkillLock(button)
				local node = tolua.cast(button, "cc.Node")
				local tag = node:getTag()
				print("onSkillLock",tag)
				if node:getParent():getChildByTag(100) == nil then
					return
				end
				print(table.maxn(SkillLockedArr))
				local lockSprite = node:getParent():getChildByTag(100)
				local bFind = false
				for j=1, table.maxn(SkillLockedArr) do
					if SkillLockedArr[j] == tag then
						bFind = true
						if lockSprite:isVisible()  then
							table.remove(SkillLockedArr, j)
							lockSprite:setVisible(false)
						end
					end
				end
				print(bFind, lockSprite:isVisible())
				if not bFind and not lockSprite:isVisible() then
					table.insert(SkillLockedArr, tag)
					lockSprite:setVisible(true)
				end
				
				setRefreshCos()
			end
			
			local chooseButton = CreateCommonButton("board_skill03.png", cc.p(520, 64), cc.size(66, 66), onSkillLock)
			chooseButton:setSwallowTouch(false)
			back:addChild(chooseButton ,0, i)
			local choose = CreateCommonSprite("pic_skilllocked.png", cc.p(520, 64))
			back:addChild(choose, 0, 100)
			choose:setVisible(false)
			local lbChoose = CreateCommonFntLabel(ZGMultiLan("game_info_state_locked"), FntTypeCommonGlowRed, Pos(choose:getContentSize(), 0.5, 0.5))
			lbChoose:setScale(0.8)
			choose:addChild(lbChoose)

			for j=1, table.maxn(SkillLockedArr) do
				if SkillLockedArr[j] == i then
					choose:setVisible(true)
					break
				end
			end
		else
			back:addChild(CreateCommonSprite("board_skill02.png", cc.p(291, 64)))
			if i<= skillCountLimit then
				back:addChild(CreateCommonLabel(MultiLan("GHL_heroSkill_5"), cc.p(291, 64), FontSize4, COLOR_GREEN))
			else
				back:addChild(CreateCommonSprite("board_skilllock.png", cc.p(291, 64)))
				back:addChild(CreateCommonLabel(string.format(MultiLan("GHL_heroSkill_4"), tostring(SKILL_COUNT_LIMIT_LEVEL[i])), cc.p(291, 64), FontSize4))
				back:addChild(CreateCommonSprite("pic_locked.png", cc.p(55, 80)))
			end
		end
	end


	local scrollLayer  = CreateLayer(cc.size(600,560), 1, Pos(POPUP_SIZE_MAX,0.5,0.57))
	scrollLayer:setScale(0.98)
	popupContent:addChild(scrollLayer)
	layer:setContentSize(cc.size(600, 560))
	local scorollView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, 0), kScrollViewDirectionVertical)
	scorollView:setTouchEnabled(false)
	
	--说明
	local ruleBack = CreateCommonSprite("board_skill01.png", Pos(POPUP_SIZE_MAX,0.5,0.91))
	ruleBack:setScaleX(1.6)
	popupContent:addChild(ruleBack)
	popupContent:addChild(CreateCommonLabel(MultiLan("GHL_heroSkill_6"), Pos(POPUP_SIZE_MAX,0.5,0.91), FontSize4))
	
	--
	local function helpFunc()
		HelpPopup("heroskill")
	end
	local popupRoot = CommonCreatePopupMax("merskill",popupContent, true, helpFunc)
	popupRoot:setScale(1)
	--按钮

	local function heroSkillRefreshCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			cclog("heroSkillRefreshCallback failed %d", jsonDataTable.ret)
			return 
		end
		
		HeroInfoTable[showedHeroTag].dynamicData.skill = jsonDataTable.data.skill
		SkillLockedArr = jsonDataTable.data.lock
		UserSelfInfo.skill_refresh = jsonDataTable.data.count
		UserSelfInfo.cash = UserSelfInfo.cash - jsonDataTable.data.cash
		UseCash(jsonDataTable.data.cash)
		removeSelf(popupRoot)
		onHeroSkill()
		UpdateHeroSkill()
	end
	
	local function refreshFunc() 
		if table.maxn(SkillLockedArr) == skillCountLimit then
			CommonNote(MultiLan("GHL_heroSkill_7"))
			return
		end
		
		if UserSelfInfo.level < 15 then
			CommonNote(MultiLan("GHL_heroSkill_8"))
			return
		end
		
		--刷新次数上限
		if GameData:getGameDataTable().consume[UserSelfInfo.skill_refresh + 1] == nil then
			CommonTodayLimit()
		end
	
		--拼字符串
		local lockStr = ""
		for j=1, table.maxn(SkillLockedArr) do
			if j ~= 1 then
				lockStr = lockStr..","
			end
			lockStr = lockStr..SkillLockedArr[j]
		end
		print("lockStr",lockStr)
		HttpSend("hire/srefresh", {"hero=" .. HeroInfoTable[showedHeroTag].staticData.id, "lock=" .. lockStr}, heroSkillRefreshCallback)
	end
	popupContent:addChild(CreateCommonButton("button_blue.png",Pos(POPUP_SIZE_MAX,0.5,0.06), cc.size(158,67), refreshFunc, {str=MultiLan("GHL_heroSkill_9"),size=FontSize3}))
end

--切换出战状态
local function onHeroState()
	local function changeStateCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			cclog("changeStateCallback failed %d", jsonDataTable.ret)
			return 
		end
		
		if jsonDataTable.data.status == 1 then
			for i=1,table.maxn(HeroInfoTable) do
				HeroInfoTable[i].dynamicData.status = 0
			end
		end
		
		for i=1,table.maxn(HeroInfoTable) do
			if HeroInfoTable[i].staticData.id == jsonDataTable.data.hero then
				HeroInfoTable[i].dynamicData.status = jsonDataTable.data.status
			end
		end
		
		UpdateHeroState()
	end

	--HeroInfoTable[showedHeroTag].dynamicData.status = (HeroInfoTable[showedHeroTag].dynamicData.status + 1) % 2
	--UpdateHeroInfo()
	HttpSend("hire/status", {"hero=" .. HeroInfoTable[showedHeroTag].staticData.id, "status=" .. (HeroInfoTable[showedHeroTag].dynamicData.status + 1)%2}, changeStateCallback)
end

local function onHeroStarup()
	Hero_ShowStarup = true
	local LevelupTable = GameData:getHeroStarTable(HeroInfoTable[showedHeroTag].staticData.role)
	local level1 = HeroInfoTable[showedHeroTag].dynamicData.star_level
	local level2 = level1
	local starexp = {e=HeroInfoTable[showedHeroTag].dynamicData.star_exp,m=LevelupTable[level1+1].exp}--HeroInfoTable[showedHeroTag].dynamicData.starExp
	
	local popupContent = CreateLayer(POPUP_SIZE_MAX, 1, Pos(POPUP_SIZE_MAX))
	local function helpFunc() 
		HelpPopup("upgradeStar") 
	end
	local function closeCallback() 
		Hero_ShowStarup = false 
		Hero_ShowStarupNode = nil
		if CommonHeroLayer:isVisible() then
			UpdateHeroInfo()
		end
	end
	local popupRoot = CommonCreatePopupMax("gostar",popupContent, closeCallback, helpFunc)
	Hero_ShowStarupNode = popupRoot
	popupRoot:addChild(CreateCommonLabel(MultiLan("GHL_star_note"), cc.p(50,820), FontSize2,nil,cc.p(0,0.5)))
	
	--属性
	local back = CreateCommonSprite("board_equip.png", Pos(POPUP_SIZE_MAX,0.5,0.75))
	back:setScaleX(570/633)
	back:setScaleY(210/573)
	popupContent:addChild(back)
	local attrLayer = CreateLayer(cc.size(560,210), 1, Pos(POPUP_SIZE_MAX,0.5,0.75))
	popupContent:addChild(attrLayer)
	local attrTable = {ATTR_DESC["hp"],ATTR_DESC["mp"],ATTR_DESC["pr"],ATTR_DESC["mr"],ATTR_DESC["hit"],
					ATTR_DESC["crit"],ATTR_DESC["dodge"],ATTR_DESC["tough"],MultiLan("attr_role_damage_min"),MultiLan("attr_role_damage_max")}
	local attrKey = {"hp", "mp", "pr", "mr", "hit", "crit", "dodge", "tough","damageMin","damageMax"}
	local yellowTable = {}
	local greenTable = {}
	local extraTable = {}
	for i=1,2 do
		for j=1,5 do
			local num = (i-1)*5+j
			local desc =  CreateCommonLabel(attrTable[num]..":", cc.p(i*290-210, 220-37*j), FontSize2, COLOR_YELLOW, cc.p(1, 0.5))
			attrLayer:addChild(desc)
			local desc1= CreateCommonLabel("+"..LevelupTable[level1+1][attrKey[num]].."%(", cc.p(desc:getPositionX()+5, 220-37*j), FontSize2, COLOR_YELLOW, cc.p(0, 0.5))
			table.insert(yellowTable, desc1)
			attrLayer:addChild(desc1)
			local desc2 = CreateCommonLabel("", cc.p(desc1:getPositionX(), 220-37*j), FontSize2, COLOR_GREEN, cc.p(0, 0.5))
			table.insert(greenTable, desc2)
			attrLayer:addChild(desc2)
			local desc3 = CreateCommonLabel(")", cc.p(desc2:getPositionX(), 220-37*j), FontSize2, COLOR_YELLOW, cc.p(0, 0.5))
			table.insert(extraTable, desc3)
			attrLayer:addChild(desc3)
		end
	end
	local function refreshAttrLayer()
		print("refreshAttrLayer", level1, level2)
		for i=1, HERO_STAR_MAX do
			if level1 == HERO_STAR_MAX then
				greenTable[i]:setString(MultiLan("GHL_train_2"))
			else
				local cha = LevelupTable[level2+1][attrKey[i]]
				print("cha",cha)
				if level2 == level1 then
					cha = LevelupTable[level2+2][attrKey[i]] 
				end
				greenTable[i]:setString("+"..cha.."%")
			end
			
			greenTable[i]:setPositionX(yellowTable[i]:getPositionX()+yellowTable[i]:getContentSize().width+5)
			extraTable[i]:setPositionX(greenTable[i]:getPositionX()+greenTable[i]:getContentSize().width+5)
		end
	end
	
	--星级MultiLan("GHL_heroStar")
	back = CreateCommonSprite("board_equip.png", Pos(POPUP_SIZE_MAX,0.5,0.365))
	back:setScaleX(570/633)
	back:setScaleY(405/573)
	back:setOpacity(180)
	popupContent:addChild(back)

	popupContent:addChild(CreateCommonLabel(MultiLan("GHL_heroStar"), Pos(popupContent:getContentSize(),0.1,0.58), FontSize2))
	local starLayer = CreateLayer(XiaLayerOwner["mHeroStarLayer"]:getContentSize(), 1,Pos(popupContent:getContentSize(), 0.5, 0.58))
	popupContent:addChild(starLayer)
	local starLevel1 = -1--HeroInfoTable
	local starLevel2 = -1
	local starArr = {}
	for i=1, HERO_STAR_MAX do
		local starBack = CreateCommonSprite("pic_blstar.png", cc.p(75+50*i, 30))
		table.insert(starArr, starBack)
		starLayer:addChild(starBack)
	end
	local barBack = CreateCommonSprite("pic_enterloading01.png", Pos(popupContent:getContentSize(), 0.5, 0.54))
	--barBack:setScale(1.15)
	local barSprite = CreateCommonBar("pic_enterloading02.png", Pos(popupContent:getContentSize(), 0.5, 0.54))
	--barSprite:setScale(1.15)
	local barLabel =  CreateCommonLabel("", Pos(popupContent:getContentSize(), 0.5, 0.54),FontSize2)
	popupContent:addChild(barBack)
	popupContent:addChild(barSprite)
	popupContent:addChild(barLabel)
	print("ttt")
	local function refreshHeroStar()
		print("refreshHeroStar", level1,level2,starLevel1,starLevel2)
		if starLevel1 ~= level1 or starLevel2 ~= level2 then
			starLevel1 = level1
			starLevel2 = level2
			for i=1,HERO_STAR_MAX do
				starArr[i]:removeAllChildren(true)
				if i <= starLevel2 then
					local star = CreateCommonSprite("pic_shstar.png",Pos(starArr[i]:getContentSize()))
					starArr[i]:addChild(star)
					if i> starLevel1 then
						star:setScale(1.1)
						star:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.FadeTo:create(0.8,0), cc.DelayTime:create(0.1), cc.FadeTo:create(0.6,200),cc.DelayTime:create(0.2))))
					end
				end
			end
			refreshAttrLayer()
		end
		
		if level2 < HERO_STAR_MAX then
			barSprite:setPercentage(100*starexp.e/starexp.m)
			barLabel:setString(starexp.e.."/"..starexp.m)
		else
			barSprite:setPercentage(100)
			barLabel:setString(MultiLan("GHL_star_desc7"))
		end
	end
	--level1 = 2
	--level2 = 4
	refreshHeroStar()
	
	--按钮区域
	local leftLabel = CreateCommonLabel("", Pos(popupContent:getContentSize(),0.5,0.15), FontSize2, COLOR_GREEN)
	popupContent:addChild(leftLabel)
	local costLabel = CreateCommonLabel(MultiLan("GHL_star_desc2"), Pos(popupContent:getContentSize(),0.5,0.50),FontSize4)
	popupContent:addChild(costLabel)
	local noteLabel = CreateCommonLabel(MultiLan("GHL_star_desc3"), Pos(popupContent:getContentSize(),0.5,0.34),FontSize4)
	popupContent:addChild(noteLabel)
	local eatPillData = {}
	local eatArr = {}
	local prepareArr = {}
	local leftEatCount = 0
	print("ppp")
	local function expChange(changeValue)
		print("expChange", changeValue)
		starexp.e = starexp.e + changeValue
		if changeValue > 0 then
			print("+", starexp.e, starexp.m, level2)
			while starexp.e >= starexp.m and level2 < HERO_STAR_MAX do
				starexp.e = starexp.e - starexp.m
				level2 = level2 + 1
				starexp.m = LevelupTable[level2+1].exp
				print(level2, starexp.m, starexp.e)
			end
		elseif changeValue < 0 then
			while starexp.e < 0 and level2 >= level1 do
				level2 = level2 - 1
				starexp.m = LevelupTable[level2+1].exp
				starexp.e = starexp.e + starexp.m
			end
		end
	end

	--刷新消耗
	local function refreshEatLayer()
		local eatCount = 0
		for i=1, table.maxn(eatArr) do
			if eatArr[i] == nil or eatArr[i].num == 0 then
				eatArr[i].sprite:setSpriteFrame("board_baseboard.png")
				eatArr[i].frame:setSpriteFrame("frame_grey.png")
				eatArr[i].count:setString("")
			else
				local staticData = FindFirstByKey(eatPillData,"id", eatArr[i].id)
				eatArr[i].sprite:setSpriteFrame("prop_"..staticData.id..".png")
				eatArr[i].frame:setSpriteFrame(FRAME_ICON_ARR[staticData.color])
				eatArr[i].count:setString(eatArr[i].num)
				eatCount = eatCount + eatArr[i].num
			end
		end
		
		leftLabel:setString(MultiLan("GHL_star_desc1")..(UserVipInfo.hire_star - UserSelfInfo.hero_star["hero_"..HeroInfoTable[showedHeroTag].dynamicData.id]-eatCount).."/"..UserVipInfo.hire_star)
		leftEatCount = UserVipInfo.hire_star - UserSelfInfo.hero_star["hero_"..HeroInfoTable[showedHeroTag].dynamicData.id] - eatCount
		
		for i=1, table.maxn(prepareArr) do
			if prepareArr[i] == nil or prepareArr[i].num == 0 then
				prepareArr[i].sprite:setSpriteFrame("board_dyboard.png")
				prepareArr[i].frame:setSpriteFrame("frame_grey.png")
				prepareArr[i].count:setString("")
			else
				local staticData = FindFirstByKey(eatPillData,"id", prepareArr[i].id)
				prepareArr[i].sprite:setSpriteFrame("prop_"..staticData.id..".png")
				prepareArr[i].frame:setSpriteFrame(FRAME_ICON_ARR[staticData.color])
				prepareArr[i].count:setString(prepareArr[i].num)
				eatCount = eatCount + prepareArr[i].num
			end
		end
	end
	
	--消耗丹药点击
	local function onDanClick(node)
		local tag = node:getTag()
		if eatArr[tag] ~= nil and eatArr[tag].id ~= 0 then
			eatArr[tag].num = eatArr[tag].num - 1
			--经验变化attr_value
			expChange(0-FindFirstByKey(eatPillData, "id", eatArr[tag].id).attr_value)
			for i=1, table.maxn(prepareArr) do
				if prepareArr[i].id == eatArr[tag].id then
					prepareArr[i].num = prepareArr[i].num + 1
				end
			end
			
			if eatArr[tag].num <= 0 then
				eatArr[tag].id = 0
			end
			
			refreshEatLayer()
			refreshHeroStar()
		end
	end
	
	local function addCostPill(addPropId)
		print("addCostPill",addPropId)
		local bFind = false
		for i=1, table.maxn(eatArr) do
			if eatArr[i].id == addPropId then
				eatArr[i].num = eatArr[i].num + 1
				bFind = true
				break
			end
		end
		
		if bFind == false then
			for i=1, table.maxn(eatArr) do
				if eatArr[i].id == 0 then
					eatArr[i].id = addPropId
					eatArr[i].num = 1
					break
				end
			end
		end
	end
	
	--可用丹药点击
	local function onPrepareClick(node)
		local tag = node:getTag()
		print("onPrepareClick", tag, prepareArr[tag].id, prepareArr[tag].num)
		if prepareArr[tag] ~= nil and prepareArr[tag].id ~= 0 and prepareArr[tag].num > 0 then
			if leftEatCount <= 0 then
				CommonNote(MultiLan("GHL_star_desc4"))
				return
			end
			prepareArr[tag].num = prepareArr[tag].num - 1
			
			addCostPill(prepareArr[tag].id)
			
			expChange(FindFirstByKey(eatPillData, "id", prepareArr[tag].id).attr_value)
			
			refreshEatLayer()
			refreshHeroStar()
		end
	end
	
	local function initPillData()
		print("initPillData")
		for i=1, table.maxn(PILL_ID_ARR) do 
			eatPillData[i] = GameData:getPropDataTable(PILL_ID_ARR[i]) 
		end
		
		for i=1,table.maxn(PILL_ID_ARR) do
			local dynamicProp = FindFirstByKey(UserInfo:getUserInfo().data.bag_prop, "prop_id", PILL_ID_ARR[i])
			print(i, dynamicProp, PILL_ID_ARR[i])
			if dynamicProp ~= nil then
				
				local c = table.maxn(prepareArr)+1
				local button = CreateCommonButton("pic_suiyiaaa.png", Pos(popupContent:getContentSize(), 0.2*c,0.26), cc.size(90,90), onPrepareClick)
				local sprite1 = CreateCommonSprite("board_dyboard.png", Pos(popupContent:getContentSize(), 0.2*c,0.26))
				local sprite2 = CreateCommonSprite("frame_grey.png", Pos(popupContent:getContentSize(), 0.2*c,0.26))
				local countLabel = CreateCommonLabel("", cc.p(82,10),FontSize1,nil,cc.p(1,0))
				local nameLabel = CreateCommonLabel(MultiLan(eatPillData[i].name), Pos(popupContent:getContentSize(), 0.2*c,0.19),FontSize2)
				popupContent:addChild(button, 0, c)
				popupContent:addChild(sprite1)
				popupContent:addChild(sprite2)
				popupContent:addChild(nameLabel)
				sprite2:addChild(countLabel)
				table.insert(prepareArr, {id=eatPillData[i].id, num=dynamicProp.amount, sprite=sprite1, frame = sprite2, count = countLabel})
			end
		end
		
		for i=1, table.maxn(PILL_ID_ARR) do
			if i> table.maxn(prepareArr) then
				local button =  CreateCommonSprite("pic_suiyiaaa.png", Pos(popupContent:getContentSize(), 0.2*i,0.26))
				local sprite1 = CreateCommonSprite("board_dyboard.png", Pos(popupContent:getContentSize(), 0.2*i,0.26))
				local sprite2 = CreateCommonSprite("frame_grey.png", Pos(popupContent:getContentSize(), 0.2*i,0.26))
				popupContent:addChild(button)
				popupContent:addChild(sprite1)
				popupContent:addChild(sprite2)
			end
		end
		
		refreshEatLayer()
	end
	initPillData()
	
	for i=1, table.maxn(PILL_ID_ARR) do
		local button = CreateCommonButton("pic_suiyiaaa.png", Pos(popupContent:getContentSize(),0.2*i,0.42), cc.size(90,90), onDanClick)
		popupContent:addChild(button,0,i)
		local sprite1 = CreateCommonSprite("board_baseboard.png", Pos(popupContent:getContentSize(), 0.2*i,0.42))
		popupContent:addChild(sprite1)
		local sprite2 = CreateCommonSprite("frame_grey.png", Pos(popupContent:getContentSize(), 0.2*i,0.42))
		popupContent:addChild(sprite2)
		local countLabel = CreateCommonLabel("", cc.p(82,10),FontSize1,nil,cc.p(1,0))
		sprite2:addChild(countLabel)
		eatArr[i] = {id=0, num=0, sprite=sprite1, frame = sprite2, count = countLabel}
	end
	--合成
	local function onMergeClick()
		PillMergePopup()
	end
	popupContent:addChild(CreateCommonButton("button_blue.png", Pos(POPUP_SIZE_MAX,0.2,0.06), cc.size(158,67), onMergeClick, {str=MultiLan("propdetail_button5"), size = FontSize3}))

	--一键放入
	local function quickPutFunc()
		print("quickPutFunc", leftEatCount)
		local count = leftEatCount
		local bFind = false
		for i=1,table.maxn(prepareArr) do
			if prepareArr[i].id ~= 0 and prepareArr[i].num > 0 then
				bFind = true
				break
			end
		end
		
		for i = 1, count do
			for j=1 ,table.maxn(prepareArr) do
				print("j",j,prepareArr[j].id,prepareArr[j].num)
				if prepareArr[j].id ~= 0 and prepareArr[j].num > 0 then
					if leftEatCount == 0 then
						break
					end
					prepareArr[j].num = prepareArr[j].num - 1
					addCostPill(prepareArr[j].id)
					expChange(FindFirstByKey(eatPillData, "id", prepareArr[j].id).attr_value)
					break
				end
			end
		end
		
		if leftEatCount == 0 and bFind then
			CommonNote(MultiLan("GHL_star_desc4"))
			return
		end

		if bFind then
			refreshEatLayer()
			refreshHeroStar()
		end
	end
	popupContent:addChild(CreateCommonButton("button_blue.png", Pos(POPUP_SIZE_MAX,0.5,0.06), cc.size(158,67), quickPutFunc, {str=MultiLan("GHL_button_putin"), size = FontSize3}))
	
	
	--护法升星
	local function sendStarupFunc()
		if UserSelfInfo.level < 20 then
			CommonNote(MultiLan("GHL_star_desc8"))
			return 
		end
	
		local str = "num="
		local bFind1 = false
		local addExp = 0
		for i=1,table.maxn(PILL_ID_ARR) do
			if i~= 1 then
				str = str..","
			end
			local bFind2 = false
			for j=1,table.maxn(eatArr) do
				if eatArr[j].id == PILL_ID_ARR[i] then
					str = str..eatArr[j].num
					bFind1 = true
					bFind2 = true
					addExp = addExp + eatPillData[i].attr_value * eatArr[j].num
				end
			end
			
			if bFind2 == false then
				str = str.."0"
			end
		end
		if bFind1 == false then
			CommonNote(MultiLan("GHL_star_desc5"))
			return 
		end
		
		local function starupCallback(jsonDataTable)
			if jsonDataTable.ret == 0 then
				print("starupCallback", jsonDataTable.data.star_level, HeroInfoTable[showedHeroTag].dynamicData.star_level)
				CommonNote(MultiLan("GHL_star_desc6").." +"..addExp)
				local bLevelUp = false
				if jsonDataTable.data.star_level > HeroInfoTable[showedHeroTag].dynamicData.star_level then
					bLevelUp = true
				end
				HeroInfoTable[showedHeroTag].dynamicData.star_level = jsonDataTable.data.star_level
				HeroInfoTable[showedHeroTag].dynamicData.star_exp = jsonDataTable.data.star_exp
				UserSelfInfo.hero_star["hero_"..HeroInfoTable[showedHeroTag].dynamicData.id] = jsonDataTable.data.pill_use
				for i=1,table.maxn(jsonDataTable.data.use_items) do
					UserInfo:removepropByPropId(jsonDataTable.data.use_items[i].prop_id,jsonDataTable.data.use_items[i].num)
				end
				--刷新界面
				level1 = HeroInfoTable[showedHeroTag].dynamicData.star_level
				level2 = level1
				starexp = {e=HeroInfoTable[showedHeroTag].dynamicData.star_exp, m=LevelupTable[level1+1].exp}
				for i=1,2 do
					for j=1,5 do
						local num = (i-1)*5+j
						yellowTable[num]:setString("+"..LevelupTable[level1+1][attrKey[num]].."% (")
					end
				end
				for i=1,table.maxn(eatArr) do 
					eatArr[i].id=0
					eatArr[i].num=0
				end
				
				if bLevelUp then
					UserAttr:CalHeroFinalAttr(HeroInfoTable[showedHeroTag].staticData.id, true)
				end
				
				refreshHeroStar()
				refreshEatLayer()
				BagLayer:refreshPropLayer()
			end
		end
		HttpSend("hire/star",{"hero="..HeroInfoTable[showedHeroTag].staticData.id, str}, starupCallback)
	end
	popupContent:addChild(CreateCommonButton("button_green.png", Pos(POPUP_SIZE_MAX,0.8,0.06), cc.size(158,67), sendStarupFunc, {str=MultiLan("GHL_button_starup"), size = FontSize3}))
end

--丹药合成弹窗
function PillMergePopup(pillType)
	--Hero_ShowStarup  Hero_ShowStarupNode
	local popupContent = CreateLayer(POPUP_SIZE_MID, 1, Pos(POPUP_SIZE_MID))
	local function closeCallback() 
	    if Hero_ShowStarupNode ~= nil then
			print(1111)
			removeSelf(Hero_ShowStarupNode)
			Hero_ShowStarupNode = nil
			onHeroStarup()
		end
	end
	local popupRoot = CommonCreatePopupMid("medhc",popupContent, closeCallback)
	
	--描述
	local back = CreateCommonSprite("board_equip.png", Pos(POPUP_SIZE_MID,0.5,0.35))
	back:setScaleX(400/633)
	back:setScaleY(160/573)
	back:setOpacity(180)
	popupContent:addChild(back)
	local descLayer = CreateLayer(cc.size(400,160), 1, Pos(POPUP_SIZE_MID,0.5,0.35))
	popupContent:addChild(descLayer)
	
	local costArr = {{use_type="gold",use_num=50000}, {use_type="cash",use_num=10},{use_type="cash",use_num=25},{use_type="cash",use_num=60}}
	local costNum = {5,3,3,3}
	local choosedPropId = 0
	local choosedPropType = 0
	local function refreshDesc(i)
		print("refreshDesc",i)
		descLayer:removeAllChildren(true)
		if i >= 1+table.maxn(PILL_ID_ARR) then
			choosedPropId = 0
			choosedPropType = 0
			descLayer:addChild(CreateCommonLabel(MultiLan("GHL_star_desc9"), Pos(descLayer:getContentSize()),FontSize4))
		else
			--descLayer:addChild(CreateCommonLabel(MultiLan("GHL_star_desc10"), ))
			descLayer:addChild(CreateCommonLabel(MultiLan("GHL_star_desc10"), cc.p(10,140), FontSize4, COLOR_GREEN, cc.p(0,0.5)))
			
			local cost = MultiLan("lan_"..costArr[i].use_type).." "..costArr[i].use_num.." ("..MultiLan("desc_now_have")..UserSelfInfo[costArr[i].use_type]..")"
			if UserSelfInfo[costArr[i].use_type] < costArr[i].use_num then
				descLayer:addChild(CreateCommonLabel(cost, cc.p(40,100), FontSize2, COLOR_RED, cc.p(0,0.5)))
			else
				descLayer:addChild(CreateCommonLabel(cost, cc.p(40,100), FontSize2, COLOR_WHITE, cc.p(0,0.5)))
			end
			
			local propid = PROP_ID_PILL
			if i > 1 then
				propid = PILL_ID_ARR[table.maxn(PILL_ID_ARR)+2-i]
			end
			choosedPropId = propid
			choosedPropType = i
			local propInfo =  FindFirstByKey(UserInfo:getUserInfo().data.bag_prop, "prop_id", propid)
			local currentHave = 0
			if propInfo ~= nil then
				currentHave = propInfo.amount
			end
			local need = MultiLan("prop_name_"..propid).." "..costNum[i].." ("..MultiLan("desc_now_have")..currentHave.." )"
			if currentHave < costNum[i] then
				descLayer:addChild(CreateCommonLabel(need, cc.p(40,70), FontSize2, COLOR_RED, cc.p(0,0.5)))
			else
				descLayer:addChild(CreateCommonLabel(need, cc.p(40,70), FontSize2, COLOR_WHITE, cc.p(0,0.5)))
			end
		end
	end

	--
	local propLayer = CreateLayer(cc.size(500,100), 1, Pos(POPUP_SIZE_MID,0.5,0.7))
	popupContent:addChild(propLayer)
	local chooseSprite = CreateCommonSprite("board_picdy.png", Pos(propLayer:getContentSize()))
	propLayer:addChild(chooseSprite)
	
	local function choosePillFunc(node)
		print("choosePillFunc",node:getTag())
		chooseSprite:setPosition(Pos(propLayer:getContentSize(),0.2*node:getTag()-0.1,0.5))
		refreshDesc(node:getTag())
	end
	local countLabelArr = {}
	for i=1, 1+table.maxn(PILL_ID_ARR) do
		local propid = PROP_ID_PILL
		if i > 1 then
			propid = PILL_ID_ARR[table.maxn(PILL_ID_ARR)+2-i]
		end
		
		local button = CreateCommonButton("prop_"..propid..".png",Pos(propLayer:getContentSize(),0.2*i-0.1,0.5),cc.size(90,90), choosePillFunc) 
		propLayer:addChild(button,0,i)
		local staticData = GameData:getPropDataTable(propid)
		button:addChild(CreateCommonSprite(FRAME_ICON_ARR[staticData.color], Pos(button:getContentSize())))
		propLayer:addChild(CreateCommonLabel(MultiLan(staticData.name), Pos(propLayer:getContentSize(),0.2*i-0.1,-0.1), FontSize2))
		local countLabel = CreateCommonLabel("", cc.p(70, 16), FontSize2,nil,nil,cc.p(1,0))
		button:addChild(countLabel)
		table.insert(countLabelArr, countLabel)
	end
	local function refreshCount()
		local propIdArr = {}
		for i=1, 1+ table.maxn(PILL_ID_ARR) do
			if i == 1 then
				propIdArr[i] = PROP_ID_PILL  
			else
				propIdArr[i] = PILL_ID_ARR[table.maxn(PILL_ID_ARR)+2-i]
			end
		end
		
		for i=1,table.maxn(countLabelArr) do
			local propInfo = FindFirstByKey(UserInfo:getUserInfo().data.bag_prop, "prop_id", propIdArr[i])
			local count = 0
			if propInfo == nil then
				countLabelArr[i]:setString("0")
			else
				countLabelArr[i]:setString(propInfo.amount)
				count = propInfo.amount
			end
			if costNum[i] ~= nil and count < costNum[i] then
				countLabelArr[i]:setColor(COLOR_RED)
			else
				countLabelArr[i]:setColor(COLOR_WHITE)
			end
		end	
	end
	refreshCount()
	local tempNode = cc.Node:create()
	print("pillType",pillType)
	if pillType ~= nil then
		if pillType == PROP_ID_PILL then
			tempNode:setTag(1)
		else
			for i=1,table.maxn(PILL_ID_ARR) do
				if pillType == PILL_ID_ARR[i] then
					tempNode:setTag(2+table.maxn(PILL_ID_ARR)-i)
				end
			end
			
		end
	else
		tempNode:setTag(1)
	end
	choosePillFunc(tempNode)
	--合成
	local function mergePill()
		if choosedPropId == 0 then
			CommonNote(MultiLan("GHL_star_desc11"))
			return
		end
		
		local notEnough = false
		if UserSelfInfo[costArr[choosedPropType].use_type] < costArr[choosedPropType].use_num then
			notEnough = true
			if costArr[choosedPropType].use_type == "gold" then
				CommonGoldNeed()
			elseif costArr[choosedPropType].use_type == "cash" then
				CommonCashNeed()
			end
		end
		
		local propInfo =  FindFirstByKey(UserInfo:getUserInfo().data.bag_prop, "prop_id", choosedPropId)
		if propInfo == nil or propInfo.amount < costNum[choosedPropType] then
			notEnough = true
			CommonNote(MultiLan("GHL_star_desc12"))
		end
		if notEnough then
			return
		end
		
		local function mergePillCallback(jsonDataTable)
			if jsonDataTable.ret == 0 then
				UserInfo:addProp(jsonDataTable.data.items)
				UserInfo:addPropNote(jsonDataTable.data.items)

				if jsonDataTable.data.use_prop_id ~= nil then
					UserInfo:removepropByPropId(jsonDataTable.data.use_prop_id, jsonDataTable.data.use_prop_num)
				end
				
				UserSelfInfo[jsonDataTable.data.use_type] = UserSelfInfo[jsonDataTable.data.use_type] - jsonDataTable.data.use_num
				if jsonDataTable.data.use_type == "cash" then
					UseCash(jsonDataTable.data.use_num)
				end
				
				refreshCount()
				refreshDesc(choosedPropType)
				BagLayer:refreshPropLayer()
			end
		end
		HttpSend("hire/propup",{"id="..choosedPropId}, mergePillCallback)
	end
	popupContent:addChild(CreateCommonButton("button_green.png", Pos(POPUP_SIZE_MID,0.5,0.08), cc.size(158,67), mergePill, {str=MultiLan("propdetail_button5"), size = FontSize3}))
end

XiaLayer["onHeroMoreProperty"]     = onHeroMoreProperty
XiaLayer["onHeroTrain"]        = onHeroTrain
XiaLayer["onHeroSkill"]        = onHeroSkill
XiaLayer["onHeroState"]        = onHeroState
XiaLayer["onHeroStarup"]        = onHeroStarup
