LoginRegisterLayer = class("LoginRegisterLayer")
LoginRegisterLayer.__index = LoginRegisterLayer

LoginRegisterLayer.topNode = nil
LoginRegisterLayer.editbox = nil
LoginRegisterLayer.selectedIndex = 0
LoginRegisterLayer.name = ""

ccb["LoginRegisterLayer"] = LoginRegisterLayer
LoginRegisterLayerOwner = LoginRegisterLayerOwner or {}
ccb["LoginRegisterLayerOwner"] = LoginRegisterLayerOwner

--[[Chinese
MAX_XING = 496
MAX_MING_MAN = 2300
MAX_MING_WOMAN = 4100
]]
--[[English]]
MAX_XING = 8
MAX_MING_MAN = 639
MAX_MING_WOMAN = 373


function LoginRegisterLayer:LoginRegisterLayerEnter()
	GameEnteringLayer.topNode:setVisible(false)
	local proxy = cc.CCBProxy:create()
	self.topNode = CCBReaderLoad("ccb/LoginRegister.ccbi",proxy,LoginRegisterLayerOwner)
	scene:addChild(self.topNode)

	local lbInputYourNameHere = LoginRegisterLayerOwner["lbInputYourNameHere"]
	
	LoginRegisterLayerOwner["mLoginName"]:setString(MultiLan("login_desc6"))
	-- LoginRegisterLayerOwner["mCreateActor"]:setTitleForState(MultiLan("login_button_enter"), cc.CONTROL_STATE_NORMAL)
	LoginRegisterLayerOwner["mTitleChooseRole"]:setString(ZGMultiLan("mTitleChooseRole"))
	SetTouchEventForLayer(LoginRegisterLayerOwner["mRegisterSwallow"], TouchSwallow)
	local editLayer = LoginRegisterLayerOwner["mLoginRegisterNameLayer"]
	-- editLayer:addChild(CreateCommonSprite("board_creatname.png", Pos(editLayer:getContentSize())))
	self.editbox = cc.EditBox:create(lbInputYourNameHere:getContentSize(), cc.Scale9Sprite:createWithSpriteFrameName("pic_suiyiaaa.png"))
	editLayer:addChild(self.editbox)
	self.editbox:setText("")
	self.editbox:setPlaceHolder(MultiLan("register_desc1"))
	self.editbox:setPosition(lbInputYourNameHere:getPosition())
	self.editbox:setFontSize(25)
	self.editbox:setPlaceholderFontSize(25)

	lbInputYourNameHere:removeFromParent()		-- remove after used
	
	onLoginRegisterBtn(LoginRegisterLayerOwner["mLoginRegisterBtn1"])

	CommonMoveLabelUnderBtn(LoginRegisterLayerOwner["mCreateActor"], LoginRegisterLayerOwner["lbBtnCreateActor"])
	LoginRegisterLayerOwner["lbBtnCreateActor"]:setString(ZGMultiLan("crate_btn_create_actor"))
end

function LoginRegisterLayer:LoginRegisterLayerExit()
end

function onLoginRegisterBtn(node)
	for i = 1, 3 do
		LoginRegisterLayerOwner["mLoginRegisterSelect" .. i]:setVisible(false)
	end
	LoginRegisterLayer.selectedIndex = tolua.cast(node, "cc.Node"):getTag()
	LoginRegisterLayerOwner["mLoginRegisterLabel"]:setString(MultiLan("career_desc_" .. LoginRegisterLayer.selectedIndex))
	LoginRegisterLayerOwner["mLoginRegisterSelect" .. LoginRegisterLayer.selectedIndex]:setVisible(true)
end

local function onLoginRegisterRandom()
	local nameXing = NameMultiLan("rnd_first_name_" .. (math.random(os.clock()*10^6)%MAX_XING + 1))
	local nameMing = ""
	if LoginRegisterLayer.selectedIndex == 3 then
		nameMing = NameMultiLan("rnd_last_name_woman_" .. (math.random(os.clock()*10^6)%MAX_MING_WOMAN + 1))
	else
		nameMing = NameMultiLan("rnd_last_name_man_" .. (math.random(os.clock()*10^6)%MAX_MING_MAN + 1))
	end
	if SDK_PLATFORM == "SDK_TGAME_TH_IOS" or SDK_PLATFORM == "SDK_TGAME_TH_ANDROID" then
		LoginRegisterLayer.name = nameMing..nameXing 
	else
		LoginRegisterLayer.name = nameXing..nameMing
	end
	LoginRegisterLayer.editbox:setText(LoginRegisterLayer.name)
end

local function onLoginCheckName()
	local nameLen = GetUTF8LogicStrLen(LoginRegisterLayer.name)
	cclog("name len is %d", nameLen)
	local maxNameLen = 13
	local minNameLen = 4
	if SDK_PLATFORM == "SDK_TGAME_TH_IOS" or SDK_PLATFORM == "SDK_TGAME_TH_ANDROID" or SDK_PLATFORM == "SDK_TGAME_VN_IOS" or SDK_PLATFORM == "SDK_TGAME_VN_ANDROID"  then
		maxNameLen = 35
		minNameLen = 1
	end
	if nameLen < minNameLen or nameLen > maxNameLen then
		CreateSmallPopupWithCancel(nil, CreateCommonLabel(MultiLan("register_desc2"), nil, FontSize3), nil)
		return false
	end
	return true
end

local function onLoginRegisterCreateActor(node)
	LoginRegisterLayer.name = LoginRegisterLayer.editbox:getText()
	if onLoginCheckName() == false then
		cclog("check actor name failed %s", LoginRegisterLayer.name)
		return
	end
	local function onLoginRegisterCreateActorCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			cclog("login create actor name failed %d", jsonDataTable.ret)
			return 
		end
		tolua.cast(node, "cc.ControlButton"):setEnabled(false)
		UserInfo:getUserInfo().data.info.role = jsonDataTable.data.role
		UserInfo:getUserInfo().data.info.name = jsonDataTable.data.name
		LoginRegisterLayer:LoginRegisterLayerExit()
		InitGameUi()
	end
	if 	SDK_PLATFORM == "SDK_TGAME_ANDROID" or SDK_PLATFORM == "SDK_TGAME_IOS" or SDK_PLATFORM == "SDK_JAGUAR_ANDROID" or SDK_PLATFORM == "SDK_JAGUAR_THIRD" then
		local tmpTable = {
						eventType = tostring(1),
						roleId = tostring(UserInfo:getUserInfo().data.info.uid),
						roleName = tostring(UserInfo:getUserInfo().data.info.name),
						serverId = tostring(LOGIN_SERVER_ID),
					}
					
		DevicePlatform:getInstance():sdkExtraFunction(tmpTable)
	end
	HttpSend("user/role", {"role=" .. LoginRegisterLayer.selectedIndex, "name=" .. LoginRegisterLayer.name}, onLoginRegisterCreateActorCallback)
end

LoginRegisterLayer["onLoginRegisterBtn"] = onLoginRegisterBtn
LoginRegisterLayer["onLoginRegisterRandom"] = onLoginRegisterRandom
LoginRegisterLayer["onLoginRegisterCreateActor"] = onLoginRegisterCreateActor