GameMailLayer = class("GameMailLayer")
GameMailLayer.__index = GameMailLayer

GameMailLayer.topNode = nil
GameMailLayer.filterScroll = nil
GameMailLayer.userMailInfoList = {}
GameMailLayer.selectMailInfo = {}

ccb["GameMailLayer"] = GameMailLayer
GameMailLayerOwner = GameMailLayerOwner or {}
ccb["GameMailLayerOwner"] = GameMailLayerOwner

function onGameMailLayerLayerClose()
	GameMailLayer:GameMailLayerExit()
	setMailNote(false)
end

local function deleteMailCallback(jsonDataTable)
	if jsonDataTable.ret ~= 0 then
		CommonNote(MultiLan("mail_desc1"))
    else
        CommonNote(MultiLan("mail_desc2"))
		local  removeMailIds = jsonDataTable.data
		for k = 1,table.maxn(removeMailIds) do
			for i = 1 ,table.maxn(GameMailLayer.userMailInfoList) do
				if GameMailLayer.userMailInfoList[i].id ==  removeMailIds[k] then
					table.remove(GameMailLayer.userMailInfoList,i)
					break
				end
			end
		end 	
	end
    GameMailLayer:GameMailLayerRefresh(GameMailLayer.userMailInfoList)
end

local function getMailItemCallback(jsonDataTable)

	if jsonDataTable.ret ~= 0 then
		CommonNote(MultiLan("mail_desc3"))
    else
        --CommonNote("获得物品成功")
		
		local  mailItemInfo = jsonDataTable.data
		for i = 1 ,table.maxn(GameMailLayer.userMailInfoList) do
			if GameMailLayer.userMailInfoList[i].id ==  mailItemInfo.id then
				if true then
					table.remove(GameMailLayer.userMailInfoList,i)
				else
					GameMailLayer.userMailInfoList[i].items = nil
				end
				
				break
			end
		end
		
		UserInfo:addProp(mailItemInfo.items)
		UserInfo:addPropNote(mailItemInfo.items)
	end
	
    GameMailLayer:GameMailLayerRefresh(GameMailLayer.userMailInfoList)
end

function createMailItemInfoRichtext(infoTable)

	local infoText = ccui.RichText:create()
	infoText:setContentSize(cc.size(400, 500))
	infoText:ignoreContentAdaptWithSize(false)

    if infoTable.msg ~= nil then
        local mailMsg = GameData:getMailMsg(infoTable.msg)
        if mailMsg == nil then
            mailMsg = infoTable.msg
        end
    	infoText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255, mailMsg, DefaultFontName, FontSize1))
		infoText:pushBackElement(ccui.RichElementNewLine:create())
    end

    if infoTable.items ~= nil  and infoTable.items ~= CJSON_NULL then
         infoText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255, MultiLan("mail_desc4"), DefaultFontName, FontSize1))
		 --infoText:pushBackElement(ccui.RichElementNewLine:create())
         local propInfoTable = nil
         local count = 0
         for i =1,table.maxn(infoTable.items) do
            propInfoTable = GameData:getPropDataTable(infoTable.items[i].prop_id)
			if propInfoTable.ptype == PROP_TYPE_EQUIP then
				infoText:pushBackElement(ccui.RichElementText:create(1, EQUIP_COLOR_ARR[EquipHelper:getEquipGrade(infoTable.items[i])], 255, MultiLan(propInfoTable.name).."*", DefaultFontName, FontSize2))
				infoText:pushBackElement(ccui.RichElementText:create(1, COLOR_YELLOW, 255, "1  ", DefaultFontName, FontSize2))
			else
				infoText:pushBackElement(ccui.RichElementText:create(1, COLOR_DIANQING, 255, MultiLan(propInfoTable.name).."*", DefaultFontName, FontSize2))
				infoText:pushBackElement(ccui.RichElementText:create(1, COLOR_YELLOW, 255, infoTable.items[i].amount.."  ", DefaultFontName, FontSize2))
			end
            if count > 1 then
               infoText:pushBackElement(ccui.RichElementNewLine:create())
               count = 0
            end
         end
         infoText:pushBackElement(ccui.RichElementNewLine:create())
    end

	return infoText
end

function GameMailLayer:GameMailLayerRefresh(userMailInfos)

    self.userMailInfoList = userMailInfos

	local scrollLayer = cc.Layer:create()
	scrollLayer:ignoreAnchorPointForPosition(true)
    self.filterScroll:removeAllChildren()
	self.filterScroll:setContainer(scrollLayer)
	local scrollWorldPos = self.filterScroll:getParent():convertToWorldSpace(cc.p(self.filterScroll:getPosition()))
	local scrollViewSize = self.filterScroll:getViewSize()
	local curPosY = table.maxn(userMailInfos)*161

	local count = table.maxn(userMailInfos)
	for i =1,table.maxn(userMailInfos)do

		local itemLayer = cc.Layer:create()
		itemLayer:ignoreAnchorPointForPosition(false)
		itemLayer:setAnchorPoint(cc.p(0, 1))
			
		local itemBgSprite = cc.Sprite:createWithSpriteFrameName("board_equipchoose.png")
		itemBgSprite:setAnchorPoint(cc.p(0, 0))
        itemBgSprite:setFlippedX(true)
		itemLayer:addChild(itemBgSprite)
		itemLayer:setContentSize(496, itemBgSprite:getContentSize().height)
        	
		local itemRichInfo = createMailItemInfoRichtext(userMailInfos[i])
		itemRichInfo:setContentSize(cc.size(365, 500))
		itemRichInfo:formatText()
		itemRichInfo:ignoreAnchorPointForPosition(true)
		itemRichInfo:setPosition(cc.p(20, itemRichInfo:getTextMaxHeight()/2-500 + itemBgSprite:getContentSize().height/2 ))
		itemLayer:addChild(itemRichInfo)


        local mailDate = os.date("*t", userMailInfos[i].addtime)

        local mailDateBg = cc.Sprite:createWithSpriteFrameName("board_mername.png")
		mailDateBg:setAnchorPoint(cc.p(0, 0.5))
		mailDateBg:setPosition(cc.p(0 , itemLayer:getContentSize().height *0.85 ))
        itemLayer:addChild(mailDateBg)

        local mailDateInfo = cc.Label:create(mailDate.year.."."..mailDate.month.."."..mailDate.day, DefaultFontName, FontSize2)
        mailDateInfo:setAnchorPoint(cc.p(0, 0.5))
		mailDateInfo:setPosition(cc.p(8 , itemLayer:getContentSize().height *0.85 ))--+mailDateInfo:getContentSize().width/2
        itemLayer:addChild(mailDateInfo,1,1)

		itemLayer:setPosition(cc.p(0, curPosY))
		curPosY = curPosY - itemLayer:getContentSize().height
				
		local function sendDeleteMail(node)
            HttpSend("mail/del", {"ids=" .. node:getTag()}, deleteMailCallback)
        end
		
		local function sendGetMailItem(node)
            HttpSend("mail/item", {"id=" .. node:getTag()}, getMailItemCallback)
        end
		
		local function sendLookMailItem(node)
			print("sendLookMailItem",node:getTag(),self.userMailInfoList[node:getTag()].id,self.userMailInfoList[node:getTag()].logid )
			GetGroupBattleInfo(self.userMailInfoList[node:getTag()].logid , self.userMailInfoList[node:getTag()].match)
        end
		
		if self.userMailInfoList[i].items ~= nil and self.userMailInfoList[i].items ~= CJSON_NULL then
			itemLayer:addChild(CreateCommonButton("button_reward.png", cc.p(440, itemLayer:getContentSize().height * 0.5), cc.size(92,92), sendGetMailItem), 0, self.userMailInfoList[i].id)
			local lb = CreateCommonFntLabel(ZGMultiLan("lbBtnReward"), FntTypeCommonYellow, cc.p(440, itemLayer:getContentSize().height * 0.5))
			lb:setScale(0.65)
			itemLayer:addChild(lb)
		elseif self.userMailInfoList[i].logid ~= nil and self.userMailInfoList[i].logid ~= 0 then
			local button = CreateCommonButton("button_blue.png", cc.p(440, itemLayer:getContentSize().height * 0.7), cc.size(158,67), sendLookMailItem,{str=MultiLan("button_look"), size = FontSize3})
			button:setScale(0.6)
			itemLayer:addChild(button, 0, i)
			local button = CreateCommonButton("button_red.png", cc.p(440, itemLayer:getContentSize().height * 0.3), cc.size(158,67), sendDeleteMail,{str=MultiLan("button_delete"), size = FontSize3})
			button:setScale(0.6)
			itemLayer:addChild(button, 0, self.userMailInfoList[i].id)
		else
			local button = CreateCommonButton("button_red.png", cc.p(440, itemLayer:getContentSize().height * 0.5), cc.size(158,67), sendDeleteMail,{str=MultiLan("button_delete"), size = FontSize3})
			button:setScale(0.6)
			itemLayer:addChild(button, 0, self.userMailInfoList[i].id)
		end

		scrollLayer:addChild(itemLayer)
	end
	
	local filterLayer = GameMailLayerOwner["mGameMailChoose"]
	if scrollLayer:getContentSize().height <= filterLayer:getContentSize().height then
		scrollLayer:setContentSize(cc.size(filterLayer:getContentSize().width, filterLayer:getContentSize().height))
		self.filterScroll:setContentOffset(cc.p(0, 0), false)
	else
		scrollLayer:setContentSize(cc.size(filterLayer:getContentSize().width, table.maxn(userMailInfos)*161))
		self.filterScroll:setContentOffset(cc.p(0, -scrollLayer:getContentSize().height + filterLayer:getContentSize().height), false)
	end
	self.filterScroll:updateInset()
	
end

function GameMailLayer:GameMailLayerEnter(userMailInfos)
    
    if self.topNode ~= nil then
        return
    end

	local proxy = cc.CCBProxy:create()
	self.topNode = CCBReaderLoad("ccb/GameMailLayer.ccbi",proxy,GameMailLayerOwner)
	POPUP_LAYER:addChild(self.topNode)
	GameMailLayerOwner["mMailDesc"]:setString(MultiLan("mail_desc5"))
	GameMailLayerOwner["mButtonClose"]:setTitleForState(MultiLan("button_close"), 1)
	GameMailLayerOwner["mTitleGameEmail"]:setString(ZGMultiLan("mTitleGameEmail"))
		
	self:GameMailLayerCreate()
	self:GameMailLayerRefresh(userMailInfos)
end

function GameMailLayer:GameMailLayerExit()
	self.topNode:removeFromParent()
	self.topNode = nil
end

function GameMailLayer:GameMailLayerCreate()
	local filterLayer = GameMailLayerOwner["mGameMailChoose"]
	self.filterScroll = cc.ScrollView:create()
	filterLayer:addChild(self.filterScroll)
	self.filterScroll:setViewSize(cc.size(filterLayer:getContentSize().width, filterLayer:getContentSize().height))
	self.filterScroll:setPosition(cc.p(0,0))
	self.filterScroll:ignoreAnchorPointForPosition(true)
	self.filterScroll:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
	self.filterScroll:setClippingToBounds(true)
	self.filterScroll:setBounceable(true)
	self.filterScroll:setDelegate()
	self.filterScroll:setVisible(true)

    --swallowLaer
	local function onGameMailSwallowTouch(touch, event)
		return true
	end
	SetTouchEventForLayer(GameMailLayerOwner["mGameMailLayerSwallowLayer"], onGameMailSwallowTouch)
end
-----
GameMailLayer["onGameMailLayerLayerClose"] = onGameMailLayerLayerClose