require "lua/cells/UserTitleChooseCell"

PlayerInfoLayer = class("PlayerInfoLayer")
PlayerInfoLayer.__index = PlayerInfoLayer

PlayerInfoLayer.topNode = nil


ccb["PlayerInfoLayer"] = PlayerInfoLayer
PlayerInfoLayerOwner = PlayerInfoLayerOwner or {}
ccb["PlayerInfoLayerOwner"] = PlayerInfoLayerOwner
local playerInfo = {}

USER_TITLE_MAX = 12

--//////////////////////////////////////////////////////
--设置主页玩家数据
function SetPlayerInfo()

	--swallowLaer
	local function onPlayerInfoSwallowTouch(touch, event)
		--print("onPlayerInfoSwallowTouch")
		return true
	end
	SetTouchEventForLayer(PlayerInfoLayerOwner["mPlayerInfoSwallowLayer"], onPlayerInfoSwallowTouch)

    playerInfo = UserInfo:getUserInfo().data.info

	local playerName = playerInfo.name
    local uid =  playerInfo.uid
    local title_list = playerInfo.title_list
	local titleNow = playerInfo.title
    local role = playerInfo.role
    local playerLevel = playerInfo.level 
    local playerExp = playerInfo.exp
    local playerVip = playerInfo.vip
	 local playerHonor = playerInfo.prestige 
	print("SetPlayerInfo")
	--头像
	tolua.cast(PlayerInfoLayerOwner["mPlayerHead"], "cc.Sprite"):setSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame("actor_icon_"..role..".png"))
    --name
	tolua.cast(PlayerInfoLayerOwner["mPlayerName"], "cc.Label"):setString(playerName)
	--id
    tolua.cast(PlayerInfoLayerOwner["mPlayerUsid"], "cc.Label"):setString(MultiLan("playerinfo_desc1")..uid)
	--vip
	PlayerInfoLayerOwner["mVip"]:setString(UserSelfInfo.vip)
	
    --Title
    if titleNow == 0 then
		tolua.cast(PlayerInfoLayerOwner["mPlayerTitle"], "cc.Label"):setString(MultiLan("playerinfo_desc2")..MultiLan("desc_nothing"))
    else
		tolua.cast(PlayerInfoLayerOwner["mPlayerTitle"], "cc.Label"):setString(MultiLan("playerinfo_desc2")..MultiLan("description_"..titleNow))
    end
	--职业
	tolua.cast(PlayerInfoLayerOwner["mPlayerType"], "cc.Label"):setString(MultiLan("playerinfo_desc3")..MultiLan("role_career_"..role))
	--Level
	tolua.cast(PlayerInfoLayerOwner["mPlayerLevel"], "cc.Label"):setString(MultiLan("playerinfo_desc4")..playerLevel)
	--Honor
	tolua.cast(PlayerInfoLayerOwner["mPlayerHonor"], "cc.Label"):setString(MultiLan("playerinfo_desc5")..playerHonor)
	--经验
	local maxExp = GameData:getGameDataTable()["exp"][UserSelfInfo.level].exp
	tolua.cast(PlayerInfoLayerOwner["mPlayerExp"], "cc.Label"):setString(MultiLan("playerinfo_desc6")..playerExp.."/"..maxExp)
	--VIP
	tolua.cast(PlayerInfoLayerOwner["mPlayerVip"], "cc.Label"):setString(MultiLan("playerinfo_desc7").."VIP"..playerVip)
	--signature
	tolua.cast(PlayerInfoLayerOwner["mPlayerSignature"], "cc.Label"):setString(playerInfo.sign_msg)
	
end

function PlayerInfoLayer:PlayerInfoLayerExit()
	if self.topNode ~= nil then
		self.topNode:removeFromParent()
		self.topNode = nil
	end
end

function PlayerInfoLayer:PlayerInfoLayerEnter()
	local proxy = cc.CCBProxy:create()
	self.topNode = CCBReaderLoad("ccb/PlayerInfoLayer.ccbi",proxy,PlayerInfoLayerOwner)
	
	PlayerInfoLayerOwner["mButton1"]:setTitleForState(MultiLan("playerinfo_button1"),1)
	PlayerInfoLayerOwner["mButton2"]:setTitleForState(MultiLan("playerinfo_button2"),1)
	PlayerInfoLayerOwner["mButton3"]:setTitleForState(MultiLan("playerinfo_button3"),1)
	PlayerInfoLayerOwner["mButton4"]:setTitleForState(MultiLan("playerinfo_button4"),1)
	PlayerInfoLayerOwner["mButton5"]:setTitleForState(MultiLan("playerinfo_button5"),1)
	PlayerInfoLayerOwner["mTitlePlayerInfo"]:setString(ZGMultiLan("mTitlePlayerInfo"))
	if POPUP_LAYER ~= nil then
	    POPUP_LAYER:addChild(self.topNode)
		SetPlayerInfo()
	end
end


local function onChangeSignatureBtnClick()	
    local popupContet = CreateLayer(POPUP_SIZE_SML, 1, Pos(POPUP_SIZE_SML))
	popupContet:addChild(CreateCommonLabel(MultiLan("playerinfo_desc8"), Pos(POPUP_SIZE_SML, 0.5,0.7), FontSize2, COLOR_GREEN))
	
	local popupRoot = CommonCreatePopupSmall("signmyword", popupContet)
	
	local function closeFunc() removeSelf(popupRoot) end
	popupContet:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_SML, 0.3, 0.18), cc.size(158,67), closeFunc, {str=MultiLan("button_cancel"), size = FontSize3}))
	
    local function utfstrlen(str)
        local len = #str;
        local left = len;
        local cnt = 0;
        local arr={0,0xc0,0xe0,0xf0,0xf8,0xfc};
        local basecount = 1
        while left ~= 0 do
            local tmp=string.byte(str,-left);
            local i=#arr;
            basecount = 1
            while arr[i] do
                if tmp>=arr[i] then 
                    left=left-i;
                    if i ~= 1 then
                        basecount = 2
                    end
                    break;
                end
                i=i-1;
            end
            cnt=cnt+basecount;
         end
         return cnt;
    end
   
    local SingatureEditBox = nil
    local function setSingatureCallBack(jsonDataTable)
    	if jsonDataTable.ret ~= 0 then
			return 
		end

        if jsonDataTable.data ~= CJSON_NULL then
           CommonNote(MultiLan("playerinfo_desc9"))
           local usrsignature = jsonDataTable.data.msg
           	--signature
	       tolua.cast(PlayerInfoLayerOwner["mPlayerSignature"], "cc.Label"):setString(usrsignature)
           UserInfo:getUserInfo().data.info.sign_msg = usrsignature
           	--signature
	       tolua.cast(PlayerInfoLayerOwner["mPlayerSignature"], "cc.Label"):setString(playerInfo.sign_msg)
           removeSelf(popupRoot)
        end
    end

	local function setSingatureFunc()
        local singature = tostring(tolua.cast(SingatureEditBox,"cc.EditBox"):getText())
        local nameLen = utfstrlen(singature)
        if nameLen < 1 or nameLen > 30 then
           CommonNote(MultiLan("playerinfo_desc10"))
           return
        end
        HttpSend("user/signmsg", {"msg="..singature}, setSingatureCallBack)
	end

	popupContet:addChild(CreateCommonButton("button_blue.png", Pos(POPUP_SIZE_SML, 0.7, 0.18), cc.size(158,67), setSingatureFunc, {str=MultiLan("button_ok"), size = FontSize3}))

    SingatureEditBox = cc.EditBox:create(cc.size(460, 60), cc.Scale9Sprite:createWithSpriteFrameName("board_account01.png"))
	popupContet:addChild(SingatureEditBox)
	SingatureEditBox:setReturnType(cc.KEYBOARD_RETURNTYPE_SEND)
	SingatureEditBox:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
	SingatureEditBox:setText(MultiLan("playerinfo_desc11"))
	SingatureEditBox:setPosition(cc.p(popupContet:getContentSize().width / 2, popupContet:getContentSize().height / 2))

end

function onChangePlayerTitleBtnClick()
	PlayerInfoLayer:PlayerInfoLayerExit()
    --UserSelfInfo.title_list = {101, 102, 103,104,106,107,109}
	print("", table.maxn(UserSelfInfo.title_list),UserSelfInfo.title_list[1])
	local userTitleId = UserSelfInfo.title
	local titleArr = {}
	for i=1, USER_TITLE_MAX do table.insert(titleArr, 100+i) end
	--将已获得的称号排在前面
	local function sortTitle(a,b)
		if FindFirstByValue(UserSelfInfo.title_list, a) ~= nil and FindFirstByValue(UserSelfInfo.title_list, b) == nil then
			return true
		elseif FindFirstByValue(UserSelfInfo.title_list, a) == nil and FindFirstByValue(UserSelfInfo.title_list, b) ~= nil then
			return false
		else
			return a < b
		end
	end
	table.sort(titleArr, sortTitle)
	
	
	local popupContent = CreateLayer(POPUP_SIZE_MID, 1, Pos(POPUP_SIZE_MID))
	--说明
	local ruleBack = CreateCommonSprite("board_skill01.png", Pos(POPUP_SIZE_MID,0.5,0.91))
	ruleBack:setScaleX(1.4)
	popupContent:addChild(ruleBack)
	popupContent:addChild(CreateCommonLabel(string.format(MultiLan("playerinfo_desc12"), table.maxn(UserSelfInfo.title_list), (USER_TITLE_MAX-table.maxn(UserSelfInfo.title_list))), Pos(POPUP_SIZE_MID,0.5,0.91), FontSize4))
	
	local scrollLayer  = CreateLayer(cc.size(490, 470), 1, Pos(POPUP_SIZE_MID, 0.5, 0.515))
	popupContent:addChild(scrollLayer)
	local layer = cc.Layer:create()
	
	--设置按钮点击状态及显示
	--[[
	local function setTitleState()
		local pChildrenArray = layer:getChildren()
		local len = table.getn(pChildrenArray)
		print("setTitleState", userTitleId, len)
		if userTitleId == 0 then
			for j=0, len-1, 1 do
				child = pChildrenArray[j + 1]
				if child:getChildByTag(1)~=nil and child:getChildByTag(1):isVisible() then
					tolua.cast(child:getChildByTag(1),"cc.ControlButton"):setEnabled(true)
					child:getChildByTag(2):setVisible(false)
					child:getChildByTag(3):setVisible(false)
				end
			end
		else
			for j=0, len-1, 1 do
				child = pChildrenArray[j + 1]
				print("in",child:getChildByTag(1),child:getChildByTag(1):isVisible(),child:getTag())
				if child:getChildByTag(1) ~= nil and child:getChildByTag(1):isVisible() then
				    if userTitleId == child:getTag() then
						print(1)
						tolua.cast(child:getChildByTag(1),"cc.ControlButton"):setEnabled(true)
						child:getChildByTag(2):setVisible(true)
						child:getChildByTag(3):setVisible(false)
					else
						print(2)
						tolua.cast(child:getChildByTag(1),"cc.ControlButton"):setEnabled(false)
						child:getChildByTag(2):setVisible(false)
						child:getChildByTag(3):setVisible(true)
					end
				end
			end
		end
	end

	local function onTitleStateChange(node)
		local backLayer = tolua.cast(node,"cc.Node"):getParent()
		if backLayer:getChildByTag(2):isVisible() and backLayer:getChildByTag(3):isVisible() == false then
			userTitleId = 0
		elseif backLayer:getChildByTag(2):isVisible() == false and backLayer:getChildByTag(3):isVisible() == false then
			userTitleId = backLayer:getTag()
		end
		setTitleState()
	end
	]]

	local allTitleCells = {}
	local function setTitleState(  )
		for i = 1, USER_TITLE_MAX do
			local cell = allTitleCells[i]
			local titleId = cell.data.titleId
			if userTitleId == 0 then
				-- 没有选中的
				if nil == FindFirstByValue(UserSelfInfo.title_list, titleId) then
					cell:setLocked()
				else
					cell:setUnChoosed()
				end
			else
				if cell.data.titleId == userTitleId then
					-- 选中状态
					cell:setChoosed()
				else
					if nil == FindFirstByValue(UserSelfInfo.title_list, titleId) then
						-- 未解锁状态
						cell:setLocked()
					else
						-- 解锁状态未选中
						cell:setDisabled()
					end
				end
			end
		end
	end
	
	--更换状态
	function onTitleStateChange(titleId)
		cclog("click titleId is " .. titleId)
		if userTitleId == titleId then
			userTitleId = 0
		else
			userTitleId = titleId
		end
		setTitleState()
	end
	
	local height = 110
	local y = USER_TITLE_MAX * height
	for i=1, USER_TITLE_MAX do
		--[[
		local titleId = titleArr[i]
		local backLayer = CreateLayer(cc.size(490, height), 1, cc.p(245, y-i*height))
		layer:addChild(backLayer,0,titleId)
		local chooseBtn = CreateCommonButton("board_skill03.png", cc.p(440, height/2), cc.size(66, 66), onTitleStateChange)
		chooseBtn:setSwallowTouch(false)
		chooseBtn:setVisible(false)
		backLayer:addChild(chooseBtn,1,1)
		local choose = CreateCommonSprite("pic_hook.png", cc.p(440, height/2))
		backLayer:addChild(choose, 2, 2)
		choose:setVisible(false)
		local disable = CreateCommonSprite("pic_disable.png", cc.p(440, height/2))
		backLayer:addChild(disable, 3, 3)
		disable:setVisible(false)
		local desc = CreateCommonLabel(MultiLan("playerinfo_desc13"), cc.p(425, height*0.5), FontSize2, COLOR_RED)
		desc:setVisible(false)
		backLayer:addChild(desc,4,4)
		
		if nil == FindFirstByValue(UserSelfInfo.title_list, titleId) then
			backLayer:addChild(CreateCommonSprite("board_overmap.png", cc.p(245, height/2), 0.83),-1,0)
			desc:setVisible(true)
		else
			backLayer:addChild(CreateCommonSprite("board_overmap.png", cc.p(245, height/2), 0.83),-1, 0)--board_overmap
			chooseBtn:setVisible(true)
		end
		
		backLayer:addChild(CreateCommonSprite("board_skill01.png", cc.p(200, height*0.62)))
		-- backLayer:addChild(CreateCommonSprite("honor_"..titleId..".png", cc.p(200, height*0.7),0.9))
		-- backLayer:addChild(CreateCommonLabel(ZGMultiLan("honor_" .. titleId), cc.p(200, height * 0.7), FontSize3))
		backLayer:addChild(CreateCommonFntLabel(ZGMultiLan("honor_" .. titleId), FntTypeUserTitle, cc.p(200, height * 0.7)), 2)
		backLayer:addChild(CreateCommonLabel(MultiLan("description_con_"..titleId), cc.p(200, height*0.35),FontSize2))
		]]
		local cell = UserTitleChooseCell:new()
		cell:create({titleId = titleArr[i], cb_setTitleState = onTitleStateChange})
		local cellNode = cell.topNode
		cellNode:setPosition(cc.p(0, y - i * height))
		layer:addChild(cellNode)
		table.insert(allTitleCells, cell)
	end
	ccdump(allTitleCells, "allTitleCells")
	setTitleState()
	
	layer:setContentSize(cc.size(490, math.max(470,USER_TITLE_MAX * height-5)))
	local scrollView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, math.min(0,470 -USER_TITLE_MAX * height +5)), kScrollViewDirectionVertical)
	local popupRoot = CommonCreatePopupMid("changebigname", popupContent, true)
	
	--取消按钮
	local function cancelFunc() 
		removeSelf(popupRoot)
	end
	popupContent:addChild(CreateCommonButton("button_red.png",Pos(POPUP_SIZE_BIG,0.3,0.06), cc.size(158,67), cancelFunc, {str=MultiLan("button_cancel"),size=FontSize3}))
	
	--保存回调
	local function changeTitleCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			UserSelfInfo.title = jsonDataTable.data.title
			removeSelf(popupRoot)
			CommonNote(MultiLan("playerinfo_desc14"))
		end
	end
	
	local function saveTitleFunc() 
		if userTitleId == UserSelfInfo.title then
			removeSelf(popupRoot)
		else
			HttpSend("user/title", {"title=" ..userTitleId}, changeTitleCallback)
		end
	end
	popupContent:addChild(CreateCommonButton("button_green.png",Pos(POPUP_SIZE_BIG,0.7,0.06), cc.size(158,67), saveTitleFunc, {str=MultiLan("button_save"),size=FontSize3}))
end

function onVipDetailBtnClick()
	cclog("onVipDetailBtnClick")
	onVipClick()
end

function onVoiceControlBtnClick()
	cclog("onVoiceControlBtnClick")
end

function onVoiceControlBtnClick()
	cclog("onVoiceControlBtnClick")
	
	local popupContet = CreateLayer(POPUP_SIZE_SML, 1)
	local musicTag = cc.UserDefault:getInstance():getIntegerForKey("MusicTag")
	local effectTag = cc.UserDefault:getInstance():getIntegerForKey("EffectTag")
	local tagArr = {musicTag, effectTag}
	 
	local function onMusicChoose(node)
		local tag = node:getTag()
		if node:getChildByTag(1) ~= nil then
			node:removeChildByTag(1)
			tagArr[tag] = M.MUSIC_ON
		else 
			node:addChild(CreateCommonSprite("pic_hook.png", cc.p(33,33)), 0, 1)
			tagArr[tag] = M.MUSIC_OFF
		end
	end
	--music
	print(1)
	local mLayer = CreateLayer(cc.size(450,60), 1, Pos(POPUP_SIZE_SML, 0.5,0.6))
	mLayer:addChild(CreateCommonSprite("board_skill01.png", Pos(mLayer:getContentSize())))
	mLayer:addChild(CreateCommonLabel(MultiLan("playerinfo_close_music"), Pos(mLayer:getContentSize(), 0.15, 0.5), FontSize2, nil,cc.p(0,0.5)))
	local chooseButton = CreateCommonButton("board_skill03.png", Pos(mLayer:getContentSize(), 0.8, 0.5), cc.size(66,66), onMusicChoose)
	chooseButton:setScale(0.8)
	mLayer:addChild(chooseButton, 0 ,1) 
	popupContet:addChild(mLayer)
	if musicTag == M.MUSIC_OFF then
		chooseButton:addChild(CreateCommonSprite("pic_hook.png", cc.p(33,33)), 0, 1)
	end
	--effect
	local mLayer = CreateLayer(cc.size(450,60), 1, Pos(POPUP_SIZE_SML, 0.5,0.35))
	mLayer:addChild(CreateCommonSprite("board_skill01.png", Pos(mLayer:getContentSize())))
	mLayer:addChild(CreateCommonLabel(MultiLan("playerinfo_close_effect"), Pos(mLayer:getContentSize(), 0.15, 0.5), FontSize2, nil,cc.p(0,0.5)))
	local chooseButton = CreateCommonButton("board_skill03.png", Pos(mLayer:getContentSize(), 0.8, 0.5), cc.size(66,66), onMusicChoose)
	chooseButton:setScale(0.8)
	mLayer:addChild(chooseButton, 0 ,2) 
	popupContet:addChild(mLayer)
	if effectTag == M.MUSIC_OFF then
		chooseButton:addChild(CreateCommonSprite("pic_hook.png", cc.p(33,33)), 0, 1)
	end
	
	
	local function onChangeMusicSure()
		M.setMusicTag(tagArr[1])
		M.setEffectTag(tagArr[2])
	end
	
	CreateSmallPopupWithCancel("setup", popupContet, onChangeMusicSure)
	--
end

function onSureLogout()
    cclog("on sure logout")

	--local layer = cc.Layer:create()
	--layer:setVisible(false)
	--local popup = CommonCreatePopup(layer)
	
	if SDK_PLATFORM == "SDK_XY_IOS" then
		DevicePlatform:getInstance():logout()
	else
		DevicePlatform:getInstance():logout()
		gameEntrance()
	end
	local function delayLogout()

	end

	--UI_LAYER:runAction(cc.Sequence:create(cc.DelayTime:create(0.1),cc.CallFunc:create(delayLogout)))

	--[[
	DevicePlatform:getInstance():logout()
	gameEntrance()
	]]
end

function onLogoutBtnClick()
	cclog("onLogoutBtnClick")
	CreateSmallPopupWithCancel(nil, CreateCommonLabel(MultiLan("playerinfo_desc15"), nil, FontSize3), onSureLogout)
end

function onClosePlayerInfoBtnClick()
	cclog("onClosePlayerInfoBtnClick")
	PlayerInfoLayer:PlayerInfoLayerExit()
end

PlayerInfoLayer["onChangeSignatureBtnClick"] = onChangeSignatureBtnClick
PlayerInfoLayer["onChangePlayerTitleBtnClick"] = onChangePlayerTitleBtnClick
PlayerInfoLayer["onVipDetailBtnClick"] = onVipDetailBtnClick
PlayerInfoLayer["onVoiceControlBtnClick"] = onVoiceControlBtnClick
PlayerInfoLayer["onLogoutBtnClick"] = onLogoutBtnClick
PlayerInfoLayer["onClosePlayerInfoBtnClick"] = onClosePlayerInfoBtnClick