SkillLayer = class("SkillLayer")
SkillLayer.__index = SkillLayer

SkillLayer.isCreated = false
SkillLayer.topNode = nil

ccb["SkillLayer"] = SkillLayer
SkillLayerOwner = SkillLayerOwner or {}
ccb["SkillLayerOwner"] = SkillLayerOwner

local skillShowType = 1
local skillScrollLayer = nil
local skillTableArr = {}

function SkillLayer:SkillLayerEnter()
	if self.isCreated then
		updateSkillLayer()
		self.topNode:setVisible(true)
	else
		self.isCreated = true
		
		local proxy = cc.CCBProxy:create()
		self.topNode = CCBReaderLoad("ccb/SkillLayer.ccbi",proxy,SkillLayerOwner)
		CommonSkillLayer:addChild(self.topNode)
		
		--初始化
		cc.SpriteFrameCache:getInstance():addSpriteFrames("ccb/ccbResources/SkillIcon.plist")
		skillScrollLayer = SkillLayerOwner["mSkillScrollLayer"]
		
		SkillLayerOwner["mSkillBattleSkillBtn"]:setTitleForState(MultiLan("skill_desc1"), cc.CONTROL_STATE_NORMAL)
		SkillLayerOwner["mSkillArenaSkillBtn"]:setTitleForState(MultiLan("skill_desc2"), cc.CONTROL_STATE_NORMAL)
		SkillLayerOwner["mSkillChangeBtn"]:setTitleForState(MultiLan("skill_desc3"), cc.CONTROL_STATE_NORMAL)
		SkillLayerOwner["mSkillLevelupBtn"]:setTitleForState(MultiLan("skill_desc9"), cc.CONTROL_STATE_NORMAL)
		SkillLayerOwner["mSkillMasterBtn"]:setTitleForState(MultiLan("skill_desc13"), cc.CONTROL_STATE_NORMAL)
		
		table.insert(skillTableArr, UserSelfInfo.pve_skill)
		table.insert(skillTableArr, UserSelfInfo.pvp_skill)
		updateSkillLayer()
	end
	
	GameGuide:GuideEnter(GUIDE_TYPE_SKILL)
	
	--特殊处理
	if GameGuide:checkGuide(GUIDE_TYPE_SKILLUP) and SkillLayerOwner["mSkillLevelupBtn"]:getChildByTag(GUIDE_EFFECT_TAG) == nil then
		GameGuide.noteButton[GUIDE_TYPE_SKILLUP] = SkillLayerOwner["mSkillLevelupBtn"]
		AddNewNoteEffect(GameGuide.noteButton[GUIDE_TYPE_SKILLUP],Pos(cc.size(158,67),0.95,0.8))
	end
	
	if GameGuide:checkGuide(GUIDE_TYPE_SKILLMASTER) and SkillLayerOwner["mSkillMasterBtn"]:getChildByTag(GUIDE_EFFECT_TAG) == nil then
		GameGuide.noteButton[GUIDE_TYPE_SKILLMASTER] = SkillLayerOwner["mSkillMasterBtn"]
		AddNewNoteEffect(GameGuide.noteButton[GUIDE_TYPE_SKILLMASTER],Pos(cc.size(158,67),0.95,0.8))
	end
end

function SkillLayer:SkillLayerExit()
	self.topNode:setVisible(false)
end

local function onSkillZhuanjingBtnClick()
	cclog("onSkillZhuanjingBtnClick")
	
	local skillScroll = cc.ScrollView:create()
	local skillScrollParent = SkillLayerOwner["mSkillScrollLayer"]
	skillScrollParent:addChild(skillScroll)
	skillScroll:setViewSize(cc.size(skillScrollParent:getContentSize().width, skillScrollParent:getContentSize().height))
	skillScroll:setPosition(cc.p(0,0))
	skillScroll:ignoreAnchorPointForPosition(true)
	skillScroll:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
	skillScroll:setClippingToBounds(true)
	skillScroll:setBounceable(true)
	skillScroll:setDelegate()
	skillScroll:registerScriptHandler(onSkillMoreSkillBtnClick, cc.SCROLLVIEW_SCRIPT_SCROLL)
	
	local scrollInsideLayer = cc.LayerGradient:create(cc.c4b(255, 255, 0, 255), cc.c4b(255, 0, 255, 255))
	scrollInsideLayer:ignoreAnchorPointForPosition(true)
	scrollInsideLayer:setContentSize(skillScrollParent:getContentSize().width, skillScrollParent:getContentSize().height * 3)
	skillScroll:setContainer(scrollInsideLayer)
end

	
--保存回调
function skillChangeCallback(jsonDataTable)
	if jsonDataTable.ret ~= 0 then
		cclog("saveSkillCallback failed %d", jsonDataTable.ret)
		return 
	end
	
	local skillTable = skillTableArr[jsonDataTable.data.t]
	for i=1,table.maxn(skillTable) do
		table.remove(skillTable, 1)
	end
	for i=1,table.maxn(jsonDataTable.data.s) do
		table.insert(skillTable, jsonDataTable.data.s[i])
	end
	updateSkillLayer()
end

function GetSkillCountByLevel(userlevel)
	for i = 1,table.maxn(SKILL_COUNT_LIMIT_LEVEL) do
		if userlevel < SKILL_COUNT_LIMIT_LEVEL[i] then
			return (i - 1)
		end
	end
	
	return table.maxn(SKILL_COUNT_LIMIT_LEVEL)
end



--更换技能
function onSkillMoreSkillBtnClick()
	cclog("onSkillMoreSkillBtnClick")
	local skillTable = skillTableArr[skillShowType]
	local userLevel = UserSelfInfo.level
	local skillCountLimit = GetSkillCountByLevel(userLevel)
	local userRole  = UserSelfInfo.role
	local skillData = GameData:getGameDataTable().skill
	--内容
	local layer = cc.Layer:create()
	local count = 0
	for i=1,table.maxn(skillData) do if skillData[i].role == userRole then count = count + 1 end end
	local y = count * 140 - 80
	for i=1, table.maxn(skillData) do
		if skillData[i].role == userRole then
			local backArr = {"board_overmap.png", "board_challengemap.png"}
			local back = CreateCommonSprite(backArr[skillShowType], cc.p(300, y))
			back:setTag(skillData[i].id)
			layer:addChild(back)
			
			back:addChild(CreateCommonSprite("skill_"..skillData[i].id..".png", cc.p(60, 64)))
			back:addChild(CreateCommonLabel("Lv."..GetSkillLevel(skillData[i].id), cc.p(60, 15), FontSize4))
			back:addChild(CreateCommonSprite("board_skill01.png", cc.p(291, 96)))
			back:addChild(CreateCommonSprite("board_skill02.png", cc.p(291, 41)))
			local name = CreateCommonLabel(GetSkillName(skillData[i]), cc.p(118, 96), FontSize2)
			name:setAnchorPoint(cc.p(0,0.5))
			back:addChild(name)
			if skillData[i].level <= userLevel then
				name = CreateCommonLabel(MultiLan("skill_desc4")..skillData[i].mp, cc.p(462, 96), FontSize2, COLOR_CYAN)
			else
				name = CreateCommonLabel(string.format(MultiLan("skill_desc5"),tostring(skillData[i].level)), cc.p(462, 96), FontSize2, COLOR_RED)
			end
			name:setAnchorPoint(cc.p(1,0.5))
			back:addChild(name)
			local desc = CreateCommonLabel(GetSkillDesc(skillData[i]), cc.p(291, 41), 14, COLOR_CYAN,nil,cc.size(340,55))
			back:addChild(desc)
			--按钮
			local function onSkillStateChange(button)
				local node = tolua.cast(button, "cc.Node")
				local tag = node:getTag()
				if node:getParent():getChildByTag(2):isVisible() then
					return 
				end
				
				node:getParent():getChildByTag(1):setVisible(not node:getParent():getChildByTag(1):isVisible()) 
				--重置其他状态
				local pChildrenArray = layer:getChildren()
				local len = table.getn(pChildrenArray)
				local state = false
				local child = nil
				local c = 0
				for j=0, len-1, 1 do
					child = pChildrenArray[j + 1]
					if child:getChildByTag(1)~=nil and child:getChildByTag(1):isVisible() then
						c = c + 1
					end
				end

				if c >= skillCountLimit then
					state = true
				end

				for j=0, len-1, 1 do
					child = pChildrenArray[j + 1]
					if child:getChildByTag(1)~= nil and  not child:getChildByTag(1):isVisible() then
						child:getChildByTag(2):setVisible(state)
					end
				end
			end
			
			if skillData[i].level <= userLevel then
				local chooseBtn = CreateCommonButton("board_skill03.png", cc.p(520, 64), cc.size(66, 66), onSkillStateChange)
				chooseBtn:setSwallowTouch(false)
				back:addChild(chooseBtn)
				local choose = CreateCommonSprite("pic_hook.png", cc.p(520, 64))
				back:addChild(choose, 0, 1)
				choose:setVisible(false)
				local disable = CreateCommonSprite("pic_disable.png", cc.p(520, 64))
				back:addChild(disable, 0, 2)
				disable:setVisible(false)
				local bFind = false
				for j=1, table.maxn(skillTable) do
					print(j, skillTable[j], skillData[j].id)
					if skillTable[j] == skillData[i].id then
						choose:setVisible(true)
						bFind = true
						break
					end
				end
				
				if bFind == false and table.maxn(skillTable) == skillCountLimit then
					disable:setVisible(true)
				end
			else
				back:addChild(CreateCommonSprite("pic_locked.png", cc.p(55, 80)))
			end
			
			y = y - 140
		end
	end

	local popupContent = CreateLayer(POPUP_SIZE_MAX, 1, Pos(POPUP_SIZE_MAX))
	local scrollLayer  = CreateLayer(cc.size(600,650), 1, Pos(POPUP_SIZE_MAX,0.5,0.5))--,nil,nil,cc.c4b(0,255,0,255))
	scrollLayer:setScale(0.98)
	popupContent:addChild(scrollLayer)
	layer:setContentSize(cc.size(600, math.max(650, 140*count-10)))
	CreateScrollViewByFather(scrollLayer, layer, cc.p(0, 650-(140*count-10)), kScrollViewDirectionVertical)
	
	--说明
	local ruleBack = CreateCommonSprite("board_skill01.png", Pos(POPUP_SIZE_MAX,0.5,0.91))
	ruleBack:setScaleX(1.6)
	popupContent:addChild(ruleBack)
	popupContent:addChild(CreateCommonLabel(string.format(MultiLan("skill_desc6"), UserSelfInfo.level, math.min(4,math.floor((UserSelfInfo.level+5)/10))),Pos(POPUP_SIZE_MAX,0.5,0.91), FontSize3))
	
	local popupRoot = CommonCreatePopupMax("skillchange", popupContent)
	--按钮
	local function cancelFunc() 
		removeSelf(popupRoot) 
	end
	popupContent:addChild(CreateCommonButton("button_red.png",Pos(POPUP_SIZE_MAX,0.3,0.06), cc.size(158,67), cancelFunc, {str=MultiLan("button_cancel"),size=FontSize3}))
	
	local function saveFunc() 
		--拼字符串
		local sStr = ""
		local pChildrenArray = layer:getChildren()
		local len = table.getn(pChildrenArray)
		local count = 0
		for j=0, len-1, 1 do
			child = pChildrenArray[j + 1]
			if child:getChildByTag(1) ~= nil and child:getChildByTag(1):isVisible() then
				count = count + 1
				if count ~= 1 then
					sStr = sStr..","
				end
				sStr = sStr..child:getTag() 
			end
		end
		print("sStr",sStr)
		HttpSend("hero/skill", {"t=" .. skillShowType, "s=" .. sStr}, skillChangeCallback)
		
		removeSelf(popupRoot)
	end
	popupContent:addChild(CreateCommonButton("button_green.png", Pos(POPUP_SIZE_MAX,0.7,0.06), cc.size(158,67), saveFunc, {str=MultiLan("button_save"),size=FontSize3}))
end

function GetSkillName(skillData)
	local searchTable = GameData:getGameDataTable().prop
	for i=1,table.maxn(searchTable) do
		if searchTable[i].attr_value == skillData.id and searchTable[i].level == GetSkillMaster(skillData.id)  then
			return MultiLan(searchTable[i].name)
		end
	end
	
	return MultiLan(skillData.name)
end

function GetSkillLevel(id)
	local level = 1
	local dynamicSkillData = UserInfo:getUserInfo().data.skill
	for i=1, table.maxn(dynamicSkillData) do
		if dynamicSkillData[i].id == id then
			level = dynamicSkillData[i].level 
		end
	end
	
	return level
end

function GetSkillMaster(id)
	local master = 0
	local dynamicSkillData = UserInfo:getUserInfo().data.skill
	for i=1, table.maxn(dynamicSkillData) do
		if dynamicSkillData[i].id == id and dynamicSkillData[i].master ~= nil then
			master = dynamicSkillData[i].master 
		end
	end
	
	return master
end

function GetSkillDesc(staticInfo, level)
	local desc = ""
	local dynamicLevel = level
	if level == nil then
		dynamicLevel = GetSkillLevel(staticInfo.id)
	end
	
	
	local master = GetSkillMaster(staticInfo.id)
	local masterTable = GameData:getGameDataTable().skill_master_value
	local masterValue = 0
	for i=1,table.maxn(masterTable)  do
		if masterTable[i].master == master and  masterTable[i].id == staticInfo.id then
			masterValue = masterTable[i].value
			break
		end
	end
	print("GetSkillDesc", staticInfo.id, master, masterValue)
	if staticInfo.up_value > 0 then
		print(staticInfo.desc)
		desc = string.format(MultiLan(staticInfo.desc), staticInfo.effect_value + (dynamicLevel-1)*staticInfo.up_value + masterValue)
	elseif staticInfo.up_buff > 0 then
		desc = string.format(MultiLan(staticInfo.desc), staticInfo.value_1 + (dynamicLevel-1)*staticInfo.up_buff + masterValue)
	else
		desc = MultiLan(staticInfo.desc)
	end
	
	return desc
end 

function onSkillMasterClick()
	cclog("onSkillMasterClick")
	if UserSelfInfo.level < 50 then
		CommonNote(MultiLan("skill_desc14"))
		return
	end
	
	--数据
	local button1,button2,button3 = nil
	local getBookLock = false
	local BookLevel = 1
	local BookMakeLevel = 2
	
	--弹窗内容
	local popupContent = CreateLayer(POPUP_SIZE_MAX, 1, Pos(POPUP_SIZE_MAX))
	
	local function skillMasterHelp()
		HelpPopup("skillmaster")
	end
	local popupRoot = CommonCreatePopupMax("goumaimj", popupContent, true, skillMasterHelp)
	popupContent:addChild(CreateCommonSprite("pic_bgchoumj.png",Pos(POPUP_SIZE_MAX,0.5,0.48)))
	local showSize = cc.size(560,550)
	local showLayer = CreateLayer(showSize, 1, Pos(POPUP_SIZE_MAX,0.5,0.48))
	popupContent:addChild(showLayer)
	
	local noteLayer = CreateLayer(showSize, 1, Pos(POPUP_SIZE_MAX,0.5,0.5))
	popupContent:addChild(noteLayer)
	
	--复用的提示效果
	local function noteFunc(title ,spriteName, itemName)
		noteLayer:removeAllChildren()
		local spriteBack = CreateCommonSprite("board_ewaihuode.png", Pos(showSize))
		noteLayer:addChild(spriteBack)
		if title ~= nil then
			spriteBack:addChild(CreateCommonLabel(title, Pos(spriteBack:getContentSize(),0.5,0.8), FontSize3))
		end
		if spriteName ~= nil then
			spriteBack:addChild(CreateCommonSprite(spriteName, Pos(spriteBack:getContentSize(),0.5,0.55)))
		end
		if itemName ~= nil then
			spriteBack:addChild(CreateCommonLabel(itemName, Pos(spriteBack:getContentSize(),0.5,0.3), FontSize2))
		end
		
		spriteBack:setScale(1.2)
		spriteBack:runAction(cc.Sequence:create(cc.ScaleTo:create(0.15, 1), cc.DelayTime:create(2), cc.CallFunc:create(removeSelf)))
	end
	
	--秘籍购买
	local function getBookFunc() 
		button1:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_yellow.png"), cc.CONTROL_STATE_NORMAL)
		button1:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_yellow.png"), cc.CONTROL_STATE_HIGH_LIGHTED)
		button2:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_blue.png"), cc.CONTROL_STATE_NORMAL)
		button2:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_blue.png"), cc.CONTROL_STATE_HIGH_LIGHTED)
		button3:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_blue.png"), cc.CONTROL_STATE_NORMAL)
		button3:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_blue.png"), cc.CONTROL_STATE_HIGH_LIGHTED)
		showLayer:removeAllChildren(true)
		local button1,button2 = nil,nil
		local price1,price2 = 280,2500
		local rate = 0.6
		local priceLabel1, priceLabel2 = nil,nil
		if UserSelfInfo.free_book == 0 then
			price1 = 0
		end
		if UserSelfInfo.skill_book == 0 then
			price2 = 2500*rate
		end
		
		local staticSize  = cc.size(600,400)
		local staticLayer = CreateLayer(staticSize, 1, Pos(cc.size(560,550),0.5,0.65))--,nil,nil,cc.c4b(128,128,128,128))
		showLayer:addChild(staticLayer)
		local picTable = {{"prop_121005.png","prop_121004.png","prop_121003.png","prop_121002.png","prop_121001.png"},
					      {"prop_122005.png","prop_122004.png","prop_122003.png","prop_122002.png","prop_122001.png"},
						  {"prop_123005.png","prop_123004.png","prop_123003.png","prop_123002.png","prop_123001.png"}}
		staticLayer:addChild(CreateCommonSprite(picTable[UserSelfInfo.role][1], Pos(staticSize, 0.5, 0.7), 1.4))
		staticLayer:addChild(CreateCommonSprite(picTable[UserSelfInfo.role][2], Pos(staticSize, 0.2, 0.4)))
		staticLayer:addChild(CreateCommonSprite(picTable[UserSelfInfo.role][3], Pos(staticSize, 0.4, 0.4)))
		staticLayer:addChild(CreateCommonSprite(picTable[UserSelfInfo.role][4], Pos(staticSize, 0.6, 0.4)))
		staticLayer:addChild(CreateCommonSprite(picTable[UserSelfInfo.role][5], Pos(staticSize, 0.8, 0.4)))
		
		--特效
		local bookLayer = CreateLayer(staticSize, 1, Pos(cc.size(560,550),0.5,0.7))--,nil,nil,cc.c4b(128,128,128,128))
		bookLayer:setVisible(false)
		showLayer:addChild(bookLayer)
		local title = CreateCommonLabel("", Pos(bookLayer:getContentSize(),0.5,0.9),FontSize3)
		bookLayer:addChild(title)
		bookLayer:addChild(CreateCommonSprite("board_equip.png", Pos(bookLayer:getContentSize(),0.5,0.5), 0.83, 0.5))
		local effectLayer = CreateLayer(cc.size(540,280), 1, Pos(staticSize,0.5,0.5))--,nil,nil,cc.c4b(200,15,200,128))
		bookLayer:addChild(effectLayer)
		bookLayer:addChild(CreateCommonLabel(MultiLan("skill_desc28"), Pos(bookLayer:getContentSize(),0.5,0.1),FontSize2))
		
		local function showBookEffect(count, bookInfo)
			print("showBookEffect")
			staticLayer:setVisible(false)
			bookLayer:setVisible(true)
			effectLayer:stopAllActions()
			effectLayer:removeAllChildren(true)
			
			local layerTable = {}
			for i=1, count do
				local sprite = CreateCommonSprite("prop_"..bookInfo[i].prop_id..".png")
				sprite:setVisible(false)
				sprite:addChild(CreateCommonLabel(MultiLan(GameData:getPropDataTable(bookInfo[i].prop_id).name), Pos(sprite:getContentSize(),0.5,0), FontSize1))
				table.insert(layerTable, sprite)
			end
			
			if count == 1 then
				CreateMxN(effectLayer,1, 1, layerTable, nil, effectLayer:getContentSize())
			else
				CreateMxN(effectLayer,5, 2, layerTable, nil, effectLayer:getContentSize())
				print("pp", layerTable[1]:getPositionX(), layerTable[1]:getPositionY(), effectLayer:getContentSize().width, effectLayer:getContentSize().height)
			end
			print(1)
			local t =0.15
			for i=1, count do
				if count ~= i then
					layerTable[i]:runAction(cc.Sequence:create(cc.DelayTime:create((i-1)*t), cc.CallFunc:create(GaiEffect)))
				else
					local function resetState(node)
						getBookLock = false
						GaiEffect(node)
					end

					layerTable[i]:runAction(cc.Sequence:create(cc.DelayTime:create((i-1)*t), cc.CallFunc:create(resetState)))
				end
			end
			print(2)
			if count == 10 and bookInfo[11] ~= nil then
				local staticData = GameData:getPropDataTable(bookInfo[11].prop_id)
					print("staticData", staticData.id)
				if staticData ~= nil then
					local function delayNote()
						noteFunc(MultiLan("skill_desc35"), "prop_"..bookInfo[11].prop_id..".png", MultiLan(staticData.name))
					end
					
					effectLayer:runAction(cc.Sequence:create(cc.DelayTime:create(10*t), cc.CallFunc:create(delayNote)))
				end
			end
			print("333")
		end
		
		local function onBookGetClick(node)
			if getBookLock then
				return
			end
			local tag = node:getTag()
			local desc = ""
			
			--秘籍抽取回调
			function getBookCallback(jsonDataTable)
				print("getBookCallback", jsonDataTable.ret)
				if jsonDataTable.ret ~= 0 then
					cclog("getBookCallback failed %d", jsonDataTable.ret)
					return 
				end
				getBookLock = true
				--消耗
				UserSelfInfo[jsonDataTable.data.use_type] = UserSelfInfo[jsonDataTable.data.use_type] - jsonDataTable.data.use_num
				
				--获得
				UserInfo:addProp(jsonDataTable.data.item)
				
				--数据
				UserSelfInfo.free_book = UserSelfInfo.free_book + 1
				UserSelfInfo.skill_book = UserSelfInfo.skill_book + 1
				
				--界面变化
				GameGuide:setButtonNote(button1, false)
				if tag == 1 then
					price1 = 280
					priceLabel1:setString(price1)
					button1:setTitleForState(MultiLan("skill_desc19"), cc.CONTROL_STATE_NORMAL)
				elseif tag == 2 then
					price2 = 2500
					priceLabel2:setString(price2)
				end
				
				--特效
				if tag == 1 then
					showBookEffect(1, jsonDataTable.data.display)
				elseif tag == 2 then
					showBookEffect(10, jsonDataTable.data.display)
				end
			end
			
			local function sendGetBookRequest()
				if UserSelfInfo.cash < cost then
					CommonCashNeed()
				else
					HttpSend("skill/lottery", {"type="..tag}, getBookCallback)
				end
			end
			
			if tag == 1 then
				cost = price1
				if UserSelfInfo.free_book == 0 then
					--desc = string.format(MultiLan("skill_desc23"))
					sendGetBookRequest()
					return
				else
					desc = string.format(MultiLan("skill_desc24"), cost)
				end	
			elseif tag == 2 then
				cost = price2
				if UserSelfInfo.skill_book == 0 then
					desc = string.format(MultiLan("skill_desc24"), cost)..MultiLan("skill_desc25")
				else
					desc = string.format(MultiLan("skill_desc24"), cost)
				end	
			end	

			CreateSmallPopupWithCancel("prompt",CreateCommonLabel(desc,nil,FontSize3,nil,nil,cc.size(455, 120)), sendGetBookRequest)
		end
		
		local leftLayer = CreateCommonSprite("board_choumj.png", Pos(showSize, 0.25,0.18))
		showLayer:addChild(leftLayer)
		leftLayer:addChild(CreateCommonLabel(MultiLan("skill_desc18"), Pos(leftLayer:getContentSize(),0.5,0.8), FontSize2))
		leftLayer:addChild(CreateCommonSprite("icon_gold.png", Pos(leftLayer:getContentSize(),0.33,0.5)))
		priceLabel1 = CreateCommonLabel(price1, Pos(leftLayer:getContentSize(),0.5,0.5),FontSize2,nil,cc.p(0,0.5))
		leftLayer:addChild(priceLabel1)
		if UserSelfInfo.free_book == 0 then
			button1 = CreateCommonButton("MainButton12.png", Pos(leftLayer:getContentSize(),0.5,0.25),cc.size(137, 53), onBookGetClick,{str=MultiLan("skill_desc20"),size=FontSize2})
			GameGuide:setButtonNote(button1, true, cc.p(120,50))
		else
			button1 = CreateCommonButton("MainButton12.png", Pos(leftLayer:getContentSize(),0.5,0.25),cc.size(137, 53), onBookGetClick,{str=MultiLan("skill_desc19"),size=FontSize2})
		end
		leftLayer:addChild(button1, 0, 1)
		
		local rightLayer = CreateCommonSprite("board_choumj.png", Pos(showSize, 0.75,0.18))
		showLayer:addChild(rightLayer)
		rightLayer:addChild(CreateCommonLabel(MultiLan("skill_desc21"), Pos(rightLayer:getContentSize(),0.5,0.8), FontSize2))
		rightLayer:addChild(CreateCommonSprite("icon_gold.png", Pos(rightLayer:getContentSize(),0.33,0.5)))
		priceLabel2 = CreateCommonLabel(price2, Pos(rightLayer:getContentSize(),0.5,0.5),FontSize2,nil,cc.p(0,0.5))
		rightLayer:addChild(priceLabel2)
		button2 = CreateCommonButton("MainButton12.png", Pos(leftLayer:getContentSize(),0.5,0.25),cc.size(137, 53), onBookGetClick, {str=MultiLan("skill_desc22"),size=FontSize2})
		rightLayer:addChild(button2,0,2)
	end
	button1 = CreateCommonButton("button_blue.png",Pos(POPUP_SIZE_MAX,0.23,0.87), cc.size(158,67), getBookFunc, {str=MultiLan("skill_desc15"),size=FontSize3})
	popupContent:addChild(button1)

	--秘籍融合
	local function mergeBookFunc() 
		print("mergeBookFunc")
		button1:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_blue.png"), cc.CONTROL_STATE_NORMAL)
		button1:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_blue.png"), cc.CONTROL_STATE_HIGH_LIGHTED)
		button2:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_yellow.png"), cc.CONTROL_STATE_NORMAL)
		button2:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_yellow.png"), cc.CONTROL_STATE_HIGH_LIGHTED)
		button3:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_blue.png"), cc.CONTROL_STATE_NORMAL)
		button3:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_blue.png"), cc.CONTROL_STATE_HIGH_LIGHTED)
		showLayer:removeAllChildren(true)
		local buttonArr = {}
		local bookButtonArr = {}
		local bookStaticArr = {}
		

		local position = {cc.p(110,355), cc.p(306,355), cc.p(48,166), cc.p(368, 166), cc.p(210,50)}
		local back = nil
		local mergeDesc = nil
		
		local function checkBookMerge(bookInfo)
			local bFind = false
			local skillTable = UserInfo:getUserInfo().data.skill
			for i=1, table.maxn(skillTable) do
				if skillTable[i].id == bookInfo.attr_value then
					bFind = true
					if bookInfo.role == UserSelfInfo.role and skillTable[i].master < skillTable[i].level then	
						return false
					end
				end
			end
			
			if bFind == false and bookInfo.role == UserSelfInfo.role then
				return false
			end
			
			return true
		end
		
		local function onMergeClick()
			if table.maxn(bookButtonArr) == 0 then
				CommonNote(MultiLan("skill_desc32"))
				return
			end
		
			local bCheck = false
			for i=1, table.maxn(bookButtonArr) do
				if bookButtonArr[i] ~= nil and false == checkBookMerge(bookStaticArr[i]) then
					bCheck = true
					break
				end
			end
			
			local function bookMergeCallback(jsonDataTable)
				if jsonDataTable.ret == 0 then
					back:stopAllActions()
					back:setRotation(0)
					
					--数据
					for i=1, table.maxn(jsonDataTable.data.use_prop) do
						UserInfo:removepropByPropId(jsonDataTable.data.use_prop[i].prop_id,jsonDataTable.data.use_prop[i].num)
					end
					UserInfo:addProp(jsonDataTable.data.item)
					
					if jsonDataTable.data.success == 1 then
						noteFunc(MultiLan("skill_desc36"), "prop_"..jsonDataTable.data.item[1].prop_id..".png", MultiLan(GameData:getPropDataTable(jsonDataTable.data.item[1].prop_id).name))
					else
						noteFunc(MultiLan("skill_desc37"), "prop_"..jsonDataTable.data.item[1].prop_id..".png", MultiLan("skill_desc38")..jsonDataTable.data.item[1].num)
					end
					
					mergeBookFunc()
				end
			end
			
			local function sendBookMerge()
				local desc = "ids="
				local bFirst = true
				print("sendBookMerge", table.maxn(bookButtonArr))
				for i=1, table.maxn(bookButtonArr) do
					if bookButtonArr[i] ~= nil then
						if bFirst then
							desc = desc..bookButtonArr[i]:getParent():getTag()
							bFirst = false
						else	
							desc = desc..","..bookButtonArr[i]:getParent():getTag()
						end
					end
				end
				
				local function trueSendMerge()
					HttpSend("skill/fusion", {desc}, bookMergeCallback)
				end
				
				back:runAction(cc.Sequence:create(cc.RotateBy:create(0.1, 180),
												  cc.RotateBy:create(0.2,540),
												  cc.RotateBy:create(0.2,720),
												  cc.CallFunc:create(trueSendMerge),
												  cc.RotateBy:create(2,7200)))
				
			end
			
			if bCheck then
				CreateSmallPopupWithCancel("prompt",CreateCommonLabel(MultiLan("skill_desc31"),nil,FontSize3,nil,nil,cc.size(455, 120)), sendBookMerge)
			else
				sendBookMerge()
			end
			
		end
		
		local function setMergeDesc(m)
			local count = 0
			for i=1, table.maxn(bookButtonArr) do
				if bookButtonArr[i] ~= nil then
					count = count + 1
				end
			end
		
			if m == 5 then
				mergeDesc:setString(MultiLan("skill_desc34")..(200*count))
			else
				mergeDesc:setString(MultiLan("skill_desc33")..(20*count).."%")
			end
		end
		
		local function removeBook(node)
			bookButtonArr[node:getTag()] = nil
			bookStaticArr[node:getTag()] = nil
			
			node:getParent():removeFromParent()
			setMergeDesc(BookLevel)
		end
		

		
		local function changeBookLevel(m)
			BookLevel = m
			back:stopAllActions()
			back:removeAllChildren(true)
			back:setRotation(0)
			local bookData = UserInfo:getBookList(m)
			bookButtonArr = {}
			for i=1, 5 do
				if bookData[i] ~= nil then
					local bookSprite = CreateCommonSprite("prop_"..bookData[i].prop_id..".png", position[i])
					local button = CreateCommonButton("pic_suiyiaaa.png", Pos(bookSprite:getContentSize()), bookSprite:getContentSize(), removeBook)
					button:setTag(i)
					bookSprite:addChild(button)
					bookSprite:addChild(CreateCommonLabel(MultiLan(bookData[i].sData.name), Pos(bookSprite:getContentSize(),0.5,0), FontSize1))
					bookButtonArr[i] = button
					bookStaticArr[i] = bookData[i].sData
					back:addChild(bookSprite, 0, bookData[i].prop_id)
				end
			end
			
			for i=1, 5 do
				if i == m then
					buttonArr[i]:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_battlecount.png"), cc.CONTROL_STATE_NORMAL)
					buttonArr[i]:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_battlecount.png"), cc.CONTROL_STATE_HIGH_LIGHTED)
				else
					buttonArr[i]:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_chuangguan.png"), cc.CONTROL_STATE_NORMAL)
					buttonArr[i]:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_chuangguan.png"), cc.CONTROL_STATE_HIGH_LIGHTED)				
				end
			end
			
			setMergeDesc(BookLevel)
		end
		
		local function onBookClick(node)
			print("onBookClick", node:getTag())
			changeBookLevel(node:getTag())
		end
		
		for i=1, 5 do
			local button = CreateCommonButton("button_chuangguan.png",nil,cc.size(144, 50), onBookClick, {str=string.format(MultiLan("skill_desc29"), i), size = FontSize1})
			button:setScale(0.73)
			button:setTag(i)
			table.insert(buttonArr, button)
		end
		CreateMxN(showLayer,5, 1, buttonArr,nil,cc.size(560,100),cc.p(0,470))
		
		back = CreateCommonSprite("pic_ronghewp.png", Pos(showLayer:getContentSize()))
		showLayer:addChild(back)
		showLayer:addChild(CreateCommonSprite("board_skill01.png",  Pos(showLayer:getContentSize(), 0.5, 0.29), 0.5,1))
		mergeDesc = CreateCommonLabel("", Pos(showLayer:getContentSize(),0.5,0.29),FontSize1)
		showLayer:addChild(mergeDesc)
		showLayer:addChild(CreateCommonButton("button_ronghe.png", Pos(showLayer:getContentSize()), cc.size(107,107), onMergeClick, {str=MultiLan("skill_desc30"),size=FontSize3}))
	
		changeBookLevel(BookLevel)
	end
	button2 = CreateCommonButton("button_blue.png",Pos(POPUP_SIZE_MAX,0.5,0.87), cc.size(158,67), mergeBookFunc, {str=MultiLan("skill_desc16"),size=FontSize3})
	popupContent:addChild(button2)

	--秘籍合成
	local function exchangeBookFunc() 
		button1:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_blue.png"), cc.CONTROL_STATE_NORMAL)
		button1:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_blue.png"), cc.CONTROL_STATE_HIGH_LIGHTED)
		button2:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_blue.png"), cc.CONTROL_STATE_NORMAL)
		button2:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_blue.png"), cc.CONTROL_STATE_HIGH_LIGHTED)
		button3:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_yellow.png"), cc.CONTROL_STATE_NORMAL)
		button3:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_yellow.png"), cc.CONTROL_STATE_HIGH_LIGHTED)
		showLayer:removeAllChildren(true)
		
		local makeButtonArr = {}
		
		local scrollLayer  = nil
		
		local function setBookDesc()
			local count = 0
			local dynamicData = UserInfo:getPropByPropid(110005)
			if dynamicData ~= nil then
				count = dynamicData.amount
			end
			bookDesc:setString(MultiLan("skill_desc39")..count)
		end
		
		--获取秘籍合成消耗数量
		local function getBookMakeCost(propid)
			print("getBookMakeCost", propid)
			return FindFirstByKey(GameData:getGameDataTable().skill_master,"prop_id",propid).compose_num
		end
		
		local function changeBookLevel(m)
			print("changeBookLevel", m)
			BookMakeLevel = m
			
			for i=2, 5 do
				if i == m then
					makeButtonArr[i-1]:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_battlecount.png"), cc.CONTROL_STATE_NORMAL)
					makeButtonArr[i-1]:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_battlecount.png"), cc.CONTROL_STATE_HIGH_LIGHTED)
				else
					makeButtonArr[i-1]:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_chuangguan.png"), cc.CONTROL_STATE_NORMAL)
					makeButtonArr[i-1]:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("button_chuangguan.png"), cc.CONTROL_STATE_HIGH_LIGHTED)				
				end
			end
			
			
			scrollLayer:removeAllChildren()

			local skillData = GameData:getGameDataTable().prop
			local layer = cc.Layer:create()
			local count = 0
			for i=1,table.maxn(skillData) do 
				if skillData[i].ptype == 16 and skillData[i].role == UserSelfInfo.role and skillData[i].level == BookMakeLevel then 
					count = count + 1 
				end 
			end
			local y = count * 140 - 80
			for i=1, table.maxn(skillData) do
				
				if skillData[i].ptype == 16 and skillData[i].role == UserSelfInfo.role and skillData[i].level == BookMakeLevel then
					--local backArr = {"board_overmap.png", "board_challengemap.png"}
					local back = CreateCommonSprite("board_challengemap.png", cc.p(300, y))
					back:setTag(skillData[i].id)
					layer:addChild(back)
					
					back:addChild(CreateCommonSprite("prop_"..skillData[i].id..".png", cc.p(60, 64)))
					--back:addChild(CreateCommonLabel("Lv."..GetSkillLevel(skillData[i].id), cc.p(60, 15), FontSize4))
					back:addChild(CreateCommonSprite("board_skill01.png", cc.p(291, 96)))
					back:addChild(CreateCommonSprite("board_skill02.png", cc.p(291, 41)))
					local skillName = MultiLan(skillData[i].name)
					local name = CreateCommonLabel(skillName, cc.p(118, 96), FontSize4)
					name:setAnchorPoint(cc.p(0,0.5))
					back:addChild(name)
					print("skillData[i].id", skillData[i].id)
					local costDesc = CreateCommonLabel(string.format(MultiLan("skill_desc41"),tostring(getBookMakeCost(skillData[i].id))), cc.p(462, 96), FontSize2, COLOR_CYAN)
					costDesc:setAnchorPoint(cc.p(1,0.5))
					back:addChild(costDesc)
					local desc = CreateCommonLabel(string.format(MultiLan("skill_desc42"), skillName), cc.p(291, 41), FontSize1, COLOR_CYAN,nil,cc.size(340,55))
					back:addChild(desc)
					--按钮
					local function onSkillMake(button)
						local node = tolua.cast(button, "cc.Node")
						local tag = node:getTag()

						local count = 0
						local dynamicData = UserInfo:getPropByPropid(110005)
						if dynamicData ~= nil then
							count = dynamicData.amount
						end
						if getBookMakeCost(tag) > count then
							CommonNote(MultiLan("skill_desc43"))
							return 
						end
						
						local function bookMakeCallback(jsonDataTable)
							if jsonDataTable.ret == 0 then
								--增加
								UserInfo:addProp(jsonDataTable.data.item)
								UserInfo:addPropNote(jsonDataTable.data.item)
							
								
								--消耗
								for i=1,table.maxn(jsonDataTable.data.use_prop) do
									UserInfo:removepropByPropId(jsonDataTable.data.use_prop[i].prop_id, jsonDataTable.data.use_prop[i].num)
								end
								
								setBookDesc()
							end
						end
				
						HttpSend("skill/exchange", {"id="..tag}, bookMakeCallback)
					end
					

					local makeBtn = CreateCommonButton("button_blue.png", cc.p(520, 64), cc.size(158, 67), onSkillMake, {str=MultiLan("skill_desc40"), size=FontSize3})
					makeBtn:setScale(0.7)
					makeBtn:setSwallowTouch(false)
					back:addChild(makeBtn, 0, skillData[i].id)
					
					y = y - 140
				end
			end

			print("count",count)
			layer:setContentSize(cc.size(600, 140*count-10))
			CreateScrollViewByFather(scrollLayer, layer, cc.p(0, 480-140*count), kScrollViewDirectionVertical)

			
			setBookDesc()
		end
		
		local function onBookMakeClick(node)
			print("onBookClick", node:getTag())
			changeBookLevel(node:getTag())
		end
		
		for i=1, 4 do
			local button = CreateCommonButton("button_chuangguan.png",nil,cc.size(144, 50), onBookMakeClick, {str=string.format(MultiLan("skill_desc29"), i+1), size = FontSize1})
			button:setScale(0.75)
			button:setTag(i+1)
			table.insert(makeButtonArr, button)
		end
		CreateMxN(showLayer,4, 1, makeButtonArr,nil,cc.size(560,100),cc.p(0,470))
		
		showLayer:addChild(CreateCommonSprite("board_skill01.png", cc.p(280,480)))
		bookDesc = CreateCommonLabel("", cc.p(280,480), FontSize1)
		showLayer:addChild(bookDesc)
		scrollLayer = CreateLayer(cc.size(600,480), 1, Pos(showSize,0.5,0.43), nil,nil,cc.c4b(128,128,128,128))
		scrollLayer:setScale(0.95)
		showLayer:addChild(scrollLayer)
		
		changeBookLevel(BookMakeLevel)
	end
	button3 = CreateCommonButton("button_blue.png",Pos(POPUP_SIZE_MAX,0.77,0.87), cc.size(158,67), exchangeBookFunc, {str=MultiLan("skill_desc17"),size=FontSize3})
	popupContent:addChild(button3)

	getBookFunc()
	GameGuide:GuideEnter(GUIDE_TYPE_SKILLMASTER)
end

function onSkillLevelupClick()
	cclog("onSkillLevelupClick")
	if UserSelfInfo.level < 30 then
		CommonNote(MultiLan("skill_desc11"))
		return
	end
	
	local skillTable = UserSelfInfo.skill
	local userLevel = UserSelfInfo.level
	local skillCountLimit = GetSkillCountByLevel(userLevel)
	local userRole  = UserSelfInfo.role
	local skillData = GameData:getGameDataTable().skill
	
	local function onSkillClick(node)
		local skillId = node:getParent():getTag()
	end
	--内容
	local layer = cc.Layer:create()
	local count = 0
	for i=1,table.maxn(skillData) do 
		if skillData[i].role == userRole and skillData[i].level <= userLevel then 
			count = count + 1 
		end 
	end
	
	local function updateLevelupLayer(changeSkill)
		print("updateLevelupLayer")
		local pChildrenArray = layer:getChildren()
		local count = table.getn(pChildrenArray)

		local child = nil
		local bookData = UserInfo:getPropByPropid(PROP_ID_BOOK)
		print("count", count)
		for j=0, count-1, 1 do
			child = pChildrenArray[j + 1]
			local skillId = child:getTag()
			local dynamicLevel = GetSkillLevel(skillId)
			local staticInfo = FindFirstByKey(skillData, "id", skillId)
			print("staticInfo",staticInfo,staticInfo.levelup)
			if staticInfo ~= nil and staticInfo.levelup == 1 then
				if changeSkill == nil or changeSkill == skillId then
					print("j",j,dynamicLevel)
					child:getChildByTag(1):setString("Lv."..dynamicLevel)
					child:getChildByTag(2):setString(GetSkillDesc(staticInfo, dynamicLevel))
					child:getChildByTag(3):setString(GameData:getGameDataTable().skill_upgrade[dynamicLevel].num)
				end
				if bookData == nil or bookData.amount < GameData:getGameDataTable().skill_upgrade[dynamicLevel].num then
					child:getChildByTag(3):setColor(COLOR_RED)
				else
					child:getChildByTag(3):setColor(COLOR_WHITE)
				end
			end 
		end
	end
	
	--升级
	local function onSkillLevelup(node)
		local skillId = node:getParent():getTag()
		--保存回调
		function skillLevelupCallback(jsonDataTable)
			if jsonDataTable.ret ~= 0 then
				cclog("skillLevelupCallback failed %d", jsonDataTable.ret)
				return 
			end
			
			--删除道具
			UserInfo:removepropByPropId(PROP_ID_BOOK,jsonDataTable.data.use_num)
			
			--更新技能等级
			local dynamicSkill = FindFirstByKey(UserInfo:getUserInfo().data.skill, "id", jsonDataTable.data.skill.id) 
			print("dynamicSkill", dynamicSkill)
			if dynamicSkill == nil then
				table.insert(UserInfo:getUserInfo().data.skill, jsonDataTable.data.skill)
			else
				dynamicSkill.level = jsonDataTable.data.skill.level
			end
			
			--飘字
			CommonNote(MultiLan("stoneup_desc3"))

			updateLevelupLayer()
		end
		
		local bookData = UserInfo:getPropByPropid(PROP_ID_BOOK)
		local skillLevel = GetSkillLevel(skillId)
		if bookData == nil or bookData.amount < GameData:getGameDataTable().skill_upgrade[skillLevel].num then
			CommonNote(MultiLan("CD_propIsNotEnough_7"))
		elseif skillLevel >= UserSelfInfo.level then
			CommonNote(MultiLan("skill_desc12"))
		else
			HttpSend("skill/levelup", {"id="..skillId}, skillLevelupCallback)
		end
	end
	
	local y = count * 140 - 80
	for i=1, table.maxn(skillData) do
		if skillData[i].role == userRole and skillData[i].level <= userLevel then
			--local backArr = {, "board_challengemap.png"}
			local dynamicLevel = GetSkillLevel(skillData[i].id)
			local back = CreateCommonSprite("board_overmap.png", cc.p(300, y))
			back:setTag(skillData[i].id)
			layer:addChild(back)
			
			local skillButton = CreateCommonButton("skill_"..skillData[i].id..".png", cc.p(60, 64), cc.size(95, 95), onSkillClick)
			skillButton:setSwallowTouch(false)
			back:addChild(skillButton)
			
			back:addChild(CreateCommonLabel("Lv.1", cc.p(60, 15), FontSize4), 0, 1)
			back:addChild(CreateCommonSprite("board_skill01.png", cc.p(291, 96)))
			back:addChild(CreateCommonSprite("board_skill02.png", cc.p(291, 41)))
			local name = CreateCommonLabel(GetSkillName(skillData[i]), cc.p(118, 96), FontSize2)
			name:setAnchorPoint(cc.p(0,0.5))
			back:addChild(name)
			print("fuck")
			name = CreateCommonLabel(MultiLan("skill_desc4")..skillData[i].mp, cc.p(462, 96), FontSize2, COLOR_CYAN)
			print(1)
			name:setAnchorPoint(cc.p(1,0.5))
			back:addChild(name)
			local desc = CreateCommonLabel("", cc.p(291, 41), FontSize1, COLOR_CYAN,nil,cc.size(340,55))
			back:addChild(desc, 0, 2)
			print(2)
			if skillData[i].levelup == 1 then
				back:addChild(CreateCommonSprite("icon_canjuan.png", cc.p(490, 80)))
				back:addChild(CreateCommonLabel("", cc.p(540, 80), FontSize1),0,3)
				
				local levelupBtn = CreateCommonButton("button_green.png", cc.p(520, 40), cc.size(158, 67), onSkillLevelup, {str=MultiLan("lan_levelup"), size=FontSize4})
				levelupBtn:setSwallowTouch(false)
				levelupBtn:setScale(0.65)
				back:addChild(levelupBtn)
			else
				print(skillData[i].id, GetSkillDesc(skillData[i], 1))
				desc:setString(GetSkillDesc(skillData[i], 1))
				back:addChild(CreateCommonLabel(MultiLan("skill_desc10"), cc.p(520, 64), FontSize1))
			end
			
			y = y - 140
		end
	end
	updateLevelupLayer()
	local popupContent = CreateLayer(POPUP_SIZE_MAX, 1, Pos(POPUP_SIZE_MAX))
	local scrollLayer  = CreateLayer(cc.size(600,690), 1, Pos(POPUP_SIZE_MAX,0.5,0.53))--,nil,nil,cc.c4b(0,255,0,255))
	scrollLayer:setScale(0.98)
	popupContent:addChild(scrollLayer)
	layer:setContentSize(cc.size(600, math.max(690, 140*count-10)))
	CreateScrollViewByFather(scrollLayer, layer, cc.p(0, 690-(140*count-10)), kScrollViewDirectionVertical)

	local function skillLevelupHelp()
		HelpPopup("skilllevelup")
	end
	local popupRoot = CommonCreatePopupMax("jnshuom", popupContent, nil, skillLevelupHelp)
	--按钮
	local function cancelFunc() 
		removeSelf(popupRoot) 
	end
	popupContent:addChild(CreateCommonButton("button_red.png",Pos(POPUP_SIZE_MAX,0.5,0.06), cc.size(158,67), cancelFunc, {str=MultiLan("button_close"),size=FontSize3}))

	GameGuide:GuideEnter(GUIDE_TYPE_SKILLUP)
end

--技能上移
function onSkillUp(node)
	local tag = tolua.cast(node, "cc.Node"):getTag()
	local skillTable = skillTableArr[skillShowType]
	print("onSkillUp",tag, skillShowType)
	if tag < 2 or tag > 5 then
		print("onSkillUp wrong")
		return
	end
	
	--创建临时表
	local tempTable = {}
	print(table.maxn(skillTable))
	for i=1,table.maxn(skillTable) do
		tempTable[i] = skillTable[i]
	end
	local temp = tempTable[tag-1]
	tempTable[tag-1] = tempTable[tag]
	tempTable[tag]   = temp
	
	--拼字符串
	local sStr = ""
	for i=1,table.maxn(tempTable) do
		sStr = sStr..tempTable[i]
		if i ~= table.maxn(tempTable) then
			sStr = sStr..","
		end
	end
	HttpSend("hero/skill", {"t=" .. skillShowType, "s=" .. sStr}, skillChangeCallback)
	--skillUpCallback()
end

--刷新技能界面
function updateSkillLayer()
	local skillTable = skillTableArr[skillShowType]
	local SKILL_COUNT_LIMIT_LEVEL = {5, 15, 25 ,35}
	local titmeArr = {MultiLan("skill_desc1"), MultiLan("skill_desc2")}
	local userLevel = UserSelfInfo.level
	
	--标题
	SkillLayerOwner["mSkillTitle"]:setString(titmeArr[skillShowType])
	
	--内容
	local layer = cc.Layer:create()
	local y = 490
	for i=1, 4 do
		if SKILL_COUNT_LIMIT_LEVEL[i] > userLevel then
			layer:addChild(CreateCommonSprite("board_skilllock.png", cc.p(300, y)))
			layer:addChild(CreateCommonSprite("board_skill02.png", cc.p(300, y)))
			layer:addChild(CreateCommonLabel(string.format(MultiLan("skill_desc7"),tostring(SKILL_COUNT_LIMIT_LEVEL[i])), cc.p(300, y), FontSize4))
			layer:addChild(CreateCommonSprite("pic_locked.png", cc.p(55, y+20)))
		else
			local backArr = {"board_overmap.png", "board_challengemap.png"}
			local backName = backArr[skillShowType]
			if skillShowType == 1 then
				--layer:addChild(CreateCommonSprite(backName, cc.p(300, y)))
			elseif skillShowType == 2 then
				--layer:addChild(CreateCommonSprite(backName, cc.p(300, y)))
			end
			print("updateSkillLayer", i,skillTable[i])
			if skillTable[i] ~= nil then --有服务器数据
				local button = CreateCommonButton(backName, cc.p(300, y), cc.size(582, 128), onSkillMoreSkillBtnClick)
				button:setEnabled(false)
				button:setSwallowTouch(false)
				layer:addChild(button)
				
				button:addChild(CreateCommonSprite("skill_"..skillTable[i]..".png", cc.p(60, 64)))
				button:addChild(CreateCommonLabel("Lv."..GetSkillLevel(skillTable[i]), cc.p(60, 15), FontSize4))
				button:addChild(CreateCommonSprite("board_skill01.png", cc.p(291, 96)))
				button:addChild(CreateCommonSprite("board_skill02.png", cc.p(291, 41)))
				if i== 1 then
					button:addChild(CreateCommonSprite("wordboard_firstgo.png", cc.p(522, 64)))
					-- button:addChild(CreateCommonLabel("firstgo", cc.p(522, 64), FontSize3))
				else
					button:addChild(CreateCommonButton("wordboard_upgo.png", cc.p(522, 64), cc.size(82, 82), onSkillUp), 0, i)
					-- button:addChild(CreateCommonLabel("upgo", cc.p(522, 64), FontSize3))
				end
				print(i,skillTable[i])
				local skillInfo = GameData:getSkill(skillTable[i])
				local name = CreateCommonLabel(GetSkillName(skillInfo), cc.p(118, 96), FontSize2)
				name:setAnchorPoint(cc.p(0,0.5))
				button:addChild(name)
				local name = CreateCommonLabel(MultiLan("skill_desc4")..skillInfo.mp, cc.p(462, 96), FontSize2, COLOR_CYAN)
				name:setAnchorPoint(cc.p(1,0.5))
				button:addChild(name)
				local desc = CreateCommonLabel(GetSkillDesc(skillInfo), cc.p(291, 41), 14, COLOR_CYAN,nil,cc.size(340,55))
				button:addChild(desc)
			else
				local button = CreateCommonButton(backName, cc.p(300, y), cc.size(582, 128), onSkillMoreSkillBtnClick)
				button:setSwallowTouch(false)
				layer:addChild(button)
				
				button:addChild(CreateCommonSprite("board_skill02.png", cc.p(291, 64)))
				button:addChild(CreateCommonLabel(MultiLan("skill_desc8"), cc.p(291, 64), FontSize4, COLOR_GREEN))
			end
		end
		
		
		
		y = y - 140
	end
	
	layer:setContentSize(cc.size(600, 550))
	CreateScrollViewByFather(skillScrollLayer, layer , cc.p(0, 0), kScrollViewDirectionVertical)
end

--更换显示的技能类型
local function onSkillTypeChange(node)
	local newType = tolua.cast(node, "cc.ControlButton"):getTag()
	if newType == skillShowType then
		return
	end
	
	skillShowType = newType
	updateSkillLayer()
end

SkillLayer["onSkillMoreSkillBtnClick"] = onSkillMoreSkillBtnClick
SkillLayer["onSkillLevelupClick"] = onSkillLevelupClick
SkillLayer["onSkillMasterClick"] = onSkillMasterClick
SkillLayer["onSkillTypeChange"]        = onSkillTypeChange