StoneUpGradeLayer = class("StoneUpGradeLayer")
StoneUpGradeLayer.__index = StoneUpGradeLayer

StoneUpGradeLayer.topNode = nil

ccb["StoneUpGradeLayer"] = StoneUpGradeLayer
StoneUpGradeLayerOwner = StoneUpGradeLayerOwner or {}
ccb["StoneUpGradeLayerOwner"] = StoneUpGradeLayerOwner

StoneUpGradeLayer.upGradeStoneItem = nil
StoneUpGradeLayer.selectUpGradeStoneData = nil
StoneUpGradeLayer.StoneUpGradePer = nil
StoneUpGradeLayer.upGradedata = {}
StoneUpGradeLayer.stoneLevel = 1
StoneUpGradeLayer.upGradeLuckLimit = {10,20,40,100,150,200,300,400,500,0}
StoneUpGradeLayer.bNeedProp = false
--//////////////////////////////////////////////////////

function refreshStoneUpGradeValue()
	print("refreshStoneUpGradeValue")
    local propdetail = GameData:getPropDataTable(StoneUpGradeLayer.selectUpGradeStoneData.prop_id)
    if  propdetail == nil or propdetail.level >= STONE_LEVEL_MAX then
        return
    end
    StoneUpGradeLayer.stoneLevel = propdetail.level
    StoneUpGradeLayer.upGradedata = GameData:getStoneUpGradeByLevel(StoneUpGradeLayer.stoneLevel)

    tolua.cast(StoneUpGradeLayerOwner["mStoneUpGradeName"], "cc.Label"):setString(MultiLan(propdetail.name))

	StoneUpGradeLayerOwner["mStoneUpGradeCost"]:setString(MultiLan("prop_name_100002")..":"..StoneUpGradeLayer.upGradedata.gold.."("..MultiLan("desc_now_have")..UserSelfInfo.gold..")")
	if StoneUpGradeLayer.upGradedata.gold > UserSelfInfo.gold then
		StoneUpGradeLayerOwner["mStoneUpGradeCost"]:setColor(COLOR_RED)
	else
		StoneUpGradeLayerOwner["mStoneUpGradeCost"]:setColor(COLOR_WHITE)
	end

    tolua.cast(StoneUpGradeLayerOwner["mStoneUpGradeLuck"], "cc.Label"):
        setString(UserInfo.UserInfoTable.data.info.stone_luck.."/"..StoneUpGradeLayer.upGradeLuckLimit[StoneUpGradeLayer.stoneLevel] )

	StoneUpGradeLayer.bNeedProp = false
    if table.maxn(StoneUpGradeLayer.upGradedata.prop) > 0 then
        StoneUpGradeLayerOwner["mStoneUpGradeConsume"]:setVisible(true)
        local consumePropDetail = GameData:getPropDataTableByLevel(propdetail.place ,propdetail.ptype,StoneUpGradeLayer.upGradedata.prop[1])
    	
        local haveCount = 0
        local size = table.maxn(UserInfo.UserInfoTable.data.bag_prop)
        for i = 1,size do
            if UserInfo.UserInfoTable.data.bag_prop[i].prop_id == consumePropDetail.id then
               haveCount = haveCount + UserInfo.UserInfoTable.data.bag_prop[i].amount
            end
        end
        
        tolua.cast(StoneUpGradeLayerOwner["mStoneUpGradeConsume"], "cc.Label"):
            setString(MultiLan(consumePropDetail.name).."*"..StoneUpGradeLayer.upGradedata.prop[2].."("..MultiLan("desc_now_have")..haveCount..")")
        if haveCount < StoneUpGradeLayer.upGradedata.prop[2] then
            StoneUpGradeLayerOwner["mStoneUpGradeConsume"]:setColor(COLOR_RED)
			StoneUpGradeLayer.bNeedProp = true
        else
            StoneUpGradeLayerOwner["mStoneUpGradeConsume"]:setColor(COLOR_GREEN)
        end
    else
        StoneUpGradeLayerOwner["mStoneUpGradeConsume"]:setVisible(false)
    end

    tolua.cast(StoneUpGradeLayer.StoneUpGradePer, "cc.ProgressTimer"):
        setPercentage(UserInfo.UserInfoTable.data.info.stone_luck / StoneUpGradeLayer.upGradeLuckLimit[StoneUpGradeLayer.stoneLevel] * 100)
end

function StoneUpGradeLayerCreatItem(selectStone)
   StoneUpGradeLayer.upGradeStoneItem = CreateBagItem()
   StoneUpGradeLayer.upGradeStoneItem:setPosition(cc.p(BAG_ITEM_SIZE / 2, BAG_ITEM_SIZE / 2))
   StoneUpGradeLayer.upGradeStoneItem:setTag(0)
   tolua.cast(StoneUpGradeLayerOwner["mUpGradeStoneItemLayer"], "cc.Node"):addChild(StoneUpGradeLayer.upGradeStoneItem)

   StoneUpGradeLayer:StoneUpGradeLayerRefreshItem(selectStone)
end

function StoneUpGradeLayer:StoneUpGradeLayerRefreshItem(selectStone)

    StoneUpGradeLayer.selectUpGradeStoneData = selectStone
    
    if  StoneUpGradeLayer.selectUpGradeStoneData ~= nil then

	    self.upGradeStoneItem:setItemType(BAG_ITEM_TYPE_THING)
	    self.upGradeStoneItem:setItemInfoTable(StoneUpGradeLayer.selectUpGradeStoneData)
        self.upGradeStoneItem.itemCount:setVisible(false)
        self.upGradeStoneItem.itemName:setVisible(false)
        self.upGradeStoneItem:setCanTouch(false)
        refreshStoneUpGradeValue()

    end
    
end

function InitStoneUpGradeLayer()
	--swallowLaer
	local function onStoneUpGradeSwallowTouch(touch, event)
		return true
	end

	StoneUpGradeLayer.StoneUpGradePer = CreateCommonBar("pic_equiptiao02.png",cc.p(320, 259))
    StoneUpGradeLayer.topNode:addChild(StoneUpGradeLayer.StoneUpGradePer)
	
	SetTouchEventForLayer(StoneUpGradeLayerOwner["mStoneUpGradeSwallowLayer"], onStoneUpGradeSwallowTouch)
    StoneUpGradeLayer.selectUpGradeStoneData = nil
end

function StoneUpGradeLayer: StoneUpGradeLayerExit()
	self.topNode:removeFromParent()
	self.topNode = nil
end

function StoneUpGradeLayer:StoneUpGradeLayerEnter(selectStone)
    
    if self.topNode ~= nil then
        return
    end

	local proxy = cc.CCBProxy:create()
	self.topNode = CCBReaderLoad("ccb/StoneUpGradeLayer.ccbi",proxy,StoneUpGradeLayerOwner)
	
	StoneUpGradeLayerOwner["mButtonUpgrade"]:setTitleForState(MultiLan("stoneup_button1"), 1)
	StoneUpGradeLayerOwner["mDesc1"]:setString(MultiLan("stoneup_desc4"))
	StoneUpGradeLayerOwner["mDesc2"]:setString(MultiLan("stoneup_desc5"))
	StoneUpGradeLayerOwner["mDesc3"]:setString(MultiLan("stoneup_desc6"))
    StoneUpGradeLayerOwner["mTitleStoneUpgrade"]:setString(ZGMultiLan("mTitleStoneUpgrade"))

	if POPUP_LAYER ~= nil then
	    POPUP_LAYER:addChild(self.topNode)
		InitStoneUpGradeLayer()

		StoneUpGradeLayerCreatItem(selectStone)
	end
end

function onStoneUpGradeBtnClick()
	print("onStoneUpGradeBtnClick", StoneUpGradeLayer.stoneLevel)
    if  StoneUpGradeLayer.selectUpGradeStoneData == nil then
       return
	end

    if  StoneUpGradeLayer.stoneLevel >= STONE_LEVEL_MAX then
       CommonNote(MultiLan("stoneup_desc1"))
       return
	end
	
	local needMoney = false
    if StoneUpGradeLayer.upGradedata.gold > UserInfo:getUserInfo().data.info.gold then
		CommonGoldNeed()
		needMoney = true
    end
	if StoneUpGradeLayer.bNeedProp then
		CommonNote(MultiLan("lan_jewelIsShort"))
	end
	
    if needMoney or StoneUpGradeLayer.bNeedProp then
		return
	end
	
	local function stoneUpGradeCallback(jsonDataTable)
        if  jsonDataTable == CJSON_NULL  or jsonDataTable.ret ~= 0 then
            return
        end

        upGradeInfo = jsonDataTable.data

        if upGradeInfo.luck > 0 then
           UserInfo:getUserInfo().data.info.stone_luck = UserInfo:getUserInfo().data.info.stone_luck + upGradeInfo.luck
        else
           UserInfo:getUserInfo().data.info.stone_luck = 0
        end

        UserInfo:setGold(UserInfo:getGold() - upGradeInfo.gold)

        if upGradeInfo.items == nil then
            CommonNote(MultiLan("stoneup_desc2"))
        else
            CommonNote(MultiLan("stoneup_desc3"))
            UserInfo:removepropByPropId(StoneUpGradeLayer.selectUpGradeStoneData.prop_id,1)--删除原来的宝石

            UserInfo:addProp(upGradeInfo.items)
            StoneUpGradeLayer:StoneUpGradeLayerRefreshItem(upGradeInfo.items[1].obj)
        end

        if upGradeInfo.use_prop_id ~= nil then
            UserInfo:removepropByPropId(upGradeInfo.use_prop_id,upGradeInfo.use_prop_num)--删除消耗的宝石
        end

        refreshStoneUpGradeValue()
        BagLayer:RefreshBagScrollLayer()
	end

	HttpSend("item/stoneupgrade", {"id="..StoneUpGradeLayer.selectUpGradeStoneData.id}, stoneUpGradeCallback)

end

function onStoneUpGradeHelpBtnClick()
	HelpPopup("stoneupgrade")
end

function onCloseStoneUpGradeBtnClick()
	StoneUpGradeLayer:StoneUpGradeLayerExit()
end

--//////////////////////////////////
StoneUpGradeLayer["onStoneUpGradeBtnClick"] = onStoneUpGradeBtnClick
StoneUpGradeLayer["onStoneUpGradeHelpBtnClick"] = onStoneUpGradeHelpBtnClick
StoneUpGradeLayer["onCloseStoneUpGradeBtnClick"] = onCloseStoneUpGradeBtnClick