
local bTeamInited = false
local TeamTimerId = 0
local TeamPopupTimerId = 0
UserTeamInfo = nil

local TEAM_ENEMY_COUNT = 12

--ս
function CalGroupTotalFightnum(t)
	local totle = 0
	for i=1,table.maxn(t) do
		if t[i].uid ~= UserSelfInfo.uid then
			totle = totle + t[i].power
		else
			totle = totle + UserAttr:getFightNum()
		end
	end
	return totle
end

--ʱ
local function SetTeamCountdown()
	local function teamTimeup()
		XiaLayerOwner["mTeamDesc3"]:setString(MultiLan("team_desc3"))
		XiaLayerOwner["mTeamDesc3"]:setColor(COLOR_GREEN)
		XiaLayerOwner["mTeamDesc2"]:setVisible(false)
	end

	if UserTeamInfo.countdown > 0 then
		if TeamTimerId == 0 then
			TeamTimerId = TimeDown:register(TeamTimerId)
		end
		XiaLayerOwner["mTeamDesc2"]:setString(MultiLan("team_desc2"))
		XiaLayerOwner["mTeamDesc2"]:setColor(COLOR_WHITE)
		XiaLayerOwner["mTeamDesc2"]:setVisible(true)
		XiaLayerOwner["mTeamDesc3"]:setColor(COLOR_WHITE)
		TimeDown:setTimeInfo(TeamTimerId, UserTeamInfo.countdown, XiaLayerOwner["mTeamDesc3"], teamTimeup, TimeDown.MM_SS)
		SetDownTimeForLabel(XiaLayerOwner["mTeamDesc3"], UserTeamInfo.countdown)
	else
		TimeDown:unregister(TeamTimerId)
		TeamTimerId = 0
		teamTimeup()
	end
end

local function SetResetLabel()
	XiaLayerOwner["mTeamDesc7"]:setString(MultiLan("team_desc10")..(UserVipInfo.hero_group - UserTeamInfo.reset))
end

local function SetInspireLabel()
	XiaLayerOwner["mTeamDesc6"]:setString(" "..UserTeamInfo.inspire.."%")
end

--
local function SetTeamBox()
	local deadEnemyCount = 0
	for i=1, table.maxn(UserTeamInfo.list) do
		deadEnemyCount = deadEnemyCount + UserTeamInfo.list[i].status
	end

	XiaLayerOwner["mTeamBoxLayer"]:removeAllChildren(true)
	
	local function onBoxClicked(node)
		local boxNum = node:getTag()
		if deadEnemyCount >= 3*boxNum then
			local function rewardCallback(jsonDataTable)
				if jsonDataTable.ret == 0 then
					UserInfo:addProp(jsonDataTable.data.item)
					UserInfo:addPropNote(jsonDataTable.data.item)
					
					UserTeamInfo.award = jsonDataTable.data.award
					SetTeamBox()
				end
			end
			
			HttpSend("herogroup/award", {"idx="..boxNum}, rewardCallback)
		else
			local popupContet = CreateLayer(POPUP_SIZE_SML, 1, Pos(POPUP_SIZE_SML))
			local popupRoot = CommonCreatePopupSmall("qzbaoxi", popupContet)
			
			local rewardTable = {}
			local rewardIdTable = {{100301, PROP_ID_GOLD, PROP_ID_PRESTIGE},
									{100301, PROP_ID_GOLD, PROP_ID_PRESTIGE},
									{100301, PROP_ID_GOLD, PROP_ID_PRESTIGE},
									{100302, PROP_ID_GOLD, PROP_ID_PRESTIGE}}
			local userLevel = UserSelfInfo.level
			local rewardNumTable = {{(math.floor(userLevel/10)-1)*2+1, 2000*userLevel, 10},
									{(math.floor(userLevel/10)-1)*2+1, 4000*userLevel, 30},
									{(math.floor(userLevel/10)-1)*2+1, 6000*userLevel, 50},
									{(math.floor(userLevel/10)-1)*2+1, 8000*userLevel, 100}}
				
			for i=1, 3 do
				rewardTable[i] = {prop_id=rewardIdTable[boxNum][i], num = rewardNumTable[boxNum][i]}
			end

			local rewardLayer = createRewardLayer(rewardTable)
			rewardLayer:setAnchorPoint(cc.p(0.5, 0.5))
			rewardLayer:setPosition(Pos(POPUP_SIZE_SML,0.5,0.53))
			popupContet:addChild(rewardLayer)
			popupContet:addChild(CreateCommonLabel(MultiLan("team_desc6"), Pos(POPUP_SIZE_SML, 0.5,0.79),FontSize3, EQUIP_COLOR_ARR[4]))
			popupContet:addChild(CreateCommonLabel("+", Pos(POPUP_SIZE_SML, 0.5,0.70),FontSize4))
			
			local function closeFunc() 
				removeSelf(popupRoot)
			end
			popupContet:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_SML, 0.5, 0.18), cc.size(158,67), closeFunc, {str=MultiLan("button_close"), size = FontSize3}))
		end
	end
	
	--UserTeamInfo.award = {0,0,0,0}
	print(UserTeamInfo.award[1],UserTeamInfo.award[2],UserTeamInfo.award[3])
	for i=1, 4 do
		local position = cc.p(-50+140*i,50)
		if UserTeamInfo.award[i] == 1 then
			XiaLayerOwner["mTeamBoxLayer"]:addChild(CreateCommonSprite("pic_hfbox1.png", position))
		else
			if deadEnemyCount >= 3*i then
				local box = CreateCommonButton("pic_hfbox2.png", position, cc.size(115, 115), onBoxClicked)
				XiaLayerOwner["mTeamBoxLayer"]:addChild(box, 0, i)
				GameGuide:setButtonNote(box, true, cc.p(87, 87))
			else
				XiaLayerOwner["mTeamBoxLayer"]:addChild(CreateCommonButton("pic_hfbox3.png", position, cc.size(115, 115), onBoxClicked), 0, i)
			end
		end
		
	end
end

--ͷ
local function onEnemyClicked(node)
	local enemyInfo = UserTeamInfo.list[node:getTag()]
	if enemyInfo == nil then
		return
	elseif enemyInfo.status ~= 0 then
		CommonNote(MultiLan("team_desc5"))
		return
	end
	cc.SpriteFrameCache:getInstance():addSpriteFrames("ccb/ccbResources/SkillIcon.plist")
	

	--
	local popupContent = CreateLayer(POPUP_SIZE_MAX, 1, Pos(POPUP_SIZE_MAX))
	local layer = cc.Layer:create()
	local count = table.maxn(enemyInfo.team)
	local height = 640
	print("onEnemyClicked", count)
	local y = count*140-70
	for i=1, count do
		if i == 1 then
			layer:addChild(CreateCommonSprite("board_challengemap.png", cc.p(300, y)))
		else
			layer:addChild(CreateCommonSprite("board_overmap.png", cc.p(300, y)))
		end
		layer:addChild(CreateCommonSprite("board_skill01.png", cc.p(291, y+32)))
		local skillBack = CreateCommonSprite("board_skill02.png", cc.p(291, y-23))
		layer:addChild(skillBack)

		--ͷ
		local roleData = GameData:getRoleDataById(enemyInfo.team[i].id)
		
		if i == 1 then
			layer:addChild(CreateCommonSprite("actor_icon_"..roleData.role..".png", cc.p(65, y)))
			layer:addChild(CreateCommonLabel(enemyInfo.team[i].name, cc.p(120, y+32), FontSize2, nil,cc.p(0,0.5)))
		else
			layer:addChild(CreateCommonSprite("hero_icon_"..roleData.role..".png", cc.p(65, y)))
			layer:addChild(CreateCommonLabel(MultiLan(enemyInfo.team[i].name), cc.p(120, y+32), FontSize2, nil,cc.p(0,0.5)))
		end
		layer:addChild(GetSchoolIconByRole(roleData.role, cc.p(30, y + 45)))
		layer:addChild(GetLevelLabel(enemyInfo.team[i].level, cc.p(70, y - 47), FontSize2))
		layer:addChild(CreateCommonLabel(MultiLan("GFL_unionMember_8")..":"..enemyInfo.team[i].power, cc.p(460, y+32), FontSize2, COLOR_GREEN,cc.p(1,0.5)))

		if enemyInfo.team[i].skill ~= nil and enemyInfo.team[i].skill ~= CJSON_NULL then
			for j=1, 4 do
				if enemyInfo.team[i].skill[j] ~= nil then
					skillBack:addChild(CreateCommonSprite("skill_"..enemyInfo.team[i].skill[j].id..".png", cc.p(-20+70*j, 30), 0.5))
				end
			end
		end
		--ӳ
		if i == 1 then
			if enemyInfo.inspire > 0 then
				layer:addChild(CreateCommonSprite("pic_hfguwu.png", cc.p(530, y+12)))
				layer:addChild(CreateCommonLabel(MultiLan("GFL_unionBoss_4")..":", cc.p(529, y-15), FontSize4, nil,cc.p(1,0.5)))
				layer:addChild(CreateCommonLabel(enemyInfo.inspire.."%", cc.p(531, y-15), FontSize4, COLOR_GREEN,cc.p(0,0.5)))
			end
		else
			layer:addChild(CreateCommonLabel(MultiLan("lan_hero"), cc.p(530, y), FontSize3))
		end

		y = y - 140
	end
	
	layer:setContentSize(cc.size(600, math.max(height,count*140)))
	local scrollLayer = CreateLayer(cc.size(600,height), 1, Pos(POPUP_SIZE_MAX))--,nil,nil,cc.c4b(128,128,128,255))
	popupContent:addChild(scrollLayer)
	local scrollview = CreateScrollViewByFather(scrollLayer, layer , cc.p(0, height-count*140), kScrollViewDirectionVertical)
	scrollview:setScale(0.98)
	if count*140 < height then
		scrollview:setTouchEnabled(false)
	end
	
	--ս
	popupContent:addChild(CreateCommonLabel(MultiLan("GGL_declare_5")..CalGroupTotalFightnum(enemyInfo.team), Pos(POPUP_SIZE_MAX,0.1,0.905), FontSize4, nil,cc.p(0,0.5)))
	
	--ʱ
	local desc1 = CreateCommonLabel(MultiLan("team_desc2"), Pos(POPUP_SIZE_MAX,0.24,0.06),FontSize4,nil,cc.p(1,0.5))
	popupContent:addChild(desc1)
	local desc2 = CreateCommonLabel("", Pos(POPUP_SIZE_MAX,0.25,0.06),FontSize4,nil,cc.p(0,0.5))
	popupContent:addChild(desc2)
	local leftTime = 0
	if TeamTimerId ~= 0 then
		leftTime = TimeDown:getTimeById(TeamTimerId)
	end

	local function teamTimeup()
		desc1:setString(MultiLan("team_desc3"))
		desc1:setColor(COLOR_GREEN)
		desc2:setVisible(false)
	end

	if leftTime > 0 then
		TimeDown:unregister(TeamPopupTimerId)
		TeamPopupTimerId = TimeDown:register()
		desc2:setColor(COLOR_RED)
		TimeDown:setTimeInfo(TeamPopupTimerId, leftTime, desc2, teamTimeup, TimeDown.MM_SS)
		SetDownTimeForLabel(desc2, leftTime)
	else
		teamTimeup()
	end
	
	local function closeFunc()
		TimeDown:unregister(TeamPopupTimerId)
		TeamPopupTimerId = 0
	end
	
	local root = CommonCreatePopupMax("hfqunp", popupContent, closeFunc)
	local function sendChallenge()
		if TeamPopupTimerId ~= 0 and TimeDown:getTimeById(TeamTimerId) > 0 then
			CommonNote(MultiLan("team_desc4"))
			return
		end

		local function teamFightCallback(jsonDataTable)
			if jsonDataTable.ret == 0 then
				if jsonDataTable.data.log.status == 1 then --ʤ ˢ½ ˢ± ʤЧ
					--UserTeamInfo.award = jsonDataTable.data.award
					enemyInfo.status = 1
					node:getChildByTag(20):setVisible(true)
					
					SetTeamBox()
				end
				--ʱ
				UserTeamInfo.countdown = jsonDataTable.data.countdown
				SetTeamCountdown()
				
				--ս 
				ShowGroupFight(jsonDataTable.data.log)
				
				--Ч
				local node = nil
				if jsonDataTable.data.log.status == 1 then
					node = CreateCommonSprite("pic_hfwin.png", Pos(POPUP_LAYER:getContentSize(),0.5,0.7))
					-- node:addChild(CreateCommonFntLabel(ZGMultiLan("game_war_result_win"), FntTypeCommonYellow, Pos(node:getContentSize(), 0.5, 0.5)))
				else
					node = CreateCommonSprite("pic_hffail.png", Pos(POPUP_LAYER:getContentSize(),0.5,0.7))
					-- node:addChild(CreateCommonFntLabel(ZGMultiLan("game_war_result_lose"), FntTypeCommonDisableGray, Pos(node:getContentSize(), 0.5, 0.5)))
				end
				POPUP_LAYER:addChild(node)
				node:setOpacity(64)
				node:setScale(3)
				
				local oldScaleX, oldScaleY = scene:getScaleX(), scene:getScaleY()
				local function chandou()
					scene:setScaleX(oldScaleX*0.99)
					scene:setScaleY(oldScaleX*0.99)
					local function resetScale()
						scene:setScaleX(oldScaleX)
						scene:setScaleY(oldScaleY)
					end
					scene:runAction(cc.Sequence:create(cc.DelayTime:create(0.01),cc.CallFunc:create(resetScale)))
				end
				
				node:runAction(cc.FadeTo:create(0.15, 255))
				node:runAction(cc.Sequence:create(cc.ScaleTo:create(0.15, 1), 
													cc.CallFunc:create(chandou),
													cc.DelayTime:create(0.7), 
													cc.Spawn:create(cc.FadeOut:create(0.5),cc.ScaleTo:create(0.4,1.1)),
													cc.CallFunc:create(removeSelf)))
			end
		end
		
		--رյ
		closeFunc()
		removeSelf(root)
		HttpSend("herogroup/fight", {"idx=" .. node:getTag()}, teamFightCallback)
	end
	popupContent:addChild(CreateCommonButton("button_green.png",Pos(POPUP_SIZE_MAX,0.5,0.06), cc.size(158,67), sendChallenge, {str=MultiLan("button_challenge"),size=FontSize3}))
	
	
	
end

--Ϣ
local function SetTeamEnemy()
	local layer = cc.Layer:create()
	local scrolView = CreateScrollViewByFather(XiaLayerOwner["mTeamEnemyLayer"], layer, cc.p(0,0), kScrollViewDirectionVertical)
	local line = math.ceil(TEAM_ENEMY_COUNT/4)
	local scrollWorldPos = XiaLayerOwner["mTeamEnemyLayer"]:convertToWorldSpace(cc.p(scrolView:getPosition()))
	local scrollViewSize = scrolView:getViewSize()
	local width = XiaLayerOwner["mTeamEnemyLayer"]:getContentSize().width/4
	local height = XiaLayerOwner["mTeamEnemyLayer"]:getContentSize().height/3
	local size = cc.size(119, 136)
	local y = height * (line - 0.5)
	local chachaTag = 20
	
	--UserTeamInfo.list = {}
	for i=1, 12 do
		--UserTeamInfo.list[i] = {team={{id=1, level=3*i, name="width",power=12345, skill={101,102,103,104}},{id=12, level=3*i, name="width",power=12345, skill={201,202,203,204}}},status=i%2,inspire=100}
	end
	print("SetTeamEnemy")
	for i=1, line do
		for j=1,4 do
			local x = width*(j-0.5)
			local num = (i-1)*4+j
			local itemInfo = UserTeamInfo.list[num]
			print(x, itemInfo)
			if itemInfo ~= nil then
				local button = CreateCommonButton("board_diduim.png", cc.p(x, y), size, onEnemyClicked)
				button:setScrollViewRect(cc.rect(scrollWorldPos.x, scrollWorldPos.y, scrollViewSize.width, scrollViewSize.height))
				button:setSwallowTouch(false)
				layer:addChild(button, 0, num)
				
				local heroData = GameData:getRoleDataById(itemInfo.team[1].id)
				if heroData ~= nil then
					button:addChild(CreateCommonSprite("actor_icon_"..heroData.role..".png", Pos(size,0.5,0.6)))
					button:addChild(CreateCommonSprite("school_icon_"..heroData.role..".png", Pos(size,0.18,0.85)))
				end
				button:addChild(CreateCommonLabel("Lv."..itemInfo.team[1].level, Pos(size,0.5,0.12), FontSize2))
				
				--
				local chacha = CreateCommonSprite("pic_overman.png", Pos(size,0.5,0.5))
				button:addChild(chacha, 0, chachaTag)
				if itemInfo.status == 0 then
					chacha:setVisible(false)
				end
			end
		end
	
		y = y- height
	end

	layer:setContentSize(cc.size(XiaLayerOwner["mTeamEnemyLayer"]:getContentSize().width, math.max(XiaLayerOwner["mTeamEnemyLayer"]:getContentSize().height, height*line)))
	scrolView:setContentOffset(cc.p(0, XiaLayerOwner["mTeamEnemyLayer"]:getContentSize().height-height*line))
	if height*line <= XiaLayerOwner["mTeamEnemyLayer"]:getContentSize().height then
		scrolView:setTouchEnabled(false)
	end
end

local function TeamLayerInit()
	if bTeamInited then
		return
	end
	bTeamInited = true
	print(1)
	--ɫ
	XiaLayerOwner["mTeamDesc1"]:setString(MultiLan("team_desc1"))
	XiaLayerOwner["mTeamDesc2"]:setString(MultiLan("team_desc2"))
	XiaLayerOwner["mTeamDesc4"]:setString(string.format(MultiLan("GFL_inspire_2"), 10, 20))
	XiaLayerOwner["mTeamDesc4"]:setColor(COLOR_CYAN)
	XiaLayerOwner["mTeamDesc5"]:setString(MultiLan("GFL_inspire_1"))
	XiaLayerOwner["mTeamDesc6"]:setPositionX(XiaLayerOwner["mTeamDesc5"]:getPositionX()+XiaLayerOwner["mTeamDesc5"]:getContentSize().width)
	XiaLayerOwner["mTeamDesc6"]:setColor(COLOR_CYAN)
	--ť
	XiaLayerOwner["mTeamButtonInspire"]:setTitleForState(MultiLan("GFL_unionBoss_4"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mTeamButtonReset"]:setTitleForState(MultiLan("button_reset"), cc.CONTROL_STATE_NORMAL)
end

local function RefreshTeamLayer()
	SetTeamEnemy()
	SetTeamCountdown()
	SetTeamBox()
	SetResetLabel()
	SetInspireLabel()
end

function TeamEnter()
	print("GroupEnter")

	XiaLayerOwner["mPvpLayer"]:setVisible(true)
	XiaLayerOwner["mPvpMain"]:setVisible(false)
	TeamLayerInit()
	RefreshTeamLayer()

	--setGroupInfoLayer(true)
end

function TeamExit()
	TimeDown:unregister(TeamTimerId)
	TeamTimerId = 0
end

--
local function onTeamResetClick()
	if UserTeamInfo.reset >= UserVipInfo.hero_group then
		CommonNote(MultiLan("team_desc7"))
		if UserSelfInfo.vip < 6 then
			CommonNote(MultiLan("team_desc11"))
		end
		return
	end
	
	local function sendResetTeam()
		local function resetCallback(jsonDataTable)
			if jsonDataTable.ret == 0 then
				UserTeamInfo = jsonDataTable.data
				RefreshTeamLayer()

				CommonNote(MultiLan("team_desc9"))
			end 
		end
			
		HttpSend("herogroup/reset", {}, resetCallback)
	end
	
	CreateSmallPopupWithCancel("prompt",CreateCommonLabel(MultiLan("team_desc8"),nil,FontSize3,nil,nil,cc.size(455, 80)), sendResetTeam)
end

local function onTeamInspireClick()
	print("onTeamInspireClick")
	if UserTeamInfo.inspire >= 100 then
		CommonNote(MultiLan("GFL_inspire_3"))
		return
	end
	
	if UserSelfInfo.cash < 20 then
		CommonCashNeed()
		return
	end
	
	local function inspireCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			UserSelfInfo.cash = UserSelfInfo.cash - jsonDataTable.data.use_cash
			UseCash(jsonDataTable.data.use_cash)
			UserTeamInfo.inspire = jsonDataTable.data.inspire
			SetInspireLabel()

			CommonNote(MultiLan("GFL_inspire_4"))
		end 
	end
		
	HttpSend("herogroup/inspire", {}, inspireCallback)
end

XiaLayer["onTeamResetClick"]        = onTeamResetClick
XiaLayer["onTeamInspireClick"]      = onTeamInspireClick