HttpReq = class("HttpReq")
HttpReq.__index = HttpReq

HttpReq.blockLayer = nil
HttpReq.swallowLayer = nil
HttpReq.httpReqUpdateEntry = nil

GameRequestNum = 0
LastRequestInterface = ""
LastRequestBackData = ""

function HttpReq:ctor()
	cclog("http req ctor")
end

function HttpReq:addSwallow(touchCallback)
	if POPUP_LAYER ~= nil then
		self.swallowLayer = CreateLayer(CommonSize, 1, Pos(CommonSize),nil,touchCallback)
		POPUP_LAYER:addChild(self.swallowLayer)
	end
end

function HttpReq:deleteSwallow()
	if self.swallowLayer ~= nil then
		removeSelf(self.swallowLayer)
		self.swallowLayer = nil
	end
end

function HttpReq:update()
	if self.blockLayer == nil then
		local tmpSprite = cc.Sprite:createWithSpriteFrameName("pic_loading.png")
		tmpSprite:runAction(cc.RepeatForever:create(cc.RotateBy:create(2, -360)))
		self.blockLayer = CommonCreatePopup(tmpSprite)
	end
end

function HttpReq:hideBlock()
	if self.blockLayer ~= nil then
		self.blockLayer:removeFromParent(true)
	end
	if self.httpReqUpdateEntry ~= nil then
		scheduler:unscheduleScriptEntry(self.httpReqUpdateEntry)
	end
end

function HttpReq:send(InterfaceString, ParamTable, Callback, bOnlyOne, bRetry)
	print("HttpReq:send ",NetWorkLock,InterfaceString)
	for k,v in pairs(ParamTable) do
		print("param ",k,tostring(v))
	end
	print("---------1-----das---------")
	if NetWorkLock == true and bRetry == nil then
		cclog("http already send! %s", InterfaceString)
		return
	end
	LastRequestInterface = InterfaceString
	NetWorkLock = true
	local requestBack = false
	local decodeError = true
	local bShowRetryPopup = false
	local ParamStringTable = table.concat(ParamTable, "&")
	print("---------2-----das---------")
	local xhr = cc.XMLHttpRequest:new()
	print("---------3-----das---------")
	xhr:retain()
	xhr.responseType = cc.XMLHTTPREQUEST_RESPONSE_STRING
		print("--------------das---------")
	if InterfaceString == "jsonconf/info" then
		xhr:open("POST", "http://45.63.64.160:8080/jsonconf/info")
		print("--------------das")
		--xhr:open("POST", "http://168.63.249.127:8080/" .. InterfaceString)
	elseif InterfaceString == "pay/items" or InterfaceString == "pay/order" or InterfaceString == "game/appstorepaycall" or InterfaceString == "game/googleplaypaycall" then
		xhr:open("POST", GameConfig:GetLoginAddress() .. InterfaceString)
	else
		if SERVER_ADDRESS == nil or SERVER_ADDRESS == "" then
			xhr:open("POST", GameConfig:GetLoginAddress() .. InterfaceString)
		else
			xhr:open("POST", SERVER_ADDRESS .. InterfaceString)
		end	
	end
	cclog("Http Status Code1:"..xhr.status)
	--重试弹窗
	local function RetryPopup()
		bShowRetryPopup = true
		local function httpSendRetry()
			HttpSend(InterfaceString, ParamTable, Callback, nil, true)
		end
		CreateSmallPopupWithTryAgain(nil, CreateCommonLabel(MultiLan("httpreq_desc1"), nil, FontSize3), httpSendRetry)
	end
	
	local function QuestSwallowTouch()
		print("QuestSwallowTouch")
		if requestBack and decodeError and bShowRetryPopup == false then
			--解析错误记录
			if bTestVersion then
				local layer = CreateLayer(POPUP_SIZE_MID, 1,Pos(POPUP_SIZE_MID))
				local contentLayer = CreateLayer(cc.size(490,510),1,Pos(POPUP_SIZE_MID,0.5,0.546))
				layer:addChild(contentLayer)
				CreateRichtextByFather(contentLayer, {{str="LastRequestBackData: "..LastRequestBackData,size=FontSize3}}, nil, true) 
				CommonCreatePopupMid("prompt",layer,true)
			end
		
		
			self:deleteSwallow()
			RetryPopup()
		end
		return true
	end
	
	--屏蔽点击层
	self:addSwallow(QuestSwallowTouch)
	
	--开始弹板计时
	local function httpReqUpdate()
		self:update()
	end
	
	local function httpCommonCallback()
		
		if bOnlyOne then
			self:deleteSwallow()
			NetWorkLock = false
			xhr:release()
			return 
		end
		self:hideBlock()
		
		if xhr.status ~= 200 then
			--CommonNote("网络不通 Status:"..xhr.status.."正在重连..")
			cclog("Http request failed, retrying....")
			self:deleteSwallow()
			RetryPopup()
		elseif Callback ~= nil then
			requestBack = true
			LastRequestBackData = xhr.response
			if string.len(xhr.response) < 500 then
				cclog("http call back string : %s", xhr.response)
			end
			local dataTable = (require "cjson").decode(xhr.response)
			decodeError = false
			xhr:release()
			NetWorkLock = false
			if dataTable.ret ~= nil and dataTable.ret ~= 0 then
				cclog("http ret failed ret %d", dataTable.ret)
				if dataTable.ret == 501 then
					CommonCreatePopupSmallWithOneButtonCallback(nil, 
												CreateCommonLabel(MultiLan("httpreq_desc2"), nil, FontSize3,nil,nil,cc.size(400,120)), MultiLan("button_ok"),ExitGame)
					return
				elseif "game/login" ~= InterfaceString then
					local erroStr = MultiLan("error_"..dataTable.ret)
					if erroStr == "invalid" then
						erroStr = MultiLan("httpreq_desc3")..dataTable.ret
					end
				
					if GameConfig:GetIsRelease() then
						CreateSmallPopupWithCancel(nil,CreateCommonLabel(erroStr, nil,FontSize3))
					else
						CreateSmallPopupWithCancel(nil, 
										CreateCommonLabel(erroStr.." \nInterface:"..InterfaceString.."\nParameter:"..table.concat(ParamTable, "&"), nil, FontSize3,nil,nil,cc.size(400,120)))
					end
				end
			end
			self:deleteSwallow()
			Callback(dataTable)
		end
	end

	--1秒后转圈
	if bOnlyOne == nil or bOnlyOne == false then
		self.httpReqUpdateEntry = scheduler:scheduleScriptFunc(httpReqUpdate, 1, false)
	end
	xhr:registerScriptHandler(httpCommonCallback)
	--修改参数
	if bRetry ~= true then
		if bOnlyOne == nil then
			GameRequestNum = GameRequestNum + 1
			table.insert(ParamTable, "request_num="..GameRequestNum)
		end
		
		if InterfaceString ~= "game/login" and InterfaceString ~= "jsonconf/info" then
			table.insert(ParamTable, "token="..USER_TOKEN)
		end
	end
	
	table.sort(ParamTable, function(x,y) return x < y end)
	local ParamString = table.concat(ParamTable, "&")
	cclog("send interface %s", InterfaceString)
	cclog("origin param string %s", ParamString)
	local encryptParamSig = IHelper:getInstance():getHTTPRequestSignature(InterfaceString, ParamString)
	cclog("sig string %s", encryptParamSig)
	
	table.foreachi(ParamTable, 
		function(i, v)
			local tokenStr = tostring(v)
			local findStartIndex, findEndIndex = string.find(tokenStr, "token=")
			if findStartIndex ~= nil then
				local tailStr = string.sub(tokenStr, findEndIndex+1)
				tokenStr = IHelper:getInstance():getURLEncode(tailStr)
				ParamTable[i] = "token=" .. tokenStr
			end
		end
	)
	ParamString = table.concat(ParamTable, "&")
	cclog("find http string %s", ParamString .. "&sig=" .. encryptParamSig)
	cclog("Http Status Code5:"..xhr.status)
	xhr:send(ParamString .. "&sig=" .. encryptParamSig)
end

return HttpReq