MasterEquipFilterChange = class("MasterEquipFilterChange")
MasterEquipFilterChange.__index = MasterEquipFilterChange

MasterEquipFilterChange.topNode = nil
MasterEquipFilterChange.selectMasterinfo = {}
MasterEquipFilterChange.equipedLayer = nil	--上面那个层
MasterEquipFilterChange.filterLayer = nil	
MasterEquipFilterChange.filterScroll = nil	--下面的滚动层

MasterEquipFilterChange.masterEquipFilterDataTable = {}
MasterEquipFilterChange.masterEquipList = {} 
MasterEquipFilterChange.masterFilterType = nil
MasterEquipFilterChange.MasterEquipType = nil
MasterEquipFilterChange.MasterEquipFilterCount = 0
MasterEquipFilterChange.MASTERMAXCOUNT = 1


function MasterEquipFilterChange:MasterEquipFilterChangeCreate()
	self.filterScroll = cc.ScrollView:create()
	self.filterLayer:addChild(self.filterScroll)
	self.filterScroll:setViewSize(cc.size(self.filterLayer:getContentSize().width, self.filterLayer:getContentSize().height))
	self.filterScroll:setPosition(cc.p(0,0))
	self.filterScroll:ignoreAnchorPointForPosition(true)
	self.filterScroll:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
	self.filterScroll:setClippingToBounds(true)
	self.filterScroll:setBounceable(true)
	self.filterScroll:setDelegate()
	self.filterScroll:setVisible(true)
end

function MasterEquipFilterChange:MasterEquipFilterChangeRefresh()
	if self.equipedLayer ~= nil then
		self.equipedLayer:removeFromParent()
		self.equipedLayer = nil
	end
	self.equipedLayer = cc.Layer:create()
	self.equipedLayer:ignoreAnchorPointForPosition(false)
	self.equipedLayer:setAnchorPoint(cc.p(0, 1))
	self.equipedLayer:setPosition(cc.p(0, self.filterLayer:getContentSize().height))
	
	local equipedItemBgSprite = cc.Sprite:createWithSpriteFrameName("board_equipchoose.png")
	equipedItemBgSprite:setAnchorPoint(cc.p(0, 0))
	self.equipedLayer:addChild(equipedItemBgSprite)
	
	local equipedRichInfo = EquipHelper:createItemInfoRichtext(self.selectMasterinfo,nil,true)
	equipedRichInfo:setContentSize(cc.size(270, 500))
	equipedRichInfo:formatText()
	equipedRichInfo:ignoreAnchorPointForPosition(true)
	equipedRichInfo:setPosition(cc.p(115, equipedRichInfo:getTextMaxHeight()-500 + 30/2))
	self.equipedLayer:setContentSize(496, equipedRichInfo:getTextMaxHeight() + 30)
	self.equipedLayer:addChild(equipedRichInfo)
	
	EquipHelper:setEquipPlaceNameLabel(self.equipedLayer, self.selectMasterinfo)
	
	local equipedItem = CreateBagItem()
	equipedItem:setCanTouch(false)
    equipedItem:setItemType(BAG_ITEM_TYPE_EQUIP)
	equipedItem:setItemInfoTable(self.selectMasterinfo)
	equipedItem:setPosition(cc.p(50, self.equipedLayer:getContentSize().height - 60))
	self.equipedLayer:addChild(equipedItem)
	
	equipedItemBgSprite:setScaleY(self.equipedLayer:getContentSize().height / equipedItemBgSprite:getSpriteFrame():getRect().height)
	
	self.filterLayer:addChild(self.equipedLayer)
end

function MasterEquipFilterChange:checkHasSelect(nodeIndex)
    for index = 1 , self.MasterEquipFilterCount do
        if  self.masterEquipFilterDataTable[index].id == self.masterEquipList[nodeIndex].id  then
            return index
        end
    end 
   return 0
end

function MasterEquipFilterChange:MasterItemExternFun(node)
   if node == nil then
      node = self
    end

   local nodeBagPos = node:getTag()
   local hasSelectPos = MasterEquipFilterChange:checkHasSelect(nodeBagPos)
   local pSelectFlag = tolua.cast(node, "cc.Layer"):getChildByTag(101)
   if hasSelectPos > 0 then
      MasterEquipFilterChange.MasterEquipFilterCount = MasterEquipFilterChange.MasterEquipFilterCount - 1
      table.remove(MasterEquipFilterChange.masterEquipFilterDataTable, hasSelectPos)
      pSelectFlag:setVisible(false)
   elseif hasSelectPos < 1  then
      if MasterEquipFilterChange.MASTERMAXCOUNT == 1 then
        local scrollContain =  MasterEquipFilterChange.filterScroll:getContainer()
        for i=1,table.maxn(MasterEquipFilterChange.masterEquipList) do 
           scrollContain:getChildByTag(i):getChildByTag(101):setVisible(false)
        end
        MasterEquipFilterChange.MasterEquipFilterCount = 0
        MasterEquipFilterChange.masterEquipFilterDataTable = {}
      end

      if  MasterEquipFilterChange.MasterEquipFilterCount < MasterEquipFilterChange.MASTERMAXCOUNT   then
        MasterEquipFilterChange.MasterEquipFilterCount = MasterEquipFilterChange.MasterEquipFilterCount + 1
        table.insert(MasterEquipFilterChange.masterEquipFilterDataTable, MasterEquipFilterChange.masterEquipList[nodeBagPos])
        pSelectFlag:setVisible(true)
      end
   end
end

function MasterEquipFilterChange:scrollRefresh()
	local scrollLayer = cc.Layer:create()
	scrollLayer:ignoreAnchorPointForPosition(true)
	self.filterScroll:setViewSize(cc.size(self.filterLayer:getContentSize().width, self.filterLayer:getContentSize().height - self.equipedLayer:getContentSize().height))
	self.filterScroll:setContainer(scrollLayer)
	local scrollWorldPos = self.filterScroll:getParent():convertToWorldSpace(cc.p(self.filterScroll:getPosition()))
	local scrollViewSize = self.filterScroll:getViewSize()
	local curPosY = 0

    local equipDataInfo = nil
    self.masterEquipList = {} 


    if self.masterFilterType == 1 then
        local equipList = UserInfo:getBagEquip()
        for k=1,table.maxn(equipList) do
			equipDataInfo = equipList[k]
            if equipDataInfo ~= self.selectMasterinfo and (equipDataInfo.stone == CJSON_NULL or table.maxn(equipDataInfo.stone)) then
				if (EquipHelper:isOnlyMaster(self.selectMasterinfo) and EquipHelper:isMaster(equipDataInfo)) or
				   (EquipHelper:isOnlyGlyph(self.selectMasterinfo) and EquipHelper:isGlyph(equipDataInfo)) or
				   (EquipHelper:isBothMG(self.selectMasterinfo) and EquipHelper:isRedEquip(equipDataInfo)) then
                    
					table.insert(self.masterEquipList,equipDataInfo)
				end
            end
        end
		table.sort(self.masterEquipList, sortForBagFan)
    elseif self.masterFilterType == 2 then
        local equipList = UserInfo:getBagEquip()
        for k=1,table.maxn(equipList) do
            equipDataInfo = equipList[k]
            local propInfoTable = GameData:getPropDataTable(equipDataInfo.prop_id)
 
            if ((EquipHelper:isMaster(self.selectMasterinfo) and not EquipHelper:isMaster(equipDataInfo)) or 
				(EquipHelper:isGlyph(self.selectMasterinfo) and not EquipHelper:isGlyph(equipDataInfo))) and
				propInfoTable.place ==  self.MasterEquipType then
                table.insert(self.masterEquipList,equipDataInfo)
            end
        end

        local otherEquips = UserInfo:getUserInfo().data.equip
		for k,v in pairs(otherEquips) do
			for i=1,table.maxn(v) do
				local propInfoTable = EquipHelper:getStaticData(v[i])
				if ((EquipHelper:isMaster(self.selectMasterinfo) and not EquipHelper:isMaster(v[i])) or 
					(EquipHelper:isGlyph(self.selectMasterinfo) and not EquipHelper:isGlyph(v[i]))) and
					propInfoTable.place ==  self.MasterEquipType then
					table.insert(self.masterEquipList,v[i])
				end
			end
		end
		table.sort(self.masterEquipList, sortByScore)
		
    end

    self.masterEquipFilterDataTable = {}

    if self.masterFilterType == 1 then
        self.MASTERMAXCOUNT = 6
        self.MasterEquipFilterCount = 0

        for i=1, self.MASTERMAXCOUNT do
			if MasterEquipEatLayer.eatEquipDataTable[i] ~= nil then
				self.MasterEquipFilterCount = self.MasterEquipFilterCount + 1
				table.insert(MasterEquipFilterChange.masterEquipFilterDataTable, MasterEquipEatLayer.eatEquipDataTable[i])
			end
	    end
        MasterEquipEatLayer:MasterEquipEatLayerClearItem()
    elseif self.masterFilterType == 2 then
        self.MASTERMAXCOUNT = 1
        self.MasterEquipFilterCount = table.maxn(MasterEquipInheritLayer.inheritEquipData)

        for i=1, self.MasterEquipFilterCount do
		    table.insert(MasterEquipFilterChange.masterEquipFilterDataTable, MasterEquipInheritLayer.inheritEquipData[i])
	    end
        MasterEquipInheritLayer:MasterEquipInheritLayerClearItem()
    end

	
	local i = table.maxn(self.masterEquipList)
	while i >= 1 do
		local itemLayer = CreateMasterFilterItem()
		itemLayer:ignoreAnchorPointForPosition(true)
		itemLayer:setTag(i)
        itemLayer:setExternFun(self.MasterItemExternFun)

        local itemBgSprite = cc.Sprite:createWithSpriteFrameName("board_equipchoose.png")
	    itemBgSprite:setAnchorPoint(cc.p(0, 0))
	    itemLayer:addChild(itemBgSprite)
        	
		local itemRichInfo = EquipHelper:createItemInfoRichtext(self.masterEquipList[i])
		itemRichInfo:setContentSize(cc.size(270, 500))
		itemRichInfo:formatText()
		itemRichInfo:ignoreAnchorPointForPosition(true)
		itemRichInfo:setPosition(cc.p(115, itemRichInfo:getTextMaxHeight()-500 + 30/2))

		itemLayer:setContentSize(496, itemRichInfo:getTextMaxHeight() + 30)
		itemLayer:addChild(itemRichInfo)
		itemLayer:setPosition(cc.p(0, curPosY))
		curPosY = curPosY + itemLayer:getContentSize().height
		
		EquipHelper:setEquipPlaceNameLabel(itemLayer, self.masterEquipList[i])
			
		itemBgSprite:setScaleY(itemLayer:getContentSize().height / itemBgSprite:getSpriteFrame():getRect().height)
			
		local bagItem = CreateBagItem()
		bagItem:setCanTouch(false)
        bagItem:setItemType(BAG_ITEM_TYPE_EQUIP)
		bagItem:setItemInfoTable(self.masterEquipList[i])
		bagItem:setPosition(cc.p(50, itemLayer:getContentSize().height - 60))
		itemLayer:addChild(bagItem)
			
       
		local function takeonMasterEquipment(node)
            MasterEquipFilterChange:MasterItemExternFun(node:getParent())
		end

        local pSelectFlag = cc.Scale9Sprite:createWithSpriteFrameName("pic_hook.png")
        if  MasterEquipFilterChange:checkHasSelect(i) > 0 then
            pSelectFlag:setVisible(true)
        else
            pSelectFlag:setVisible(false)
        end
        pSelectFlag:setPosition(cc.p(430, itemLayer:getContentSize().height * 0.4))
		pSelectFlag:setPreferredSize(cc.size(50, 50))
        itemLayer:addChild(pSelectFlag,101,101)

		local pBackgroundButton = cc.Scale9Sprite:createWithSpriteFrameName("board_skill03.png")
		local pTitle = cc.Label:create("", DefaultFontName, FontSize1)
		local takeonButton = cc.ControlButton:create(pTitle, pBackgroundButton)
		takeonButton:setTag(i)
		takeonButton:registerControlEventHandler(takeonMasterEquipment,cc.CONTROL_EVENTTYPE_TOUCH_UP_INSIDE)
		takeonButton:setPosition(pSelectFlag:getPosition())
		takeonButton:setPreferredSize(cc.size(45, 45))
		takeonButton:setScrollViewRect(cc.rect(scrollWorldPos.x, scrollWorldPos.y, scrollViewSize.width, scrollViewSize.height))
		itemLayer:addChild(takeonButton)

		scrollLayer:addChild(itemLayer)
	
		i = i-1
	end
	if scrollLayer:getContentSize().height <= self.filterLayer:getContentSize().height then
		scrollLayer:setContentSize(cc.size(self.filterLayer:getContentSize().width, self.filterLayer:getContentSize().height))
		self.filterScroll:setContentOffset(cc.p(0, 0), false)
	else
		scrollLayer:setContentSize(cc.size(self.filterLayer:getContentSize().width, curPosY))
		self.filterScroll:setContentOffset(cc.p(0, -scrollLayer:getContentSize().height + self.filterScroll:getViewSize().height), false)
	end
	self.filterScroll:updateInset()
end

function MasterEquipFilterChange:MasterEquipFilterChangeEnter(infoTable,needFilterType)
    if self.topNode ~= nil then
        return
    end

	self.topNode = createEquipPopupBoard(2)
	POPUP_LAYER:addChild(self.topNode)	
	self.filterLayer = tolua.cast(self.topNode:getChildByTag(1):getChildByTag(2), "cc.Layer")
	local closeButton = tolua.cast(self.topNode:getChildByTag(1):getChildByTag(3), "cc.ControlButton")
	closeButton:registerControlEventHandler(onMasterEquipFilterChangeClose,cc.CONTROL_EVENTTYPE_TOUCH_UP_INSIDE)

	local function onMasterEquipFilterSwallowTouch(touch, event)
		return true
	end

    local swallowLayer = tolua.cast(self.topNode:getChildByTag(20), "cc.Layer")
    SetTouchEventForLayer(swallowLayer, onMasterEquipFilterSwallowTouch)

    local propInfoTable = GameData:getPropDataTable(infoTable.prop_id)
    self.MasterEquipType = propInfoTable.place
	self:MasterEquipFilterChangeCreate()
	
	self.selectMasterinfo = infoTable

    self.masterFilterType = needFilterType

	self:MasterEquipFilterChangeRefresh()
	self:scrollRefresh()
end

function MasterEquipFilterChange:MasterEquipFilterChangeExit()
	if self.masterFilterType == 1 then
		MasterEquipEatLayer.eatEquipDataTable = {}
        for i=1,table.maxn(self.masterEquipFilterDataTable) do
		    table.insert(MasterEquipEatLayer.eatEquipDataTable, self.masterEquipFilterDataTable[i])
	    end
        MasterEquipEatLayer:MasterEquipEatLayerRefreshItem()
    elseif self.masterFilterType == 2 then
		MasterEquipInheritLayer.inheritEquipData = {}
		for i=1,table.maxn(self.masterEquipFilterDataTable) do
		    table.insert(MasterEquipInheritLayer.inheritEquipData, self.masterEquipFilterDataTable[i])
	    end
        MasterEquipInheritLayer:MasterEquipInheritLayerRefreshItem()
    end
    
    self.topNode:removeFromParent()
	self.topNode = nil
    self.equipedLayer = nil
    self.topNode = nil
    self.equipedLayer = nil	--上面那个层
    self.filterLayer = nil	
    self.filterScroll = nil	--下面的滚动层
end
function onMasterEquipFilterChangeClose()
	MasterEquipFilterChange:MasterEquipFilterChangeExit()
end
