MasterFilterItem = class("MasterFilterItem", function() 
	return cc.Layer:create() 
end)

MasterFilterItem.__index = MasterFilterItem
MasterFilterItem.ExternFun = nil

function MasterFilterItem:ctor()
	self:setAnchorPoint(0.5, 0.5)
	self:ignoreAnchorPointForPosition(true)
	
	
	local eventDispatcher = self:getEventDispatcher()
	
	local function onTouchBegan(touch, event)
		return getIsTouchInLayer(self, touch)
	end
	
	local function onTouchEnded(touch, event)
         self:doExternFun()
	end

	local listener = cc.EventListenerTouchOneByOne:create()    
	listener:setSwallowTouches(false)
	listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN )
	listener:registerScriptHandler(onTouchEnded,cc.Handler.EVENT_TOUCH_ENDED )
	eventDispatcher:addEventListenerWithSceneGraphPriority(listener, self)
end

function MasterFilterItem:doExternFun()
    if self.ExternFun ~= nil then
       self.ExternFun(self)
    end
end

function MasterFilterItem:setExternFun(exFuntion)
    self.ExternFun  = exFuntion
end

return MasterFilterItem