TimeDown = class("TimeDown")
TimeDown.__index = TimeDown

TimeDown.timerIdArr = {}
TimeDown.timeDownSchedule = nil
TimeDown.time = 0
TimeDown.serverTime = 0

--显示类型
TimeDown.HH_MM_SS = 1
TimeDown.MM_SS = 2

--鏍规嵁鍓╀綑绉掓暟璁剧疆鏃堕棿鏍囩
function SetDownTimeForLabel(label, downTime, countType)
	print("SetDownTimeForLabel", downTime)
	if downTime < 0 then
		downTime = 0
	end
	
	local h = math.floor(downTime/3600)
	local m = math.floor((downTime - 3600*h)/60)
	local s = downTime - 3600*h - 60*m
	local t = ""

	if countType == TimeDown.HH_MM_SS then
		if h <10 then
			t = t.."0"
		end
		t = t..h..":"
	end

	if m<10 then
		t = t.."0"
	end
	t = t..m..":"

	if s<10 then
		t = t.."0"
	end
	t = t..s
	print("t",t)
	label:setString(t)
end


local function UpdateTimeDown()
	local currentTime = os.time()
	local passTime = currentTime - TimeDown.time
	TimeDown.time = currentTime
	TimeDown.serverTime = TimeDown.serverTime + passTime
	
	for i=1,table.maxn(TimeDown.timerIdArr) do
		--print("UpdateTimeDown", i)
		if TimeDown.timerIdArr[i].downTime > 0 then
			TimeDown.timerIdArr[i].downTime = TimeDown.timerIdArr[i].downTime - passTime
			if TimeDown.timerIdArr[i].label ~= nil then
				SetDownTimeForLabel(TimeDown.timerIdArr[i].label, TimeDown.timerIdArr[i].downTime, TimeDown.timerIdArr[i].countType)
			end
			if TimeDown.timerIdArr[i].callback ~= nil and (TimeDown.timerIdArr[i].downTime + passTime) > 0 and TimeDown.timerIdArr[i].downTime <= 0 then
				TimeDown.timerIdArr[i].callback()
			end
		end
	end
end

function InitTimeDownSchedule()
	TimeDown.time = os.time()
	TimeDown.serverTime = UserInfo:getUserInfo().data.server_time
	TimeDown.timeDownSchedule = scheduler:scheduleScriptFunc(UpdateTimeDown, 1.0, false)
end

--閲嶇疆
function TimeDown:register(timerId)
	print("TimeDown:register", timerId)
	local bFind = false
	for k,v in pairs(self.timerIdArr) do
		if v.id == timerId then
			bFind = true
			break
		end
	end
	print(bFind)
	if bFind == false then

		self.timerIdArr[table.maxn(self.timerIdArr)+1] = {id = table.maxn(self.timerIdArr)+1,downTime=nil, label=nil, callback=nil, countType = nil}
		--setTimeDownSchedule()

		return table.maxn(self.timerIdArr)
	else
		return timerId
	end
end

function TimeDown:unregister(timerId)
	print("TimeDown:unregister", timerId)
	if timerId == 0 then
		return
	end
	for i=1, table.maxn(self.timerIdArr) do
		if self.timerIdArr[i].id == timerId then
			print("TimeDown:unregister remove", timerId)
			table.remove(self.timerIdArr, i)
			break
		end
	end
end
			
--璁剧疆
function TimeDown:setTimeInfo(timerId, downTime, label, callback, t)
	print("TimeDown:setTimeInfo", timerId, self.timerIdArr[timerId])
	self.timerIdArr[timerId].downTime = downTime
	self.timerIdArr[timerId].label = label
	self.timerIdArr[timerId].callback = callback
	self.timerIdArr[timerId].countType = t
end

--璁剧疆鏃堕棿
function TimeDown:setTimeById(timerId, downTime)
	self.timerIdArr[timerId].downTime = downTime
end

--璁剧疆鏃堕棿
function TimeDown:getTimeById(timerId)
	if timerId == nil or timerId <= 0 then
		return 0
	end

	if self.timerIdArr[timerId] ~= nil then
		return self.timerIdArr[timerId].downTime
	else
		return 0 
	end
end

--璁剧疆鏍囩
function TimeDown:setTimeById(timerId, label)
	self.timerIdArr[timerId].label = label
end

--璁剧疆瓒呮椂鍥炴帀
function TimeDown:setTimeById(timerId, callback)
	self.timerIdArr[timerId].callback = callback
end



