UserAttr = class("UserAttr")
UserAttr.__index = UserAttr

UserAttr.fightNum = 0
UserAttr.attrTable = {}
UserAttr.allLevel = 0
UserAttr.heroFightNum = {}
UserAttr.heroAttrTable = {}
UserAttr.heroLevel = {}
UserAttr.heroBaseAttr = {}



ATTR_DESC = {str="力量", agi="敏捷", int="智力", sta="耐力", hp="生命值", mp="魔法值", 
			damage="最大伤害", armor="护甲", pr="物抗", mr="魔抗", hit="命中", dodge="闪避", crit="暴击", tough="韧性"}
			
MAIN_ATTR_DESC = {ATTR_DESC["str"], ATTR_DESC["int"],ATTR_DESC["agi"],ATTR_DESC["sta"]}
			
MASTER_ATTR_DESC={hp="生命值加成", damage="伤害加成", armor ="护甲值加成", pr="物抗加成", mr ="魔抗加成",
				hit="命中值加成",dodge="闪避值加成",crit="暴击值加成", critdamage="暴击伤害",tough="韧性值加成",
				arp="护甲穿透", prp="物理穿透",mrp="魔抗穿透",hr="生命回复",lifesteal="普攻吸血",
				ret="对攻击者造成伤害",odebuff="抵消不良状态概率",equip="获得高品质装备概率",gold="金币掉落",exp="经验加成",mp="内力值加成"}

local sortTable1 = {"str", "agi", "int", "sta", "hp", "mp","damage", "armor", "pr", "mr", "hit", "dodge", "crit", "tough"}
local sortTable2 = {"hp","damage", "armor","pr","mr","hit","dodge","crit","critdamage","tough","arp","prp","mrp","hr","lifesteal",
					"ret","odebuff","equip","gold","exp"}
			
local function attrMultiLanguage(t,str)
	for k,v in pairs(t) do
		t[k] = MultiLan(str..k)
	end
end
			
function UserAttr:initAttrTable()
	attrMultiLanguage(ATTR_DESC, "attr_role_")
	MAIN_ATTR_DESC = {ATTR_DESC["str"], ATTR_DESC["int"], ATTR_DESC["agi"],ATTR_DESC["sta"]}
	attrMultiLanguage(MASTER_ATTR_DESC, "attr_artifact_")
end
			
--获取战力
function UserAttr:getFightNum()
	return self.fightNum
end

function UserAttr:getHeroFightNum(id)
	return self.heroFightNum[id]
end

--获取属性表
function UserAttr:getAttrTable()
	return self.attrTable
end

--获取全身强化等级
function UserAttr:getAllLevel()
	return self.allLevel
end

--
function UserAttr:setEquipGradeAndScore(equipInfo)
	--print("setEquipGradeAndScore", equipInfo.obj)
	equipInfo.grade = EquipHelper:getEquipGrade(equipInfo)
	equipInfo.score = UserAttr:CalEquipScore(equipInfo)
end

function UserAttr:getHeroAttrTable(id)
	return self.heroAttrTable[id]
end

function UserAttr:getHeroBaseAttr(id)
	return self.heroBaseAttr[id]
end

function UserAttr:CalEquipScore(equipInfo)
	if equipInfo == nil then
		return 0
	end 
	
	local score = 0
	if equipInfo.extra ~= nil and equipInfo.extra ~= CJSON_NULL then
		for k,v in pairs(equipInfo.extra) do
			score = score + v*2
		end
	end
	
	--强化
	local addPer = getStrengthPercent(equipInfo)
    if equipInfo.attr ~= nil and equipInfo.attr ~= CJSON_NULL then
	    for k,v in pairs(equipInfo.attr) do
		    local value = math.ceil(v*(1 + addPer/100))
		    if k == "damage" then
			    score = score + math.ceil(value*1.5)
		    elseif k == "hp" or k == "mp" then
			    score = score + math.ceil(value*0.1)
		    else
			    score = score + value
		    end
	    end
	end
	return score
end

--根据角色/等级/装备 计算最终属性/战斗力   --不适合护法只能计算玩家自己和其他玩家
function UserAttr:CalFinalAttr(role,level,equip)
	print("CalUserFinalAttr")
	local attr = {str=0, agi=0, int=0, sta=0, hp=0, mp=0, 
				 damage=0, armor=0, pr=0, mr=0, hit=0, dodge=0, crit=0, tough=0,
				 masterAttr={hp=0,hplevel=0,
							 damage=0,damagelevel=0,
							 armor =0,armorlevel=0,
							 pr=0,prlevel=0,
							 mr =0,mrlevel=0,
							 hit=0,hitlevel=0,
							 dodge=0,dodgelevel=0,
							 crit=0,critlevel=0,
							 critdamage=0,critdamagelevel=0,
							 tough=0,toughlevel=0,
							 arp=0,arplevel=0,
							 prp=0,prplevel=0,
							 mrp=0,mrplevel=0,
							 hr=0,hrlevel=0,
							 lifesteal=0,lifesteallevel=0,
							 ret=0,retlevel=0,
							 odebuff=0,odebufflevel=0,
							 equip=0,equiplevel=0,
							 gold=0,goldlevel=0,
							 exp=0,explevel=0,
							 mp=0}}
	
	local userLevel = level
	--计算基础属性
	local roleData = GameData:getUserRoleData(role)
	attr.mp = attr.mp + userLevel * roleData.mp_incr
	attr.str = roleData.power + userLevel * roleData.power_incr 
	attr.agi = roleData.agile + userLevel * roleData.agile_incr 
	attr.int = roleData.brain + userLevel * roleData.brain_incr 
	attr.sta = roleData.stamina + userLevel * roleData.stamina_incr 
	attr.hit = math.ceil(roleData.hit_1*userLevel*userLevel +roleData.hit_2*userLevel+roleData.hit_3)
	attr.damage = roleData.max

	--计算装备属性
	local totleEquipLevel = 100 
	local equipInfo = equip
	for i=1 , table.maxn(equipInfo) do
		totleEquipLevel = math.min(totleEquipLevel, equipInfo[i].strengthen)
	
		--主属性 
		AttrTableMerge(attr, equipInfo[i].attr)

		--附加属性
		AttrTableMerge(attr, equipInfo[i].extra)

		--神器属性
		AttrTableMerge(attr.masterAttr, equipInfo[i].master, equipInfo[i].master_level)
		AttrTableMerge(attr.masterAttr, equipInfo[i].glyph, equipInfo[i].glyph_level)

		--强化
		if equipInfo[i].strengthen > 0 then
			local tempTable = {}
			local addPer = getStrengthPercent(equipInfo[i])
			for k, v in pairs(equipInfo[i].attr) do
				tempTable[k]= math.ceil(v*addPer/100)
			end
			AttrTableMerge(attr, tempTable)
		end
		
		--宝石
		if equipInfo[i].stone ~= CJSON_NULL then
			for j=1,table.maxn(equipInfo[i].stone) do
				AttrTableMerge(attr, getStoneAttr(equipInfo[i].stone[j]))
			end
		end
	end
	if table.maxn(equipInfo) < EQUIP_MAX then
		totleEquipLevel = 0
	end
	
	--神器属性激活
	for i=1 , table.maxn(equipInfo) do
		AttrTableMerge(attr.masterAttr, equipInfo[i].master, math.min(equipInfo[i].master_level, totleEquipLevel))
		AttrTableMerge(attr.masterAttr, equipInfo[i].glyph, math.min(equipInfo[i].glyph_level, totleEquipLevel))
	end
	for k,v in pairs(attr.masterAttr) do
		--print("aaa",k,v)
	end
	--四维展开
	CalFourDimension(attr, role)
	
	--神器属性展开
	CalMasterAttr(attr)
	
	--战斗力计算
	local fightNum = CalFightNum(attr, userLevel)
	
	return attr, fightNum, totleEquipLevel
end

--计算玩家属性
function UserAttr:CalUserAttr(bNeedNote)
	local newAttr,newFightNum, totleEquipLevel = self:CalFinalAttr(UserSelfInfo.role, UserSelfInfo.level, UserInfo:getUserInfo().data.equip.hero_1)
	print("UserAttr:CalUserAttr", newAttr,newFightNum, totleEquipLevel, bNeedNote)
	--全身强化等级 
	self.allLevel = totleEquipLevel
	local oldFightNum = self.fightNum
	self.fightNum = newFightNum
	if newFightNum > 1000 and oldFightNum < 1000 then
		GameGuide:initHandGuide()
		GameGuide:refreshGuide(GUIDE_TYPE_ARENA)
	end

	if bNeedNote then
		local noteDesc = {}
		local colorTable = {}
		attrChange(noteDesc, colorTable, ATTR_DESC, sortTable1,self.attrTable, newAttr)
		attrChange(noteDesc, colorTable, MASTER_ATTR_DESC, sortTable2, self.attrTable.masterAttr, newAttr.masterAttr, true)
		CommonNote(noteDesc, colorTable)
	end
	self.attrTable = newAttr
	
	return self.attrTable, self.fightNum

end

--计算护法最终属性
function UserAttr:CalHeroFinalAttr(heroId, bNeedNote)
	print("CalHeroFinalAttr", bNeedNote)
	local attr = {str=0, agi=0, int=0, sta=0, hp=0, mp=0, 
				 damage=0, armor=0, pr=0, mr=0, hit=0, dodge=0, crit=0, tough=0,
				 masterAttr={hp=0,hplevel=0,
							 damage=0,damagelevel=0,
							 armor =0,armorlevel=0,
							 pr=0,prlevel=0,
							 mr =0,mrlevel=0,
							 hit=0,hitlevel=0,
							 dodge=0,dodgelevel=0,
							 crit=0,critlevel=0,
							 critdamage=0,critdamagelevel=0,
							 tough=0,toughlevel=0,
							 arp=0,arplevel=0,
							 prp=0,prplevel=0,
							 mrp=0,mrplevel=0,
							 hr=0,hrlevel=0,
							 lifesteal=0,lifesteallevel=0,
							 ret=0,retlevel=0,
							 odebuff=0,odebufflevel=0,
							 equip=0,equiplevel=0,
							 gold=0,goldlevel=0,
							 exp=0,explevel=0,
							 mp=0}}
	

	local heroInfo = UserInfo:getHero(heroId)
	local roleData = GameData:getHeroRoleData(heroId)
	local userLevel = UserSelfInfo.level
	
	--计算由升级带来的非四围成长
	attr.mp = attr.mp + userLevel * roleData.mp_incr
	attr.damage = roleData.max
	attr.str = roleData.power + userLevel * roleData.power_incr 
	attr.agi = roleData.agile + userLevel * roleData.agile_incr 
	attr.int = roleData.brain + userLevel * roleData.brain_incr 
	attr.sta = roleData.stamina + userLevel * roleData.stamina_incr 
	attr.hit = math.ceil(roleData.hit_1*userLevel*userLevel +roleData.hit_2*userLevel+ roleData.hit_3)
	
	--升级引起的属性变化
	if self.heroLevel[heroId] ~= nil and self.heroLevel[heroId] < userLevel then
		attr.str = roleData.power + (userLevel-self.heroLevel[heroId]) * roleData.power_incr 
		attr.agi = roleData.agile + (userLevel-self.heroLevel[heroId]) * roleData.agile_incr 
		attr.int = roleData.brain + (userLevel-self.heroLevel[heroId]) * roleData.brain_incr 
		attr.sta = roleData.stamina + (userLevel-self.heroLevel[heroId]) * roleData.stamina_incr 
		self.heroLevel[heroId] = userLevel
	end
	
	self.heroBaseAttr[heroId] = {str=attr.str, agi=attr.agi, int=attr.int, sta = attr.sta}
	
	--成长属性及培养属性 由服务器计算
	AttrTableMerge(attr, heroInfo.attr)
	AttrTableMerge(attr, heroInfo.extra)
	

	print("1111",attr.str,attr.agi,attr.int,attr.sta)
	--计算装备属性
	local equipInfo = UserInfo:getUserInfo().data.equip["hero_"..heroId]
	for i=1 , table.maxn(equipInfo) do
		--主属性 
		AttrTableMerge(attr, equipInfo[i].attr)
		print(1)
		print("1111",attr.str,attr.agi,attr.int,attr.sta)
		--附加属性
		AttrTableMerge(attr, equipInfo[i].extra)
		print(2)
		print("1111",attr.str,attr.agi,attr.int,attr.sta)
		--神器属性
		AttrTableMerge(attr.masterAttr, equipInfo[i].master, equipInfo[i].master_level)
		AttrTableMerge(attr.masterAttr, equipInfo[i].glyph, equipInfo[i].glyph_level)
		 

		print(3)
		print("1111",attr.str,attr.agi,attr.int,attr.sta)
		--强化
		if equipInfo[i].strengthen > 0 then
			local tempTable = {}
			local addPer = getStrengthPercent(equipInfo[i])
			for k, v in pairs(equipInfo[i].attr) do
				tempTable[k]= math.ceil(v*addPer/100)
			end
			AttrTableMerge(attr, tempTable)
		end
		--宝石
		if equipInfo[i].stone ~= CJSON_NULL then
			for j=1,table.maxn(equipInfo[i].stone) do
				AttrTableMerge(attr, getStoneAttr(equipInfo[i].stone[j]))
			end
		end
		print("1111",attr.str,attr.agi,attr.int,attr.sta)
	end
	
	--四维展开
	CalFourDimension(attr, roleData.role)
	
	--护法星级
	CalHeroStarAtrr(roleData.role, heroInfo.star_level,attr)
	print("after", attr.masterAttr.hp)
	
	--神器属性展开
	CalMasterAttr(attr)

	
	--战斗力计算
	self.heroFightNum[heroId] = CalFightNum(attr, UserSelfInfo.level)

	if bNeedNote then
		local noteDesc = {}
		local colorTable = {}
		attrChange(noteDesc, colorTable, ATTR_DESC, sortTable1,self.heroAttrTable[heroId], attr)
		--attrChange(noteDesc, colorTable, MASTER_ATTR_DESC, sortTable2, self.heroAttrTable[heroId].masterAttr, attr.masterAttr, true)
		CommonNote(noteDesc, colorTable)
	end
	self.heroAttrTable[heroId] = attr
	
	return attr,fNum
end

--装备变化引起属性改变 强化 宝石
function UserAttr:equipAttrChange(obj, bNeedNote)
    print("UserAttr:equipAttrChange",obj)
	if obj == 0 then

	elseif obj == 1 then
		self:CalUserAttr(bNeedNote)
		if CommonEquipLayer:isVisible() then
			EquipLayer:EquipLayerRefreshItem()
		end
	else
		self:CalHeroFinalAttr(obj, bNeedNote)
		if CommonHeroLayer:isVisible() then
			UpdateHeroInfo()
		end
	end
end

--比较装备评分
function UserAttr:compareEquipScore(equipInfo)
	print("compareEquipScore", equipInfo.prop_id)
	local newEquipData = EquipHelper:getStaticData(equipInfo)
	local place = newEquipData.place
	local userEquip = UserInfo:getUserInfo().data.equip.hero_1
	local findEquip = nil
	local equipScore = 0
	for i=1,table.maxn(userEquip) do
		if EquipHelper:getStaticData(userEquip[i]).place == place then
			findEquip = userEquip[i]
			equipScore = findEquip.score
			break
		end
	end
	
	local newEquipScore = equipInfo.score
	print("equipScore",equipScore,"newEquipScore",newEquipScore)
	print(newEquipData.role)
	if newEquipScore > equipScore and (newEquipData.role == 0 or newEquipData.role == UserSelfInfo.role) then
		EquipLayer:addNotePlace(place)
	end
end


function attrChange(noteTable, colorTable, descTable, sortTable,sourceTable, destTable, bPersentage)
	for i=1,table.maxn(sortTable) do
		for k,v in pairs(sourceTable) do
			if sortTable[i] == k then
				if type(v) ~= "table" and v ~= destTable[k] and descTable[k] ~= nil then
					local str1 = descTable[k]
					local str2 = ""
					local str3 = ""..math.abs(destTable[k]-v)
					local color = COLOR_GREEN
					if v < destTable[k] then
						str2 = " + "
						color = COLOR_GREEN
					else
						str2 = " - "
						color = COLOR_RED
					end
					
					if bPersentage and k ~= "arp" and  k ~= "prp" and  k ~= "mrp" then
						str3 = math.abs(destTable[k]-v)*100
						str3 = str3.."%"
					end
					
					if k == "damage" then
						table.insert(noteTable, MultiLan("attr_role_damage_min")..str2..math.floor(math.abs(destTable[k]-v)/2))
						table.insert(noteTable, MultiLan("attr_role_damage_max")..str2..str3)
						table.insert(colorTable, color)
						table.insert(colorTable, color)
					else
						table.insert(noteTable, str1..str2..str3)
						table.insert(colorTable, color)
					end
				end
				break
			end
		end
	end
end

--属性合并 将t2的count倍属性加入到t1中
function AttrTableMerge(t1,t2,count)
	if t1 == CJSON_NULL or t1 == nil or t2 == CJSON_NULL or t2 == nil then
		return 
	end
	for k,v in pairs(t2) do
		if count == nil then
			t1[k] = t1[k] + v
		else
			t1[k] = t1[k] + v*count
			t1[k.."level"] = t1[k.."level"] + count
		end
	end
end

--计算强化增加百分比
function getStrengthPercent(equipInfo)
	local level = equipInfo.strengthen
	local color,grade = EquipHelper:getEquipColor(equipInfo)
	local p = 0
	for i=1, level do
		p = p + grade * (1 + math.ceil(i/5))
	end
	
	return p
end

--获取宝石属性表
function getStoneAttr(stoneId)
	print("getStoneAttr", stoneId)
	local staticStone = GameData:getPropDataTable(stoneId)
	if staticStone == nil or staticStone.ptype ~= PROP_TYPE_GEM then
		print("getStoneAttr wrong")
		return 
	end
	
	local ret = {}
	if staticStone.place == 1 then
		ret.agi = staticStone.attr_value
	elseif staticStone.place == 2 then
		ret.str = staticStone.attr_value
	elseif staticStone.place == 3 then
		ret.int = staticStone.attr_value
	elseif staticStone.place == 4 then
		ret.sta = staticStone.attr_value
	end
		for k,v in pairs(ret) do
			print("222",k,v)
		end
	return ret
end

--四维展开
function CalFourDimension(attr, role)
	print("CalFourDimension",role)
	attr.hp    = attr.hp    +  attr.sta * 10 
	attr.tough = attr.tough +  attr.sta * 1
	attr.hit   = attr.hit   +  math.ceil(attr.str * 0.6)
	attr.pr    = attr.pr    +  attr.str
	attr.crit  = attr.crit  +  attr.agi 
	attr.dodge = attr.dodge +  math.ceil(attr.agi * 0.2)
	attr.mr    = attr.mr    +  attr.int 
	if role == 1 then
		attr.damage = attr.damage + attr.str
	elseif role == 2 then
		attr.damage = attr.damage + attr.int
	elseif role == 3 then
		attr.damage = attr.damage + attr.agi
	end
	print("attr.damege 2",attr.damege)
end

--护法星级叠加
function CalHeroStarAtrr(role, level, attr)
	print("CalHeroStarAtrr",level)
	local starTable = GameData:getHeroStarTable(role)

	attr.masterAttr.hp = attr.masterAttr.hp + starTable[level+1].hp/100
	attr.masterAttr.mp = attr.masterAttr.mp + starTable[level+1].mp/100
	attr.masterAttr.pr = attr.masterAttr.pr + starTable[level+1].pr/100
	attr.masterAttr.mr = attr.masterAttr.mr + starTable[level+1].mr/100
	attr.masterAttr.hit = attr.masterAttr.hit + starTable[level+1].hit/100
	attr.masterAttr.crit = attr.masterAttr.crit + starTable[level+1].crit/100
	attr.masterAttr.dodge = attr.masterAttr.dodge + starTable[level+1].dodge/100
	attr.masterAttr.tough = attr.masterAttr.tough + starTable[level+1].tough/100
	attr.masterAttr.damage = attr.masterAttr.damage + starTable[level+1].damageMin/100
end

--神器属性展开
function CalMasterAttr(attr)
	attr.hp = math.ceil(attr.hp * (attr.masterAttr.hp + 1))
	print(attr.masterAttr.mp, attr.mp)
	attr.mp = math.ceil(attr.mp * (attr.masterAttr.mp + 1))
	attr.damage = math.ceil(attr.damage * (attr.masterAttr.damage + 1))
	attr.hit = math.ceil(attr.hit * (attr.masterAttr.hit + 1))
	attr.pr = math.ceil(attr.pr * (attr.masterAttr.pr + 1))
	attr.tough = math.ceil(attr.tough * (attr.masterAttr.tough + 1))
	attr.mr = math.ceil(attr.mr * (attr.masterAttr.mr + 1))
	attr.armor = math.ceil(attr.armor * (attr.masterAttr.armor + 1))
	attr.dodge = math.ceil(attr.dodge * (attr.masterAttr.dodge + 1))
	attr.crit = math.ceil(attr.crit * (attr.masterAttr.crit + 1))
end

--计算战力
function CalFightNum(attr, level)
	local fNum = attr.hp * 0.1 +
				 attr.mp * (0.0168*level-0.0116) +
				 attr.damage * (math.max(0.1, 0.15213*level-1.5) + attr.masterAttr.lifesteallevel * 0.06) +
				 attr.armor * (1 + attr.masterAttr.odebufflevel * 0.08) +
				 attr.pr *    (1 + attr.masterAttr.retlevel * 0.08) +
				 attr.mr *    (1 + attr.masterAttr.mrplevel * 0.08) +
				 attr.crit *  (1 + attr.masterAttr.critdamagelevel * 0.08) +
				 attr.hit *   (1 + attr.masterAttr.arplevel * 0.08 + attr.masterAttr.prplevel * 0.08) +
				 attr.dodge * 5 +
				 attr.tough * (1 + attr.masterAttr.hrlevel * 0.08) 
	fNum = math.ceil(fNum)
	return fNum
end


function UserAttr:setCash(cashNum)
	self.UserInfoTable.data.info.cash = cashNum
end

function UserAttr:SetUserLevelInfo(expinfo)
	UserSelfInfo.exp = expinfo.exp
	UserSelfInfo.level = expinfo.level
	
	
	--升级处理 
	if expinfo.levelup > 0 then
		GameGuide:refreshGuide(GUIDE_TYPE_SKILL)
		GameGuide:refreshGuide(GUIDE_TYPE_HERO)
		GameGuide:refreshGuide(GUIDE_TYPE_SKILLUP)
		GameGuide:refreshGuide(GUIDE_TYPE_SKILLMASTER)
		GameGuide:refreshGuide(GUIDE_TYPE_FASTFIGHT)
		setQuestByType(QUEST_TYPE_LEVEL)
		
		--升级特效
		cc.SpriteFrameCache:getInstance():addSpriteFrames("ccb/ccbResources/LevelupEffect.plist")
		local effect = CommonAddEffect("ef_update", 12, 1.5/12, GUIDE_EFFECT_TAG, false)
		effect:setScale(1.3)
		effect:setPosition(cc.p(320, 480))
		NOTE_LAYER:addChild(effect)
		effect:runAction(cc.Sequence:create(cc.DelayTime:create(1.5), cc.CallFunc:create(removeSelf)))
		M.playEffect("sound/lvlUp.mp3")
		
		--玩家 护法属性战斗力重新计算
		self:CalUserAttr()
		if CommonEquipLayer:isVisible() then
			EquipLayer:PropertyLabelRefresh()
		end

		if HeroInfoTable ~= nil then
			self:CalHeroFinalAttr(HeroInfoTable[showedHeroTag].staticData.id)
		    if CommonHeroLayer:isVisible() then
			    UpdateHeroInfo()
		    end
		end
		
		--开启云游商人
		if expinfo.level >= 25 and expinfo.level - expinfo.levelup < 25 then
			local shopActData = {back="board_yunyousr.png", 
							   title = "pic_yunyousr.png", 
							   desc=MultiLan("GAL_actDesc_13"), 
							   timerId = zhuanTimerId,
							   callback= setShopAct,
							   layer= XiaLayerOwner["mActShop"]}
			table.insert(Activity_ActArr, shopActData)
			ACT_TYPE_SHOP = table.maxn(Activity_ActArr)
		end
		if expinfo.level >= 10 and expinfo.level - expinfo.levelup < 10 then
			if 	SDK_PLATFORM == "SDK_TGAME_ANDROID" or SDK_PLATFORM == "SDK_TGAME_IOS" then
				local tmpTable = {
								eventType = tostring(2),
								roleId = tostring(UserSelfInfo.uid),
								roleName = tostring(UserSelfInfo.name),
								serverId = tostring(LOGIN_SERVER_ID),
							}
							
				DevicePlatform:getInstance():sdkExtraFunction(tmpTable)
			end
		end
	end
end

