
UserDetailLayer = class("UserDetailLayer")
UserDetailLayer.__index = UserDetailLayer
UserDetailLayer.isCreated = false
UserDetailLayer.topNode = nil
UserDetailLayer.equipItems = {}

UserDetail = UserDetail or {}
ccb["UserDetail"] = UserDetail
UserDetailOwner = UserDetailOwner or {}
ccb["UserDetailOwner"] = UserDetailOwner

function UserDetailLayer:Exit()
	self.topNode:setVisible(false)
end

function UserDetailLayer:Enter(playerInfo)
    if playerInfo == nil or (self.isCreated and self.topNode:isVisible()) then
        return nil
    end

	if self.isCreated then
		self.topNode:setVisible(true)
	else
		local proxy = cc.CCBProxy:create()
		self.topNode = CCBReaderLoad("ccb/UserDetail.ccbi",proxy,UserDetailOwner)
		SetTouchEventForLayer(UserDetailOwner["mUserDetailSwallow"], TouchSwallow)
		UserDetailOwner["mUserDetailClose"]:setTitleForState(MultiLan("button_close"), 1)
		if POPUP_LAYER ~= nil then
			POPUP_LAYER:addChild(self.topNode)
			for i = 1, EQUIP_MAX do
				local equip = CreateBagItem()
				equip:setPosition(cc.p(BAG_ITEM_SIZE / 2, BAG_ITEM_SIZE / 2))
				equip:setTag(i)
				equip:setItemType(BAG_ITEM_TYPE_EMPTY_EQUIP)
				equip:setItemInfoTable({place=i})
				equip:setCanTouch(false)
				self.equipItems[i] = equip
				tolua.cast(UserDetailOwner["mEquipItemLayer" .. i], "cc.Node"):addChild(self.equipItems[i])
			end
		else
			return nil
		end
	end

	return self:InitUserDetail(playerInfo)
end

--初始化界面
function UserDetailLayer:InitUserDetail(playerInfo)
	print("UserDetailLayer:InitUserDetail")
	local attr, power,alllevel = UserAttr:CalFinalAttr(playerInfo.role, playerInfo.level, playerInfo.equip)
	--等级 
	UserDetailOwner["mEquipActorName"]:setColor(COLOR_CYAN)
	if playerInfo.union == nil then
		UserDetailOwner["mEquipActorName"]:setVisible(false)
	else
		tolua.cast(UserDetailOwner["mEquipActorName"], "cc.Label"):setString(MultiLan("lan_union").."：" .. playerInfo.union)
	end
	
	tolua.cast(UserDetailOwner["mDetailName"], "cc.Label"):setString("Lv." .. playerInfo.level .. " " .. playerInfo.name)
	--tolua.cast(UserDetailOwner["mEquipBattleValue"], "cc.Label"):setColor(COLOR_ORANGE)
	tolua.cast(UserDetailOwner["mEquipBattleValue"], "cc.Label"):setString(power)
	if playerInfo.title == 0 then
		-- UserDetailOwner["mEquipUserTitle"]:setVisible(false)
		UserDetailOwner["mEquipHonor"]:setVisible(false)
	else
		-- UserDetailOwner["mEquipUserTitle"]:setVisible(true)
		-- tolua.cast(UserDetailOwner["mEquipUserTitle"], "cc.Sprite"):setSpriteFrame("honor_"..playerInfo.title..".png")
		UserDetailOwner["mEquipHonor"]:setString(ZGMultiLan("honor_" .. playerInfo.title))
	end
	
	local attrTable = {"str","agi","int","sta","damage","armor","mr","hit","crit","dodge","tough"}
	for i=1, 11 do
		tolua.cast(UserDetailOwner["mEquipProperty"..i], "cc.Label"):setString(MultiLan( "attr_role_"..attrTable[i])..":")
		tolua.cast(UserDetailOwner["mEquipProperty"..i], "cc.Label"):setColor(COLOR_ORANGE)
	end

	tolua.cast(UserDetailOwner["mEquipValue1"], "cc.Label"):setString(attr.str)
	tolua.cast(UserDetailOwner["mEquipValue2"], "cc.Label"):setString(attr.agi)
	tolua.cast(UserDetailOwner["mEquipValue3"], "cc.Label"):setString(attr.int)
	tolua.cast(UserDetailOwner["mEquipValue4"], "cc.Label"):setString(attr.sta)
	tolua.cast(UserDetailOwner["mEquipValue5"], "cc.Label"):setString(math.ceil(attr.damage/2).." - "..attr.damage)
	tolua.cast(UserDetailOwner["mEquipValue6"], "cc.Label"):setString(attr.armor)
	tolua.cast(UserDetailOwner["mEquipValue7"], "cc.Label"):setString(attr.mr)
	tolua.cast(UserDetailOwner["mEquipValue8"], "cc.Label"):setString(attr.hit)
	tolua.cast(UserDetailOwner["mEquipValue9"], "cc.Label"):setString(attr.crit)
	tolua.cast(UserDetailOwner["mEquipValue10"], "cc.Label"):setString(attr.dodge)
	tolua.cast(UserDetailOwner["mEquipValue11"], "cc.Label"):setString(attr.tough)
	UserDetailOwner["mEquipValue5"]:setColor(COLOR_GREEN)
	print("InitUserDetail", playerInfo.role)
	UserDetailOwner["mEquipLayerHp"]:setString(attr.hp)
	UserDetailOwner["mEquipLayerMp"]:setString(attr.mp)
	UserDetailOwner["mEquipLayerBody"]:setSpriteFrame("body_icon_"..playerInfo.role..".png")
	UserDetailOwner["mEquipBattleValueTitle"]:setString(ZGMultiLan("equip_battle_value_title"))
	UserDetailOwner["lbBasePropertiesTitle"]:setString(ZGMultiLan("lbBasePropertiesTitle"))
	
	--装备
	local equipItems = {}
	for i = 1, EQUIP_MAX do
		self.equipItems[i]:setItemType(BAG_ITEM_TYPE_EMPTY_EQUIP)
		self.equipItems[i]:setItemInfoTable({place=i})
	end
	
	if playerInfo.equip ~= nil and table.maxn(playerInfo.equip) > 0 then
		for i = 1, table.maxn(playerInfo.equip) do
			local propId = playerInfo.equip[i].prop_id
			local propInfoTable = GameData:getPropDataTable(propId)
			cclog("place is %d", propInfoTable.place)
			playerInfo.equip[i].alllevel = alllevel
			self.equipItems[propInfoTable.place]:setItemType(BAG_ITEM_TYPE_EQUIP_DETAIL)
			self.equipItems[propInfoTable.place]:setItemInfoTable(playerInfo.equip[i])
			self.equipItems[propInfoTable.place]:setCanTouch(true)
		end
	end
end

function userDetailCallback(jsonDataTable)
	if jsonDataTable.ret == 0 then
		UserDetailLayer:Enter(jsonDataTable.data)
	end
end

function onPlayerDetailClick(node)
	--local uid = tolua.cast(node, "cc.Node"):getTag()
	local uid = tolua.cast(node, "cc.Node"):getName()
	HttpSend("user/equip", {"fuid="..uid}, userDetailCallback)
end

function CreateDetailButton(role, uid, callback)
	local function onPlayerHeadClick(node)
		-- local uid = tolua.cast(node, "cc.Node"):getTag()
		local uid = tolua.cast(node, "cc.Node"):getName()
		local function userDetailCallback(jsonDataTable)
			if jsonDataTable.ret == 0 then
				local ret = UserDetailLayer:Enter(jsonDataTable.data)
				if callback ~= nil then
					callback(ret)
				end
			end
		end
		
		HttpSend("user/equip", {"fuid="..uid}, userDetailCallback)
	end

	local headButton = CreateCommonButton("actor_icon_"..role..".png", nil, cc.size(95,95), onPlayerHeadClick)
	headButton:setTag(uid)
	headButton:setName(uid)
	return headButton
end

function onUserDetailClose()
	cclog("onUserDetailClose")
	UserDetailLayer:Exit()
end

UserDetail["onUserDetailClose"] = onUserDetailClose
