require "lua/bit"

--移动到新地方
function MoveToNew(child, father)
	child:retain()
	child:removeFromParent(false)
	father:addChild(child)
	child:release()
end

--从表中删除某元素
function removeFromTable(SourceTable, removeTaget)
	for i=1, table.maxn(SourceTable) do
		if SourceTable[i] == removeTaget then
			table.remove(SourceTable, i)
			break
		end
	end
end

--remove自己
function removeSelf(node)
	--print("removeSelf")
    if nil ~= node:getParent() then
	   node:removeFromParent(true)
    end
end

--隐藏自己
function HideSelf(node)
	--print("HideSelf")
	tolua.cast(node,"cc.Node"):setVisible(false)
end

--隐藏自己
function VisivleTrueSelf(node)
	--print("HideSelf")
	tolua.cast(node,"cc.Node"):setVisible(true)
end

--获取某size下某字符串的显示长度
function GetWidth(str, fontSize)
	return cc.Label:create(str, DefaultFontName, fontSize):getContentSize().width
end

--递归从某个节点网上找，只有所有节点都可见才返回true
function getVisibleRecur(node)
	while node ~= nil and tolua.isnull(node) == false do
		if node:isVisible() == false then
			return false
		end
		node = node:getParent()
	end
	return true
end

function CreateBagItem()
	return require("lua/BagItem").new()
end

function CreateMasterFilterItem()
	return require("lua/MasterFilterItem").new()
end

function CreateLoginRegionItem()
	return require("lua/GameLoginRegionItem").new()
end

function getIsTouchInLayer(pLayer, pTouch)
	local locationInNode = pLayer:convertToNodeSpace(pTouch:getLocation())
	if cc.rectContainsPoint(cc.rect(0, 0, pLayer:getContentSize().width, pLayer:getContentSize().height), locationInNode) and getVisibleRecur(pLayer) then
		if pLayer:getIsInScrollView() then
			return cc.rectContainsPoint(pLayer:getScrollViewRect(), pTouch:getLocation())
		end
		return true
	end
	return false
end

function HttpSend(InterfaceString, ParamString, Callback, bOnlyOne, bRetry)
	(require("lua/HttpReq").new()):send(InterfaceString, ParamString, Callback, bOnlyOne, bRetry)
	cclog("HttpSend" .. InterfaceString)
end

--线性搜索
function searchArrayById(SourceTable, id)
	for i=1,table.maxn(SourceTable) do
		if SourceTable[i].id == id then
			return SourceTable[i]
		end
	end
end

--线性搜索删除
function removeArrayById(SourceTable, id)
	for i=1,table.maxn(SourceTable) do
		if SourceTable[i].id == id then
			local findInfo = SourceTable[i]
			table.remove(SourceTable,i)
			return findInfo
		end
	end
end

--二分搜索  调用者保证SourceTable里的key全是数字且表元素的id从小到大排列
-- matchFunc返回0表示匹配成功 
function searchBinById(SourceTable, id, matchFunc)
	--print("searchBinById", id)
	local startIndex = 1
	local endIndex = table.maxn(SourceTable)
	local searchIndex = 1
	local chazhi = 0
	for i=1, table.maxn(SourceTable) do
		searchIndex = math.ceil((startIndex + endIndex)/2)
		--print(startIndex, endIndex, searchIndex, SourceTable[searchIndex].id)
		if matchFunc ~= nil then
			chazhi = matchFunc(SourceTable[searchIndex], id)
		else
			chazhi = id - SourceTable[searchIndex].id
		end
		
		if chazhi > 0 then
			startIndex = searchIndex + 1
		elseif chazhi < 0 then
			endIndex = searchIndex - 1
		else
			return SourceTable[searchIndex]
		end
		
		if startIndex > endIndex then
			print("searchBinById not find", id)
			return nil
		end
	end
	
	return SourceTable[searchIndex]
end

--获取table元素个数
function GetTableMenberCount(t)
	local grade = 0
	table.foreach(t,function(i, v) grade = grade+1 end)
	return grade
end

function TouchSwallow()
	return true
end

-- 返回一个UTF8的字符所占的字节数
local function GetUtf8ByteNumByFirstWord(firstCh)
    local temp = 128
    local num = 0
    local firstChNum = string.byte(firstCh)
    if firstChNum < 128 then
        return 1, true
    end
    while bit:_and(temp, firstChNum) ~= 0 do
        num = num+1
        temp = bit:_rshift(temp, 1)
    end
    return num, false
end

function FindValue(searchTable, value)
	if searchTable == CJSON_NULL or type(searchTable)~= "table" then
		return false
	end

	for k,v in pairs(searchTable) do
		if v == value then
			return true 
		end
	end
	
	return false
end

--从lua表里删除第一个key相等的元素 
function RemoveFirstByKey(searchTable,key,value)
	if searchTable == nil or type(searchTable) ~= "table" then
		return nil
	end

	for k,v in pairs(searchTable) do
		--print(v[key])
		if v[key] == value then
			searchTable[k] = nil
			break
		end
	end
end

--从lua表里找第一个key相等的元素 
function FindFirstByKey(searchTable,key,value)
	if searchTable == nil or type(searchTable) ~= "table" then
		return nil
	end
	--print("FindFirstByKey", key, value)
	local ret = nil
	for k,v in pairs(searchTable) do
		--print(v[key])
		if v[key] == value then
			ret = v
			break
		end
	end
	
	return ret
end

--从lua表里找第一个value相等的元素 
function FindFirstByValue(searchTable, value)
	if searchTable == nil or searchTable == CJSON_NULL or type(searchTable) ~= "table" then
		return nil
	end
	
	local ret = nil
	for k,v in pairs(searchTable) do
		if v == value then
			ret = v
			break
		end
	end
	
	return ret
end

--背景漂云
function AddCloudForBackground(back, tag)
    print("AddCloudForBackground",tag)
	cc.SpriteFrameCache:getInstance():addSpriteFrames("ccb/ccbResources/Activity.plist")
	local cloud = {CreateCommonSprite("pic_bigcloud.png"), CreateCommonSprite("pic_bigcloud.png")}
	back:addChild(cloud[1])
	back:addChild(cloud[2])
	local width = back:getContentSize().width
	local cloudWidth = cloud[1]:getContentSize().width
	print(cloudWidth,width)
	for i=1,2 do
		cloud[i]:setAnchorPoint(cc.p(0,0))
		cloud[i]:setPosition(cc.p(width, 0))
	end
	
	local function resetPosition(node)
		tolua.cast(node, "cc.Node"):setPosition(cc.p(width, 0))
	end
	
	local speed = cloudWidth/20
	cloud[1]:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.MoveBy:create((width+cloudWidth)/speed,cc.p(0-width-cloudWidth,0)),
																	cc.CallFunc:create(resetPosition),
																	cc.DelayTime:create((cloudWidth-width)/speed))))
	local function delayRun()
		print("delayRun")
		cloud[2]:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.MoveBy:create((width+cloudWidth)/speed,cc.p(0-width-cloudWidth,0)),
																		cc.CallFunc:create(resetPosition),
																		cc.DelayTime:create((cloudWidth-width)/speed))))
	end
	cloud[2]:runAction(cc.Sequence:create(cc.DelayTime:create(cloudWidth/speed), cc.CallFunc:create(delayRun)))
	
	--添加树叶粒子特效
	--[[
	if tag == nil then
		local leaf = cc.ParticleSystemQuad:create("particle/leafall.plist")
		print("leaf",leaf)
		leaf:setPosition(cc.p(640,960))
		back:addChild(leaf)
	end
	]]
end

function  addSideRect( ... )
	-- body
	local upSprite = cc.Sprite:createWithSpriteFrameName("pic_updownboard.png")
	upSprite:setAnchorPoint(cc.p(0.5, 0.0))
	upSprite:setPosition(cc.p(320, 960))
	scene:addChild(upSprite,1000)
	local downSprite = cc.Sprite:createWithSpriteFrameName("pic_updownboard.png")
	downSprite:setAnchorPoint(cc.p(0.5, 0.0))
	downSprite:setPosition(cc.p(320, 0))
	downSprite:setScaleY(-1)
	scene:addChild(downSprite,1000)
	-- local leftSprite = cc.Sprite:createWithSpriteFrameName("pic_sideboard.png")
	-- leftSprite:setAnchorPoint(cc.p(0.0, 0.5))
	-- leftSprite:setPosition(cc.p(-90, 480))
	-- scene:addChild(leftSprite,1000)
	-- local rightSprite = cc.Sprite:createWithSpriteFrameName("pic_sideboard.png")
	-- rightSprite:setAnchorPoint(cc.p(1.0, 0.5))
	-- rightSprite:setPosition(cc.p(640, 480))
	-- rightSprite:setScaleX(-1)
	-- scene:addChild(rightSprite,1000)
end

--------------------------------------------------------------------------------------------------------------------------------
--返回utf8字符串的长度，汉字两个，字符一个
function GetUTF8LogicStrLen(utfStr)
    local tempNum = 0
	local isCharacter
    local retLen = 0
    local index = 1
    while index <= string.len(utfStr) do
        tempNum, isCharacter = GetUtf8ByteNumByFirstWord(string.sub(utfStr, index, index))
		if isCharacter then
			retLen = retLen+1
		else
			retLen = retLen+2
		end
        index = index + tempNum
    end
    return retLen
end

function ExitGame()
	if DevicePlatform:getInstance():getSdkPlatform() == "SDK_BAIDU_ANDROID" then
  		DevicePlatform:getInstance():exitSdk()
  	end
	cc.Director:getInstance():endToLua()
end

-- cclog
cclog = function(...)
    print(string.format(...))
end


ccdump = function(object, label, nesting, nest)
	if type(nesting) ~= "number" then nesting = 99 end
	local lookup_table = {}
	local function _dump(object, label, indent, nest)
		label = label or "<var>"
		if type(object) ~= "table" then
			print(string.format("%s%s = %s", indent, tostring(label), tostring(object)..""))
		elseif lookup_table[object] then
			print(string.format("%s%s = *REF*", indent, tostring(label)))
		else
			lookup_table[object] = true
			if nest > nesting then
				print(string.format("%s%s = *MAX NESTING*", indent, label))
			else
				print(string.format("%s%s = {", indent, tostring(label)))
				local indent2 = indent.."    "
				for k, v in pairs(object) do
					_dump(v, k, indent2, nest + 1)
				end
				print(string.format("%s}", indent))
			end
		end
	end
	_dump(object, label, "- ", 1)
end