require "lua/Cocos2d"
require "lua/Cocos2dConstants"
require "lua/CCBReaderLoad"
require "lua/GameData"
require "lua/Localization"
require "lua/HttpReq"
require "lua/GameConfig"
require "lua/CommonDefine"
require "lua/config/DataConfig"
require "lua/CommonLayer"
require "lua/GameLoginLayer"
require "lua/UserInfo"
require "lua/UserAttr"
require "lua/ItemDetail"
require "lua/PropDetail"
require "lua/GameLoginRegisterLayer"
require "lua/GameEnteringLayer"
require "lua/GameBattleSetting"
require "lua/MessagePack"
require "lua/EquipFilterLayer"
require "lua/EquipStrengthen"
require "lua/EquipHelper"
require "lua/EquipStoneSet"
require "lua/EquipFilterChange"
require "lua/EquipMeltFilterLayer"
require "lua/MasterEquipFilterChange"
require "lua/SpecialForgeLayer"

scene = nil
USER_TOKEN= ""
bTestVersion = false

-- for CCLuaEngine traceback
function __G__TRACKBACK__(msg)
    cclog("----------------------------------------")
    cclog("LUA ERROR: " .. tostring(msg) .. "\n")
	--CommonNote("LUA ERROR: " .. tostring(msg) .. "\n")
    cclog(debug.traceback())
	--CommonNote(debug.traceback())
	print("bTestVersion",bTestVersion)
	if bTestVersion then
		local layer = CreateLayer(POPUP_SIZE_MID, 1,Pos(POPUP_SIZE_MID))
		local contentLayer = CreateLayer(cc.size(490,510),1,Pos(POPUP_SIZE_MID,0.5,0.546))
		layer:addChild(contentLayer)
		--layer:addChild(CreateCommonLabel("LUA ERROR: " .. tostring(msg) .. "\n"..debug.traceback(), Pos(POPUP_SIZE_MID,0.5,0.546),FontSize4,nil,nil,cc.size(490,510)))
		--string.("LUA ERROR: " .. tostring(msg) .. "\n"..debug.traceback())
		
		CreateRichtextByFather(contentLayer, {{str=string.gsub("LUA ERROR: " .. tostring(msg) .. "\n"..debug.traceback(), "\n", ""),size=FontSize4}}, nil, true) 
		CommonCreatePopupMid("prompt",layer,true)
		print(1)
	else
		print(2,SERVER_ADDRESS)
		local function delaySend()
			print("delaySend")
			local xhr = cc.XMLHttpRequest:new()
			xhr.responseType = cc.XMLHTTPREQUEST_RESPONSE_STRING
			xhr:open("POST", SERVER_ADDRESS .. "user/err")
			local function httpCommonCallback()
				
			end
			xhr:registerScriptHandler(httpCommonCallback)
			local ParamTable = {"err="..LoginLayer.curGameVersion.."  "..tostring(msg), "token="..USER_TOKEN}
			table.sort(ParamTable, function(x,y) return x < y end)
			local ParamString = table.concat(ParamTable, "&")
			cclog("send interface %s", InterfaceString)
			cclog("origin param string %s", ParamString)
			local encryptParamSig = IHelper:getInstance():getHTTPRequestSignature("user/err", ParamString)
			cclog("encrypt param string %s", ParamString)
			cclog("sig string %s", encryptParamSig)
			xhr:send(ParamString .. "&sig=" .. encryptParamSig)
			
		end
		if SERVER_ADDRESS ~= nil then
			UI_LAYER:runAction(cc.Sequence:create(cc.DelayTime:create(0.1), cc.CallFunc:create(delaySend)))
		end
	end

    cclog("----------------------------------------")
    return msg
end

function main()
	print("old main call")
    collectgarbage("collect")
    -- avoid memory leak
    collectgarbage("setpause", 100)
    collectgarbage("setstepmul", 5000)
--[[
    -- initialize director
    local director = cc.Director:getInstance()
    local glview = director:getOpenGLView()
    if nil == glview then
        glview = cc.GLView:createWithRect("HelloLua", cc.rect(0,0,960,640))
        director:setOpenGLView(glview)
    end

    glview:setDesignResolutionSize(960, 640, cc.ResolutionPolicy.NO_BORDER)

    --turn on display FPS
    director:setDisplayStats(true)

    --set FPS. the default value is 1.0/60 if you don't call this
    director:setAnimationInterval(1.0 / 60)
--]]

	scene = cc.Scene:create()
	scene:setAnchorPoint(cc.p(0.5, 0.5))
	scene:ignoreAnchorPointForPosition(false)
	scene:setContentSize(cc.size(640, 960))
	scene:setPosition(cc.p(cc.Director:getInstance():getWinSize().width / 2, cc.Director:getInstance():getWinSize().height / 2))
	local listener = cc.EventListenerKeyboard:create()
	listener:registerScriptHandler(onKeyReleased, cc.Handler.EVENT_KEYBOARD_RELEASED )
	local eventDispatcher = scene:getEventDispatcher()
	eventDispatcher:addEventListenerWithSceneGraphPriority(listener, scene)
	if cc.Director:getInstance():getRunningScene() ~= nil then
		cc.Director:getInstance():replaceScene(scene)
	else
		cc.Director:getInstance():runWithScene(scene)
	end
	scene:runAction(cc.Sequence:create(cc.DelayTime:create(0.01), cc.CallFunc:create(afterSceneCreate)))
	cc.SpriteFrameCache:getInstance():addSpriteFrames("ccb/ccbResources/BigBack.plist")
	cc.SpriteFrameCache:getInstance():addSpriteFrames("ccb/ccbResources/Activity.plist")		
	local bgSprite = cc.Sprite:createWithSpriteFrameName("MainBack.png")
	bgSprite:setPosition(cc.p(320, 480))
	scene:addChild(bgSprite)
	local logoSprite = cc.Sprite:createWithSpriteFrameName("pic_logo.png")
	logoSprite:setPosition(cc.p(320, 716))
	scene:addChild(logoSprite)
	local waitingLabel = cc.Label:create(MultiLan("desc_loading"), DefaultFontName, FontSize3)
	waitingLabel:setPosition(cc.p(320, 480))
	scene:addChild(waitingLabel)
	addSideRect()
	cc.FileUtils:getInstance():addSearchPath("ccb/")
end

function afterSceneCreate()
	cclog("ou ye")
	GameConfig:LoadConfig()
	bTestVersion = GameConfig:GetIsTest()

	--ConfigLayerEnter()
	--EquipLayer:EquipLayerEnter()
	cc.SpriteFrameCache:getInstance():addSpriteFrames("ccb/ccbResources/GameIcon.plist")	
	cc.SpriteFrameCache:getInstance():addSpriteFrames("ccb/ccbResources/GameIcon2.plist")
	cc.SpriteFrameCache:getInstance():addSpriteFrames("ccb/ccbResources/BigBack.plist")	
	cc.SpriteFrameCache:getInstance():addSpriteFrames("ccb/ccbResources/DaXia.plist")
	cc.SpriteFrameCache:getInstance():addSpriteFrames("ccb/ccbResources/DaXia2.plist")
	loadGameData()
end

function loadGameData()
	local function loadGameDataCallback(jsonTable)
		print("loadGameDataCallback")
		GameData:setGameDataTable(jsonTable)
		LoginLayer:LoginLayerEnter()
	end
	if GameConfig:GetIsRelease() or true then
		print("GameConfig:GetIsRelease()")
		local filePath = cc.FileUtils:getInstance():fullPathForFilename("lua/jsonconf.lua")
		print(filePath)
		if nil ~= filePath then
			local parseStr = cc.FileUtils:getInstance():getStringFromFile(filePath)
			loadGameDataCallback((require "cjson").decode(parseStr))
		end
	else
		HttpSend("jsonconf/info", {}, loadGameDataCallback)
	end
end

main()